"Main interface for securityhub type defs"
from __future__ import annotations

from datetime import datetime
from typing import Dict, List
from typing_extensions import TypedDict


__all__ = (
    "ClientBatchDisableStandardsResponseStandardsSubscriptionsTypeDef",
    "ClientBatchDisableStandardsResponseTypeDef",
    "ClientBatchEnableStandardsResponseStandardsSubscriptionsTypeDef",
    "ClientBatchEnableStandardsResponseTypeDef",
    "ClientBatchEnableStandardsStandardsSubscriptionRequestsTypeDef",
    "ClientBatchImportFindingsFindingsComplianceTypeDef",
    "ClientBatchImportFindingsFindingsMalwareTypeDef",
    "ClientBatchImportFindingsFindingsNetworkTypeDef",
    "ClientBatchImportFindingsFindingsNoteTypeDef",
    "ClientBatchImportFindingsFindingsProcessTypeDef",
    "ClientBatchImportFindingsFindingsRelatedFindingsTypeDef",
    "ClientBatchImportFindingsFindingsRemediationRecommendationTypeDef",
    "ClientBatchImportFindingsFindingsRemediationTypeDef",
    "ClientBatchImportFindingsFindingsResourcesDetailsAwsEc2InstanceTypeDef",
    "ClientBatchImportFindingsFindingsResourcesDetailsAwsIamAccessKeyTypeDef",
    "ClientBatchImportFindingsFindingsResourcesDetailsAwsS3BucketTypeDef",
    "ClientBatchImportFindingsFindingsResourcesDetailsContainerTypeDef",
    "ClientBatchImportFindingsFindingsResourcesDetailsTypeDef",
    "ClientBatchImportFindingsFindingsResourcesTypeDef",
    "ClientBatchImportFindingsFindingsSeverityTypeDef",
    "ClientBatchImportFindingsFindingsThreatIntelIndicatorsTypeDef",
    "ClientBatchImportFindingsFindingsTypeDef",
    "ClientBatchImportFindingsResponseFailedFindingsTypeDef",
    "ClientBatchImportFindingsResponseTypeDef",
    "ClientCreateActionTargetResponseTypeDef",
    "ClientCreateInsightFiltersAwsAccountIdTypeDef",
    "ClientCreateInsightFiltersCompanyNameTypeDef",
    "ClientCreateInsightFiltersComplianceStatusTypeDef",
    "ClientCreateInsightFiltersConfidenceTypeDef",
    "ClientCreateInsightFiltersCreatedAtDateRangeTypeDef",
    "ClientCreateInsightFiltersCreatedAtTypeDef",
    "ClientCreateInsightFiltersCriticalityTypeDef",
    "ClientCreateInsightFiltersDescriptionTypeDef",
    "ClientCreateInsightFiltersFirstObservedAtDateRangeTypeDef",
    "ClientCreateInsightFiltersFirstObservedAtTypeDef",
    "ClientCreateInsightFiltersGeneratorIdTypeDef",
    "ClientCreateInsightFiltersIdTypeDef",
    "ClientCreateInsightFiltersKeywordTypeDef",
    "ClientCreateInsightFiltersLastObservedAtDateRangeTypeDef",
    "ClientCreateInsightFiltersLastObservedAtTypeDef",
    "ClientCreateInsightFiltersMalwareNameTypeDef",
    "ClientCreateInsightFiltersMalwarePathTypeDef",
    "ClientCreateInsightFiltersMalwareStateTypeDef",
    "ClientCreateInsightFiltersMalwareTypeTypeDef",
    "ClientCreateInsightFiltersNetworkDestinationDomainTypeDef",
    "ClientCreateInsightFiltersNetworkDestinationIpV4TypeDef",
    "ClientCreateInsightFiltersNetworkDestinationIpV6TypeDef",
    "ClientCreateInsightFiltersNetworkDestinationPortTypeDef",
    "ClientCreateInsightFiltersNetworkDirectionTypeDef",
    "ClientCreateInsightFiltersNetworkProtocolTypeDef",
    "ClientCreateInsightFiltersNetworkSourceDomainTypeDef",
    "ClientCreateInsightFiltersNetworkSourceIpV4TypeDef",
    "ClientCreateInsightFiltersNetworkSourceIpV6TypeDef",
    "ClientCreateInsightFiltersNetworkSourceMacTypeDef",
    "ClientCreateInsightFiltersNetworkSourcePortTypeDef",
    "ClientCreateInsightFiltersNoteTextTypeDef",
    "ClientCreateInsightFiltersNoteUpdatedAtDateRangeTypeDef",
    "ClientCreateInsightFiltersNoteUpdatedAtTypeDef",
    "ClientCreateInsightFiltersNoteUpdatedByTypeDef",
    "ClientCreateInsightFiltersProcessLaunchedAtDateRangeTypeDef",
    "ClientCreateInsightFiltersProcessLaunchedAtTypeDef",
    "ClientCreateInsightFiltersProcessNameTypeDef",
    "ClientCreateInsightFiltersProcessParentPidTypeDef",
    "ClientCreateInsightFiltersProcessPathTypeDef",
    "ClientCreateInsightFiltersProcessPidTypeDef",
    "ClientCreateInsightFiltersProcessTerminatedAtDateRangeTypeDef",
    "ClientCreateInsightFiltersProcessTerminatedAtTypeDef",
    "ClientCreateInsightFiltersProductArnTypeDef",
    "ClientCreateInsightFiltersProductFieldsTypeDef",
    "ClientCreateInsightFiltersProductNameTypeDef",
    "ClientCreateInsightFiltersRecommendationTextTypeDef",
    "ClientCreateInsightFiltersRecordStateTypeDef",
    "ClientCreateInsightFiltersRelatedFindingsIdTypeDef",
    "ClientCreateInsightFiltersRelatedFindingsProductArnTypeDef",
    "ClientCreateInsightFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef",
    "ClientCreateInsightFiltersResourceAwsEc2InstanceImageIdTypeDef",
    "ClientCreateInsightFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef",
    "ClientCreateInsightFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef",
    "ClientCreateInsightFiltersResourceAwsEc2InstanceKeyNameTypeDef",
    "ClientCreateInsightFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef",
    "ClientCreateInsightFiltersResourceAwsEc2InstanceLaunchedAtTypeDef",
    "ClientCreateInsightFiltersResourceAwsEc2InstanceSubnetIdTypeDef",
    "ClientCreateInsightFiltersResourceAwsEc2InstanceTypeTypeDef",
    "ClientCreateInsightFiltersResourceAwsEc2InstanceVpcIdTypeDef",
    "ClientCreateInsightFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef",
    "ClientCreateInsightFiltersResourceAwsIamAccessKeyCreatedAtTypeDef",
    "ClientCreateInsightFiltersResourceAwsIamAccessKeyStatusTypeDef",
    "ClientCreateInsightFiltersResourceAwsIamAccessKeyUserNameTypeDef",
    "ClientCreateInsightFiltersResourceAwsS3BucketOwnerIdTypeDef",
    "ClientCreateInsightFiltersResourceAwsS3BucketOwnerNameTypeDef",
    "ClientCreateInsightFiltersResourceContainerImageIdTypeDef",
    "ClientCreateInsightFiltersResourceContainerImageNameTypeDef",
    "ClientCreateInsightFiltersResourceContainerLaunchedAtDateRangeTypeDef",
    "ClientCreateInsightFiltersResourceContainerLaunchedAtTypeDef",
    "ClientCreateInsightFiltersResourceContainerNameTypeDef",
    "ClientCreateInsightFiltersResourceDetailsOtherTypeDef",
    "ClientCreateInsightFiltersResourceIdTypeDef",
    "ClientCreateInsightFiltersResourcePartitionTypeDef",
    "ClientCreateInsightFiltersResourceRegionTypeDef",
    "ClientCreateInsightFiltersResourceTagsTypeDef",
    "ClientCreateInsightFiltersResourceTypeTypeDef",
    "ClientCreateInsightFiltersSeverityLabelTypeDef",
    "ClientCreateInsightFiltersSeverityNormalizedTypeDef",
    "ClientCreateInsightFiltersSeverityProductTypeDef",
    "ClientCreateInsightFiltersSourceUrlTypeDef",
    "ClientCreateInsightFiltersThreatIntelIndicatorCategoryTypeDef",
    "ClientCreateInsightFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef",
    "ClientCreateInsightFiltersThreatIntelIndicatorLastObservedAtTypeDef",
    "ClientCreateInsightFiltersThreatIntelIndicatorSourceTypeDef",
    "ClientCreateInsightFiltersThreatIntelIndicatorSourceUrlTypeDef",
    "ClientCreateInsightFiltersThreatIntelIndicatorTypeTypeDef",
    "ClientCreateInsightFiltersThreatIntelIndicatorValueTypeDef",
    "ClientCreateInsightFiltersTitleTypeDef",
    "ClientCreateInsightFiltersTypeTypeDef",
    "ClientCreateInsightFiltersUpdatedAtDateRangeTypeDef",
    "ClientCreateInsightFiltersUpdatedAtTypeDef",
    "ClientCreateInsightFiltersUserDefinedFieldsTypeDef",
    "ClientCreateInsightFiltersVerificationStateTypeDef",
    "ClientCreateInsightFiltersWorkflowStateTypeDef",
    "ClientCreateInsightFiltersTypeDef",
    "ClientCreateInsightResponseTypeDef",
    "ClientCreateMembersAccountDetailsTypeDef",
    "ClientCreateMembersResponseUnprocessedAccountsTypeDef",
    "ClientCreateMembersResponseTypeDef",
    "ClientDeclineInvitationsResponseUnprocessedAccountsTypeDef",
    "ClientDeclineInvitationsResponseTypeDef",
    "ClientDeleteActionTargetResponseTypeDef",
    "ClientDeleteInsightResponseTypeDef",
    "ClientDeleteInvitationsResponseUnprocessedAccountsTypeDef",
    "ClientDeleteInvitationsResponseTypeDef",
    "ClientDeleteMembersResponseUnprocessedAccountsTypeDef",
    "ClientDeleteMembersResponseTypeDef",
    "ClientDescribeActionTargetsResponseActionTargetsTypeDef",
    "ClientDescribeActionTargetsResponseTypeDef",
    "ClientDescribeHubResponseTypeDef",
    "ClientDescribeProductsResponseProductsTypeDef",
    "ClientDescribeProductsResponseTypeDef",
    "ClientEnableImportFindingsForProductResponseTypeDef",
    "ClientGetEnabledStandardsResponseStandardsSubscriptionsTypeDef",
    "ClientGetEnabledStandardsResponseTypeDef",
    "ClientGetFindingsFiltersAwsAccountIdTypeDef",
    "ClientGetFindingsFiltersCompanyNameTypeDef",
    "ClientGetFindingsFiltersComplianceStatusTypeDef",
    "ClientGetFindingsFiltersConfidenceTypeDef",
    "ClientGetFindingsFiltersCreatedAtDateRangeTypeDef",
    "ClientGetFindingsFiltersCreatedAtTypeDef",
    "ClientGetFindingsFiltersCriticalityTypeDef",
    "ClientGetFindingsFiltersDescriptionTypeDef",
    "ClientGetFindingsFiltersFirstObservedAtDateRangeTypeDef",
    "ClientGetFindingsFiltersFirstObservedAtTypeDef",
    "ClientGetFindingsFiltersGeneratorIdTypeDef",
    "ClientGetFindingsFiltersIdTypeDef",
    "ClientGetFindingsFiltersKeywordTypeDef",
    "ClientGetFindingsFiltersLastObservedAtDateRangeTypeDef",
    "ClientGetFindingsFiltersLastObservedAtTypeDef",
    "ClientGetFindingsFiltersMalwareNameTypeDef",
    "ClientGetFindingsFiltersMalwarePathTypeDef",
    "ClientGetFindingsFiltersMalwareStateTypeDef",
    "ClientGetFindingsFiltersMalwareTypeTypeDef",
    "ClientGetFindingsFiltersNetworkDestinationDomainTypeDef",
    "ClientGetFindingsFiltersNetworkDestinationIpV4TypeDef",
    "ClientGetFindingsFiltersNetworkDestinationIpV6TypeDef",
    "ClientGetFindingsFiltersNetworkDestinationPortTypeDef",
    "ClientGetFindingsFiltersNetworkDirectionTypeDef",
    "ClientGetFindingsFiltersNetworkProtocolTypeDef",
    "ClientGetFindingsFiltersNetworkSourceDomainTypeDef",
    "ClientGetFindingsFiltersNetworkSourceIpV4TypeDef",
    "ClientGetFindingsFiltersNetworkSourceIpV6TypeDef",
    "ClientGetFindingsFiltersNetworkSourceMacTypeDef",
    "ClientGetFindingsFiltersNetworkSourcePortTypeDef",
    "ClientGetFindingsFiltersNoteTextTypeDef",
    "ClientGetFindingsFiltersNoteUpdatedAtDateRangeTypeDef",
    "ClientGetFindingsFiltersNoteUpdatedAtTypeDef",
    "ClientGetFindingsFiltersNoteUpdatedByTypeDef",
    "ClientGetFindingsFiltersProcessLaunchedAtDateRangeTypeDef",
    "ClientGetFindingsFiltersProcessLaunchedAtTypeDef",
    "ClientGetFindingsFiltersProcessNameTypeDef",
    "ClientGetFindingsFiltersProcessParentPidTypeDef",
    "ClientGetFindingsFiltersProcessPathTypeDef",
    "ClientGetFindingsFiltersProcessPidTypeDef",
    "ClientGetFindingsFiltersProcessTerminatedAtDateRangeTypeDef",
    "ClientGetFindingsFiltersProcessTerminatedAtTypeDef",
    "ClientGetFindingsFiltersProductArnTypeDef",
    "ClientGetFindingsFiltersProductFieldsTypeDef",
    "ClientGetFindingsFiltersProductNameTypeDef",
    "ClientGetFindingsFiltersRecommendationTextTypeDef",
    "ClientGetFindingsFiltersRecordStateTypeDef",
    "ClientGetFindingsFiltersRelatedFindingsIdTypeDef",
    "ClientGetFindingsFiltersRelatedFindingsProductArnTypeDef",
    "ClientGetFindingsFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef",
    "ClientGetFindingsFiltersResourceAwsEc2InstanceImageIdTypeDef",
    "ClientGetFindingsFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef",
    "ClientGetFindingsFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef",
    "ClientGetFindingsFiltersResourceAwsEc2InstanceKeyNameTypeDef",
    "ClientGetFindingsFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef",
    "ClientGetFindingsFiltersResourceAwsEc2InstanceLaunchedAtTypeDef",
    "ClientGetFindingsFiltersResourceAwsEc2InstanceSubnetIdTypeDef",
    "ClientGetFindingsFiltersResourceAwsEc2InstanceTypeTypeDef",
    "ClientGetFindingsFiltersResourceAwsEc2InstanceVpcIdTypeDef",
    "ClientGetFindingsFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef",
    "ClientGetFindingsFiltersResourceAwsIamAccessKeyCreatedAtTypeDef",
    "ClientGetFindingsFiltersResourceAwsIamAccessKeyStatusTypeDef",
    "ClientGetFindingsFiltersResourceAwsIamAccessKeyUserNameTypeDef",
    "ClientGetFindingsFiltersResourceAwsS3BucketOwnerIdTypeDef",
    "ClientGetFindingsFiltersResourceAwsS3BucketOwnerNameTypeDef",
    "ClientGetFindingsFiltersResourceContainerImageIdTypeDef",
    "ClientGetFindingsFiltersResourceContainerImageNameTypeDef",
    "ClientGetFindingsFiltersResourceContainerLaunchedAtDateRangeTypeDef",
    "ClientGetFindingsFiltersResourceContainerLaunchedAtTypeDef",
    "ClientGetFindingsFiltersResourceContainerNameTypeDef",
    "ClientGetFindingsFiltersResourceDetailsOtherTypeDef",
    "ClientGetFindingsFiltersResourceIdTypeDef",
    "ClientGetFindingsFiltersResourcePartitionTypeDef",
    "ClientGetFindingsFiltersResourceRegionTypeDef",
    "ClientGetFindingsFiltersResourceTagsTypeDef",
    "ClientGetFindingsFiltersResourceTypeTypeDef",
    "ClientGetFindingsFiltersSeverityLabelTypeDef",
    "ClientGetFindingsFiltersSeverityNormalizedTypeDef",
    "ClientGetFindingsFiltersSeverityProductTypeDef",
    "ClientGetFindingsFiltersSourceUrlTypeDef",
    "ClientGetFindingsFiltersThreatIntelIndicatorCategoryTypeDef",
    "ClientGetFindingsFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef",
    "ClientGetFindingsFiltersThreatIntelIndicatorLastObservedAtTypeDef",
    "ClientGetFindingsFiltersThreatIntelIndicatorSourceTypeDef",
    "ClientGetFindingsFiltersThreatIntelIndicatorSourceUrlTypeDef",
    "ClientGetFindingsFiltersThreatIntelIndicatorTypeTypeDef",
    "ClientGetFindingsFiltersThreatIntelIndicatorValueTypeDef",
    "ClientGetFindingsFiltersTitleTypeDef",
    "ClientGetFindingsFiltersTypeTypeDef",
    "ClientGetFindingsFiltersUpdatedAtDateRangeTypeDef",
    "ClientGetFindingsFiltersUpdatedAtTypeDef",
    "ClientGetFindingsFiltersUserDefinedFieldsTypeDef",
    "ClientGetFindingsFiltersVerificationStateTypeDef",
    "ClientGetFindingsFiltersWorkflowStateTypeDef",
    "ClientGetFindingsFiltersTypeDef",
    "ClientGetFindingsResponseFindingsComplianceTypeDef",
    "ClientGetFindingsResponseFindingsMalwareTypeDef",
    "ClientGetFindingsResponseFindingsNetworkTypeDef",
    "ClientGetFindingsResponseFindingsNoteTypeDef",
    "ClientGetFindingsResponseFindingsProcessTypeDef",
    "ClientGetFindingsResponseFindingsRelatedFindingsTypeDef",
    "ClientGetFindingsResponseFindingsRemediationRecommendationTypeDef",
    "ClientGetFindingsResponseFindingsRemediationTypeDef",
    "ClientGetFindingsResponseFindingsResourcesDetailsAwsEc2InstanceTypeDef",
    "ClientGetFindingsResponseFindingsResourcesDetailsAwsIamAccessKeyTypeDef",
    "ClientGetFindingsResponseFindingsResourcesDetailsAwsS3BucketTypeDef",
    "ClientGetFindingsResponseFindingsResourcesDetailsContainerTypeDef",
    "ClientGetFindingsResponseFindingsResourcesDetailsTypeDef",
    "ClientGetFindingsResponseFindingsResourcesTypeDef",
    "ClientGetFindingsResponseFindingsSeverityTypeDef",
    "ClientGetFindingsResponseFindingsThreatIntelIndicatorsTypeDef",
    "ClientGetFindingsResponseFindingsTypeDef",
    "ClientGetFindingsResponseTypeDef",
    "ClientGetFindingsSortCriteriaTypeDef",
    "ClientGetInsightResultsResponseInsightResultsResultValuesTypeDef",
    "ClientGetInsightResultsResponseInsightResultsTypeDef",
    "ClientGetInsightResultsResponseTypeDef",
    "ClientGetInsightsResponseInsightsFiltersAwsAccountIdTypeDef",
    "ClientGetInsightsResponseInsightsFiltersCompanyNameTypeDef",
    "ClientGetInsightsResponseInsightsFiltersComplianceStatusTypeDef",
    "ClientGetInsightsResponseInsightsFiltersConfidenceTypeDef",
    "ClientGetInsightsResponseInsightsFiltersCreatedAtDateRangeTypeDef",
    "ClientGetInsightsResponseInsightsFiltersCreatedAtTypeDef",
    "ClientGetInsightsResponseInsightsFiltersCriticalityTypeDef",
    "ClientGetInsightsResponseInsightsFiltersDescriptionTypeDef",
    "ClientGetInsightsResponseInsightsFiltersFirstObservedAtDateRangeTypeDef",
    "ClientGetInsightsResponseInsightsFiltersFirstObservedAtTypeDef",
    "ClientGetInsightsResponseInsightsFiltersGeneratorIdTypeDef",
    "ClientGetInsightsResponseInsightsFiltersIdTypeDef",
    "ClientGetInsightsResponseInsightsFiltersKeywordTypeDef",
    "ClientGetInsightsResponseInsightsFiltersLastObservedAtDateRangeTypeDef",
    "ClientGetInsightsResponseInsightsFiltersLastObservedAtTypeDef",
    "ClientGetInsightsResponseInsightsFiltersMalwareNameTypeDef",
    "ClientGetInsightsResponseInsightsFiltersMalwarePathTypeDef",
    "ClientGetInsightsResponseInsightsFiltersMalwareStateTypeDef",
    "ClientGetInsightsResponseInsightsFiltersMalwareTypeTypeDef",
    "ClientGetInsightsResponseInsightsFiltersNetworkDestinationDomainTypeDef",
    "ClientGetInsightsResponseInsightsFiltersNetworkDestinationIpV4TypeDef",
    "ClientGetInsightsResponseInsightsFiltersNetworkDestinationIpV6TypeDef",
    "ClientGetInsightsResponseInsightsFiltersNetworkDestinationPortTypeDef",
    "ClientGetInsightsResponseInsightsFiltersNetworkDirectionTypeDef",
    "ClientGetInsightsResponseInsightsFiltersNetworkProtocolTypeDef",
    "ClientGetInsightsResponseInsightsFiltersNetworkSourceDomainTypeDef",
    "ClientGetInsightsResponseInsightsFiltersNetworkSourceIpV4TypeDef",
    "ClientGetInsightsResponseInsightsFiltersNetworkSourceIpV6TypeDef",
    "ClientGetInsightsResponseInsightsFiltersNetworkSourceMacTypeDef",
    "ClientGetInsightsResponseInsightsFiltersNetworkSourcePortTypeDef",
    "ClientGetInsightsResponseInsightsFiltersNoteTextTypeDef",
    "ClientGetInsightsResponseInsightsFiltersNoteUpdatedAtDateRangeTypeDef",
    "ClientGetInsightsResponseInsightsFiltersNoteUpdatedAtTypeDef",
    "ClientGetInsightsResponseInsightsFiltersNoteUpdatedByTypeDef",
    "ClientGetInsightsResponseInsightsFiltersProcessLaunchedAtDateRangeTypeDef",
    "ClientGetInsightsResponseInsightsFiltersProcessLaunchedAtTypeDef",
    "ClientGetInsightsResponseInsightsFiltersProcessNameTypeDef",
    "ClientGetInsightsResponseInsightsFiltersProcessParentPidTypeDef",
    "ClientGetInsightsResponseInsightsFiltersProcessPathTypeDef",
    "ClientGetInsightsResponseInsightsFiltersProcessPidTypeDef",
    "ClientGetInsightsResponseInsightsFiltersProcessTerminatedAtDateRangeTypeDef",
    "ClientGetInsightsResponseInsightsFiltersProcessTerminatedAtTypeDef",
    "ClientGetInsightsResponseInsightsFiltersProductArnTypeDef",
    "ClientGetInsightsResponseInsightsFiltersProductFieldsTypeDef",
    "ClientGetInsightsResponseInsightsFiltersProductNameTypeDef",
    "ClientGetInsightsResponseInsightsFiltersRecommendationTextTypeDef",
    "ClientGetInsightsResponseInsightsFiltersRecordStateTypeDef",
    "ClientGetInsightsResponseInsightsFiltersRelatedFindingsIdTypeDef",
    "ClientGetInsightsResponseInsightsFiltersRelatedFindingsProductArnTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceImageIdTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceKeyNameTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceLaunchedAtTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceSubnetIdTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceTypeTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceVpcIdTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourceAwsIamAccessKeyCreatedAtTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourceAwsIamAccessKeyStatusTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourceAwsIamAccessKeyUserNameTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourceAwsS3BucketOwnerIdTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourceAwsS3BucketOwnerNameTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourceContainerImageIdTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourceContainerImageNameTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourceContainerLaunchedAtDateRangeTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourceContainerLaunchedAtTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourceContainerNameTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourceDetailsOtherTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourceIdTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourcePartitionTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourceRegionTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourceTagsTypeDef",
    "ClientGetInsightsResponseInsightsFiltersResourceTypeTypeDef",
    "ClientGetInsightsResponseInsightsFiltersSeverityLabelTypeDef",
    "ClientGetInsightsResponseInsightsFiltersSeverityNormalizedTypeDef",
    "ClientGetInsightsResponseInsightsFiltersSeverityProductTypeDef",
    "ClientGetInsightsResponseInsightsFiltersSourceUrlTypeDef",
    "ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorCategoryTypeDef",
    "ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef",
    "ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorLastObservedAtTypeDef",
    "ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorSourceTypeDef",
    "ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorSourceUrlTypeDef",
    "ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorTypeTypeDef",
    "ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorValueTypeDef",
    "ClientGetInsightsResponseInsightsFiltersTitleTypeDef",
    "ClientGetInsightsResponseInsightsFiltersTypeTypeDef",
    "ClientGetInsightsResponseInsightsFiltersUpdatedAtDateRangeTypeDef",
    "ClientGetInsightsResponseInsightsFiltersUpdatedAtTypeDef",
    "ClientGetInsightsResponseInsightsFiltersUserDefinedFieldsTypeDef",
    "ClientGetInsightsResponseInsightsFiltersVerificationStateTypeDef",
    "ClientGetInsightsResponseInsightsFiltersWorkflowStateTypeDef",
    "ClientGetInsightsResponseInsightsFiltersTypeDef",
    "ClientGetInsightsResponseInsightsTypeDef",
    "ClientGetInsightsResponseTypeDef",
    "ClientGetInvitationsCountResponseTypeDef",
    "ClientGetMasterAccountResponseMasterTypeDef",
    "ClientGetMasterAccountResponseTypeDef",
    "ClientGetMembersResponseMembersTypeDef",
    "ClientGetMembersResponseUnprocessedAccountsTypeDef",
    "ClientGetMembersResponseTypeDef",
    "ClientInviteMembersResponseUnprocessedAccountsTypeDef",
    "ClientInviteMembersResponseTypeDef",
    "ClientListEnabledProductsForImportResponseTypeDef",
    "ClientListInvitationsResponseInvitationsTypeDef",
    "ClientListInvitationsResponseTypeDef",
    "ClientListMembersResponseMembersTypeDef",
    "ClientListMembersResponseTypeDef",
    "ClientListTagsForResourceResponseTypeDef",
    "ClientUpdateFindingsFiltersAwsAccountIdTypeDef",
    "ClientUpdateFindingsFiltersCompanyNameTypeDef",
    "ClientUpdateFindingsFiltersComplianceStatusTypeDef",
    "ClientUpdateFindingsFiltersConfidenceTypeDef",
    "ClientUpdateFindingsFiltersCreatedAtDateRangeTypeDef",
    "ClientUpdateFindingsFiltersCreatedAtTypeDef",
    "ClientUpdateFindingsFiltersCriticalityTypeDef",
    "ClientUpdateFindingsFiltersDescriptionTypeDef",
    "ClientUpdateFindingsFiltersFirstObservedAtDateRangeTypeDef",
    "ClientUpdateFindingsFiltersFirstObservedAtTypeDef",
    "ClientUpdateFindingsFiltersGeneratorIdTypeDef",
    "ClientUpdateFindingsFiltersIdTypeDef",
    "ClientUpdateFindingsFiltersKeywordTypeDef",
    "ClientUpdateFindingsFiltersLastObservedAtDateRangeTypeDef",
    "ClientUpdateFindingsFiltersLastObservedAtTypeDef",
    "ClientUpdateFindingsFiltersMalwareNameTypeDef",
    "ClientUpdateFindingsFiltersMalwarePathTypeDef",
    "ClientUpdateFindingsFiltersMalwareStateTypeDef",
    "ClientUpdateFindingsFiltersMalwareTypeTypeDef",
    "ClientUpdateFindingsFiltersNetworkDestinationDomainTypeDef",
    "ClientUpdateFindingsFiltersNetworkDestinationIpV4TypeDef",
    "ClientUpdateFindingsFiltersNetworkDestinationIpV6TypeDef",
    "ClientUpdateFindingsFiltersNetworkDestinationPortTypeDef",
    "ClientUpdateFindingsFiltersNetworkDirectionTypeDef",
    "ClientUpdateFindingsFiltersNetworkProtocolTypeDef",
    "ClientUpdateFindingsFiltersNetworkSourceDomainTypeDef",
    "ClientUpdateFindingsFiltersNetworkSourceIpV4TypeDef",
    "ClientUpdateFindingsFiltersNetworkSourceIpV6TypeDef",
    "ClientUpdateFindingsFiltersNetworkSourceMacTypeDef",
    "ClientUpdateFindingsFiltersNetworkSourcePortTypeDef",
    "ClientUpdateFindingsFiltersNoteTextTypeDef",
    "ClientUpdateFindingsFiltersNoteUpdatedAtDateRangeTypeDef",
    "ClientUpdateFindingsFiltersNoteUpdatedAtTypeDef",
    "ClientUpdateFindingsFiltersNoteUpdatedByTypeDef",
    "ClientUpdateFindingsFiltersProcessLaunchedAtDateRangeTypeDef",
    "ClientUpdateFindingsFiltersProcessLaunchedAtTypeDef",
    "ClientUpdateFindingsFiltersProcessNameTypeDef",
    "ClientUpdateFindingsFiltersProcessParentPidTypeDef",
    "ClientUpdateFindingsFiltersProcessPathTypeDef",
    "ClientUpdateFindingsFiltersProcessPidTypeDef",
    "ClientUpdateFindingsFiltersProcessTerminatedAtDateRangeTypeDef",
    "ClientUpdateFindingsFiltersProcessTerminatedAtTypeDef",
    "ClientUpdateFindingsFiltersProductArnTypeDef",
    "ClientUpdateFindingsFiltersProductFieldsTypeDef",
    "ClientUpdateFindingsFiltersProductNameTypeDef",
    "ClientUpdateFindingsFiltersRecommendationTextTypeDef",
    "ClientUpdateFindingsFiltersRecordStateTypeDef",
    "ClientUpdateFindingsFiltersRelatedFindingsIdTypeDef",
    "ClientUpdateFindingsFiltersRelatedFindingsProductArnTypeDef",
    "ClientUpdateFindingsFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef",
    "ClientUpdateFindingsFiltersResourceAwsEc2InstanceImageIdTypeDef",
    "ClientUpdateFindingsFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef",
    "ClientUpdateFindingsFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef",
    "ClientUpdateFindingsFiltersResourceAwsEc2InstanceKeyNameTypeDef",
    "ClientUpdateFindingsFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef",
    "ClientUpdateFindingsFiltersResourceAwsEc2InstanceLaunchedAtTypeDef",
    "ClientUpdateFindingsFiltersResourceAwsEc2InstanceSubnetIdTypeDef",
    "ClientUpdateFindingsFiltersResourceAwsEc2InstanceTypeTypeDef",
    "ClientUpdateFindingsFiltersResourceAwsEc2InstanceVpcIdTypeDef",
    "ClientUpdateFindingsFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef",
    "ClientUpdateFindingsFiltersResourceAwsIamAccessKeyCreatedAtTypeDef",
    "ClientUpdateFindingsFiltersResourceAwsIamAccessKeyStatusTypeDef",
    "ClientUpdateFindingsFiltersResourceAwsIamAccessKeyUserNameTypeDef",
    "ClientUpdateFindingsFiltersResourceAwsS3BucketOwnerIdTypeDef",
    "ClientUpdateFindingsFiltersResourceAwsS3BucketOwnerNameTypeDef",
    "ClientUpdateFindingsFiltersResourceContainerImageIdTypeDef",
    "ClientUpdateFindingsFiltersResourceContainerImageNameTypeDef",
    "ClientUpdateFindingsFiltersResourceContainerLaunchedAtDateRangeTypeDef",
    "ClientUpdateFindingsFiltersResourceContainerLaunchedAtTypeDef",
    "ClientUpdateFindingsFiltersResourceContainerNameTypeDef",
    "ClientUpdateFindingsFiltersResourceDetailsOtherTypeDef",
    "ClientUpdateFindingsFiltersResourceIdTypeDef",
    "ClientUpdateFindingsFiltersResourcePartitionTypeDef",
    "ClientUpdateFindingsFiltersResourceRegionTypeDef",
    "ClientUpdateFindingsFiltersResourceTagsTypeDef",
    "ClientUpdateFindingsFiltersResourceTypeTypeDef",
    "ClientUpdateFindingsFiltersSeverityLabelTypeDef",
    "ClientUpdateFindingsFiltersSeverityNormalizedTypeDef",
    "ClientUpdateFindingsFiltersSeverityProductTypeDef",
    "ClientUpdateFindingsFiltersSourceUrlTypeDef",
    "ClientUpdateFindingsFiltersThreatIntelIndicatorCategoryTypeDef",
    "ClientUpdateFindingsFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef",
    "ClientUpdateFindingsFiltersThreatIntelIndicatorLastObservedAtTypeDef",
    "ClientUpdateFindingsFiltersThreatIntelIndicatorSourceTypeDef",
    "ClientUpdateFindingsFiltersThreatIntelIndicatorSourceUrlTypeDef",
    "ClientUpdateFindingsFiltersThreatIntelIndicatorTypeTypeDef",
    "ClientUpdateFindingsFiltersThreatIntelIndicatorValueTypeDef",
    "ClientUpdateFindingsFiltersTitleTypeDef",
    "ClientUpdateFindingsFiltersTypeTypeDef",
    "ClientUpdateFindingsFiltersUpdatedAtDateRangeTypeDef",
    "ClientUpdateFindingsFiltersUpdatedAtTypeDef",
    "ClientUpdateFindingsFiltersUserDefinedFieldsTypeDef",
    "ClientUpdateFindingsFiltersVerificationStateTypeDef",
    "ClientUpdateFindingsFiltersWorkflowStateTypeDef",
    "ClientUpdateFindingsFiltersTypeDef",
    "ClientUpdateFindingsNoteTypeDef",
    "ClientUpdateInsightFiltersAwsAccountIdTypeDef",
    "ClientUpdateInsightFiltersCompanyNameTypeDef",
    "ClientUpdateInsightFiltersComplianceStatusTypeDef",
    "ClientUpdateInsightFiltersConfidenceTypeDef",
    "ClientUpdateInsightFiltersCreatedAtDateRangeTypeDef",
    "ClientUpdateInsightFiltersCreatedAtTypeDef",
    "ClientUpdateInsightFiltersCriticalityTypeDef",
    "ClientUpdateInsightFiltersDescriptionTypeDef",
    "ClientUpdateInsightFiltersFirstObservedAtDateRangeTypeDef",
    "ClientUpdateInsightFiltersFirstObservedAtTypeDef",
    "ClientUpdateInsightFiltersGeneratorIdTypeDef",
    "ClientUpdateInsightFiltersIdTypeDef",
    "ClientUpdateInsightFiltersKeywordTypeDef",
    "ClientUpdateInsightFiltersLastObservedAtDateRangeTypeDef",
    "ClientUpdateInsightFiltersLastObservedAtTypeDef",
    "ClientUpdateInsightFiltersMalwareNameTypeDef",
    "ClientUpdateInsightFiltersMalwarePathTypeDef",
    "ClientUpdateInsightFiltersMalwareStateTypeDef",
    "ClientUpdateInsightFiltersMalwareTypeTypeDef",
    "ClientUpdateInsightFiltersNetworkDestinationDomainTypeDef",
    "ClientUpdateInsightFiltersNetworkDestinationIpV4TypeDef",
    "ClientUpdateInsightFiltersNetworkDestinationIpV6TypeDef",
    "ClientUpdateInsightFiltersNetworkDestinationPortTypeDef",
    "ClientUpdateInsightFiltersNetworkDirectionTypeDef",
    "ClientUpdateInsightFiltersNetworkProtocolTypeDef",
    "ClientUpdateInsightFiltersNetworkSourceDomainTypeDef",
    "ClientUpdateInsightFiltersNetworkSourceIpV4TypeDef",
    "ClientUpdateInsightFiltersNetworkSourceIpV6TypeDef",
    "ClientUpdateInsightFiltersNetworkSourceMacTypeDef",
    "ClientUpdateInsightFiltersNetworkSourcePortTypeDef",
    "ClientUpdateInsightFiltersNoteTextTypeDef",
    "ClientUpdateInsightFiltersNoteUpdatedAtDateRangeTypeDef",
    "ClientUpdateInsightFiltersNoteUpdatedAtTypeDef",
    "ClientUpdateInsightFiltersNoteUpdatedByTypeDef",
    "ClientUpdateInsightFiltersProcessLaunchedAtDateRangeTypeDef",
    "ClientUpdateInsightFiltersProcessLaunchedAtTypeDef",
    "ClientUpdateInsightFiltersProcessNameTypeDef",
    "ClientUpdateInsightFiltersProcessParentPidTypeDef",
    "ClientUpdateInsightFiltersProcessPathTypeDef",
    "ClientUpdateInsightFiltersProcessPidTypeDef",
    "ClientUpdateInsightFiltersProcessTerminatedAtDateRangeTypeDef",
    "ClientUpdateInsightFiltersProcessTerminatedAtTypeDef",
    "ClientUpdateInsightFiltersProductArnTypeDef",
    "ClientUpdateInsightFiltersProductFieldsTypeDef",
    "ClientUpdateInsightFiltersProductNameTypeDef",
    "ClientUpdateInsightFiltersRecommendationTextTypeDef",
    "ClientUpdateInsightFiltersRecordStateTypeDef",
    "ClientUpdateInsightFiltersRelatedFindingsIdTypeDef",
    "ClientUpdateInsightFiltersRelatedFindingsProductArnTypeDef",
    "ClientUpdateInsightFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef",
    "ClientUpdateInsightFiltersResourceAwsEc2InstanceImageIdTypeDef",
    "ClientUpdateInsightFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef",
    "ClientUpdateInsightFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef",
    "ClientUpdateInsightFiltersResourceAwsEc2InstanceKeyNameTypeDef",
    "ClientUpdateInsightFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef",
    "ClientUpdateInsightFiltersResourceAwsEc2InstanceLaunchedAtTypeDef",
    "ClientUpdateInsightFiltersResourceAwsEc2InstanceSubnetIdTypeDef",
    "ClientUpdateInsightFiltersResourceAwsEc2InstanceTypeTypeDef",
    "ClientUpdateInsightFiltersResourceAwsEc2InstanceVpcIdTypeDef",
    "ClientUpdateInsightFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef",
    "ClientUpdateInsightFiltersResourceAwsIamAccessKeyCreatedAtTypeDef",
    "ClientUpdateInsightFiltersResourceAwsIamAccessKeyStatusTypeDef",
    "ClientUpdateInsightFiltersResourceAwsIamAccessKeyUserNameTypeDef",
    "ClientUpdateInsightFiltersResourceAwsS3BucketOwnerIdTypeDef",
    "ClientUpdateInsightFiltersResourceAwsS3BucketOwnerNameTypeDef",
    "ClientUpdateInsightFiltersResourceContainerImageIdTypeDef",
    "ClientUpdateInsightFiltersResourceContainerImageNameTypeDef",
    "ClientUpdateInsightFiltersResourceContainerLaunchedAtDateRangeTypeDef",
    "ClientUpdateInsightFiltersResourceContainerLaunchedAtTypeDef",
    "ClientUpdateInsightFiltersResourceContainerNameTypeDef",
    "ClientUpdateInsightFiltersResourceDetailsOtherTypeDef",
    "ClientUpdateInsightFiltersResourceIdTypeDef",
    "ClientUpdateInsightFiltersResourcePartitionTypeDef",
    "ClientUpdateInsightFiltersResourceRegionTypeDef",
    "ClientUpdateInsightFiltersResourceTagsTypeDef",
    "ClientUpdateInsightFiltersResourceTypeTypeDef",
    "ClientUpdateInsightFiltersSeverityLabelTypeDef",
    "ClientUpdateInsightFiltersSeverityNormalizedTypeDef",
    "ClientUpdateInsightFiltersSeverityProductTypeDef",
    "ClientUpdateInsightFiltersSourceUrlTypeDef",
    "ClientUpdateInsightFiltersThreatIntelIndicatorCategoryTypeDef",
    "ClientUpdateInsightFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef",
    "ClientUpdateInsightFiltersThreatIntelIndicatorLastObservedAtTypeDef",
    "ClientUpdateInsightFiltersThreatIntelIndicatorSourceTypeDef",
    "ClientUpdateInsightFiltersThreatIntelIndicatorSourceUrlTypeDef",
    "ClientUpdateInsightFiltersThreatIntelIndicatorTypeTypeDef",
    "ClientUpdateInsightFiltersThreatIntelIndicatorValueTypeDef",
    "ClientUpdateInsightFiltersTitleTypeDef",
    "ClientUpdateInsightFiltersTypeTypeDef",
    "ClientUpdateInsightFiltersUpdatedAtDateRangeTypeDef",
    "ClientUpdateInsightFiltersUpdatedAtTypeDef",
    "ClientUpdateInsightFiltersUserDefinedFieldsTypeDef",
    "ClientUpdateInsightFiltersVerificationStateTypeDef",
    "ClientUpdateInsightFiltersWorkflowStateTypeDef",
    "ClientUpdateInsightFiltersTypeDef",
    "GetEnabledStandardsPaginatePaginationConfigTypeDef",
    "GetEnabledStandardsPaginateResponseStandardsSubscriptionsTypeDef",
    "GetEnabledStandardsPaginateResponseTypeDef",
    "GetFindingsPaginateFiltersAwsAccountIdTypeDef",
    "GetFindingsPaginateFiltersCompanyNameTypeDef",
    "GetFindingsPaginateFiltersComplianceStatusTypeDef",
    "GetFindingsPaginateFiltersConfidenceTypeDef",
    "GetFindingsPaginateFiltersCreatedAtDateRangeTypeDef",
    "GetFindingsPaginateFiltersCreatedAtTypeDef",
    "GetFindingsPaginateFiltersCriticalityTypeDef",
    "GetFindingsPaginateFiltersDescriptionTypeDef",
    "GetFindingsPaginateFiltersFirstObservedAtDateRangeTypeDef",
    "GetFindingsPaginateFiltersFirstObservedAtTypeDef",
    "GetFindingsPaginateFiltersGeneratorIdTypeDef",
    "GetFindingsPaginateFiltersIdTypeDef",
    "GetFindingsPaginateFiltersKeywordTypeDef",
    "GetFindingsPaginateFiltersLastObservedAtDateRangeTypeDef",
    "GetFindingsPaginateFiltersLastObservedAtTypeDef",
    "GetFindingsPaginateFiltersMalwareNameTypeDef",
    "GetFindingsPaginateFiltersMalwarePathTypeDef",
    "GetFindingsPaginateFiltersMalwareStateTypeDef",
    "GetFindingsPaginateFiltersMalwareTypeTypeDef",
    "GetFindingsPaginateFiltersNetworkDestinationDomainTypeDef",
    "GetFindingsPaginateFiltersNetworkDestinationIpV4TypeDef",
    "GetFindingsPaginateFiltersNetworkDestinationIpV6TypeDef",
    "GetFindingsPaginateFiltersNetworkDestinationPortTypeDef",
    "GetFindingsPaginateFiltersNetworkDirectionTypeDef",
    "GetFindingsPaginateFiltersNetworkProtocolTypeDef",
    "GetFindingsPaginateFiltersNetworkSourceDomainTypeDef",
    "GetFindingsPaginateFiltersNetworkSourceIpV4TypeDef",
    "GetFindingsPaginateFiltersNetworkSourceIpV6TypeDef",
    "GetFindingsPaginateFiltersNetworkSourceMacTypeDef",
    "GetFindingsPaginateFiltersNetworkSourcePortTypeDef",
    "GetFindingsPaginateFiltersNoteTextTypeDef",
    "GetFindingsPaginateFiltersNoteUpdatedAtDateRangeTypeDef",
    "GetFindingsPaginateFiltersNoteUpdatedAtTypeDef",
    "GetFindingsPaginateFiltersNoteUpdatedByTypeDef",
    "GetFindingsPaginateFiltersProcessLaunchedAtDateRangeTypeDef",
    "GetFindingsPaginateFiltersProcessLaunchedAtTypeDef",
    "GetFindingsPaginateFiltersProcessNameTypeDef",
    "GetFindingsPaginateFiltersProcessParentPidTypeDef",
    "GetFindingsPaginateFiltersProcessPathTypeDef",
    "GetFindingsPaginateFiltersProcessPidTypeDef",
    "GetFindingsPaginateFiltersProcessTerminatedAtDateRangeTypeDef",
    "GetFindingsPaginateFiltersProcessTerminatedAtTypeDef",
    "GetFindingsPaginateFiltersProductArnTypeDef",
    "GetFindingsPaginateFiltersProductFieldsTypeDef",
    "GetFindingsPaginateFiltersProductNameTypeDef",
    "GetFindingsPaginateFiltersRecommendationTextTypeDef",
    "GetFindingsPaginateFiltersRecordStateTypeDef",
    "GetFindingsPaginateFiltersRelatedFindingsIdTypeDef",
    "GetFindingsPaginateFiltersRelatedFindingsProductArnTypeDef",
    "GetFindingsPaginateFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef",
    "GetFindingsPaginateFiltersResourceAwsEc2InstanceImageIdTypeDef",
    "GetFindingsPaginateFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef",
    "GetFindingsPaginateFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef",
    "GetFindingsPaginateFiltersResourceAwsEc2InstanceKeyNameTypeDef",
    "GetFindingsPaginateFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef",
    "GetFindingsPaginateFiltersResourceAwsEc2InstanceLaunchedAtTypeDef",
    "GetFindingsPaginateFiltersResourceAwsEc2InstanceSubnetIdTypeDef",
    "GetFindingsPaginateFiltersResourceAwsEc2InstanceTypeTypeDef",
    "GetFindingsPaginateFiltersResourceAwsEc2InstanceVpcIdTypeDef",
    "GetFindingsPaginateFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef",
    "GetFindingsPaginateFiltersResourceAwsIamAccessKeyCreatedAtTypeDef",
    "GetFindingsPaginateFiltersResourceAwsIamAccessKeyStatusTypeDef",
    "GetFindingsPaginateFiltersResourceAwsIamAccessKeyUserNameTypeDef",
    "GetFindingsPaginateFiltersResourceAwsS3BucketOwnerIdTypeDef",
    "GetFindingsPaginateFiltersResourceAwsS3BucketOwnerNameTypeDef",
    "GetFindingsPaginateFiltersResourceContainerImageIdTypeDef",
    "GetFindingsPaginateFiltersResourceContainerImageNameTypeDef",
    "GetFindingsPaginateFiltersResourceContainerLaunchedAtDateRangeTypeDef",
    "GetFindingsPaginateFiltersResourceContainerLaunchedAtTypeDef",
    "GetFindingsPaginateFiltersResourceContainerNameTypeDef",
    "GetFindingsPaginateFiltersResourceDetailsOtherTypeDef",
    "GetFindingsPaginateFiltersResourceIdTypeDef",
    "GetFindingsPaginateFiltersResourcePartitionTypeDef",
    "GetFindingsPaginateFiltersResourceRegionTypeDef",
    "GetFindingsPaginateFiltersResourceTagsTypeDef",
    "GetFindingsPaginateFiltersResourceTypeTypeDef",
    "GetFindingsPaginateFiltersSeverityLabelTypeDef",
    "GetFindingsPaginateFiltersSeverityNormalizedTypeDef",
    "GetFindingsPaginateFiltersSeverityProductTypeDef",
    "GetFindingsPaginateFiltersSourceUrlTypeDef",
    "GetFindingsPaginateFiltersThreatIntelIndicatorCategoryTypeDef",
    "GetFindingsPaginateFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef",
    "GetFindingsPaginateFiltersThreatIntelIndicatorLastObservedAtTypeDef",
    "GetFindingsPaginateFiltersThreatIntelIndicatorSourceTypeDef",
    "GetFindingsPaginateFiltersThreatIntelIndicatorSourceUrlTypeDef",
    "GetFindingsPaginateFiltersThreatIntelIndicatorTypeTypeDef",
    "GetFindingsPaginateFiltersThreatIntelIndicatorValueTypeDef",
    "GetFindingsPaginateFiltersTitleTypeDef",
    "GetFindingsPaginateFiltersTypeTypeDef",
    "GetFindingsPaginateFiltersUpdatedAtDateRangeTypeDef",
    "GetFindingsPaginateFiltersUpdatedAtTypeDef",
    "GetFindingsPaginateFiltersUserDefinedFieldsTypeDef",
    "GetFindingsPaginateFiltersVerificationStateTypeDef",
    "GetFindingsPaginateFiltersWorkflowStateTypeDef",
    "GetFindingsPaginateFiltersTypeDef",
    "GetFindingsPaginatePaginationConfigTypeDef",
    "GetFindingsPaginateResponseFindingsComplianceTypeDef",
    "GetFindingsPaginateResponseFindingsMalwareTypeDef",
    "GetFindingsPaginateResponseFindingsNetworkTypeDef",
    "GetFindingsPaginateResponseFindingsNoteTypeDef",
    "GetFindingsPaginateResponseFindingsProcessTypeDef",
    "GetFindingsPaginateResponseFindingsRelatedFindingsTypeDef",
    "GetFindingsPaginateResponseFindingsRemediationRecommendationTypeDef",
    "GetFindingsPaginateResponseFindingsRemediationTypeDef",
    "GetFindingsPaginateResponseFindingsResourcesDetailsAwsEc2InstanceTypeDef",
    "GetFindingsPaginateResponseFindingsResourcesDetailsAwsIamAccessKeyTypeDef",
    "GetFindingsPaginateResponseFindingsResourcesDetailsAwsS3BucketTypeDef",
    "GetFindingsPaginateResponseFindingsResourcesDetailsContainerTypeDef",
    "GetFindingsPaginateResponseFindingsResourcesDetailsTypeDef",
    "GetFindingsPaginateResponseFindingsResourcesTypeDef",
    "GetFindingsPaginateResponseFindingsSeverityTypeDef",
    "GetFindingsPaginateResponseFindingsThreatIntelIndicatorsTypeDef",
    "GetFindingsPaginateResponseFindingsTypeDef",
    "GetFindingsPaginateResponseTypeDef",
    "GetFindingsPaginateSortCriteriaTypeDef",
    "GetInsightsPaginatePaginationConfigTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersAwsAccountIdTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersCompanyNameTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersComplianceStatusTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersConfidenceTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersCreatedAtDateRangeTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersCreatedAtTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersCriticalityTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersDescriptionTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersFirstObservedAtDateRangeTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersFirstObservedAtTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersGeneratorIdTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersIdTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersKeywordTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersLastObservedAtDateRangeTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersLastObservedAtTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersMalwareNameTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersMalwarePathTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersMalwareStateTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersMalwareTypeTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersNetworkDestinationDomainTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersNetworkDestinationIpV4TypeDef",
    "GetInsightsPaginateResponseInsightsFiltersNetworkDestinationIpV6TypeDef",
    "GetInsightsPaginateResponseInsightsFiltersNetworkDestinationPortTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersNetworkDirectionTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersNetworkProtocolTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersNetworkSourceDomainTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersNetworkSourceIpV4TypeDef",
    "GetInsightsPaginateResponseInsightsFiltersNetworkSourceIpV6TypeDef",
    "GetInsightsPaginateResponseInsightsFiltersNetworkSourceMacTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersNetworkSourcePortTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersNoteTextTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersNoteUpdatedAtDateRangeTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersNoteUpdatedAtTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersNoteUpdatedByTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersProcessLaunchedAtDateRangeTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersProcessLaunchedAtTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersProcessNameTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersProcessParentPidTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersProcessPathTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersProcessPidTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersProcessTerminatedAtDateRangeTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersProcessTerminatedAtTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersProductArnTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersProductFieldsTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersProductNameTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersRecommendationTextTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersRecordStateTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersRelatedFindingsIdTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersRelatedFindingsProductArnTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceImageIdTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceKeyNameTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceLaunchedAtTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceSubnetIdTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceTypeTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceVpcIdTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourceAwsIamAccessKeyCreatedAtTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourceAwsIamAccessKeyStatusTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourceAwsIamAccessKeyUserNameTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourceAwsS3BucketOwnerIdTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourceAwsS3BucketOwnerNameTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourceContainerImageIdTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourceContainerImageNameTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourceContainerLaunchedAtDateRangeTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourceContainerLaunchedAtTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourceContainerNameTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourceDetailsOtherTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourceIdTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourcePartitionTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourceRegionTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourceTagsTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersResourceTypeTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersSeverityLabelTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersSeverityNormalizedTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersSeverityProductTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersSourceUrlTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorCategoryTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorLastObservedAtTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorSourceTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorSourceUrlTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorTypeTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorValueTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersTitleTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersTypeTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersUpdatedAtDateRangeTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersUpdatedAtTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersUserDefinedFieldsTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersVerificationStateTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersWorkflowStateTypeDef",
    "GetInsightsPaginateResponseInsightsFiltersTypeDef",
    "GetInsightsPaginateResponseInsightsTypeDef",
    "GetInsightsPaginateResponseTypeDef",
    "ListEnabledProductsForImportPaginatePaginationConfigTypeDef",
    "ListEnabledProductsForImportPaginateResponseTypeDef",
    "ListInvitationsPaginatePaginationConfigTypeDef",
    "ListInvitationsPaginateResponseInvitationsTypeDef",
    "ListInvitationsPaginateResponseTypeDef",
    "ListMembersPaginatePaginationConfigTypeDef",
    "ListMembersPaginateResponseMembersTypeDef",
    "ListMembersPaginateResponseTypeDef",
)


_ClientBatchDisableStandardsResponseStandardsSubscriptionsTypeDef = TypedDict(
    "_ClientBatchDisableStandardsResponseStandardsSubscriptionsTypeDef",
    {
        "StandardsSubscriptionArn": str,
        "StandardsArn": str,
        "StandardsInput": Dict[str, str],
        "StandardsStatus": str,
    },
    total=False,
)


class ClientBatchDisableStandardsResponseStandardsSubscriptionsTypeDef(
    _ClientBatchDisableStandardsResponseStandardsSubscriptionsTypeDef
):
    """
    Type definition for `ClientBatchDisableStandardsResponse` `StandardsSubscriptions`

    A resource that represents your subscription to a supported standard.

    - **StandardsSubscriptionArn** *(string) --*

      The ARN of a resource that represents your subscription to a supported standard.

    - **StandardsArn** *(string) --*

      The ARN of a standard.

      In this release, Security Hub supports only the CIS AWS Foundations standard, which uses the
      following ARN: ``arn:aws:securityhub:::ruleset/cis-aws-foundations-benchmark/v/1.2.0.``

    - **StandardsInput** *(dict) --*

      A key-value pair of input for the standard.

      - *(string) --*

        - *(string) --*

    - **StandardsStatus** *(string) --*

      The status of the standards subscription.
    """


_ClientBatchDisableStandardsResponseTypeDef = TypedDict(
    "_ClientBatchDisableStandardsResponseTypeDef",
    {
        "StandardsSubscriptions": List[
            ClientBatchDisableStandardsResponseStandardsSubscriptionsTypeDef
        ]
    },
    total=False,
)


class ClientBatchDisableStandardsResponseTypeDef(_ClientBatchDisableStandardsResponseTypeDef):
    """
    Type definition for `ClientBatchDisableStandards` `Response`

    - **StandardsSubscriptions** *(list) --*

      The details of the standards subscriptions that were disabled.

      - *(dict) --*

        A resource that represents your subscription to a supported standard.

        - **StandardsSubscriptionArn** *(string) --*

          The ARN of a resource that represents your subscription to a supported standard.

        - **StandardsArn** *(string) --*

          The ARN of a standard.

          In this release, Security Hub supports only the CIS AWS Foundations standard, which uses
          the following ARN:
          ``arn:aws:securityhub:::ruleset/cis-aws-foundations-benchmark/v/1.2.0.``

        - **StandardsInput** *(dict) --*

          A key-value pair of input for the standard.

          - *(string) --*

            - *(string) --*

        - **StandardsStatus** *(string) --*

          The status of the standards subscription.
    """


_ClientBatchEnableStandardsResponseStandardsSubscriptionsTypeDef = TypedDict(
    "_ClientBatchEnableStandardsResponseStandardsSubscriptionsTypeDef",
    {
        "StandardsSubscriptionArn": str,
        "StandardsArn": str,
        "StandardsInput": Dict[str, str],
        "StandardsStatus": str,
    },
    total=False,
)


class ClientBatchEnableStandardsResponseStandardsSubscriptionsTypeDef(
    _ClientBatchEnableStandardsResponseStandardsSubscriptionsTypeDef
):
    """
    Type definition for `ClientBatchEnableStandardsResponse` `StandardsSubscriptions`

    A resource that represents your subscription to a supported standard.

    - **StandardsSubscriptionArn** *(string) --*

      The ARN of a resource that represents your subscription to a supported standard.

    - **StandardsArn** *(string) --*

      The ARN of a standard.

      In this release, Security Hub supports only the CIS AWS Foundations standard, which uses the
      following ARN: ``arn:aws:securityhub:::ruleset/cis-aws-foundations-benchmark/v/1.2.0.``

    - **StandardsInput** *(dict) --*

      A key-value pair of input for the standard.

      - *(string) --*

        - *(string) --*

    - **StandardsStatus** *(string) --*

      The status of the standards subscription.
    """


_ClientBatchEnableStandardsResponseTypeDef = TypedDict(
    "_ClientBatchEnableStandardsResponseTypeDef",
    {
        "StandardsSubscriptions": List[
            ClientBatchEnableStandardsResponseStandardsSubscriptionsTypeDef
        ]
    },
    total=False,
)


class ClientBatchEnableStandardsResponseTypeDef(_ClientBatchEnableStandardsResponseTypeDef):
    """
    Type definition for `ClientBatchEnableStandards` `Response`

    - **StandardsSubscriptions** *(list) --*

      The details of the standards subscriptions that were enabled.

      - *(dict) --*

        A resource that represents your subscription to a supported standard.

        - **StandardsSubscriptionArn** *(string) --*

          The ARN of a resource that represents your subscription to a supported standard.

        - **StandardsArn** *(string) --*

          The ARN of a standard.

          In this release, Security Hub supports only the CIS AWS Foundations standard, which uses
          the following ARN:
          ``arn:aws:securityhub:::ruleset/cis-aws-foundations-benchmark/v/1.2.0.``

        - **StandardsInput** *(dict) --*

          A key-value pair of input for the standard.

          - *(string) --*

            - *(string) --*

        - **StandardsStatus** *(string) --*

          The status of the standards subscription.
    """


_RequiredClientBatchEnableStandardsStandardsSubscriptionRequestsTypeDef = TypedDict(
    "_RequiredClientBatchEnableStandardsStandardsSubscriptionRequestsTypeDef", {"StandardsArn": str}
)
_OptionalClientBatchEnableStandardsStandardsSubscriptionRequestsTypeDef = TypedDict(
    "_OptionalClientBatchEnableStandardsStandardsSubscriptionRequestsTypeDef",
    {"StandardsInput": Dict[str, str]},
    total=False,
)


class ClientBatchEnableStandardsStandardsSubscriptionRequestsTypeDef(
    _RequiredClientBatchEnableStandardsStandardsSubscriptionRequestsTypeDef,
    _OptionalClientBatchEnableStandardsStandardsSubscriptionRequestsTypeDef,
):
    """
    Type definition for `ClientBatchEnableStandards` `StandardsSubscriptionRequests`

    The standard that you want to enable.

    - **StandardsArn** *(string) --* **[REQUIRED]**

      The ARN of the standard that you want to enable.

      .. warning::

        In this release, Security Hub only supports the CIS AWS Foundations standard.

        Its ARN is ``arn:aws:securityhub:::ruleset/cis-aws-foundations-benchmark/v/1.2.0`` .

    - **StandardsInput** *(dict) --*

      A key-value pair of input for the standard.

      - *(string) --*

        - *(string) --*
    """


_ClientBatchImportFindingsFindingsComplianceTypeDef = TypedDict(
    "_ClientBatchImportFindingsFindingsComplianceTypeDef", {"Status": str}, total=False
)


class ClientBatchImportFindingsFindingsComplianceTypeDef(
    _ClientBatchImportFindingsFindingsComplianceTypeDef
):
    """
    Type definition for `ClientBatchImportFindingsFindings` `Compliance`

    This data type is exclusive to findings that are generated as the result of a check run against
    a specific rule in a supported standard (for example, CIS AWS Foundations). Contains
    compliance-related finding details.

    - **Status** *(string) --*

      The result of a compliance check.
    """


_RequiredClientBatchImportFindingsFindingsMalwareTypeDef = TypedDict(
    "_RequiredClientBatchImportFindingsFindingsMalwareTypeDef", {"Name": str}
)
_OptionalClientBatchImportFindingsFindingsMalwareTypeDef = TypedDict(
    "_OptionalClientBatchImportFindingsFindingsMalwareTypeDef",
    {"Type": str, "Path": str, "State": str},
    total=False,
)


class ClientBatchImportFindingsFindingsMalwareTypeDef(
    _RequiredClientBatchImportFindingsFindingsMalwareTypeDef,
    _OptionalClientBatchImportFindingsFindingsMalwareTypeDef,
):
    """
    Type definition for `ClientBatchImportFindingsFindings` `Malware`

    A list of malware related to a finding.

    - **Name** *(string) --* **[REQUIRED]**

      The name of the malware that was observed.

    - **Type** *(string) --*

      The type of the malware that was observed.

    - **Path** *(string) --*

      The file system path of the malware that was observed.

    - **State** *(string) --*

      The state of the malware that was observed.
    """


_ClientBatchImportFindingsFindingsNetworkTypeDef = TypedDict(
    "_ClientBatchImportFindingsFindingsNetworkTypeDef",
    {
        "Direction": str,
        "Protocol": str,
        "SourceIpV4": str,
        "SourceIpV6": str,
        "SourcePort": int,
        "SourceDomain": str,
        "SourceMac": str,
        "DestinationIpV4": str,
        "DestinationIpV6": str,
        "DestinationPort": int,
        "DestinationDomain": str,
    },
    total=False,
)


class ClientBatchImportFindingsFindingsNetworkTypeDef(
    _ClientBatchImportFindingsFindingsNetworkTypeDef
):
    """
    Type definition for `ClientBatchImportFindingsFindings` `Network`

    The details of network-related information about a finding.

    - **Direction** *(string) --*

      The direction of network traffic associated with a finding.

    - **Protocol** *(string) --*

      The protocol of network-related information about a finding.

    - **SourceIpV4** *(string) --*

      The source IPv4 address of network-related information about a finding.

    - **SourceIpV6** *(string) --*

      The source IPv6 address of network-related information about a finding.

    - **SourcePort** *(integer) --*

      The source port of network-related information about a finding.

    - **SourceDomain** *(string) --*

      The source domain of network-related information about a finding.

    - **SourceMac** *(string) --*

      The source media access control (MAC) address of network-related information about a finding.

    - **DestinationIpV4** *(string) --*

      The destination IPv4 address of network-related information about a finding.

    - **DestinationIpV6** *(string) --*

      The destination IPv6 address of network-related information about a finding.

    - **DestinationPort** *(integer) --*

      The destination port of network-related information about a finding.

    - **DestinationDomain** *(string) --*

      The destination domain of network-related information about a finding.
    """


_ClientBatchImportFindingsFindingsNoteTypeDef = TypedDict(
    "_ClientBatchImportFindingsFindingsNoteTypeDef",
    {"Text": str, "UpdatedBy": str, "UpdatedAt": str},
)


class ClientBatchImportFindingsFindingsNoteTypeDef(_ClientBatchImportFindingsFindingsNoteTypeDef):
    """
    Type definition for `ClientBatchImportFindingsFindings` `Note`

    A user-defined note added to a finding.

    - **Text** *(string) --* **[REQUIRED]**

      The text of a note.

    - **UpdatedBy** *(string) --* **[REQUIRED]**

      The principal that created a note.

    - **UpdatedAt** *(string) --* **[REQUIRED]**

      The timestamp of when the note was updated.
    """


_ClientBatchImportFindingsFindingsProcessTypeDef = TypedDict(
    "_ClientBatchImportFindingsFindingsProcessTypeDef",
    {
        "Name": str,
        "Path": str,
        "Pid": int,
        "ParentPid": int,
        "LaunchedAt": str,
        "TerminatedAt": str,
    },
    total=False,
)


class ClientBatchImportFindingsFindingsProcessTypeDef(
    _ClientBatchImportFindingsFindingsProcessTypeDef
):
    """
    Type definition for `ClientBatchImportFindingsFindings` `Process`

    The details of process-related information about a finding.

    - **Name** *(string) --*

      The name of the process.

    - **Path** *(string) --*

      The path to the process executable.

    - **Pid** *(integer) --*

      The process ID.

    - **ParentPid** *(integer) --*

      The parent process ID.

    - **LaunchedAt** *(string) --*

      The date/time that the process was launched.

    - **TerminatedAt** *(string) --*

      The date and time when the process was terminated.
    """


_ClientBatchImportFindingsFindingsRelatedFindingsTypeDef = TypedDict(
    "_ClientBatchImportFindingsFindingsRelatedFindingsTypeDef", {"ProductArn": str, "Id": str}
)


class ClientBatchImportFindingsFindingsRelatedFindingsTypeDef(
    _ClientBatchImportFindingsFindingsRelatedFindingsTypeDef
):
    """
    Type definition for `ClientBatchImportFindingsFindings` `RelatedFindings`

    Details about a related finding.

    - **ProductArn** *(string) --* **[REQUIRED]**

      The ARN of the product that generated a related finding.

    - **Id** *(string) --* **[REQUIRED]**

      The product-generated identifier for a related finding.
    """


_ClientBatchImportFindingsFindingsRemediationRecommendationTypeDef = TypedDict(
    "_ClientBatchImportFindingsFindingsRemediationRecommendationTypeDef",
    {"Text": str, "Url": str},
    total=False,
)


class ClientBatchImportFindingsFindingsRemediationRecommendationTypeDef(
    _ClientBatchImportFindingsFindingsRemediationRecommendationTypeDef
):
    """
    Type definition for `ClientBatchImportFindingsFindingsRemediation` `Recommendation`

    A recommendation on the steps to take to remediate the issue identified by a finding.

    - **Text** *(string) --*

      Describes the recommended steps to take to remediate an issue identified in a finding.

    - **Url** *(string) --*

      A URL to a page or site that contains information about how to remediate a finding.
    """


_ClientBatchImportFindingsFindingsRemediationTypeDef = TypedDict(
    "_ClientBatchImportFindingsFindingsRemediationTypeDef",
    {"Recommendation": ClientBatchImportFindingsFindingsRemediationRecommendationTypeDef},
    total=False,
)


class ClientBatchImportFindingsFindingsRemediationTypeDef(
    _ClientBatchImportFindingsFindingsRemediationTypeDef
):
    """
    Type definition for `ClientBatchImportFindingsFindings` `Remediation`

    A data type that describes the remediation options for a finding.

    - **Recommendation** *(dict) --*

      A recommendation on the steps to take to remediate the issue identified by a finding.

      - **Text** *(string) --*

        Describes the recommended steps to take to remediate an issue identified in a finding.

      - **Url** *(string) --*

        A URL to a page or site that contains information about how to remediate a finding.
    """


_ClientBatchImportFindingsFindingsResourcesDetailsAwsEc2InstanceTypeDef = TypedDict(
    "_ClientBatchImportFindingsFindingsResourcesDetailsAwsEc2InstanceTypeDef",
    {
        "Type": str,
        "ImageId": str,
        "IpV4Addresses": List[str],
        "IpV6Addresses": List[str],
        "KeyName": str,
        "IamInstanceProfileArn": str,
        "VpcId": str,
        "SubnetId": str,
        "LaunchedAt": str,
    },
    total=False,
)


class ClientBatchImportFindingsFindingsResourcesDetailsAwsEc2InstanceTypeDef(
    _ClientBatchImportFindingsFindingsResourcesDetailsAwsEc2InstanceTypeDef
):
    """
    Type definition for `ClientBatchImportFindingsFindingsResourcesDetails` `AwsEc2Instance`

    Details about an Amazon EC2 instance related to a finding.

    - **Type** *(string) --*

      The instance type of the instance.

    - **ImageId** *(string) --*

      The Amazon Machine Image (AMI) ID of the instance.

    - **IpV4Addresses** *(list) --*

      The IPv4 addresses associated with the instance.

      - *(string) --*

    - **IpV6Addresses** *(list) --*

      The IPv6 addresses associated with the instance.

      - *(string) --*

    - **KeyName** *(string) --*

      The key name associated with the instance.

    - **IamInstanceProfileArn** *(string) --*

      The IAM profile ARN of the instance.

    - **VpcId** *(string) --*

      The identifier of the VPC that the instance was launched in.

    - **SubnetId** *(string) --*

      The identifier of the subnet that the instance was launched in.

    - **LaunchedAt** *(string) --*

      The date/time the instance was launched.
    """


_ClientBatchImportFindingsFindingsResourcesDetailsAwsIamAccessKeyTypeDef = TypedDict(
    "_ClientBatchImportFindingsFindingsResourcesDetailsAwsIamAccessKeyTypeDef",
    {"UserName": str, "Status": str, "CreatedAt": str},
    total=False,
)


class ClientBatchImportFindingsFindingsResourcesDetailsAwsIamAccessKeyTypeDef(
    _ClientBatchImportFindingsFindingsResourcesDetailsAwsIamAccessKeyTypeDef
):
    """
    Type definition for `ClientBatchImportFindingsFindingsResourcesDetails` `AwsIamAccessKey`

    Details about an IAM access key related to a finding.

    - **UserName** *(string) --*

      The user associated with the IAM access key related to a finding.

    - **Status** *(string) --*

      The status of the IAM access key related to a finding.

    - **CreatedAt** *(string) --*

      The creation date/time of the IAM access key related to a finding.
    """


_ClientBatchImportFindingsFindingsResourcesDetailsAwsS3BucketTypeDef = TypedDict(
    "_ClientBatchImportFindingsFindingsResourcesDetailsAwsS3BucketTypeDef",
    {"OwnerId": str, "OwnerName": str},
    total=False,
)


class ClientBatchImportFindingsFindingsResourcesDetailsAwsS3BucketTypeDef(
    _ClientBatchImportFindingsFindingsResourcesDetailsAwsS3BucketTypeDef
):
    """
    Type definition for `ClientBatchImportFindingsFindingsResourcesDetails` `AwsS3Bucket`

    Details about an Amazon S3 Bucket related to a finding.

    - **OwnerId** *(string) --*

      The canonical user ID of the owner of the S3 bucket.

    - **OwnerName** *(string) --*

      The display name of the owner of the S3 bucket.
    """


_ClientBatchImportFindingsFindingsResourcesDetailsContainerTypeDef = TypedDict(
    "_ClientBatchImportFindingsFindingsResourcesDetailsContainerTypeDef",
    {"Name": str, "ImageId": str, "ImageName": str, "LaunchedAt": str},
    total=False,
)


class ClientBatchImportFindingsFindingsResourcesDetailsContainerTypeDef(
    _ClientBatchImportFindingsFindingsResourcesDetailsContainerTypeDef
):
    """
    Type definition for `ClientBatchImportFindingsFindingsResourcesDetails` `Container`

    Details about a container resource related to a finding.

    - **Name** *(string) --*

      The name of the container related to a finding.

    - **ImageId** *(string) --*

      The identifier of the image related to a finding.

    - **ImageName** *(string) --*

      The name of the image related to a finding.

    - **LaunchedAt** *(string) --*

      The date and time when the container started.
    """


_ClientBatchImportFindingsFindingsResourcesDetailsTypeDef = TypedDict(
    "_ClientBatchImportFindingsFindingsResourcesDetailsTypeDef",
    {
        "AwsEc2Instance": ClientBatchImportFindingsFindingsResourcesDetailsAwsEc2InstanceTypeDef,
        "AwsS3Bucket": ClientBatchImportFindingsFindingsResourcesDetailsAwsS3BucketTypeDef,
        "AwsIamAccessKey": ClientBatchImportFindingsFindingsResourcesDetailsAwsIamAccessKeyTypeDef,
        "Container": ClientBatchImportFindingsFindingsResourcesDetailsContainerTypeDef,
        "Other": Dict[str, str],
    },
    total=False,
)


class ClientBatchImportFindingsFindingsResourcesDetailsTypeDef(
    _ClientBatchImportFindingsFindingsResourcesDetailsTypeDef
):
    """
    Type definition for `ClientBatchImportFindingsFindingsResources` `Details`

    Additional details about the resource related to a finding.

    - **AwsEc2Instance** *(dict) --*

      Details about an Amazon EC2 instance related to a finding.

      - **Type** *(string) --*

        The instance type of the instance.

      - **ImageId** *(string) --*

        The Amazon Machine Image (AMI) ID of the instance.

      - **IpV4Addresses** *(list) --*

        The IPv4 addresses associated with the instance.

        - *(string) --*

      - **IpV6Addresses** *(list) --*

        The IPv6 addresses associated with the instance.

        - *(string) --*

      - **KeyName** *(string) --*

        The key name associated with the instance.

      - **IamInstanceProfileArn** *(string) --*

        The IAM profile ARN of the instance.

      - **VpcId** *(string) --*

        The identifier of the VPC that the instance was launched in.

      - **SubnetId** *(string) --*

        The identifier of the subnet that the instance was launched in.

      - **LaunchedAt** *(string) --*

        The date/time the instance was launched.

    - **AwsS3Bucket** *(dict) --*

      Details about an Amazon S3 Bucket related to a finding.

      - **OwnerId** *(string) --*

        The canonical user ID of the owner of the S3 bucket.

      - **OwnerName** *(string) --*

        The display name of the owner of the S3 bucket.

    - **AwsIamAccessKey** *(dict) --*

      Details about an IAM access key related to a finding.

      - **UserName** *(string) --*

        The user associated with the IAM access key related to a finding.

      - **Status** *(string) --*

        The status of the IAM access key related to a finding.

      - **CreatedAt** *(string) --*

        The creation date/time of the IAM access key related to a finding.

    - **Container** *(dict) --*

      Details about a container resource related to a finding.

      - **Name** *(string) --*

        The name of the container related to a finding.

      - **ImageId** *(string) --*

        The identifier of the image related to a finding.

      - **ImageName** *(string) --*

        The name of the image related to a finding.

      - **LaunchedAt** *(string) --*

        The date and time when the container started.

    - **Other** *(dict) --*

      Details about a resource that doesn't have a specific type defined.

      - *(string) --*

        - *(string) --*
    """


_RequiredClientBatchImportFindingsFindingsResourcesTypeDef = TypedDict(
    "_RequiredClientBatchImportFindingsFindingsResourcesTypeDef", {"Type": str, "Id": str}
)
_OptionalClientBatchImportFindingsFindingsResourcesTypeDef = TypedDict(
    "_OptionalClientBatchImportFindingsFindingsResourcesTypeDef",
    {
        "Partition": str,
        "Region": str,
        "Tags": Dict[str, str],
        "Details": ClientBatchImportFindingsFindingsResourcesDetailsTypeDef,
    },
    total=False,
)


class ClientBatchImportFindingsFindingsResourcesTypeDef(
    _RequiredClientBatchImportFindingsFindingsResourcesTypeDef,
    _OptionalClientBatchImportFindingsFindingsResourcesTypeDef,
):
    """
    Type definition for `ClientBatchImportFindingsFindings` `Resources`

    A resource related to a finding.

    - **Type** *(string) --* **[REQUIRED]**

      The type of the resource that details are provided for.

    - **Id** *(string) --* **[REQUIRED]**

      The canonical identifier for the given resource type.

    - **Partition** *(string) --*

      The canonical AWS partition name that the Region is assigned to.

    - **Region** *(string) --*

      The canonical AWS external Region name where this resource is located.

    - **Tags** *(dict) --*

      A list of AWS tags associated with a resource at the time the finding was processed.

      - *(string) --*

        - *(string) --*

    - **Details** *(dict) --*

      Additional details about the resource related to a finding.

      - **AwsEc2Instance** *(dict) --*

        Details about an Amazon EC2 instance related to a finding.

        - **Type** *(string) --*

          The instance type of the instance.

        - **ImageId** *(string) --*

          The Amazon Machine Image (AMI) ID of the instance.

        - **IpV4Addresses** *(list) --*

          The IPv4 addresses associated with the instance.

          - *(string) --*

        - **IpV6Addresses** *(list) --*

          The IPv6 addresses associated with the instance.

          - *(string) --*

        - **KeyName** *(string) --*

          The key name associated with the instance.

        - **IamInstanceProfileArn** *(string) --*

          The IAM profile ARN of the instance.

        - **VpcId** *(string) --*

          The identifier of the VPC that the instance was launched in.

        - **SubnetId** *(string) --*

          The identifier of the subnet that the instance was launched in.

        - **LaunchedAt** *(string) --*

          The date/time the instance was launched.

      - **AwsS3Bucket** *(dict) --*

        Details about an Amazon S3 Bucket related to a finding.

        - **OwnerId** *(string) --*

          The canonical user ID of the owner of the S3 bucket.

        - **OwnerName** *(string) --*

          The display name of the owner of the S3 bucket.

      - **AwsIamAccessKey** *(dict) --*

        Details about an IAM access key related to a finding.

        - **UserName** *(string) --*

          The user associated with the IAM access key related to a finding.

        - **Status** *(string) --*

          The status of the IAM access key related to a finding.

        - **CreatedAt** *(string) --*

          The creation date/time of the IAM access key related to a finding.

      - **Container** *(dict) --*

        Details about a container resource related to a finding.

        - **Name** *(string) --*

          The name of the container related to a finding.

        - **ImageId** *(string) --*

          The identifier of the image related to a finding.

        - **ImageName** *(string) --*

          The name of the image related to a finding.

        - **LaunchedAt** *(string) --*

          The date and time when the container started.

      - **Other** *(dict) --*

        Details about a resource that doesn't have a specific type defined.

        - *(string) --*

          - *(string) --*
    """


_RequiredClientBatchImportFindingsFindingsSeverityTypeDef = TypedDict(
    "_RequiredClientBatchImportFindingsFindingsSeverityTypeDef", {"Normalized": int}
)
_OptionalClientBatchImportFindingsFindingsSeverityTypeDef = TypedDict(
    "_OptionalClientBatchImportFindingsFindingsSeverityTypeDef", {"Product": float}, total=False
)


class ClientBatchImportFindingsFindingsSeverityTypeDef(
    _RequiredClientBatchImportFindingsFindingsSeverityTypeDef,
    _OptionalClientBatchImportFindingsFindingsSeverityTypeDef,
):
    """
    Type definition for `ClientBatchImportFindingsFindings` `Severity`

    A finding's severity.

    - **Product** *(float) --*

      The native severity as defined by the AWS service or integrated partner product that generated
      the finding.

    - **Normalized** *(integer) --* **[REQUIRED]**

      The normalized severity of a finding.
    """


_ClientBatchImportFindingsFindingsThreatIntelIndicatorsTypeDef = TypedDict(
    "_ClientBatchImportFindingsFindingsThreatIntelIndicatorsTypeDef",
    {
        "Type": str,
        "Value": str,
        "Category": str,
        "LastObservedAt": str,
        "Source": str,
        "SourceUrl": str,
    },
    total=False,
)


class ClientBatchImportFindingsFindingsThreatIntelIndicatorsTypeDef(
    _ClientBatchImportFindingsFindingsThreatIntelIndicatorsTypeDef
):
    """
    Type definition for `ClientBatchImportFindingsFindings` `ThreatIntelIndicators`

    Details about the threat intel related to a finding.

    - **Type** *(string) --*

      The type of a threat intel indicator.

    - **Value** *(string) --*

      The value of a threat intel indicator.

    - **Category** *(string) --*

      The category of a threat intel indicator.

    - **LastObservedAt** *(string) --*

      The date and time when the most recent instance of a threat intel indicator was observed.

    - **Source** *(string) --*

      The source of the threat intel indicator.

    - **SourceUrl** *(string) --*

      The URL to the page or site where you can get more information about the threat intel
      indicator.
    """


_RequiredClientBatchImportFindingsFindingsTypeDef = TypedDict(
    "_RequiredClientBatchImportFindingsFindingsTypeDef",
    {
        "SchemaVersion": str,
        "Id": str,
        "ProductArn": str,
        "GeneratorId": str,
        "AwsAccountId": str,
        "Types": List[str],
        "CreatedAt": str,
        "UpdatedAt": str,
        "Severity": ClientBatchImportFindingsFindingsSeverityTypeDef,
        "Title": str,
        "Description": str,
        "Resources": List[ClientBatchImportFindingsFindingsResourcesTypeDef],
    },
)
_OptionalClientBatchImportFindingsFindingsTypeDef = TypedDict(
    "_OptionalClientBatchImportFindingsFindingsTypeDef",
    {
        "FirstObservedAt": str,
        "LastObservedAt": str,
        "Confidence": int,
        "Criticality": int,
        "Remediation": ClientBatchImportFindingsFindingsRemediationTypeDef,
        "SourceUrl": str,
        "ProductFields": Dict[str, str],
        "UserDefinedFields": Dict[str, str],
        "Malware": List[ClientBatchImportFindingsFindingsMalwareTypeDef],
        "Network": ClientBatchImportFindingsFindingsNetworkTypeDef,
        "Process": ClientBatchImportFindingsFindingsProcessTypeDef,
        "ThreatIntelIndicators": List[
            ClientBatchImportFindingsFindingsThreatIntelIndicatorsTypeDef
        ],
        "Compliance": ClientBatchImportFindingsFindingsComplianceTypeDef,
        "VerificationState": str,
        "WorkflowState": str,
        "RecordState": str,
        "RelatedFindings": List[ClientBatchImportFindingsFindingsRelatedFindingsTypeDef],
        "Note": ClientBatchImportFindingsFindingsNoteTypeDef,
    },
    total=False,
)


class ClientBatchImportFindingsFindingsTypeDef(
    _RequiredClientBatchImportFindingsFindingsTypeDef,
    _OptionalClientBatchImportFindingsFindingsTypeDef,
):
    """
    Type definition for `ClientBatchImportFindings` `Findings`

    Provides consistent format for the contents of the Security Hub-aggregated findings.
    ``AwsSecurityFinding`` format enables you to share findings between AWS security services and
    third-party solutions, and compliance checks.

    .. note::

      A finding is a potential security issue generated either by AWS services (Amazon GuardDuty,
      Amazon Inspector, and Amazon Macie) or by the integrated third-party solutions and compliance
      checks.

    - **SchemaVersion** *(string) --* **[REQUIRED]**

      The schema version that a finding is formatted for.

    - **Id** *(string) --* **[REQUIRED]**

      The security findings provider-specific identifier for a finding.

    - **ProductArn** *(string) --* **[REQUIRED]**

      The ARN generated by Security Hub that uniquely identifies a third-party company
      (security-findings provider) after this provider's product (solution that generates findings)
      is registered with Security Hub.

    - **GeneratorId** *(string) --* **[REQUIRED]**

      The identifier for the solution-specific component (a discrete unit of logic) that generated a
      finding. In various security-findings providers' solutions, this generator can be called a
      rule, a check, a detector, a plug-in, etc.

    - **AwsAccountId** *(string) --* **[REQUIRED]**

      The AWS account ID that a finding is generated in.

    - **Types** *(list) --* **[REQUIRED]**

      One or more finding types in the format of ``namespace/category/classifier`` that classify a
      finding.

      Valid namespace values are: Software and Configuration Checks | TTPs | Effects | Unusual
      Behaviors | Sensitive Data Identifications

      - *(string) --*

    - **FirstObservedAt** *(string) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider first
      observed the potential security issue that a finding captured.

    - **LastObservedAt** *(string) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider most
      recently observed the potential security issue that a finding captured.

    - **CreatedAt** *(string) --* **[REQUIRED]**

      An ISO8601-formatted timestamp that indicates when the security-findings provider created the
      potential security issue that a finding captured.

    - **UpdatedAt** *(string) --* **[REQUIRED]**

      An ISO8601-formatted timestamp that indicates when the security-findings provider last updated
      the finding record.

    - **Severity** *(dict) --* **[REQUIRED]**

      A finding's severity.

      - **Product** *(float) --*

        The native severity as defined by the AWS service or integrated partner product that
        generated the finding.

      - **Normalized** *(integer) --* **[REQUIRED]**

        The normalized severity of a finding.

    - **Confidence** *(integer) --*

      A finding's confidence. Confidence is defined as the likelihood that a finding accurately
      identifies the behavior or issue that it was intended to identify. Confidence is scored on a
      0-100 basis using a ratio scale, where 0 means zero percent confidence and 100 means 100
      percent confidence.

    - **Criticality** *(integer) --*

      The level of importance assigned to the resources associated with the finding. A score of 0
      means that the underlying resources have no criticality, and a score of 100 is reserved for
      the most critical resources.

    - **Title** *(string) --* **[REQUIRED]**

      A finding's title.

      .. note::

        In this release, ``Title`` is a required property.

    - **Description** *(string) --* **[REQUIRED]**

      A finding's description.

      .. note::

        In this release, ``Description`` is a required property.

    - **Remediation** *(dict) --*

      A data type that describes the remediation options for a finding.

      - **Recommendation** *(dict) --*

        A recommendation on the steps to take to remediate the issue identified by a finding.

        - **Text** *(string) --*

          Describes the recommended steps to take to remediate an issue identified in a finding.

        - **Url** *(string) --*

          A URL to a page or site that contains information about how to remediate a finding.

    - **SourceUrl** *(string) --*

      A URL that links to a page about the current finding in the security-findings provider's
      solution.

    - **ProductFields** *(dict) --*

      A data type where security-findings providers can include additional solution-specific details
      that aren't part of the defined ``AwsSecurityFinding`` format.

      - *(string) --*

        - *(string) --*

    - **UserDefinedFields** *(dict) --*

      A list of name/value string pairs associated with the finding. These are custom, user-defined
      fields added to a finding.

      - *(string) --*

        - *(string) --*

    - **Malware** *(list) --*

      A list of malware related to a finding.

      - *(dict) --*

        A list of malware related to a finding.

        - **Name** *(string) --* **[REQUIRED]**

          The name of the malware that was observed.

        - **Type** *(string) --*

          The type of the malware that was observed.

        - **Path** *(string) --*

          The file system path of the malware that was observed.

        - **State** *(string) --*

          The state of the malware that was observed.

    - **Network** *(dict) --*

      The details of network-related information about a finding.

      - **Direction** *(string) --*

        The direction of network traffic associated with a finding.

      - **Protocol** *(string) --*

        The protocol of network-related information about a finding.

      - **SourceIpV4** *(string) --*

        The source IPv4 address of network-related information about a finding.

      - **SourceIpV6** *(string) --*

        The source IPv6 address of network-related information about a finding.

      - **SourcePort** *(integer) --*

        The source port of network-related information about a finding.

      - **SourceDomain** *(string) --*

        The source domain of network-related information about a finding.

      - **SourceMac** *(string) --*

        The source media access control (MAC) address of network-related information about a
        finding.

      - **DestinationIpV4** *(string) --*

        The destination IPv4 address of network-related information about a finding.

      - **DestinationIpV6** *(string) --*

        The destination IPv6 address of network-related information about a finding.

      - **DestinationPort** *(integer) --*

        The destination port of network-related information about a finding.

      - **DestinationDomain** *(string) --*

        The destination domain of network-related information about a finding.

    - **Process** *(dict) --*

      The details of process-related information about a finding.

      - **Name** *(string) --*

        The name of the process.

      - **Path** *(string) --*

        The path to the process executable.

      - **Pid** *(integer) --*

        The process ID.

      - **ParentPid** *(integer) --*

        The parent process ID.

      - **LaunchedAt** *(string) --*

        The date/time that the process was launched.

      - **TerminatedAt** *(string) --*

        The date and time when the process was terminated.

    - **ThreatIntelIndicators** *(list) --*

      Threat intel details related to a finding.

      - *(dict) --*

        Details about the threat intel related to a finding.

        - **Type** *(string) --*

          The type of a threat intel indicator.

        - **Value** *(string) --*

          The value of a threat intel indicator.

        - **Category** *(string) --*

          The category of a threat intel indicator.

        - **LastObservedAt** *(string) --*

          The date and time when the most recent instance of a threat intel indicator was observed.

        - **Source** *(string) --*

          The source of the threat intel indicator.

        - **SourceUrl** *(string) --*

          The URL to the page or site where you can get more information about the threat intel
          indicator.

    - **Resources** *(list) --* **[REQUIRED]**

      A set of resource data types that describe the resources that the finding refers to.

      - *(dict) --*

        A resource related to a finding.

        - **Type** *(string) --* **[REQUIRED]**

          The type of the resource that details are provided for.

        - **Id** *(string) --* **[REQUIRED]**

          The canonical identifier for the given resource type.

        - **Partition** *(string) --*

          The canonical AWS partition name that the Region is assigned to.

        - **Region** *(string) --*

          The canonical AWS external Region name where this resource is located.

        - **Tags** *(dict) --*

          A list of AWS tags associated with a resource at the time the finding was processed.

          - *(string) --*

            - *(string) --*

        - **Details** *(dict) --*

          Additional details about the resource related to a finding.

          - **AwsEc2Instance** *(dict) --*

            Details about an Amazon EC2 instance related to a finding.

            - **Type** *(string) --*

              The instance type of the instance.

            - **ImageId** *(string) --*

              The Amazon Machine Image (AMI) ID of the instance.

            - **IpV4Addresses** *(list) --*

              The IPv4 addresses associated with the instance.

              - *(string) --*

            - **IpV6Addresses** *(list) --*

              The IPv6 addresses associated with the instance.

              - *(string) --*

            - **KeyName** *(string) --*

              The key name associated with the instance.

            - **IamInstanceProfileArn** *(string) --*

              The IAM profile ARN of the instance.

            - **VpcId** *(string) --*

              The identifier of the VPC that the instance was launched in.

            - **SubnetId** *(string) --*

              The identifier of the subnet that the instance was launched in.

            - **LaunchedAt** *(string) --*

              The date/time the instance was launched.

          - **AwsS3Bucket** *(dict) --*

            Details about an Amazon S3 Bucket related to a finding.

            - **OwnerId** *(string) --*

              The canonical user ID of the owner of the S3 bucket.

            - **OwnerName** *(string) --*

              The display name of the owner of the S3 bucket.

          - **AwsIamAccessKey** *(dict) --*

            Details about an IAM access key related to a finding.

            - **UserName** *(string) --*

              The user associated with the IAM access key related to a finding.

            - **Status** *(string) --*

              The status of the IAM access key related to a finding.

            - **CreatedAt** *(string) --*

              The creation date/time of the IAM access key related to a finding.

          - **Container** *(dict) --*

            Details about a container resource related to a finding.

            - **Name** *(string) --*

              The name of the container related to a finding.

            - **ImageId** *(string) --*

              The identifier of the image related to a finding.

            - **ImageName** *(string) --*

              The name of the image related to a finding.

            - **LaunchedAt** *(string) --*

              The date and time when the container started.

          - **Other** *(dict) --*

            Details about a resource that doesn't have a specific type defined.

            - *(string) --*

              - *(string) --*

    - **Compliance** *(dict) --*

      This data type is exclusive to findings that are generated as the result of a check run
      against a specific rule in a supported standard (for example, CIS AWS Foundations). Contains
      compliance-related finding details.

      - **Status** *(string) --*

        The result of a compliance check.

    - **VerificationState** *(string) --*

      Indicates the veracity of a finding.

    - **WorkflowState** *(string) --*

      The workflow state of a finding.

    - **RecordState** *(string) --*

      The record state of a finding.

    - **RelatedFindings** *(list) --*

      A list of related findings.

      - *(dict) --*

        Details about a related finding.

        - **ProductArn** *(string) --* **[REQUIRED]**

          The ARN of the product that generated a related finding.

        - **Id** *(string) --* **[REQUIRED]**

          The product-generated identifier for a related finding.

    - **Note** *(dict) --*

      A user-defined note added to a finding.

      - **Text** *(string) --* **[REQUIRED]**

        The text of a note.

      - **UpdatedBy** *(string) --* **[REQUIRED]**

        The principal that created a note.

      - **UpdatedAt** *(string) --* **[REQUIRED]**

        The timestamp of when the note was updated.
    """


_ClientBatchImportFindingsResponseFailedFindingsTypeDef = TypedDict(
    "_ClientBatchImportFindingsResponseFailedFindingsTypeDef",
    {"Id": str, "ErrorCode": str, "ErrorMessage": str},
    total=False,
)


class ClientBatchImportFindingsResponseFailedFindingsTypeDef(
    _ClientBatchImportFindingsResponseFailedFindingsTypeDef
):
    """
    Type definition for `ClientBatchImportFindingsResponse` `FailedFindings`

    Includes details of the list of the findings that can't be imported.

    - **Id** *(string) --*

      The ID of the error made during the ``BatchImportFindings`` operation.

    - **ErrorCode** *(string) --*

      The code of the error made during the ``BatchImportFindings`` operation.

    - **ErrorMessage** *(string) --*

      The message of the error made during the ``BatchImportFindings`` operation.
    """


_ClientBatchImportFindingsResponseTypeDef = TypedDict(
    "_ClientBatchImportFindingsResponseTypeDef",
    {
        "FailedCount": int,
        "SuccessCount": int,
        "FailedFindings": List[ClientBatchImportFindingsResponseFailedFindingsTypeDef],
    },
    total=False,
)


class ClientBatchImportFindingsResponseTypeDef(_ClientBatchImportFindingsResponseTypeDef):
    """
    Type definition for `ClientBatchImportFindings` `Response`

    - **FailedCount** *(integer) --*

      The number of findings that failed to import.

    - **SuccessCount** *(integer) --*

      The number of findings that were successfully imported.

    - **FailedFindings** *(list) --*

      The list of the findings that failed to import.

      - *(dict) --*

        Includes details of the list of the findings that can't be imported.

        - **Id** *(string) --*

          The ID of the error made during the ``BatchImportFindings`` operation.

        - **ErrorCode** *(string) --*

          The code of the error made during the ``BatchImportFindings`` operation.

        - **ErrorMessage** *(string) --*

          The message of the error made during the ``BatchImportFindings`` operation.
    """


_ClientCreateActionTargetResponseTypeDef = TypedDict(
    "_ClientCreateActionTargetResponseTypeDef", {"ActionTargetArn": str}, total=False
)


class ClientCreateActionTargetResponseTypeDef(_ClientCreateActionTargetResponseTypeDef):
    """
    Type definition for `ClientCreateActionTarget` `Response`

    - **ActionTargetArn** *(string) --*

      The ARN for the custom action target.
    """


_ClientCreateInsightFiltersAwsAccountIdTypeDef = TypedDict(
    "_ClientCreateInsightFiltersAwsAccountIdTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientCreateInsightFiltersAwsAccountIdTypeDef(_ClientCreateInsightFiltersAwsAccountIdTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `AwsAccountId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersCompanyNameTypeDef = TypedDict(
    "_ClientCreateInsightFiltersCompanyNameTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientCreateInsightFiltersCompanyNameTypeDef(_ClientCreateInsightFiltersCompanyNameTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `CompanyName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersComplianceStatusTypeDef = TypedDict(
    "_ClientCreateInsightFiltersComplianceStatusTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersComplianceStatusTypeDef(
    _ClientCreateInsightFiltersComplianceStatusTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ComplianceStatus`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersConfidenceTypeDef = TypedDict(
    "_ClientCreateInsightFiltersConfidenceTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientCreateInsightFiltersConfidenceTypeDef(_ClientCreateInsightFiltersConfidenceTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `Confidence`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientCreateInsightFiltersCreatedAtDateRangeTypeDef = TypedDict(
    "_ClientCreateInsightFiltersCreatedAtDateRangeTypeDef", {"Value": int, "Unit": str}, total=False
)


class ClientCreateInsightFiltersCreatedAtDateRangeTypeDef(
    _ClientCreateInsightFiltersCreatedAtDateRangeTypeDef
):
    """
    Type definition for `ClientCreateInsightFiltersCreatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientCreateInsightFiltersCreatedAtTypeDef = TypedDict(
    "_ClientCreateInsightFiltersCreatedAtTypeDef",
    {"Start": str, "End": str, "DateRange": ClientCreateInsightFiltersCreatedAtDateRangeTypeDef},
    total=False,
)


class ClientCreateInsightFiltersCreatedAtTypeDef(_ClientCreateInsightFiltersCreatedAtTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `CreatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientCreateInsightFiltersCriticalityTypeDef = TypedDict(
    "_ClientCreateInsightFiltersCriticalityTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientCreateInsightFiltersCriticalityTypeDef(_ClientCreateInsightFiltersCriticalityTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `Criticality`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientCreateInsightFiltersDescriptionTypeDef = TypedDict(
    "_ClientCreateInsightFiltersDescriptionTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientCreateInsightFiltersDescriptionTypeDef(_ClientCreateInsightFiltersDescriptionTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `Description`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersFirstObservedAtDateRangeTypeDef = TypedDict(
    "_ClientCreateInsightFiltersFirstObservedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientCreateInsightFiltersFirstObservedAtDateRangeTypeDef(
    _ClientCreateInsightFiltersFirstObservedAtDateRangeTypeDef
):
    """
    Type definition for `ClientCreateInsightFiltersFirstObservedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientCreateInsightFiltersFirstObservedAtTypeDef = TypedDict(
    "_ClientCreateInsightFiltersFirstObservedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientCreateInsightFiltersFirstObservedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientCreateInsightFiltersFirstObservedAtTypeDef(
    _ClientCreateInsightFiltersFirstObservedAtTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `FirstObservedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientCreateInsightFiltersGeneratorIdTypeDef = TypedDict(
    "_ClientCreateInsightFiltersGeneratorIdTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientCreateInsightFiltersGeneratorIdTypeDef(_ClientCreateInsightFiltersGeneratorIdTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `GeneratorId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersIdTypeDef = TypedDict(
    "_ClientCreateInsightFiltersIdTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientCreateInsightFiltersIdTypeDef(_ClientCreateInsightFiltersIdTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `Id`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersKeywordTypeDef = TypedDict(
    "_ClientCreateInsightFiltersKeywordTypeDef", {"Value": str}, total=False
)


class ClientCreateInsightFiltersKeywordTypeDef(_ClientCreateInsightFiltersKeywordTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `Keyword`

    A keyword filter for querying findings.

    - **Value** *(string) --*

      A value for the keyword.
    """


_ClientCreateInsightFiltersLastObservedAtDateRangeTypeDef = TypedDict(
    "_ClientCreateInsightFiltersLastObservedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientCreateInsightFiltersLastObservedAtDateRangeTypeDef(
    _ClientCreateInsightFiltersLastObservedAtDateRangeTypeDef
):
    """
    Type definition for `ClientCreateInsightFiltersLastObservedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientCreateInsightFiltersLastObservedAtTypeDef = TypedDict(
    "_ClientCreateInsightFiltersLastObservedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientCreateInsightFiltersLastObservedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientCreateInsightFiltersLastObservedAtTypeDef(
    _ClientCreateInsightFiltersLastObservedAtTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `LastObservedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientCreateInsightFiltersMalwareNameTypeDef = TypedDict(
    "_ClientCreateInsightFiltersMalwareNameTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientCreateInsightFiltersMalwareNameTypeDef(_ClientCreateInsightFiltersMalwareNameTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `MalwareName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersMalwarePathTypeDef = TypedDict(
    "_ClientCreateInsightFiltersMalwarePathTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientCreateInsightFiltersMalwarePathTypeDef(_ClientCreateInsightFiltersMalwarePathTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `MalwarePath`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersMalwareStateTypeDef = TypedDict(
    "_ClientCreateInsightFiltersMalwareStateTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientCreateInsightFiltersMalwareStateTypeDef(_ClientCreateInsightFiltersMalwareStateTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `MalwareState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersMalwareTypeTypeDef = TypedDict(
    "_ClientCreateInsightFiltersMalwareTypeTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientCreateInsightFiltersMalwareTypeTypeDef(_ClientCreateInsightFiltersMalwareTypeTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `MalwareType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersNetworkDestinationDomainTypeDef = TypedDict(
    "_ClientCreateInsightFiltersNetworkDestinationDomainTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersNetworkDestinationDomainTypeDef(
    _ClientCreateInsightFiltersNetworkDestinationDomainTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `NetworkDestinationDomain`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersNetworkDestinationIpV4TypeDef = TypedDict(
    "_ClientCreateInsightFiltersNetworkDestinationIpV4TypeDef", {"Cidr": str}, total=False
)


class ClientCreateInsightFiltersNetworkDestinationIpV4TypeDef(
    _ClientCreateInsightFiltersNetworkDestinationIpV4TypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `NetworkDestinationIpV4`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientCreateInsightFiltersNetworkDestinationIpV6TypeDef = TypedDict(
    "_ClientCreateInsightFiltersNetworkDestinationIpV6TypeDef", {"Cidr": str}, total=False
)


class ClientCreateInsightFiltersNetworkDestinationIpV6TypeDef(
    _ClientCreateInsightFiltersNetworkDestinationIpV6TypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `NetworkDestinationIpV6`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientCreateInsightFiltersNetworkDestinationPortTypeDef = TypedDict(
    "_ClientCreateInsightFiltersNetworkDestinationPortTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientCreateInsightFiltersNetworkDestinationPortTypeDef(
    _ClientCreateInsightFiltersNetworkDestinationPortTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `NetworkDestinationPort`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientCreateInsightFiltersNetworkDirectionTypeDef = TypedDict(
    "_ClientCreateInsightFiltersNetworkDirectionTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersNetworkDirectionTypeDef(
    _ClientCreateInsightFiltersNetworkDirectionTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `NetworkDirection`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersNetworkProtocolTypeDef = TypedDict(
    "_ClientCreateInsightFiltersNetworkProtocolTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersNetworkProtocolTypeDef(
    _ClientCreateInsightFiltersNetworkProtocolTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `NetworkProtocol`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersNetworkSourceDomainTypeDef = TypedDict(
    "_ClientCreateInsightFiltersNetworkSourceDomainTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersNetworkSourceDomainTypeDef(
    _ClientCreateInsightFiltersNetworkSourceDomainTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `NetworkSourceDomain`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersNetworkSourceIpV4TypeDef = TypedDict(
    "_ClientCreateInsightFiltersNetworkSourceIpV4TypeDef", {"Cidr": str}, total=False
)


class ClientCreateInsightFiltersNetworkSourceIpV4TypeDef(
    _ClientCreateInsightFiltersNetworkSourceIpV4TypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `NetworkSourceIpV4`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientCreateInsightFiltersNetworkSourceIpV6TypeDef = TypedDict(
    "_ClientCreateInsightFiltersNetworkSourceIpV6TypeDef", {"Cidr": str}, total=False
)


class ClientCreateInsightFiltersNetworkSourceIpV6TypeDef(
    _ClientCreateInsightFiltersNetworkSourceIpV6TypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `NetworkSourceIpV6`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientCreateInsightFiltersNetworkSourceMacTypeDef = TypedDict(
    "_ClientCreateInsightFiltersNetworkSourceMacTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersNetworkSourceMacTypeDef(
    _ClientCreateInsightFiltersNetworkSourceMacTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `NetworkSourceMac`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersNetworkSourcePortTypeDef = TypedDict(
    "_ClientCreateInsightFiltersNetworkSourcePortTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientCreateInsightFiltersNetworkSourcePortTypeDef(
    _ClientCreateInsightFiltersNetworkSourcePortTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `NetworkSourcePort`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientCreateInsightFiltersNoteTextTypeDef = TypedDict(
    "_ClientCreateInsightFiltersNoteTextTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientCreateInsightFiltersNoteTextTypeDef(_ClientCreateInsightFiltersNoteTextTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `NoteText`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersNoteUpdatedAtDateRangeTypeDef = TypedDict(
    "_ClientCreateInsightFiltersNoteUpdatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientCreateInsightFiltersNoteUpdatedAtDateRangeTypeDef(
    _ClientCreateInsightFiltersNoteUpdatedAtDateRangeTypeDef
):
    """
    Type definition for `ClientCreateInsightFiltersNoteUpdatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientCreateInsightFiltersNoteUpdatedAtTypeDef = TypedDict(
    "_ClientCreateInsightFiltersNoteUpdatedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientCreateInsightFiltersNoteUpdatedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientCreateInsightFiltersNoteUpdatedAtTypeDef(
    _ClientCreateInsightFiltersNoteUpdatedAtTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `NoteUpdatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientCreateInsightFiltersNoteUpdatedByTypeDef = TypedDict(
    "_ClientCreateInsightFiltersNoteUpdatedByTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersNoteUpdatedByTypeDef(
    _ClientCreateInsightFiltersNoteUpdatedByTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `NoteUpdatedBy`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersProcessLaunchedAtDateRangeTypeDef = TypedDict(
    "_ClientCreateInsightFiltersProcessLaunchedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientCreateInsightFiltersProcessLaunchedAtDateRangeTypeDef(
    _ClientCreateInsightFiltersProcessLaunchedAtDateRangeTypeDef
):
    """
    Type definition for `ClientCreateInsightFiltersProcessLaunchedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientCreateInsightFiltersProcessLaunchedAtTypeDef = TypedDict(
    "_ClientCreateInsightFiltersProcessLaunchedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientCreateInsightFiltersProcessLaunchedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientCreateInsightFiltersProcessLaunchedAtTypeDef(
    _ClientCreateInsightFiltersProcessLaunchedAtTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ProcessLaunchedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientCreateInsightFiltersProcessNameTypeDef = TypedDict(
    "_ClientCreateInsightFiltersProcessNameTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientCreateInsightFiltersProcessNameTypeDef(_ClientCreateInsightFiltersProcessNameTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `ProcessName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersProcessParentPidTypeDef = TypedDict(
    "_ClientCreateInsightFiltersProcessParentPidTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientCreateInsightFiltersProcessParentPidTypeDef(
    _ClientCreateInsightFiltersProcessParentPidTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ProcessParentPid`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientCreateInsightFiltersProcessPathTypeDef = TypedDict(
    "_ClientCreateInsightFiltersProcessPathTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientCreateInsightFiltersProcessPathTypeDef(_ClientCreateInsightFiltersProcessPathTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `ProcessPath`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersProcessPidTypeDef = TypedDict(
    "_ClientCreateInsightFiltersProcessPidTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientCreateInsightFiltersProcessPidTypeDef(_ClientCreateInsightFiltersProcessPidTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `ProcessPid`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientCreateInsightFiltersProcessTerminatedAtDateRangeTypeDef = TypedDict(
    "_ClientCreateInsightFiltersProcessTerminatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientCreateInsightFiltersProcessTerminatedAtDateRangeTypeDef(
    _ClientCreateInsightFiltersProcessTerminatedAtDateRangeTypeDef
):
    """
    Type definition for `ClientCreateInsightFiltersProcessTerminatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientCreateInsightFiltersProcessTerminatedAtTypeDef = TypedDict(
    "_ClientCreateInsightFiltersProcessTerminatedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientCreateInsightFiltersProcessTerminatedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientCreateInsightFiltersProcessTerminatedAtTypeDef(
    _ClientCreateInsightFiltersProcessTerminatedAtTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ProcessTerminatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientCreateInsightFiltersProductArnTypeDef = TypedDict(
    "_ClientCreateInsightFiltersProductArnTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientCreateInsightFiltersProductArnTypeDef(_ClientCreateInsightFiltersProductArnTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `ProductArn`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersProductFieldsTypeDef = TypedDict(
    "_ClientCreateInsightFiltersProductFieldsTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersProductFieldsTypeDef(
    _ClientCreateInsightFiltersProductFieldsTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ProductFields`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_ClientCreateInsightFiltersProductNameTypeDef = TypedDict(
    "_ClientCreateInsightFiltersProductNameTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientCreateInsightFiltersProductNameTypeDef(_ClientCreateInsightFiltersProductNameTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `ProductName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersRecommendationTextTypeDef = TypedDict(
    "_ClientCreateInsightFiltersRecommendationTextTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersRecommendationTextTypeDef(
    _ClientCreateInsightFiltersRecommendationTextTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `RecommendationText`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersRecordStateTypeDef = TypedDict(
    "_ClientCreateInsightFiltersRecordStateTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientCreateInsightFiltersRecordStateTypeDef(_ClientCreateInsightFiltersRecordStateTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `RecordState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersRelatedFindingsIdTypeDef = TypedDict(
    "_ClientCreateInsightFiltersRelatedFindingsIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersRelatedFindingsIdTypeDef(
    _ClientCreateInsightFiltersRelatedFindingsIdTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `RelatedFindingsId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersRelatedFindingsProductArnTypeDef = TypedDict(
    "_ClientCreateInsightFiltersRelatedFindingsProductArnTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersRelatedFindingsProductArnTypeDef(
    _ClientCreateInsightFiltersRelatedFindingsProductArnTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `RelatedFindingsProductArn`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef(
    _ClientCreateInsightFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ResourceAwsEc2InstanceIamInstanceProfileArn`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersResourceAwsEc2InstanceImageIdTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourceAwsEc2InstanceImageIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersResourceAwsEc2InstanceImageIdTypeDef(
    _ClientCreateInsightFiltersResourceAwsEc2InstanceImageIdTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ResourceAwsEc2InstanceImageId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef",
    {"Cidr": str},
    total=False,
)


class ClientCreateInsightFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef(
    _ClientCreateInsightFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ResourceAwsEc2InstanceIpV4Addresses`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientCreateInsightFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef",
    {"Cidr": str},
    total=False,
)


class ClientCreateInsightFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef(
    _ClientCreateInsightFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ResourceAwsEc2InstanceIpV6Addresses`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientCreateInsightFiltersResourceAwsEc2InstanceKeyNameTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourceAwsEc2InstanceKeyNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersResourceAwsEc2InstanceKeyNameTypeDef(
    _ClientCreateInsightFiltersResourceAwsEc2InstanceKeyNameTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ResourceAwsEc2InstanceKeyName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientCreateInsightFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef(
    _ClientCreateInsightFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef
):
    """
    Type definition for `ClientCreateInsightFiltersResourceAwsEc2InstanceLaunchedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientCreateInsightFiltersResourceAwsEc2InstanceLaunchedAtTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourceAwsEc2InstanceLaunchedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientCreateInsightFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientCreateInsightFiltersResourceAwsEc2InstanceLaunchedAtTypeDef(
    _ClientCreateInsightFiltersResourceAwsEc2InstanceLaunchedAtTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ResourceAwsEc2InstanceLaunchedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientCreateInsightFiltersResourceAwsEc2InstanceSubnetIdTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourceAwsEc2InstanceSubnetIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersResourceAwsEc2InstanceSubnetIdTypeDef(
    _ClientCreateInsightFiltersResourceAwsEc2InstanceSubnetIdTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ResourceAwsEc2InstanceSubnetId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersResourceAwsEc2InstanceTypeTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourceAwsEc2InstanceTypeTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersResourceAwsEc2InstanceTypeTypeDef(
    _ClientCreateInsightFiltersResourceAwsEc2InstanceTypeTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ResourceAwsEc2InstanceType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersResourceAwsEc2InstanceVpcIdTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourceAwsEc2InstanceVpcIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersResourceAwsEc2InstanceVpcIdTypeDef(
    _ClientCreateInsightFiltersResourceAwsEc2InstanceVpcIdTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ResourceAwsEc2InstanceVpcId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientCreateInsightFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef(
    _ClientCreateInsightFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef
):
    """
    Type definition for `ClientCreateInsightFiltersResourceAwsIamAccessKeyCreatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientCreateInsightFiltersResourceAwsIamAccessKeyCreatedAtTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourceAwsIamAccessKeyCreatedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientCreateInsightFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientCreateInsightFiltersResourceAwsIamAccessKeyCreatedAtTypeDef(
    _ClientCreateInsightFiltersResourceAwsIamAccessKeyCreatedAtTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ResourceAwsIamAccessKeyCreatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientCreateInsightFiltersResourceAwsIamAccessKeyStatusTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourceAwsIamAccessKeyStatusTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersResourceAwsIamAccessKeyStatusTypeDef(
    _ClientCreateInsightFiltersResourceAwsIamAccessKeyStatusTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ResourceAwsIamAccessKeyStatus`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersResourceAwsIamAccessKeyUserNameTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourceAwsIamAccessKeyUserNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersResourceAwsIamAccessKeyUserNameTypeDef(
    _ClientCreateInsightFiltersResourceAwsIamAccessKeyUserNameTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ResourceAwsIamAccessKeyUserName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersResourceAwsS3BucketOwnerIdTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourceAwsS3BucketOwnerIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersResourceAwsS3BucketOwnerIdTypeDef(
    _ClientCreateInsightFiltersResourceAwsS3BucketOwnerIdTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ResourceAwsS3BucketOwnerId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersResourceAwsS3BucketOwnerNameTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourceAwsS3BucketOwnerNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersResourceAwsS3BucketOwnerNameTypeDef(
    _ClientCreateInsightFiltersResourceAwsS3BucketOwnerNameTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ResourceAwsS3BucketOwnerName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersResourceContainerImageIdTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourceContainerImageIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersResourceContainerImageIdTypeDef(
    _ClientCreateInsightFiltersResourceContainerImageIdTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ResourceContainerImageId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersResourceContainerImageNameTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourceContainerImageNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersResourceContainerImageNameTypeDef(
    _ClientCreateInsightFiltersResourceContainerImageNameTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ResourceContainerImageName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersResourceContainerLaunchedAtDateRangeTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourceContainerLaunchedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientCreateInsightFiltersResourceContainerLaunchedAtDateRangeTypeDef(
    _ClientCreateInsightFiltersResourceContainerLaunchedAtDateRangeTypeDef
):
    """
    Type definition for `ClientCreateInsightFiltersResourceContainerLaunchedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientCreateInsightFiltersResourceContainerLaunchedAtTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourceContainerLaunchedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientCreateInsightFiltersResourceContainerLaunchedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientCreateInsightFiltersResourceContainerLaunchedAtTypeDef(
    _ClientCreateInsightFiltersResourceContainerLaunchedAtTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ResourceContainerLaunchedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientCreateInsightFiltersResourceContainerNameTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourceContainerNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersResourceContainerNameTypeDef(
    _ClientCreateInsightFiltersResourceContainerNameTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ResourceContainerName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersResourceDetailsOtherTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourceDetailsOtherTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersResourceDetailsOtherTypeDef(
    _ClientCreateInsightFiltersResourceDetailsOtherTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ResourceDetailsOther`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_ClientCreateInsightFiltersResourceIdTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourceIdTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientCreateInsightFiltersResourceIdTypeDef(_ClientCreateInsightFiltersResourceIdTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `ResourceId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersResourcePartitionTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourcePartitionTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersResourcePartitionTypeDef(
    _ClientCreateInsightFiltersResourcePartitionTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ResourcePartition`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersResourceRegionTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourceRegionTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersResourceRegionTypeDef(
    _ClientCreateInsightFiltersResourceRegionTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ResourceRegion`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersResourceTagsTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourceTagsTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersResourceTagsTypeDef(_ClientCreateInsightFiltersResourceTagsTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `ResourceTags`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_ClientCreateInsightFiltersResourceTypeTypeDef = TypedDict(
    "_ClientCreateInsightFiltersResourceTypeTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientCreateInsightFiltersResourceTypeTypeDef(_ClientCreateInsightFiltersResourceTypeTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `ResourceType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersSeverityLabelTypeDef = TypedDict(
    "_ClientCreateInsightFiltersSeverityLabelTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersSeverityLabelTypeDef(
    _ClientCreateInsightFiltersSeverityLabelTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `SeverityLabel`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersSeverityNormalizedTypeDef = TypedDict(
    "_ClientCreateInsightFiltersSeverityNormalizedTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientCreateInsightFiltersSeverityNormalizedTypeDef(
    _ClientCreateInsightFiltersSeverityNormalizedTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `SeverityNormalized`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientCreateInsightFiltersSeverityProductTypeDef = TypedDict(
    "_ClientCreateInsightFiltersSeverityProductTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientCreateInsightFiltersSeverityProductTypeDef(
    _ClientCreateInsightFiltersSeverityProductTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `SeverityProduct`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientCreateInsightFiltersSourceUrlTypeDef = TypedDict(
    "_ClientCreateInsightFiltersSourceUrlTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientCreateInsightFiltersSourceUrlTypeDef(_ClientCreateInsightFiltersSourceUrlTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `SourceUrl`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersThreatIntelIndicatorCategoryTypeDef = TypedDict(
    "_ClientCreateInsightFiltersThreatIntelIndicatorCategoryTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersThreatIntelIndicatorCategoryTypeDef(
    _ClientCreateInsightFiltersThreatIntelIndicatorCategoryTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ThreatIntelIndicatorCategory`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef = TypedDict(
    "_ClientCreateInsightFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientCreateInsightFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef(
    _ClientCreateInsightFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef
):
    """
    Type definition for `ClientCreateInsightFiltersThreatIntelIndicatorLastObservedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientCreateInsightFiltersThreatIntelIndicatorLastObservedAtTypeDef = TypedDict(
    "_ClientCreateInsightFiltersThreatIntelIndicatorLastObservedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientCreateInsightFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientCreateInsightFiltersThreatIntelIndicatorLastObservedAtTypeDef(
    _ClientCreateInsightFiltersThreatIntelIndicatorLastObservedAtTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ThreatIntelIndicatorLastObservedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientCreateInsightFiltersThreatIntelIndicatorSourceTypeDef = TypedDict(
    "_ClientCreateInsightFiltersThreatIntelIndicatorSourceTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersThreatIntelIndicatorSourceTypeDef(
    _ClientCreateInsightFiltersThreatIntelIndicatorSourceTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ThreatIntelIndicatorSource`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersThreatIntelIndicatorSourceUrlTypeDef = TypedDict(
    "_ClientCreateInsightFiltersThreatIntelIndicatorSourceUrlTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersThreatIntelIndicatorSourceUrlTypeDef(
    _ClientCreateInsightFiltersThreatIntelIndicatorSourceUrlTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ThreatIntelIndicatorSourceUrl`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersThreatIntelIndicatorTypeTypeDef = TypedDict(
    "_ClientCreateInsightFiltersThreatIntelIndicatorTypeTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersThreatIntelIndicatorTypeTypeDef(
    _ClientCreateInsightFiltersThreatIntelIndicatorTypeTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ThreatIntelIndicatorType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersThreatIntelIndicatorValueTypeDef = TypedDict(
    "_ClientCreateInsightFiltersThreatIntelIndicatorValueTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersThreatIntelIndicatorValueTypeDef(
    _ClientCreateInsightFiltersThreatIntelIndicatorValueTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `ThreatIntelIndicatorValue`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersTitleTypeDef = TypedDict(
    "_ClientCreateInsightFiltersTitleTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientCreateInsightFiltersTitleTypeDef(_ClientCreateInsightFiltersTitleTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `Title`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersTypeTypeDef = TypedDict(
    "_ClientCreateInsightFiltersTypeTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientCreateInsightFiltersTypeTypeDef(_ClientCreateInsightFiltersTypeTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `Type`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersUpdatedAtDateRangeTypeDef = TypedDict(
    "_ClientCreateInsightFiltersUpdatedAtDateRangeTypeDef", {"Value": int, "Unit": str}, total=False
)


class ClientCreateInsightFiltersUpdatedAtDateRangeTypeDef(
    _ClientCreateInsightFiltersUpdatedAtDateRangeTypeDef
):
    """
    Type definition for `ClientCreateInsightFiltersUpdatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientCreateInsightFiltersUpdatedAtTypeDef = TypedDict(
    "_ClientCreateInsightFiltersUpdatedAtTypeDef",
    {"Start": str, "End": str, "DateRange": ClientCreateInsightFiltersUpdatedAtDateRangeTypeDef},
    total=False,
)


class ClientCreateInsightFiltersUpdatedAtTypeDef(_ClientCreateInsightFiltersUpdatedAtTypeDef):
    """
    Type definition for `ClientCreateInsightFilters` `UpdatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientCreateInsightFiltersUserDefinedFieldsTypeDef = TypedDict(
    "_ClientCreateInsightFiltersUserDefinedFieldsTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersUserDefinedFieldsTypeDef(
    _ClientCreateInsightFiltersUserDefinedFieldsTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `UserDefinedFields`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_ClientCreateInsightFiltersVerificationStateTypeDef = TypedDict(
    "_ClientCreateInsightFiltersVerificationStateTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersVerificationStateTypeDef(
    _ClientCreateInsightFiltersVerificationStateTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `VerificationState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersWorkflowStateTypeDef = TypedDict(
    "_ClientCreateInsightFiltersWorkflowStateTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientCreateInsightFiltersWorkflowStateTypeDef(
    _ClientCreateInsightFiltersWorkflowStateTypeDef
):
    """
    Type definition for `ClientCreateInsightFilters` `WorkflowState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientCreateInsightFiltersTypeDef = TypedDict(
    "_ClientCreateInsightFiltersTypeDef",
    {
        "ProductArn": List[ClientCreateInsightFiltersProductArnTypeDef],
        "AwsAccountId": List[ClientCreateInsightFiltersAwsAccountIdTypeDef],
        "Id": List[ClientCreateInsightFiltersIdTypeDef],
        "GeneratorId": List[ClientCreateInsightFiltersGeneratorIdTypeDef],
        "Type": List[ClientCreateInsightFiltersTypeTypeDef],
        "FirstObservedAt": List[ClientCreateInsightFiltersFirstObservedAtTypeDef],
        "LastObservedAt": List[ClientCreateInsightFiltersLastObservedAtTypeDef],
        "CreatedAt": List[ClientCreateInsightFiltersCreatedAtTypeDef],
        "UpdatedAt": List[ClientCreateInsightFiltersUpdatedAtTypeDef],
        "SeverityProduct": List[ClientCreateInsightFiltersSeverityProductTypeDef],
        "SeverityNormalized": List[ClientCreateInsightFiltersSeverityNormalizedTypeDef],
        "SeverityLabel": List[ClientCreateInsightFiltersSeverityLabelTypeDef],
        "Confidence": List[ClientCreateInsightFiltersConfidenceTypeDef],
        "Criticality": List[ClientCreateInsightFiltersCriticalityTypeDef],
        "Title": List[ClientCreateInsightFiltersTitleTypeDef],
        "Description": List[ClientCreateInsightFiltersDescriptionTypeDef],
        "RecommendationText": List[ClientCreateInsightFiltersRecommendationTextTypeDef],
        "SourceUrl": List[ClientCreateInsightFiltersSourceUrlTypeDef],
        "ProductFields": List[ClientCreateInsightFiltersProductFieldsTypeDef],
        "ProductName": List[ClientCreateInsightFiltersProductNameTypeDef],
        "CompanyName": List[ClientCreateInsightFiltersCompanyNameTypeDef],
        "UserDefinedFields": List[ClientCreateInsightFiltersUserDefinedFieldsTypeDef],
        "MalwareName": List[ClientCreateInsightFiltersMalwareNameTypeDef],
        "MalwareType": List[ClientCreateInsightFiltersMalwareTypeTypeDef],
        "MalwarePath": List[ClientCreateInsightFiltersMalwarePathTypeDef],
        "MalwareState": List[ClientCreateInsightFiltersMalwareStateTypeDef],
        "NetworkDirection": List[ClientCreateInsightFiltersNetworkDirectionTypeDef],
        "NetworkProtocol": List[ClientCreateInsightFiltersNetworkProtocolTypeDef],
        "NetworkSourceIpV4": List[ClientCreateInsightFiltersNetworkSourceIpV4TypeDef],
        "NetworkSourceIpV6": List[ClientCreateInsightFiltersNetworkSourceIpV6TypeDef],
        "NetworkSourcePort": List[ClientCreateInsightFiltersNetworkSourcePortTypeDef],
        "NetworkSourceDomain": List[ClientCreateInsightFiltersNetworkSourceDomainTypeDef],
        "NetworkSourceMac": List[ClientCreateInsightFiltersNetworkSourceMacTypeDef],
        "NetworkDestinationIpV4": List[ClientCreateInsightFiltersNetworkDestinationIpV4TypeDef],
        "NetworkDestinationIpV6": List[ClientCreateInsightFiltersNetworkDestinationIpV6TypeDef],
        "NetworkDestinationPort": List[ClientCreateInsightFiltersNetworkDestinationPortTypeDef],
        "NetworkDestinationDomain": List[ClientCreateInsightFiltersNetworkDestinationDomainTypeDef],
        "ProcessName": List[ClientCreateInsightFiltersProcessNameTypeDef],
        "ProcessPath": List[ClientCreateInsightFiltersProcessPathTypeDef],
        "ProcessPid": List[ClientCreateInsightFiltersProcessPidTypeDef],
        "ProcessParentPid": List[ClientCreateInsightFiltersProcessParentPidTypeDef],
        "ProcessLaunchedAt": List[ClientCreateInsightFiltersProcessLaunchedAtTypeDef],
        "ProcessTerminatedAt": List[ClientCreateInsightFiltersProcessTerminatedAtTypeDef],
        "ThreatIntelIndicatorType": List[ClientCreateInsightFiltersThreatIntelIndicatorTypeTypeDef],
        "ThreatIntelIndicatorValue": List[
            ClientCreateInsightFiltersThreatIntelIndicatorValueTypeDef
        ],
        "ThreatIntelIndicatorCategory": List[
            ClientCreateInsightFiltersThreatIntelIndicatorCategoryTypeDef
        ],
        "ThreatIntelIndicatorLastObservedAt": List[
            ClientCreateInsightFiltersThreatIntelIndicatorLastObservedAtTypeDef
        ],
        "ThreatIntelIndicatorSource": List[
            ClientCreateInsightFiltersThreatIntelIndicatorSourceTypeDef
        ],
        "ThreatIntelIndicatorSourceUrl": List[
            ClientCreateInsightFiltersThreatIntelIndicatorSourceUrlTypeDef
        ],
        "ResourceType": List[ClientCreateInsightFiltersResourceTypeTypeDef],
        "ResourceId": List[ClientCreateInsightFiltersResourceIdTypeDef],
        "ResourcePartition": List[ClientCreateInsightFiltersResourcePartitionTypeDef],
        "ResourceRegion": List[ClientCreateInsightFiltersResourceRegionTypeDef],
        "ResourceTags": List[ClientCreateInsightFiltersResourceTagsTypeDef],
        "ResourceAwsEc2InstanceType": List[
            ClientCreateInsightFiltersResourceAwsEc2InstanceTypeTypeDef
        ],
        "ResourceAwsEc2InstanceImageId": List[
            ClientCreateInsightFiltersResourceAwsEc2InstanceImageIdTypeDef
        ],
        "ResourceAwsEc2InstanceIpV4Addresses": List[
            ClientCreateInsightFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef
        ],
        "ResourceAwsEc2InstanceIpV6Addresses": List[
            ClientCreateInsightFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef
        ],
        "ResourceAwsEc2InstanceKeyName": List[
            ClientCreateInsightFiltersResourceAwsEc2InstanceKeyNameTypeDef
        ],
        "ResourceAwsEc2InstanceIamInstanceProfileArn": List[
            ClientCreateInsightFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef
        ],
        "ResourceAwsEc2InstanceVpcId": List[
            ClientCreateInsightFiltersResourceAwsEc2InstanceVpcIdTypeDef
        ],
        "ResourceAwsEc2InstanceSubnetId": List[
            ClientCreateInsightFiltersResourceAwsEc2InstanceSubnetIdTypeDef
        ],
        "ResourceAwsEc2InstanceLaunchedAt": List[
            ClientCreateInsightFiltersResourceAwsEc2InstanceLaunchedAtTypeDef
        ],
        "ResourceAwsS3BucketOwnerId": List[
            ClientCreateInsightFiltersResourceAwsS3BucketOwnerIdTypeDef
        ],
        "ResourceAwsS3BucketOwnerName": List[
            ClientCreateInsightFiltersResourceAwsS3BucketOwnerNameTypeDef
        ],
        "ResourceAwsIamAccessKeyUserName": List[
            ClientCreateInsightFiltersResourceAwsIamAccessKeyUserNameTypeDef
        ],
        "ResourceAwsIamAccessKeyStatus": List[
            ClientCreateInsightFiltersResourceAwsIamAccessKeyStatusTypeDef
        ],
        "ResourceAwsIamAccessKeyCreatedAt": List[
            ClientCreateInsightFiltersResourceAwsIamAccessKeyCreatedAtTypeDef
        ],
        "ResourceContainerName": List[ClientCreateInsightFiltersResourceContainerNameTypeDef],
        "ResourceContainerImageId": List[ClientCreateInsightFiltersResourceContainerImageIdTypeDef],
        "ResourceContainerImageName": List[
            ClientCreateInsightFiltersResourceContainerImageNameTypeDef
        ],
        "ResourceContainerLaunchedAt": List[
            ClientCreateInsightFiltersResourceContainerLaunchedAtTypeDef
        ],
        "ResourceDetailsOther": List[ClientCreateInsightFiltersResourceDetailsOtherTypeDef],
        "ComplianceStatus": List[ClientCreateInsightFiltersComplianceStatusTypeDef],
        "VerificationState": List[ClientCreateInsightFiltersVerificationStateTypeDef],
        "WorkflowState": List[ClientCreateInsightFiltersWorkflowStateTypeDef],
        "RecordState": List[ClientCreateInsightFiltersRecordStateTypeDef],
        "RelatedFindingsProductArn": List[
            ClientCreateInsightFiltersRelatedFindingsProductArnTypeDef
        ],
        "RelatedFindingsId": List[ClientCreateInsightFiltersRelatedFindingsIdTypeDef],
        "NoteText": List[ClientCreateInsightFiltersNoteTextTypeDef],
        "NoteUpdatedAt": List[ClientCreateInsightFiltersNoteUpdatedAtTypeDef],
        "NoteUpdatedBy": List[ClientCreateInsightFiltersNoteUpdatedByTypeDef],
        "Keyword": List[ClientCreateInsightFiltersKeywordTypeDef],
    },
    total=False,
)


class ClientCreateInsightFiltersTypeDef(_ClientCreateInsightFiltersTypeDef):
    """
    Type definition for `ClientCreateInsight` `Filters`

    One or more attributes used to filter the findings included in the insight. Only findings that
    match the criteria defined in the filters are included in the insight.

    - **ProductArn** *(list) --*

      The ARN generated by Security Hub that uniquely identifies a third-party company (security
      findings provider) after this provider's product (solution that generates findings) is
      registered with Security Hub.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **AwsAccountId** *(list) --*

      The AWS account ID that a finding is generated in.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Id** *(list) --*

      The security findings provider-specific identifier for a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **GeneratorId** *(list) --*

      The identifier for the solution-specific component (a discrete unit of logic) that generated a
      finding. In various security-findings providers' solutions, this generator can be called a
      rule, a check, a detector, a plug-in, etc.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Type** *(list) --*

      A finding type in the format of ``namespace/category/classifier`` that classifies a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **FirstObservedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider first
      observed the potential security issue that a finding captured.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **LastObservedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider most
      recently observed the potential security issue that a finding captured.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **CreatedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider captured the
      potential security issue that a finding captured.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **UpdatedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider last updated
      the finding record.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **SeverityProduct** *(list) --*

      The native severity as defined by the security-findings provider's solution that generated the
      finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **SeverityNormalized** *(list) --*

      The normalized severity of a finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **SeverityLabel** *(list) --*

      The label of a finding's severity.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Confidence** *(list) --*

      A finding's confidence. Confidence is defined as the likelihood that a finding accurately
      identifies the behavior or issue that it was intended to identify. Confidence is scored on a
      0-100 basis using a ratio scale, where 0 means zero percent confidence and 100 means 100
      percent confidence.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **Criticality** *(list) --*

      The level of importance assigned to the resources associated with the finding. A score of 0
      means that the underlying resources have no criticality, and a score of 100 is reserved for
      the most critical resources.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **Title** *(list) --*

      A finding's title.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Description** *(list) --*

      A finding's description.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RecommendationText** *(list) --*

      The recommendation of what to do about the issue described in a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **SourceUrl** *(list) --*

      A URL that links to a page about the current finding in the security-findings provider's
      solution.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProductFields** *(list) --*

      A data type where security-findings providers can include additional solution-specific details
      that aren't part of the defined ``AwsSecurityFinding`` format.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **ProductName** *(list) --*

      The name of the solution (product) that generates findings.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **CompanyName** *(list) --*

      The name of the findings provider (company) that owns the solution (product) that generates
      findings.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **UserDefinedFields** *(list) --*

      A list of name/value string pairs associated with the finding. These are custom, user-defined
      fields added to a finding.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **MalwareName** *(list) --*

      The name of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **MalwareType** *(list) --*

      The type of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **MalwarePath** *(list) --*

      The filesystem path of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **MalwareState** *(list) --*

      The state of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkDirection** *(list) --*

      Indicates the direction of network traffic associated with a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkProtocol** *(list) --*

      The protocol of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkSourceIpV4** *(list) --*

      The source IPv4 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkSourceIpV6** *(list) --*

      The source IPv6 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkSourcePort** *(list) --*

      The source port of network-related information about a finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **NetworkSourceDomain** *(list) --*

      The source domain of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkSourceMac** *(list) --*

      The source media access control (MAC) address of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkDestinationIpV4** *(list) --*

      The destination IPv4 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkDestinationIpV6** *(list) --*

      The destination IPv6 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkDestinationPort** *(list) --*

      The destination port of network-related information about a finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **NetworkDestinationDomain** *(list) --*

      The destination domain of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProcessName** *(list) --*

      The name of the process.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProcessPath** *(list) --*

      The path to the process executable.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProcessPid** *(list) --*

      The process ID.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **ProcessParentPid** *(list) --*

      The parent process ID.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **ProcessLaunchedAt** *(list) --*

      The date/time that the process was launched.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ProcessTerminatedAt** *(list) --*

      The date/time that the process was terminated.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ThreatIntelIndicatorType** *(list) --*

      The type of a threat intel indicator.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorValue** *(list) --*

      The value of a threat intel indicator.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorCategory** *(list) --*

      The category of a threat intel indicator.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorLastObservedAt** *(list) --*

      The date/time of the last observation of a threat intel indicator.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ThreatIntelIndicatorSource** *(list) --*

      The source of the threat intel.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorSourceUrl** *(list) --*

      The URL for more details from the source of the threat intel.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceType** *(list) --*

      Specifies the type of the resource that details are provided for.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceId** *(list) --*

      The canonical identifier for the given resource type.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourcePartition** *(list) --*

      The canonical AWS partition name that the Region is assigned to.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceRegion** *(list) --*

      The canonical AWS external Region name where this resource is located.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceTags** *(list) --*

      A list of AWS tags associated with a resource at the time the finding was processed.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **ResourceAwsEc2InstanceType** *(list) --*

      The instance type of the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceImageId** *(list) --*

      The Amazon Machine Image (AMI) ID of the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceIpV4Addresses** *(list) --*

      The IPv4 addresses associated with the instance.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **ResourceAwsEc2InstanceIpV6Addresses** *(list) --*

      The IPv6 addresses associated with the instance.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **ResourceAwsEc2InstanceKeyName** *(list) --*

      The key name associated with the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceIamInstanceProfileArn** *(list) --*

      The IAM profile ARN of the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceVpcId** *(list) --*

      The identifier of the VPC that the instance was launched in.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceSubnetId** *(list) --*

      The identifier of the subnet that the instance was launched in.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceLaunchedAt** *(list) --*

      The date/time the instance was launched.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ResourceAwsS3BucketOwnerId** *(list) --*

      The canonical user ID of the owner of the S3 bucket.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsS3BucketOwnerName** *(list) --*

      The display name of the owner of the S3 bucket.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsIamAccessKeyUserName** *(list) --*

      The user associated with the IAM access key related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsIamAccessKeyStatus** *(list) --*

      The status of the IAM access key related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsIamAccessKeyCreatedAt** *(list) --*

      The creation date/time of the IAM access key related to a finding.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ResourceContainerName** *(list) --*

      The name of the container related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceContainerImageId** *(list) --*

      The identifier of the image related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceContainerImageName** *(list) --*

      The name of the image related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceContainerLaunchedAt** *(list) --*

      The date/time that the container was started.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ResourceDetailsOther** *(list) --*

      The details of a resource that doesn't have a specific subfield for the resource type defined.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **ComplianceStatus** *(list) --*

      Exclusive to findings that are generated as the result of a check run against a specific rule
      in a supported standard (for example, CIS AWS Foundations). Contains compliance-related
      finding details.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **VerificationState** *(list) --*

      The veracity of a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **WorkflowState** *(list) --*

      The workflow state of a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RecordState** *(list) --*

      The updated record state for the finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RelatedFindingsProductArn** *(list) --*

      The ARN of the solution that generated a related finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RelatedFindingsId** *(list) --*

      The solution-generated identifier for a related finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NoteText** *(list) --*

      The text of a note.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NoteUpdatedAt** *(list) --*

      The timestamp of when the note was updated.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **NoteUpdatedBy** *(list) --*

      The principal that created a note.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Keyword** *(list) --*

      A keyword for a finding.

      - *(dict) --*

        A keyword filter for querying findings.

        - **Value** *(string) --*

          A value for the keyword.
    """


_ClientCreateInsightResponseTypeDef = TypedDict(
    "_ClientCreateInsightResponseTypeDef", {"InsightArn": str}, total=False
)


class ClientCreateInsightResponseTypeDef(_ClientCreateInsightResponseTypeDef):
    """
    Type definition for `ClientCreateInsight` `Response`

    - **InsightArn** *(string) --*

      The ARN of the insight created.
    """


_ClientCreateMembersAccountDetailsTypeDef = TypedDict(
    "_ClientCreateMembersAccountDetailsTypeDef", {"AccountId": str, "Email": str}, total=False
)


class ClientCreateMembersAccountDetailsTypeDef(_ClientCreateMembersAccountDetailsTypeDef):
    """
    Type definition for `ClientCreateMembers` `AccountDetails`

    The details of an AWS account.

    - **AccountId** *(string) --*

      The ID of an AWS account.

    - **Email** *(string) --*

      The email of an AWS account.
    """


_ClientCreateMembersResponseUnprocessedAccountsTypeDef = TypedDict(
    "_ClientCreateMembersResponseUnprocessedAccountsTypeDef",
    {"AccountId": str, "ProcessingResult": str},
    total=False,
)


class ClientCreateMembersResponseUnprocessedAccountsTypeDef(
    _ClientCreateMembersResponseUnprocessedAccountsTypeDef
):
    """
    Type definition for `ClientCreateMembersResponse` `UnprocessedAccounts`

    Details about the account that wasn't processed.

    - **AccountId** *(string) --*

      An AWS account ID of the account that wasn't be processed.

    - **ProcessingResult** *(string) --*

      The reason that the account wasn't be processed.
    """


_ClientCreateMembersResponseTypeDef = TypedDict(
    "_ClientCreateMembersResponseTypeDef",
    {"UnprocessedAccounts": List[ClientCreateMembersResponseUnprocessedAccountsTypeDef]},
    total=False,
)


class ClientCreateMembersResponseTypeDef(_ClientCreateMembersResponseTypeDef):
    """
    Type definition for `ClientCreateMembers` `Response`

    - **UnprocessedAccounts** *(list) --*

      A list of account ID and email address pairs of the AWS accounts that weren't processed.

      - *(dict) --*

        Details about the account that wasn't processed.

        - **AccountId** *(string) --*

          An AWS account ID of the account that wasn't be processed.

        - **ProcessingResult** *(string) --*

          The reason that the account wasn't be processed.
    """


_ClientDeclineInvitationsResponseUnprocessedAccountsTypeDef = TypedDict(
    "_ClientDeclineInvitationsResponseUnprocessedAccountsTypeDef",
    {"AccountId": str, "ProcessingResult": str},
    total=False,
)


class ClientDeclineInvitationsResponseUnprocessedAccountsTypeDef(
    _ClientDeclineInvitationsResponseUnprocessedAccountsTypeDef
):
    """
    Type definition for `ClientDeclineInvitationsResponse` `UnprocessedAccounts`

    Details about the account that wasn't processed.

    - **AccountId** *(string) --*

      An AWS account ID of the account that wasn't be processed.

    - **ProcessingResult** *(string) --*

      The reason that the account wasn't be processed.
    """


_ClientDeclineInvitationsResponseTypeDef = TypedDict(
    "_ClientDeclineInvitationsResponseTypeDef",
    {"UnprocessedAccounts": List[ClientDeclineInvitationsResponseUnprocessedAccountsTypeDef]},
    total=False,
)


class ClientDeclineInvitationsResponseTypeDef(_ClientDeclineInvitationsResponseTypeDef):
    """
    Type definition for `ClientDeclineInvitations` `Response`

    - **UnprocessedAccounts** *(list) --*

      A list of account ID and email address pairs of the AWS accounts that weren't processed.

      - *(dict) --*

        Details about the account that wasn't processed.

        - **AccountId** *(string) --*

          An AWS account ID of the account that wasn't be processed.

        - **ProcessingResult** *(string) --*

          The reason that the account wasn't be processed.
    """


_ClientDeleteActionTargetResponseTypeDef = TypedDict(
    "_ClientDeleteActionTargetResponseTypeDef", {"ActionTargetArn": str}, total=False
)


class ClientDeleteActionTargetResponseTypeDef(_ClientDeleteActionTargetResponseTypeDef):
    """
    Type definition for `ClientDeleteActionTarget` `Response`

    - **ActionTargetArn** *(string) --*

      The ARN of the custom action target that was deleted.
    """


_ClientDeleteInsightResponseTypeDef = TypedDict(
    "_ClientDeleteInsightResponseTypeDef", {"InsightArn": str}, total=False
)


class ClientDeleteInsightResponseTypeDef(_ClientDeleteInsightResponseTypeDef):
    """
    Type definition for `ClientDeleteInsight` `Response`

    - **InsightArn** *(string) --*

      The ARN of the insight that was deleted.
    """


_ClientDeleteInvitationsResponseUnprocessedAccountsTypeDef = TypedDict(
    "_ClientDeleteInvitationsResponseUnprocessedAccountsTypeDef",
    {"AccountId": str, "ProcessingResult": str},
    total=False,
)


class ClientDeleteInvitationsResponseUnprocessedAccountsTypeDef(
    _ClientDeleteInvitationsResponseUnprocessedAccountsTypeDef
):
    """
    Type definition for `ClientDeleteInvitationsResponse` `UnprocessedAccounts`

    Details about the account that wasn't processed.

    - **AccountId** *(string) --*

      An AWS account ID of the account that wasn't be processed.

    - **ProcessingResult** *(string) --*

      The reason that the account wasn't be processed.
    """


_ClientDeleteInvitationsResponseTypeDef = TypedDict(
    "_ClientDeleteInvitationsResponseTypeDef",
    {"UnprocessedAccounts": List[ClientDeleteInvitationsResponseUnprocessedAccountsTypeDef]},
    total=False,
)


class ClientDeleteInvitationsResponseTypeDef(_ClientDeleteInvitationsResponseTypeDef):
    """
    Type definition for `ClientDeleteInvitations` `Response`

    - **UnprocessedAccounts** *(list) --*

      A list of account ID and email address pairs of the AWS accounts that invitations weren't
      deleted for.

      - *(dict) --*

        Details about the account that wasn't processed.

        - **AccountId** *(string) --*

          An AWS account ID of the account that wasn't be processed.

        - **ProcessingResult** *(string) --*

          The reason that the account wasn't be processed.
    """


_ClientDeleteMembersResponseUnprocessedAccountsTypeDef = TypedDict(
    "_ClientDeleteMembersResponseUnprocessedAccountsTypeDef",
    {"AccountId": str, "ProcessingResult": str},
    total=False,
)


class ClientDeleteMembersResponseUnprocessedAccountsTypeDef(
    _ClientDeleteMembersResponseUnprocessedAccountsTypeDef
):
    """
    Type definition for `ClientDeleteMembersResponse` `UnprocessedAccounts`

    Details about the account that wasn't processed.

    - **AccountId** *(string) --*

      An AWS account ID of the account that wasn't be processed.

    - **ProcessingResult** *(string) --*

      The reason that the account wasn't be processed.
    """


_ClientDeleteMembersResponseTypeDef = TypedDict(
    "_ClientDeleteMembersResponseTypeDef",
    {"UnprocessedAccounts": List[ClientDeleteMembersResponseUnprocessedAccountsTypeDef]},
    total=False,
)


class ClientDeleteMembersResponseTypeDef(_ClientDeleteMembersResponseTypeDef):
    """
    Type definition for `ClientDeleteMembers` `Response`

    - **UnprocessedAccounts** *(list) --*

      A list of account ID and email address pairs of the AWS accounts that weren't deleted.

      - *(dict) --*

        Details about the account that wasn't processed.

        - **AccountId** *(string) --*

          An AWS account ID of the account that wasn't be processed.

        - **ProcessingResult** *(string) --*

          The reason that the account wasn't be processed.
    """


_ClientDescribeActionTargetsResponseActionTargetsTypeDef = TypedDict(
    "_ClientDescribeActionTargetsResponseActionTargetsTypeDef",
    {"ActionTargetArn": str, "Name": str, "Description": str},
    total=False,
)


class ClientDescribeActionTargetsResponseActionTargetsTypeDef(
    _ClientDescribeActionTargetsResponseActionTargetsTypeDef
):
    """
    Type definition for `ClientDescribeActionTargetsResponse` `ActionTargets`

    An ``ActionTarget`` object.

    - **ActionTargetArn** *(string) --*

      The ARN for the target action.

    - **Name** *(string) --*

      The name of the action target.

    - **Description** *(string) --*

      The description of the target action.
    """


_ClientDescribeActionTargetsResponseTypeDef = TypedDict(
    "_ClientDescribeActionTargetsResponseTypeDef",
    {
        "ActionTargets": List[ClientDescribeActionTargetsResponseActionTargetsTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeActionTargetsResponseTypeDef(_ClientDescribeActionTargetsResponseTypeDef):
    """
    Type definition for `ClientDescribeActionTargets` `Response`

    - **ActionTargets** *(list) --*

      A list of ``ActionTarget`` objects. Each object includes the ``ActionTargetArn`` ,
      ``Description`` , and ``Name`` of a custom action target available in Security Hub.

      - *(dict) --*

        An ``ActionTarget`` object.

        - **ActionTargetArn** *(string) --*

          The ARN for the target action.

        - **Name** *(string) --*

          The name of the action target.

        - **Description** *(string) --*

          The description of the target action.

    - **NextToken** *(string) --*

      The token that is required for pagination.
    """


_ClientDescribeHubResponseTypeDef = TypedDict(
    "_ClientDescribeHubResponseTypeDef", {"HubArn": str, "SubscribedAt": str}, total=False
)


class ClientDescribeHubResponseTypeDef(_ClientDescribeHubResponseTypeDef):
    """
    Type definition for `ClientDescribeHub` `Response`

    - **HubArn** *(string) --*

      The ARN of the Hub resource retrieved.

    - **SubscribedAt** *(string) --*

      The date and time when Security Hub was enabled in the account.
    """


_ClientDescribeProductsResponseProductsTypeDef = TypedDict(
    "_ClientDescribeProductsResponseProductsTypeDef",
    {
        "ProductArn": str,
        "ProductName": str,
        "CompanyName": str,
        "Description": str,
        "Categories": List[str],
        "MarketplaceUrl": str,
        "ActivationUrl": str,
        "ProductSubscriptionResourcePolicy": str,
    },
    total=False,
)


class ClientDescribeProductsResponseProductsTypeDef(_ClientDescribeProductsResponseProductsTypeDef):
    """
    Type definition for `ClientDescribeProductsResponse` `Products`

    Contains details about a product.

    - **ProductArn** *(string) --*

      The ARN assigned to the product.

    - **ProductName** *(string) --*

      The name of the product.

    - **CompanyName** *(string) --*

      The name of the company that provides the product.

    - **Description** *(string) --*

      A description of the product.

    - **Categories** *(list) --*

      The categories assigned to the product.

      - *(string) --*

    - **MarketplaceUrl** *(string) --*

      The URL for the page that contains more information about the product.

    - **ActivationUrl** *(string) --*

      The URL used to activate the product.

    - **ProductSubscriptionResourcePolicy** *(string) --*

      The resource policy associated with the product.
    """


_ClientDescribeProductsResponseTypeDef = TypedDict(
    "_ClientDescribeProductsResponseTypeDef",
    {"Products": List[ClientDescribeProductsResponseProductsTypeDef], "NextToken": str},
    total=False,
)


class ClientDescribeProductsResponseTypeDef(_ClientDescribeProductsResponseTypeDef):
    """
    Type definition for `ClientDescribeProducts` `Response`

    - **Products** *(list) --*

      A list of products, including details for each product.

      - *(dict) --*

        Contains details about a product.

        - **ProductArn** *(string) --*

          The ARN assigned to the product.

        - **ProductName** *(string) --*

          The name of the product.

        - **CompanyName** *(string) --*

          The name of the company that provides the product.

        - **Description** *(string) --*

          A description of the product.

        - **Categories** *(list) --*

          The categories assigned to the product.

          - *(string) --*

        - **MarketplaceUrl** *(string) --*

          The URL for the page that contains more information about the product.

        - **ActivationUrl** *(string) --*

          The URL used to activate the product.

        - **ProductSubscriptionResourcePolicy** *(string) --*

          The resource policy associated with the product.

    - **NextToken** *(string) --*

      The token that is required for pagination.
    """


_ClientEnableImportFindingsForProductResponseTypeDef = TypedDict(
    "_ClientEnableImportFindingsForProductResponseTypeDef",
    {"ProductSubscriptionArn": str},
    total=False,
)


class ClientEnableImportFindingsForProductResponseTypeDef(
    _ClientEnableImportFindingsForProductResponseTypeDef
):
    """
    Type definition for `ClientEnableImportFindingsForProduct` `Response`

    - **ProductSubscriptionArn** *(string) --*

      The ARN of your subscription to the product to enable integrations for.
    """


_ClientGetEnabledStandardsResponseStandardsSubscriptionsTypeDef = TypedDict(
    "_ClientGetEnabledStandardsResponseStandardsSubscriptionsTypeDef",
    {
        "StandardsSubscriptionArn": str,
        "StandardsArn": str,
        "StandardsInput": Dict[str, str],
        "StandardsStatus": str,
    },
    total=False,
)


class ClientGetEnabledStandardsResponseStandardsSubscriptionsTypeDef(
    _ClientGetEnabledStandardsResponseStandardsSubscriptionsTypeDef
):
    """
    Type definition for `ClientGetEnabledStandardsResponse` `StandardsSubscriptions`

    A resource that represents your subscription to a supported standard.

    - **StandardsSubscriptionArn** *(string) --*

      The ARN of a resource that represents your subscription to a supported standard.

    - **StandardsArn** *(string) --*

      The ARN of a standard.

      In this release, Security Hub supports only the CIS AWS Foundations standard, which uses the
      following ARN: ``arn:aws:securityhub:::ruleset/cis-aws-foundations-benchmark/v/1.2.0.``

    - **StandardsInput** *(dict) --*

      A key-value pair of input for the standard.

      - *(string) --*

        - *(string) --*

    - **StandardsStatus** *(string) --*

      The status of the standards subscription.
    """


_ClientGetEnabledStandardsResponseTypeDef = TypedDict(
    "_ClientGetEnabledStandardsResponseTypeDef",
    {
        "StandardsSubscriptions": List[
            ClientGetEnabledStandardsResponseStandardsSubscriptionsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientGetEnabledStandardsResponseTypeDef(_ClientGetEnabledStandardsResponseTypeDef):
    """
    Type definition for `ClientGetEnabledStandards` `Response`

    - **StandardsSubscriptions** *(list) --*

      A list of ``StandardsSubscriptions`` objects that include information about the enabled
      standards.

      - *(dict) --*

        A resource that represents your subscription to a supported standard.

        - **StandardsSubscriptionArn** *(string) --*

          The ARN of a resource that represents your subscription to a supported standard.

        - **StandardsArn** *(string) --*

          The ARN of a standard.

          In this release, Security Hub supports only the CIS AWS Foundations standard, which uses
          the following ARN:
          ``arn:aws:securityhub:::ruleset/cis-aws-foundations-benchmark/v/1.2.0.``

        - **StandardsInput** *(dict) --*

          A key-value pair of input for the standard.

          - *(string) --*

            - *(string) --*

        - **StandardsStatus** *(string) --*

          The status of the standards subscription.

    - **NextToken** *(string) --*

      The token that is required for pagination.
    """


_ClientGetFindingsFiltersAwsAccountIdTypeDef = TypedDict(
    "_ClientGetFindingsFiltersAwsAccountIdTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientGetFindingsFiltersAwsAccountIdTypeDef(_ClientGetFindingsFiltersAwsAccountIdTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `AwsAccountId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersCompanyNameTypeDef = TypedDict(
    "_ClientGetFindingsFiltersCompanyNameTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientGetFindingsFiltersCompanyNameTypeDef(_ClientGetFindingsFiltersCompanyNameTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `CompanyName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersComplianceStatusTypeDef = TypedDict(
    "_ClientGetFindingsFiltersComplianceStatusTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersComplianceStatusTypeDef(
    _ClientGetFindingsFiltersComplianceStatusTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ComplianceStatus`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersConfidenceTypeDef = TypedDict(
    "_ClientGetFindingsFiltersConfidenceTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientGetFindingsFiltersConfidenceTypeDef(_ClientGetFindingsFiltersConfidenceTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `Confidence`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientGetFindingsFiltersCreatedAtDateRangeTypeDef = TypedDict(
    "_ClientGetFindingsFiltersCreatedAtDateRangeTypeDef", {"Value": int, "Unit": str}, total=False
)


class ClientGetFindingsFiltersCreatedAtDateRangeTypeDef(
    _ClientGetFindingsFiltersCreatedAtDateRangeTypeDef
):
    """
    Type definition for `ClientGetFindingsFiltersCreatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientGetFindingsFiltersCreatedAtTypeDef = TypedDict(
    "_ClientGetFindingsFiltersCreatedAtTypeDef",
    {"Start": str, "End": str, "DateRange": ClientGetFindingsFiltersCreatedAtDateRangeTypeDef},
    total=False,
)


class ClientGetFindingsFiltersCreatedAtTypeDef(_ClientGetFindingsFiltersCreatedAtTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `CreatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientGetFindingsFiltersCriticalityTypeDef = TypedDict(
    "_ClientGetFindingsFiltersCriticalityTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientGetFindingsFiltersCriticalityTypeDef(_ClientGetFindingsFiltersCriticalityTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `Criticality`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientGetFindingsFiltersDescriptionTypeDef = TypedDict(
    "_ClientGetFindingsFiltersDescriptionTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientGetFindingsFiltersDescriptionTypeDef(_ClientGetFindingsFiltersDescriptionTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `Description`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersFirstObservedAtDateRangeTypeDef = TypedDict(
    "_ClientGetFindingsFiltersFirstObservedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientGetFindingsFiltersFirstObservedAtDateRangeTypeDef(
    _ClientGetFindingsFiltersFirstObservedAtDateRangeTypeDef
):
    """
    Type definition for `ClientGetFindingsFiltersFirstObservedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientGetFindingsFiltersFirstObservedAtTypeDef = TypedDict(
    "_ClientGetFindingsFiltersFirstObservedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientGetFindingsFiltersFirstObservedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientGetFindingsFiltersFirstObservedAtTypeDef(
    _ClientGetFindingsFiltersFirstObservedAtTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `FirstObservedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientGetFindingsFiltersGeneratorIdTypeDef = TypedDict(
    "_ClientGetFindingsFiltersGeneratorIdTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientGetFindingsFiltersGeneratorIdTypeDef(_ClientGetFindingsFiltersGeneratorIdTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `GeneratorId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersIdTypeDef = TypedDict(
    "_ClientGetFindingsFiltersIdTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientGetFindingsFiltersIdTypeDef(_ClientGetFindingsFiltersIdTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `Id`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersKeywordTypeDef = TypedDict(
    "_ClientGetFindingsFiltersKeywordTypeDef", {"Value": str}, total=False
)


class ClientGetFindingsFiltersKeywordTypeDef(_ClientGetFindingsFiltersKeywordTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `Keyword`

    A keyword filter for querying findings.

    - **Value** *(string) --*

      A value for the keyword.
    """


_ClientGetFindingsFiltersLastObservedAtDateRangeTypeDef = TypedDict(
    "_ClientGetFindingsFiltersLastObservedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientGetFindingsFiltersLastObservedAtDateRangeTypeDef(
    _ClientGetFindingsFiltersLastObservedAtDateRangeTypeDef
):
    """
    Type definition for `ClientGetFindingsFiltersLastObservedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientGetFindingsFiltersLastObservedAtTypeDef = TypedDict(
    "_ClientGetFindingsFiltersLastObservedAtTypeDef",
    {"Start": str, "End": str, "DateRange": ClientGetFindingsFiltersLastObservedAtDateRangeTypeDef},
    total=False,
)


class ClientGetFindingsFiltersLastObservedAtTypeDef(_ClientGetFindingsFiltersLastObservedAtTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `LastObservedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientGetFindingsFiltersMalwareNameTypeDef = TypedDict(
    "_ClientGetFindingsFiltersMalwareNameTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientGetFindingsFiltersMalwareNameTypeDef(_ClientGetFindingsFiltersMalwareNameTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `MalwareName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersMalwarePathTypeDef = TypedDict(
    "_ClientGetFindingsFiltersMalwarePathTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientGetFindingsFiltersMalwarePathTypeDef(_ClientGetFindingsFiltersMalwarePathTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `MalwarePath`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersMalwareStateTypeDef = TypedDict(
    "_ClientGetFindingsFiltersMalwareStateTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientGetFindingsFiltersMalwareStateTypeDef(_ClientGetFindingsFiltersMalwareStateTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `MalwareState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersMalwareTypeTypeDef = TypedDict(
    "_ClientGetFindingsFiltersMalwareTypeTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientGetFindingsFiltersMalwareTypeTypeDef(_ClientGetFindingsFiltersMalwareTypeTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `MalwareType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersNetworkDestinationDomainTypeDef = TypedDict(
    "_ClientGetFindingsFiltersNetworkDestinationDomainTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersNetworkDestinationDomainTypeDef(
    _ClientGetFindingsFiltersNetworkDestinationDomainTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `NetworkDestinationDomain`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersNetworkDestinationIpV4TypeDef = TypedDict(
    "_ClientGetFindingsFiltersNetworkDestinationIpV4TypeDef", {"Cidr": str}, total=False
)


class ClientGetFindingsFiltersNetworkDestinationIpV4TypeDef(
    _ClientGetFindingsFiltersNetworkDestinationIpV4TypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `NetworkDestinationIpV4`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientGetFindingsFiltersNetworkDestinationIpV6TypeDef = TypedDict(
    "_ClientGetFindingsFiltersNetworkDestinationIpV6TypeDef", {"Cidr": str}, total=False
)


class ClientGetFindingsFiltersNetworkDestinationIpV6TypeDef(
    _ClientGetFindingsFiltersNetworkDestinationIpV6TypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `NetworkDestinationIpV6`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientGetFindingsFiltersNetworkDestinationPortTypeDef = TypedDict(
    "_ClientGetFindingsFiltersNetworkDestinationPortTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientGetFindingsFiltersNetworkDestinationPortTypeDef(
    _ClientGetFindingsFiltersNetworkDestinationPortTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `NetworkDestinationPort`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientGetFindingsFiltersNetworkDirectionTypeDef = TypedDict(
    "_ClientGetFindingsFiltersNetworkDirectionTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersNetworkDirectionTypeDef(
    _ClientGetFindingsFiltersNetworkDirectionTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `NetworkDirection`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersNetworkProtocolTypeDef = TypedDict(
    "_ClientGetFindingsFiltersNetworkProtocolTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersNetworkProtocolTypeDef(
    _ClientGetFindingsFiltersNetworkProtocolTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `NetworkProtocol`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersNetworkSourceDomainTypeDef = TypedDict(
    "_ClientGetFindingsFiltersNetworkSourceDomainTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersNetworkSourceDomainTypeDef(
    _ClientGetFindingsFiltersNetworkSourceDomainTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `NetworkSourceDomain`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersNetworkSourceIpV4TypeDef = TypedDict(
    "_ClientGetFindingsFiltersNetworkSourceIpV4TypeDef", {"Cidr": str}, total=False
)


class ClientGetFindingsFiltersNetworkSourceIpV4TypeDef(
    _ClientGetFindingsFiltersNetworkSourceIpV4TypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `NetworkSourceIpV4`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientGetFindingsFiltersNetworkSourceIpV6TypeDef = TypedDict(
    "_ClientGetFindingsFiltersNetworkSourceIpV6TypeDef", {"Cidr": str}, total=False
)


class ClientGetFindingsFiltersNetworkSourceIpV6TypeDef(
    _ClientGetFindingsFiltersNetworkSourceIpV6TypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `NetworkSourceIpV6`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientGetFindingsFiltersNetworkSourceMacTypeDef = TypedDict(
    "_ClientGetFindingsFiltersNetworkSourceMacTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersNetworkSourceMacTypeDef(
    _ClientGetFindingsFiltersNetworkSourceMacTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `NetworkSourceMac`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersNetworkSourcePortTypeDef = TypedDict(
    "_ClientGetFindingsFiltersNetworkSourcePortTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientGetFindingsFiltersNetworkSourcePortTypeDef(
    _ClientGetFindingsFiltersNetworkSourcePortTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `NetworkSourcePort`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientGetFindingsFiltersNoteTextTypeDef = TypedDict(
    "_ClientGetFindingsFiltersNoteTextTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientGetFindingsFiltersNoteTextTypeDef(_ClientGetFindingsFiltersNoteTextTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `NoteText`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersNoteUpdatedAtDateRangeTypeDef = TypedDict(
    "_ClientGetFindingsFiltersNoteUpdatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientGetFindingsFiltersNoteUpdatedAtDateRangeTypeDef(
    _ClientGetFindingsFiltersNoteUpdatedAtDateRangeTypeDef
):
    """
    Type definition for `ClientGetFindingsFiltersNoteUpdatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientGetFindingsFiltersNoteUpdatedAtTypeDef = TypedDict(
    "_ClientGetFindingsFiltersNoteUpdatedAtTypeDef",
    {"Start": str, "End": str, "DateRange": ClientGetFindingsFiltersNoteUpdatedAtDateRangeTypeDef},
    total=False,
)


class ClientGetFindingsFiltersNoteUpdatedAtTypeDef(_ClientGetFindingsFiltersNoteUpdatedAtTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `NoteUpdatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientGetFindingsFiltersNoteUpdatedByTypeDef = TypedDict(
    "_ClientGetFindingsFiltersNoteUpdatedByTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientGetFindingsFiltersNoteUpdatedByTypeDef(_ClientGetFindingsFiltersNoteUpdatedByTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `NoteUpdatedBy`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersProcessLaunchedAtDateRangeTypeDef = TypedDict(
    "_ClientGetFindingsFiltersProcessLaunchedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientGetFindingsFiltersProcessLaunchedAtDateRangeTypeDef(
    _ClientGetFindingsFiltersProcessLaunchedAtDateRangeTypeDef
):
    """
    Type definition for `ClientGetFindingsFiltersProcessLaunchedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientGetFindingsFiltersProcessLaunchedAtTypeDef = TypedDict(
    "_ClientGetFindingsFiltersProcessLaunchedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientGetFindingsFiltersProcessLaunchedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientGetFindingsFiltersProcessLaunchedAtTypeDef(
    _ClientGetFindingsFiltersProcessLaunchedAtTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ProcessLaunchedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientGetFindingsFiltersProcessNameTypeDef = TypedDict(
    "_ClientGetFindingsFiltersProcessNameTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientGetFindingsFiltersProcessNameTypeDef(_ClientGetFindingsFiltersProcessNameTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `ProcessName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersProcessParentPidTypeDef = TypedDict(
    "_ClientGetFindingsFiltersProcessParentPidTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientGetFindingsFiltersProcessParentPidTypeDef(
    _ClientGetFindingsFiltersProcessParentPidTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ProcessParentPid`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientGetFindingsFiltersProcessPathTypeDef = TypedDict(
    "_ClientGetFindingsFiltersProcessPathTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientGetFindingsFiltersProcessPathTypeDef(_ClientGetFindingsFiltersProcessPathTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `ProcessPath`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersProcessPidTypeDef = TypedDict(
    "_ClientGetFindingsFiltersProcessPidTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientGetFindingsFiltersProcessPidTypeDef(_ClientGetFindingsFiltersProcessPidTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `ProcessPid`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientGetFindingsFiltersProcessTerminatedAtDateRangeTypeDef = TypedDict(
    "_ClientGetFindingsFiltersProcessTerminatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientGetFindingsFiltersProcessTerminatedAtDateRangeTypeDef(
    _ClientGetFindingsFiltersProcessTerminatedAtDateRangeTypeDef
):
    """
    Type definition for `ClientGetFindingsFiltersProcessTerminatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientGetFindingsFiltersProcessTerminatedAtTypeDef = TypedDict(
    "_ClientGetFindingsFiltersProcessTerminatedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientGetFindingsFiltersProcessTerminatedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientGetFindingsFiltersProcessTerminatedAtTypeDef(
    _ClientGetFindingsFiltersProcessTerminatedAtTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ProcessTerminatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientGetFindingsFiltersProductArnTypeDef = TypedDict(
    "_ClientGetFindingsFiltersProductArnTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientGetFindingsFiltersProductArnTypeDef(_ClientGetFindingsFiltersProductArnTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `ProductArn`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersProductFieldsTypeDef = TypedDict(
    "_ClientGetFindingsFiltersProductFieldsTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersProductFieldsTypeDef(_ClientGetFindingsFiltersProductFieldsTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `ProductFields`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_ClientGetFindingsFiltersProductNameTypeDef = TypedDict(
    "_ClientGetFindingsFiltersProductNameTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientGetFindingsFiltersProductNameTypeDef(_ClientGetFindingsFiltersProductNameTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `ProductName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersRecommendationTextTypeDef = TypedDict(
    "_ClientGetFindingsFiltersRecommendationTextTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersRecommendationTextTypeDef(
    _ClientGetFindingsFiltersRecommendationTextTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `RecommendationText`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersRecordStateTypeDef = TypedDict(
    "_ClientGetFindingsFiltersRecordStateTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientGetFindingsFiltersRecordStateTypeDef(_ClientGetFindingsFiltersRecordStateTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `RecordState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersRelatedFindingsIdTypeDef = TypedDict(
    "_ClientGetFindingsFiltersRelatedFindingsIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersRelatedFindingsIdTypeDef(
    _ClientGetFindingsFiltersRelatedFindingsIdTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `RelatedFindingsId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersRelatedFindingsProductArnTypeDef = TypedDict(
    "_ClientGetFindingsFiltersRelatedFindingsProductArnTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersRelatedFindingsProductArnTypeDef(
    _ClientGetFindingsFiltersRelatedFindingsProductArnTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `RelatedFindingsProductArn`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef(
    _ClientGetFindingsFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ResourceAwsEc2InstanceIamInstanceProfileArn`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersResourceAwsEc2InstanceImageIdTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourceAwsEc2InstanceImageIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersResourceAwsEc2InstanceImageIdTypeDef(
    _ClientGetFindingsFiltersResourceAwsEc2InstanceImageIdTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ResourceAwsEc2InstanceImageId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef",
    {"Cidr": str},
    total=False,
)


class ClientGetFindingsFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef(
    _ClientGetFindingsFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ResourceAwsEc2InstanceIpV4Addresses`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientGetFindingsFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef",
    {"Cidr": str},
    total=False,
)


class ClientGetFindingsFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef(
    _ClientGetFindingsFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ResourceAwsEc2InstanceIpV6Addresses`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientGetFindingsFiltersResourceAwsEc2InstanceKeyNameTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourceAwsEc2InstanceKeyNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersResourceAwsEc2InstanceKeyNameTypeDef(
    _ClientGetFindingsFiltersResourceAwsEc2InstanceKeyNameTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ResourceAwsEc2InstanceKeyName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientGetFindingsFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef(
    _ClientGetFindingsFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef
):
    """
    Type definition for `ClientGetFindingsFiltersResourceAwsEc2InstanceLaunchedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientGetFindingsFiltersResourceAwsEc2InstanceLaunchedAtTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourceAwsEc2InstanceLaunchedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientGetFindingsFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientGetFindingsFiltersResourceAwsEc2InstanceLaunchedAtTypeDef(
    _ClientGetFindingsFiltersResourceAwsEc2InstanceLaunchedAtTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ResourceAwsEc2InstanceLaunchedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientGetFindingsFiltersResourceAwsEc2InstanceSubnetIdTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourceAwsEc2InstanceSubnetIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersResourceAwsEc2InstanceSubnetIdTypeDef(
    _ClientGetFindingsFiltersResourceAwsEc2InstanceSubnetIdTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ResourceAwsEc2InstanceSubnetId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersResourceAwsEc2InstanceTypeTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourceAwsEc2InstanceTypeTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersResourceAwsEc2InstanceTypeTypeDef(
    _ClientGetFindingsFiltersResourceAwsEc2InstanceTypeTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ResourceAwsEc2InstanceType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersResourceAwsEc2InstanceVpcIdTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourceAwsEc2InstanceVpcIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersResourceAwsEc2InstanceVpcIdTypeDef(
    _ClientGetFindingsFiltersResourceAwsEc2InstanceVpcIdTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ResourceAwsEc2InstanceVpcId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientGetFindingsFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef(
    _ClientGetFindingsFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef
):
    """
    Type definition for `ClientGetFindingsFiltersResourceAwsIamAccessKeyCreatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientGetFindingsFiltersResourceAwsIamAccessKeyCreatedAtTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourceAwsIamAccessKeyCreatedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientGetFindingsFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientGetFindingsFiltersResourceAwsIamAccessKeyCreatedAtTypeDef(
    _ClientGetFindingsFiltersResourceAwsIamAccessKeyCreatedAtTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ResourceAwsIamAccessKeyCreatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientGetFindingsFiltersResourceAwsIamAccessKeyStatusTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourceAwsIamAccessKeyStatusTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersResourceAwsIamAccessKeyStatusTypeDef(
    _ClientGetFindingsFiltersResourceAwsIamAccessKeyStatusTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ResourceAwsIamAccessKeyStatus`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersResourceAwsIamAccessKeyUserNameTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourceAwsIamAccessKeyUserNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersResourceAwsIamAccessKeyUserNameTypeDef(
    _ClientGetFindingsFiltersResourceAwsIamAccessKeyUserNameTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ResourceAwsIamAccessKeyUserName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersResourceAwsS3BucketOwnerIdTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourceAwsS3BucketOwnerIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersResourceAwsS3BucketOwnerIdTypeDef(
    _ClientGetFindingsFiltersResourceAwsS3BucketOwnerIdTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ResourceAwsS3BucketOwnerId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersResourceAwsS3BucketOwnerNameTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourceAwsS3BucketOwnerNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersResourceAwsS3BucketOwnerNameTypeDef(
    _ClientGetFindingsFiltersResourceAwsS3BucketOwnerNameTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ResourceAwsS3BucketOwnerName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersResourceContainerImageIdTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourceContainerImageIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersResourceContainerImageIdTypeDef(
    _ClientGetFindingsFiltersResourceContainerImageIdTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ResourceContainerImageId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersResourceContainerImageNameTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourceContainerImageNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersResourceContainerImageNameTypeDef(
    _ClientGetFindingsFiltersResourceContainerImageNameTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ResourceContainerImageName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersResourceContainerLaunchedAtDateRangeTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourceContainerLaunchedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientGetFindingsFiltersResourceContainerLaunchedAtDateRangeTypeDef(
    _ClientGetFindingsFiltersResourceContainerLaunchedAtDateRangeTypeDef
):
    """
    Type definition for `ClientGetFindingsFiltersResourceContainerLaunchedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientGetFindingsFiltersResourceContainerLaunchedAtTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourceContainerLaunchedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientGetFindingsFiltersResourceContainerLaunchedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientGetFindingsFiltersResourceContainerLaunchedAtTypeDef(
    _ClientGetFindingsFiltersResourceContainerLaunchedAtTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ResourceContainerLaunchedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientGetFindingsFiltersResourceContainerNameTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourceContainerNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersResourceContainerNameTypeDef(
    _ClientGetFindingsFiltersResourceContainerNameTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ResourceContainerName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersResourceDetailsOtherTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourceDetailsOtherTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersResourceDetailsOtherTypeDef(
    _ClientGetFindingsFiltersResourceDetailsOtherTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ResourceDetailsOther`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_ClientGetFindingsFiltersResourceIdTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourceIdTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientGetFindingsFiltersResourceIdTypeDef(_ClientGetFindingsFiltersResourceIdTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `ResourceId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersResourcePartitionTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourcePartitionTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersResourcePartitionTypeDef(
    _ClientGetFindingsFiltersResourcePartitionTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ResourcePartition`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersResourceRegionTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourceRegionTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientGetFindingsFiltersResourceRegionTypeDef(_ClientGetFindingsFiltersResourceRegionTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `ResourceRegion`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersResourceTagsTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourceTagsTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersResourceTagsTypeDef(_ClientGetFindingsFiltersResourceTagsTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `ResourceTags`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_ClientGetFindingsFiltersResourceTypeTypeDef = TypedDict(
    "_ClientGetFindingsFiltersResourceTypeTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientGetFindingsFiltersResourceTypeTypeDef(_ClientGetFindingsFiltersResourceTypeTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `ResourceType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersSeverityLabelTypeDef = TypedDict(
    "_ClientGetFindingsFiltersSeverityLabelTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientGetFindingsFiltersSeverityLabelTypeDef(_ClientGetFindingsFiltersSeverityLabelTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `SeverityLabel`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersSeverityNormalizedTypeDef = TypedDict(
    "_ClientGetFindingsFiltersSeverityNormalizedTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientGetFindingsFiltersSeverityNormalizedTypeDef(
    _ClientGetFindingsFiltersSeverityNormalizedTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `SeverityNormalized`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientGetFindingsFiltersSeverityProductTypeDef = TypedDict(
    "_ClientGetFindingsFiltersSeverityProductTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientGetFindingsFiltersSeverityProductTypeDef(
    _ClientGetFindingsFiltersSeverityProductTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `SeverityProduct`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientGetFindingsFiltersSourceUrlTypeDef = TypedDict(
    "_ClientGetFindingsFiltersSourceUrlTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientGetFindingsFiltersSourceUrlTypeDef(_ClientGetFindingsFiltersSourceUrlTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `SourceUrl`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersThreatIntelIndicatorCategoryTypeDef = TypedDict(
    "_ClientGetFindingsFiltersThreatIntelIndicatorCategoryTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersThreatIntelIndicatorCategoryTypeDef(
    _ClientGetFindingsFiltersThreatIntelIndicatorCategoryTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ThreatIntelIndicatorCategory`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef = TypedDict(
    "_ClientGetFindingsFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientGetFindingsFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef(
    _ClientGetFindingsFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef
):
    """
    Type definition for `ClientGetFindingsFiltersThreatIntelIndicatorLastObservedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientGetFindingsFiltersThreatIntelIndicatorLastObservedAtTypeDef = TypedDict(
    "_ClientGetFindingsFiltersThreatIntelIndicatorLastObservedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientGetFindingsFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientGetFindingsFiltersThreatIntelIndicatorLastObservedAtTypeDef(
    _ClientGetFindingsFiltersThreatIntelIndicatorLastObservedAtTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ThreatIntelIndicatorLastObservedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientGetFindingsFiltersThreatIntelIndicatorSourceTypeDef = TypedDict(
    "_ClientGetFindingsFiltersThreatIntelIndicatorSourceTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersThreatIntelIndicatorSourceTypeDef(
    _ClientGetFindingsFiltersThreatIntelIndicatorSourceTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ThreatIntelIndicatorSource`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersThreatIntelIndicatorSourceUrlTypeDef = TypedDict(
    "_ClientGetFindingsFiltersThreatIntelIndicatorSourceUrlTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersThreatIntelIndicatorSourceUrlTypeDef(
    _ClientGetFindingsFiltersThreatIntelIndicatorSourceUrlTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ThreatIntelIndicatorSourceUrl`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersThreatIntelIndicatorTypeTypeDef = TypedDict(
    "_ClientGetFindingsFiltersThreatIntelIndicatorTypeTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersThreatIntelIndicatorTypeTypeDef(
    _ClientGetFindingsFiltersThreatIntelIndicatorTypeTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ThreatIntelIndicatorType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersThreatIntelIndicatorValueTypeDef = TypedDict(
    "_ClientGetFindingsFiltersThreatIntelIndicatorValueTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersThreatIntelIndicatorValueTypeDef(
    _ClientGetFindingsFiltersThreatIntelIndicatorValueTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `ThreatIntelIndicatorValue`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersTitleTypeDef = TypedDict(
    "_ClientGetFindingsFiltersTitleTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientGetFindingsFiltersTitleTypeDef(_ClientGetFindingsFiltersTitleTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `Title`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersTypeTypeDef = TypedDict(
    "_ClientGetFindingsFiltersTypeTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientGetFindingsFiltersTypeTypeDef(_ClientGetFindingsFiltersTypeTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `Type`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersUpdatedAtDateRangeTypeDef = TypedDict(
    "_ClientGetFindingsFiltersUpdatedAtDateRangeTypeDef", {"Value": int, "Unit": str}, total=False
)


class ClientGetFindingsFiltersUpdatedAtDateRangeTypeDef(
    _ClientGetFindingsFiltersUpdatedAtDateRangeTypeDef
):
    """
    Type definition for `ClientGetFindingsFiltersUpdatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientGetFindingsFiltersUpdatedAtTypeDef = TypedDict(
    "_ClientGetFindingsFiltersUpdatedAtTypeDef",
    {"Start": str, "End": str, "DateRange": ClientGetFindingsFiltersUpdatedAtDateRangeTypeDef},
    total=False,
)


class ClientGetFindingsFiltersUpdatedAtTypeDef(_ClientGetFindingsFiltersUpdatedAtTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `UpdatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientGetFindingsFiltersUserDefinedFieldsTypeDef = TypedDict(
    "_ClientGetFindingsFiltersUserDefinedFieldsTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersUserDefinedFieldsTypeDef(
    _ClientGetFindingsFiltersUserDefinedFieldsTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `UserDefinedFields`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_ClientGetFindingsFiltersVerificationStateTypeDef = TypedDict(
    "_ClientGetFindingsFiltersVerificationStateTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetFindingsFiltersVerificationStateTypeDef(
    _ClientGetFindingsFiltersVerificationStateTypeDef
):
    """
    Type definition for `ClientGetFindingsFilters` `VerificationState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersWorkflowStateTypeDef = TypedDict(
    "_ClientGetFindingsFiltersWorkflowStateTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientGetFindingsFiltersWorkflowStateTypeDef(_ClientGetFindingsFiltersWorkflowStateTypeDef):
    """
    Type definition for `ClientGetFindingsFilters` `WorkflowState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetFindingsFiltersTypeDef = TypedDict(
    "_ClientGetFindingsFiltersTypeDef",
    {
        "ProductArn": List[ClientGetFindingsFiltersProductArnTypeDef],
        "AwsAccountId": List[ClientGetFindingsFiltersAwsAccountIdTypeDef],
        "Id": List[ClientGetFindingsFiltersIdTypeDef],
        "GeneratorId": List[ClientGetFindingsFiltersGeneratorIdTypeDef],
        "Type": List[ClientGetFindingsFiltersTypeTypeDef],
        "FirstObservedAt": List[ClientGetFindingsFiltersFirstObservedAtTypeDef],
        "LastObservedAt": List[ClientGetFindingsFiltersLastObservedAtTypeDef],
        "CreatedAt": List[ClientGetFindingsFiltersCreatedAtTypeDef],
        "UpdatedAt": List[ClientGetFindingsFiltersUpdatedAtTypeDef],
        "SeverityProduct": List[ClientGetFindingsFiltersSeverityProductTypeDef],
        "SeverityNormalized": List[ClientGetFindingsFiltersSeverityNormalizedTypeDef],
        "SeverityLabel": List[ClientGetFindingsFiltersSeverityLabelTypeDef],
        "Confidence": List[ClientGetFindingsFiltersConfidenceTypeDef],
        "Criticality": List[ClientGetFindingsFiltersCriticalityTypeDef],
        "Title": List[ClientGetFindingsFiltersTitleTypeDef],
        "Description": List[ClientGetFindingsFiltersDescriptionTypeDef],
        "RecommendationText": List[ClientGetFindingsFiltersRecommendationTextTypeDef],
        "SourceUrl": List[ClientGetFindingsFiltersSourceUrlTypeDef],
        "ProductFields": List[ClientGetFindingsFiltersProductFieldsTypeDef],
        "ProductName": List[ClientGetFindingsFiltersProductNameTypeDef],
        "CompanyName": List[ClientGetFindingsFiltersCompanyNameTypeDef],
        "UserDefinedFields": List[ClientGetFindingsFiltersUserDefinedFieldsTypeDef],
        "MalwareName": List[ClientGetFindingsFiltersMalwareNameTypeDef],
        "MalwareType": List[ClientGetFindingsFiltersMalwareTypeTypeDef],
        "MalwarePath": List[ClientGetFindingsFiltersMalwarePathTypeDef],
        "MalwareState": List[ClientGetFindingsFiltersMalwareStateTypeDef],
        "NetworkDirection": List[ClientGetFindingsFiltersNetworkDirectionTypeDef],
        "NetworkProtocol": List[ClientGetFindingsFiltersNetworkProtocolTypeDef],
        "NetworkSourceIpV4": List[ClientGetFindingsFiltersNetworkSourceIpV4TypeDef],
        "NetworkSourceIpV6": List[ClientGetFindingsFiltersNetworkSourceIpV6TypeDef],
        "NetworkSourcePort": List[ClientGetFindingsFiltersNetworkSourcePortTypeDef],
        "NetworkSourceDomain": List[ClientGetFindingsFiltersNetworkSourceDomainTypeDef],
        "NetworkSourceMac": List[ClientGetFindingsFiltersNetworkSourceMacTypeDef],
        "NetworkDestinationIpV4": List[ClientGetFindingsFiltersNetworkDestinationIpV4TypeDef],
        "NetworkDestinationIpV6": List[ClientGetFindingsFiltersNetworkDestinationIpV6TypeDef],
        "NetworkDestinationPort": List[ClientGetFindingsFiltersNetworkDestinationPortTypeDef],
        "NetworkDestinationDomain": List[ClientGetFindingsFiltersNetworkDestinationDomainTypeDef],
        "ProcessName": List[ClientGetFindingsFiltersProcessNameTypeDef],
        "ProcessPath": List[ClientGetFindingsFiltersProcessPathTypeDef],
        "ProcessPid": List[ClientGetFindingsFiltersProcessPidTypeDef],
        "ProcessParentPid": List[ClientGetFindingsFiltersProcessParentPidTypeDef],
        "ProcessLaunchedAt": List[ClientGetFindingsFiltersProcessLaunchedAtTypeDef],
        "ProcessTerminatedAt": List[ClientGetFindingsFiltersProcessTerminatedAtTypeDef],
        "ThreatIntelIndicatorType": List[ClientGetFindingsFiltersThreatIntelIndicatorTypeTypeDef],
        "ThreatIntelIndicatorValue": List[ClientGetFindingsFiltersThreatIntelIndicatorValueTypeDef],
        "ThreatIntelIndicatorCategory": List[
            ClientGetFindingsFiltersThreatIntelIndicatorCategoryTypeDef
        ],
        "ThreatIntelIndicatorLastObservedAt": List[
            ClientGetFindingsFiltersThreatIntelIndicatorLastObservedAtTypeDef
        ],
        "ThreatIntelIndicatorSource": List[
            ClientGetFindingsFiltersThreatIntelIndicatorSourceTypeDef
        ],
        "ThreatIntelIndicatorSourceUrl": List[
            ClientGetFindingsFiltersThreatIntelIndicatorSourceUrlTypeDef
        ],
        "ResourceType": List[ClientGetFindingsFiltersResourceTypeTypeDef],
        "ResourceId": List[ClientGetFindingsFiltersResourceIdTypeDef],
        "ResourcePartition": List[ClientGetFindingsFiltersResourcePartitionTypeDef],
        "ResourceRegion": List[ClientGetFindingsFiltersResourceRegionTypeDef],
        "ResourceTags": List[ClientGetFindingsFiltersResourceTagsTypeDef],
        "ResourceAwsEc2InstanceType": List[
            ClientGetFindingsFiltersResourceAwsEc2InstanceTypeTypeDef
        ],
        "ResourceAwsEc2InstanceImageId": List[
            ClientGetFindingsFiltersResourceAwsEc2InstanceImageIdTypeDef
        ],
        "ResourceAwsEc2InstanceIpV4Addresses": List[
            ClientGetFindingsFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef
        ],
        "ResourceAwsEc2InstanceIpV6Addresses": List[
            ClientGetFindingsFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef
        ],
        "ResourceAwsEc2InstanceKeyName": List[
            ClientGetFindingsFiltersResourceAwsEc2InstanceKeyNameTypeDef
        ],
        "ResourceAwsEc2InstanceIamInstanceProfileArn": List[
            ClientGetFindingsFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef
        ],
        "ResourceAwsEc2InstanceVpcId": List[
            ClientGetFindingsFiltersResourceAwsEc2InstanceVpcIdTypeDef
        ],
        "ResourceAwsEc2InstanceSubnetId": List[
            ClientGetFindingsFiltersResourceAwsEc2InstanceSubnetIdTypeDef
        ],
        "ResourceAwsEc2InstanceLaunchedAt": List[
            ClientGetFindingsFiltersResourceAwsEc2InstanceLaunchedAtTypeDef
        ],
        "ResourceAwsS3BucketOwnerId": List[
            ClientGetFindingsFiltersResourceAwsS3BucketOwnerIdTypeDef
        ],
        "ResourceAwsS3BucketOwnerName": List[
            ClientGetFindingsFiltersResourceAwsS3BucketOwnerNameTypeDef
        ],
        "ResourceAwsIamAccessKeyUserName": List[
            ClientGetFindingsFiltersResourceAwsIamAccessKeyUserNameTypeDef
        ],
        "ResourceAwsIamAccessKeyStatus": List[
            ClientGetFindingsFiltersResourceAwsIamAccessKeyStatusTypeDef
        ],
        "ResourceAwsIamAccessKeyCreatedAt": List[
            ClientGetFindingsFiltersResourceAwsIamAccessKeyCreatedAtTypeDef
        ],
        "ResourceContainerName": List[ClientGetFindingsFiltersResourceContainerNameTypeDef],
        "ResourceContainerImageId": List[ClientGetFindingsFiltersResourceContainerImageIdTypeDef],
        "ResourceContainerImageName": List[
            ClientGetFindingsFiltersResourceContainerImageNameTypeDef
        ],
        "ResourceContainerLaunchedAt": List[
            ClientGetFindingsFiltersResourceContainerLaunchedAtTypeDef
        ],
        "ResourceDetailsOther": List[ClientGetFindingsFiltersResourceDetailsOtherTypeDef],
        "ComplianceStatus": List[ClientGetFindingsFiltersComplianceStatusTypeDef],
        "VerificationState": List[ClientGetFindingsFiltersVerificationStateTypeDef],
        "WorkflowState": List[ClientGetFindingsFiltersWorkflowStateTypeDef],
        "RecordState": List[ClientGetFindingsFiltersRecordStateTypeDef],
        "RelatedFindingsProductArn": List[ClientGetFindingsFiltersRelatedFindingsProductArnTypeDef],
        "RelatedFindingsId": List[ClientGetFindingsFiltersRelatedFindingsIdTypeDef],
        "NoteText": List[ClientGetFindingsFiltersNoteTextTypeDef],
        "NoteUpdatedAt": List[ClientGetFindingsFiltersNoteUpdatedAtTypeDef],
        "NoteUpdatedBy": List[ClientGetFindingsFiltersNoteUpdatedByTypeDef],
        "Keyword": List[ClientGetFindingsFiltersKeywordTypeDef],
    },
    total=False,
)


class ClientGetFindingsFiltersTypeDef(_ClientGetFindingsFiltersTypeDef):
    """
    Type definition for `ClientGetFindings` `Filters`

    The findings attributes used to define a condition to filter the findings returned.

    - **ProductArn** *(list) --*

      The ARN generated by Security Hub that uniquely identifies a third-party company (security
      findings provider) after this provider's product (solution that generates findings) is
      registered with Security Hub.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **AwsAccountId** *(list) --*

      The AWS account ID that a finding is generated in.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Id** *(list) --*

      The security findings provider-specific identifier for a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **GeneratorId** *(list) --*

      The identifier for the solution-specific component (a discrete unit of logic) that generated a
      finding. In various security-findings providers' solutions, this generator can be called a
      rule, a check, a detector, a plug-in, etc.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Type** *(list) --*

      A finding type in the format of ``namespace/category/classifier`` that classifies a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **FirstObservedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider first
      observed the potential security issue that a finding captured.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **LastObservedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider most
      recently observed the potential security issue that a finding captured.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **CreatedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider captured the
      potential security issue that a finding captured.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **UpdatedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider last updated
      the finding record.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **SeverityProduct** *(list) --*

      The native severity as defined by the security-findings provider's solution that generated the
      finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **SeverityNormalized** *(list) --*

      The normalized severity of a finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **SeverityLabel** *(list) --*

      The label of a finding's severity.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Confidence** *(list) --*

      A finding's confidence. Confidence is defined as the likelihood that a finding accurately
      identifies the behavior or issue that it was intended to identify. Confidence is scored on a
      0-100 basis using a ratio scale, where 0 means zero percent confidence and 100 means 100
      percent confidence.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **Criticality** *(list) --*

      The level of importance assigned to the resources associated with the finding. A score of 0
      means that the underlying resources have no criticality, and a score of 100 is reserved for
      the most critical resources.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **Title** *(list) --*

      A finding's title.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Description** *(list) --*

      A finding's description.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RecommendationText** *(list) --*

      The recommendation of what to do about the issue described in a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **SourceUrl** *(list) --*

      A URL that links to a page about the current finding in the security-findings provider's
      solution.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProductFields** *(list) --*

      A data type where security-findings providers can include additional solution-specific details
      that aren't part of the defined ``AwsSecurityFinding`` format.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **ProductName** *(list) --*

      The name of the solution (product) that generates findings.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **CompanyName** *(list) --*

      The name of the findings provider (company) that owns the solution (product) that generates
      findings.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **UserDefinedFields** *(list) --*

      A list of name/value string pairs associated with the finding. These are custom, user-defined
      fields added to a finding.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **MalwareName** *(list) --*

      The name of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **MalwareType** *(list) --*

      The type of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **MalwarePath** *(list) --*

      The filesystem path of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **MalwareState** *(list) --*

      The state of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkDirection** *(list) --*

      Indicates the direction of network traffic associated with a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkProtocol** *(list) --*

      The protocol of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkSourceIpV4** *(list) --*

      The source IPv4 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkSourceIpV6** *(list) --*

      The source IPv6 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkSourcePort** *(list) --*

      The source port of network-related information about a finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **NetworkSourceDomain** *(list) --*

      The source domain of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkSourceMac** *(list) --*

      The source media access control (MAC) address of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkDestinationIpV4** *(list) --*

      The destination IPv4 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkDestinationIpV6** *(list) --*

      The destination IPv6 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkDestinationPort** *(list) --*

      The destination port of network-related information about a finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **NetworkDestinationDomain** *(list) --*

      The destination domain of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProcessName** *(list) --*

      The name of the process.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProcessPath** *(list) --*

      The path to the process executable.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProcessPid** *(list) --*

      The process ID.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **ProcessParentPid** *(list) --*

      The parent process ID.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **ProcessLaunchedAt** *(list) --*

      The date/time that the process was launched.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ProcessTerminatedAt** *(list) --*

      The date/time that the process was terminated.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ThreatIntelIndicatorType** *(list) --*

      The type of a threat intel indicator.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorValue** *(list) --*

      The value of a threat intel indicator.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorCategory** *(list) --*

      The category of a threat intel indicator.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorLastObservedAt** *(list) --*

      The date/time of the last observation of a threat intel indicator.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ThreatIntelIndicatorSource** *(list) --*

      The source of the threat intel.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorSourceUrl** *(list) --*

      The URL for more details from the source of the threat intel.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceType** *(list) --*

      Specifies the type of the resource that details are provided for.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceId** *(list) --*

      The canonical identifier for the given resource type.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourcePartition** *(list) --*

      The canonical AWS partition name that the Region is assigned to.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceRegion** *(list) --*

      The canonical AWS external Region name where this resource is located.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceTags** *(list) --*

      A list of AWS tags associated with a resource at the time the finding was processed.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **ResourceAwsEc2InstanceType** *(list) --*

      The instance type of the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceImageId** *(list) --*

      The Amazon Machine Image (AMI) ID of the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceIpV4Addresses** *(list) --*

      The IPv4 addresses associated with the instance.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **ResourceAwsEc2InstanceIpV6Addresses** *(list) --*

      The IPv6 addresses associated with the instance.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **ResourceAwsEc2InstanceKeyName** *(list) --*

      The key name associated with the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceIamInstanceProfileArn** *(list) --*

      The IAM profile ARN of the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceVpcId** *(list) --*

      The identifier of the VPC that the instance was launched in.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceSubnetId** *(list) --*

      The identifier of the subnet that the instance was launched in.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceLaunchedAt** *(list) --*

      The date/time the instance was launched.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ResourceAwsS3BucketOwnerId** *(list) --*

      The canonical user ID of the owner of the S3 bucket.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsS3BucketOwnerName** *(list) --*

      The display name of the owner of the S3 bucket.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsIamAccessKeyUserName** *(list) --*

      The user associated with the IAM access key related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsIamAccessKeyStatus** *(list) --*

      The status of the IAM access key related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsIamAccessKeyCreatedAt** *(list) --*

      The creation date/time of the IAM access key related to a finding.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ResourceContainerName** *(list) --*

      The name of the container related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceContainerImageId** *(list) --*

      The identifier of the image related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceContainerImageName** *(list) --*

      The name of the image related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceContainerLaunchedAt** *(list) --*

      The date/time that the container was started.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ResourceDetailsOther** *(list) --*

      The details of a resource that doesn't have a specific subfield for the resource type defined.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **ComplianceStatus** *(list) --*

      Exclusive to findings that are generated as the result of a check run against a specific rule
      in a supported standard (for example, CIS AWS Foundations). Contains compliance-related
      finding details.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **VerificationState** *(list) --*

      The veracity of a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **WorkflowState** *(list) --*

      The workflow state of a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RecordState** *(list) --*

      The updated record state for the finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RelatedFindingsProductArn** *(list) --*

      The ARN of the solution that generated a related finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RelatedFindingsId** *(list) --*

      The solution-generated identifier for a related finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NoteText** *(list) --*

      The text of a note.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NoteUpdatedAt** *(list) --*

      The timestamp of when the note was updated.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **NoteUpdatedBy** *(list) --*

      The principal that created a note.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Keyword** *(list) --*

      A keyword for a finding.

      - *(dict) --*

        A keyword filter for querying findings.

        - **Value** *(string) --*

          A value for the keyword.
    """


_ClientGetFindingsResponseFindingsComplianceTypeDef = TypedDict(
    "_ClientGetFindingsResponseFindingsComplianceTypeDef", {"Status": str}, total=False
)


class ClientGetFindingsResponseFindingsComplianceTypeDef(
    _ClientGetFindingsResponseFindingsComplianceTypeDef
):
    """
    Type definition for `ClientGetFindingsResponseFindings` `Compliance`

    This data type is exclusive to findings that are generated as the result of a check run against
    a specific rule in a supported standard (for example, CIS AWS Foundations). Contains
    compliance-related finding details.

    - **Status** *(string) --*

      The result of a compliance check.
    """


_ClientGetFindingsResponseFindingsMalwareTypeDef = TypedDict(
    "_ClientGetFindingsResponseFindingsMalwareTypeDef",
    {"Name": str, "Type": str, "Path": str, "State": str},
    total=False,
)


class ClientGetFindingsResponseFindingsMalwareTypeDef(
    _ClientGetFindingsResponseFindingsMalwareTypeDef
):
    """
    Type definition for `ClientGetFindingsResponseFindings` `Malware`

    A list of malware related to a finding.

    - **Name** *(string) --*

      The name of the malware that was observed.

    - **Type** *(string) --*

      The type of the malware that was observed.

    - **Path** *(string) --*

      The file system path of the malware that was observed.

    - **State** *(string) --*

      The state of the malware that was observed.
    """


_ClientGetFindingsResponseFindingsNetworkTypeDef = TypedDict(
    "_ClientGetFindingsResponseFindingsNetworkTypeDef",
    {
        "Direction": str,
        "Protocol": str,
        "SourceIpV4": str,
        "SourceIpV6": str,
        "SourcePort": int,
        "SourceDomain": str,
        "SourceMac": str,
        "DestinationIpV4": str,
        "DestinationIpV6": str,
        "DestinationPort": int,
        "DestinationDomain": str,
    },
    total=False,
)


class ClientGetFindingsResponseFindingsNetworkTypeDef(
    _ClientGetFindingsResponseFindingsNetworkTypeDef
):
    """
    Type definition for `ClientGetFindingsResponseFindings` `Network`

    The details of network-related information about a finding.

    - **Direction** *(string) --*

      The direction of network traffic associated with a finding.

    - **Protocol** *(string) --*

      The protocol of network-related information about a finding.

    - **SourceIpV4** *(string) --*

      The source IPv4 address of network-related information about a finding.

    - **SourceIpV6** *(string) --*

      The source IPv6 address of network-related information about a finding.

    - **SourcePort** *(integer) --*

      The source port of network-related information about a finding.

    - **SourceDomain** *(string) --*

      The source domain of network-related information about a finding.

    - **SourceMac** *(string) --*

      The source media access control (MAC) address of network-related information about a finding.

    - **DestinationIpV4** *(string) --*

      The destination IPv4 address of network-related information about a finding.

    - **DestinationIpV6** *(string) --*

      The destination IPv6 address of network-related information about a finding.

    - **DestinationPort** *(integer) --*

      The destination port of network-related information about a finding.

    - **DestinationDomain** *(string) --*

      The destination domain of network-related information about a finding.
    """


_ClientGetFindingsResponseFindingsNoteTypeDef = TypedDict(
    "_ClientGetFindingsResponseFindingsNoteTypeDef",
    {"Text": str, "UpdatedBy": str, "UpdatedAt": str},
    total=False,
)


class ClientGetFindingsResponseFindingsNoteTypeDef(_ClientGetFindingsResponseFindingsNoteTypeDef):
    """
    Type definition for `ClientGetFindingsResponseFindings` `Note`

    A user-defined note added to a finding.

    - **Text** *(string) --*

      The text of a note.

    - **UpdatedBy** *(string) --*

      The principal that created a note.

    - **UpdatedAt** *(string) --*

      The timestamp of when the note was updated.
    """


_ClientGetFindingsResponseFindingsProcessTypeDef = TypedDict(
    "_ClientGetFindingsResponseFindingsProcessTypeDef",
    {
        "Name": str,
        "Path": str,
        "Pid": int,
        "ParentPid": int,
        "LaunchedAt": str,
        "TerminatedAt": str,
    },
    total=False,
)


class ClientGetFindingsResponseFindingsProcessTypeDef(
    _ClientGetFindingsResponseFindingsProcessTypeDef
):
    """
    Type definition for `ClientGetFindingsResponseFindings` `Process`

    The details of process-related information about a finding.

    - **Name** *(string) --*

      The name of the process.

    - **Path** *(string) --*

      The path to the process executable.

    - **Pid** *(integer) --*

      The process ID.

    - **ParentPid** *(integer) --*

      The parent process ID.

    - **LaunchedAt** *(string) --*

      The date/time that the process was launched.

    - **TerminatedAt** *(string) --*

      The date and time when the process was terminated.
    """


_ClientGetFindingsResponseFindingsRelatedFindingsTypeDef = TypedDict(
    "_ClientGetFindingsResponseFindingsRelatedFindingsTypeDef",
    {"ProductArn": str, "Id": str},
    total=False,
)


class ClientGetFindingsResponseFindingsRelatedFindingsTypeDef(
    _ClientGetFindingsResponseFindingsRelatedFindingsTypeDef
):
    """
    Type definition for `ClientGetFindingsResponseFindings` `RelatedFindings`

    Details about a related finding.

    - **ProductArn** *(string) --*

      The ARN of the product that generated a related finding.

    - **Id** *(string) --*

      The product-generated identifier for a related finding.
    """


_ClientGetFindingsResponseFindingsRemediationRecommendationTypeDef = TypedDict(
    "_ClientGetFindingsResponseFindingsRemediationRecommendationTypeDef",
    {"Text": str, "Url": str},
    total=False,
)


class ClientGetFindingsResponseFindingsRemediationRecommendationTypeDef(
    _ClientGetFindingsResponseFindingsRemediationRecommendationTypeDef
):
    """
    Type definition for `ClientGetFindingsResponseFindingsRemediation` `Recommendation`

    A recommendation on the steps to take to remediate the issue identified by a finding.

    - **Text** *(string) --*

      Describes the recommended steps to take to remediate an issue identified in a finding.

    - **Url** *(string) --*

      A URL to a page or site that contains information about how to remediate a finding.
    """


_ClientGetFindingsResponseFindingsRemediationTypeDef = TypedDict(
    "_ClientGetFindingsResponseFindingsRemediationTypeDef",
    {"Recommendation": ClientGetFindingsResponseFindingsRemediationRecommendationTypeDef},
    total=False,
)


class ClientGetFindingsResponseFindingsRemediationTypeDef(
    _ClientGetFindingsResponseFindingsRemediationTypeDef
):
    """
    Type definition for `ClientGetFindingsResponseFindings` `Remediation`

    A data type that describes the remediation options for a finding.

    - **Recommendation** *(dict) --*

      A recommendation on the steps to take to remediate the issue identified by a finding.

      - **Text** *(string) --*

        Describes the recommended steps to take to remediate an issue identified in a finding.

      - **Url** *(string) --*

        A URL to a page or site that contains information about how to remediate a finding.
    """


_ClientGetFindingsResponseFindingsResourcesDetailsAwsEc2InstanceTypeDef = TypedDict(
    "_ClientGetFindingsResponseFindingsResourcesDetailsAwsEc2InstanceTypeDef",
    {
        "Type": str,
        "ImageId": str,
        "IpV4Addresses": List[str],
        "IpV6Addresses": List[str],
        "KeyName": str,
        "IamInstanceProfileArn": str,
        "VpcId": str,
        "SubnetId": str,
        "LaunchedAt": str,
    },
    total=False,
)


class ClientGetFindingsResponseFindingsResourcesDetailsAwsEc2InstanceTypeDef(
    _ClientGetFindingsResponseFindingsResourcesDetailsAwsEc2InstanceTypeDef
):
    """
    Type definition for `ClientGetFindingsResponseFindingsResourcesDetails` `AwsEc2Instance`

    Details about an Amazon EC2 instance related to a finding.

    - **Type** *(string) --*

      The instance type of the instance.

    - **ImageId** *(string) --*

      The Amazon Machine Image (AMI) ID of the instance.

    - **IpV4Addresses** *(list) --*

      The IPv4 addresses associated with the instance.

      - *(string) --*

    - **IpV6Addresses** *(list) --*

      The IPv6 addresses associated with the instance.

      - *(string) --*

    - **KeyName** *(string) --*

      The key name associated with the instance.

    - **IamInstanceProfileArn** *(string) --*

      The IAM profile ARN of the instance.

    - **VpcId** *(string) --*

      The identifier of the VPC that the instance was launched in.

    - **SubnetId** *(string) --*

      The identifier of the subnet that the instance was launched in.

    - **LaunchedAt** *(string) --*

      The date/time the instance was launched.
    """


_ClientGetFindingsResponseFindingsResourcesDetailsAwsIamAccessKeyTypeDef = TypedDict(
    "_ClientGetFindingsResponseFindingsResourcesDetailsAwsIamAccessKeyTypeDef",
    {"UserName": str, "Status": str, "CreatedAt": str},
    total=False,
)


class ClientGetFindingsResponseFindingsResourcesDetailsAwsIamAccessKeyTypeDef(
    _ClientGetFindingsResponseFindingsResourcesDetailsAwsIamAccessKeyTypeDef
):
    """
    Type definition for `ClientGetFindingsResponseFindingsResourcesDetails` `AwsIamAccessKey`

    Details about an IAM access key related to a finding.

    - **UserName** *(string) --*

      The user associated with the IAM access key related to a finding.

    - **Status** *(string) --*

      The status of the IAM access key related to a finding.

    - **CreatedAt** *(string) --*

      The creation date/time of the IAM access key related to a finding.
    """


_ClientGetFindingsResponseFindingsResourcesDetailsAwsS3BucketTypeDef = TypedDict(
    "_ClientGetFindingsResponseFindingsResourcesDetailsAwsS3BucketTypeDef",
    {"OwnerId": str, "OwnerName": str},
    total=False,
)


class ClientGetFindingsResponseFindingsResourcesDetailsAwsS3BucketTypeDef(
    _ClientGetFindingsResponseFindingsResourcesDetailsAwsS3BucketTypeDef
):
    """
    Type definition for `ClientGetFindingsResponseFindingsResourcesDetails` `AwsS3Bucket`

    Details about an Amazon S3 Bucket related to a finding.

    - **OwnerId** *(string) --*

      The canonical user ID of the owner of the S3 bucket.

    - **OwnerName** *(string) --*

      The display name of the owner of the S3 bucket.
    """


_ClientGetFindingsResponseFindingsResourcesDetailsContainerTypeDef = TypedDict(
    "_ClientGetFindingsResponseFindingsResourcesDetailsContainerTypeDef",
    {"Name": str, "ImageId": str, "ImageName": str, "LaunchedAt": str},
    total=False,
)


class ClientGetFindingsResponseFindingsResourcesDetailsContainerTypeDef(
    _ClientGetFindingsResponseFindingsResourcesDetailsContainerTypeDef
):
    """
    Type definition for `ClientGetFindingsResponseFindingsResourcesDetails` `Container`

    Details about a container resource related to a finding.

    - **Name** *(string) --*

      The name of the container related to a finding.

    - **ImageId** *(string) --*

      The identifier of the image related to a finding.

    - **ImageName** *(string) --*

      The name of the image related to a finding.

    - **LaunchedAt** *(string) --*

      The date and time when the container started.
    """


_ClientGetFindingsResponseFindingsResourcesDetailsTypeDef = TypedDict(
    "_ClientGetFindingsResponseFindingsResourcesDetailsTypeDef",
    {
        "AwsEc2Instance": ClientGetFindingsResponseFindingsResourcesDetailsAwsEc2InstanceTypeDef,
        "AwsS3Bucket": ClientGetFindingsResponseFindingsResourcesDetailsAwsS3BucketTypeDef,
        "AwsIamAccessKey": ClientGetFindingsResponseFindingsResourcesDetailsAwsIamAccessKeyTypeDef,
        "Container": ClientGetFindingsResponseFindingsResourcesDetailsContainerTypeDef,
        "Other": Dict[str, str],
    },
    total=False,
)


class ClientGetFindingsResponseFindingsResourcesDetailsTypeDef(
    _ClientGetFindingsResponseFindingsResourcesDetailsTypeDef
):
    """
    Type definition for `ClientGetFindingsResponseFindingsResources` `Details`

    Additional details about the resource related to a finding.

    - **AwsEc2Instance** *(dict) --*

      Details about an Amazon EC2 instance related to a finding.

      - **Type** *(string) --*

        The instance type of the instance.

      - **ImageId** *(string) --*

        The Amazon Machine Image (AMI) ID of the instance.

      - **IpV4Addresses** *(list) --*

        The IPv4 addresses associated with the instance.

        - *(string) --*

      - **IpV6Addresses** *(list) --*

        The IPv6 addresses associated with the instance.

        - *(string) --*

      - **KeyName** *(string) --*

        The key name associated with the instance.

      - **IamInstanceProfileArn** *(string) --*

        The IAM profile ARN of the instance.

      - **VpcId** *(string) --*

        The identifier of the VPC that the instance was launched in.

      - **SubnetId** *(string) --*

        The identifier of the subnet that the instance was launched in.

      - **LaunchedAt** *(string) --*

        The date/time the instance was launched.

    - **AwsS3Bucket** *(dict) --*

      Details about an Amazon S3 Bucket related to a finding.

      - **OwnerId** *(string) --*

        The canonical user ID of the owner of the S3 bucket.

      - **OwnerName** *(string) --*

        The display name of the owner of the S3 bucket.

    - **AwsIamAccessKey** *(dict) --*

      Details about an IAM access key related to a finding.

      - **UserName** *(string) --*

        The user associated with the IAM access key related to a finding.

      - **Status** *(string) --*

        The status of the IAM access key related to a finding.

      - **CreatedAt** *(string) --*

        The creation date/time of the IAM access key related to a finding.

    - **Container** *(dict) --*

      Details about a container resource related to a finding.

      - **Name** *(string) --*

        The name of the container related to a finding.

      - **ImageId** *(string) --*

        The identifier of the image related to a finding.

      - **ImageName** *(string) --*

        The name of the image related to a finding.

      - **LaunchedAt** *(string) --*

        The date and time when the container started.

    - **Other** *(dict) --*

      Details about a resource that doesn't have a specific type defined.

      - *(string) --*

        - *(string) --*
    """


_ClientGetFindingsResponseFindingsResourcesTypeDef = TypedDict(
    "_ClientGetFindingsResponseFindingsResourcesTypeDef",
    {
        "Type": str,
        "Id": str,
        "Partition": str,
        "Region": str,
        "Tags": Dict[str, str],
        "Details": ClientGetFindingsResponseFindingsResourcesDetailsTypeDef,
    },
    total=False,
)


class ClientGetFindingsResponseFindingsResourcesTypeDef(
    _ClientGetFindingsResponseFindingsResourcesTypeDef
):
    """
    Type definition for `ClientGetFindingsResponseFindings` `Resources`

    A resource related to a finding.

    - **Type** *(string) --*

      The type of the resource that details are provided for.

    - **Id** *(string) --*

      The canonical identifier for the given resource type.

    - **Partition** *(string) --*

      The canonical AWS partition name that the Region is assigned to.

    - **Region** *(string) --*

      The canonical AWS external Region name where this resource is located.

    - **Tags** *(dict) --*

      A list of AWS tags associated with a resource at the time the finding was processed.

      - *(string) --*

        - *(string) --*

    - **Details** *(dict) --*

      Additional details about the resource related to a finding.

      - **AwsEc2Instance** *(dict) --*

        Details about an Amazon EC2 instance related to a finding.

        - **Type** *(string) --*

          The instance type of the instance.

        - **ImageId** *(string) --*

          The Amazon Machine Image (AMI) ID of the instance.

        - **IpV4Addresses** *(list) --*

          The IPv4 addresses associated with the instance.

          - *(string) --*

        - **IpV6Addresses** *(list) --*

          The IPv6 addresses associated with the instance.

          - *(string) --*

        - **KeyName** *(string) --*

          The key name associated with the instance.

        - **IamInstanceProfileArn** *(string) --*

          The IAM profile ARN of the instance.

        - **VpcId** *(string) --*

          The identifier of the VPC that the instance was launched in.

        - **SubnetId** *(string) --*

          The identifier of the subnet that the instance was launched in.

        - **LaunchedAt** *(string) --*

          The date/time the instance was launched.

      - **AwsS3Bucket** *(dict) --*

        Details about an Amazon S3 Bucket related to a finding.

        - **OwnerId** *(string) --*

          The canonical user ID of the owner of the S3 bucket.

        - **OwnerName** *(string) --*

          The display name of the owner of the S3 bucket.

      - **AwsIamAccessKey** *(dict) --*

        Details about an IAM access key related to a finding.

        - **UserName** *(string) --*

          The user associated with the IAM access key related to a finding.

        - **Status** *(string) --*

          The status of the IAM access key related to a finding.

        - **CreatedAt** *(string) --*

          The creation date/time of the IAM access key related to a finding.

      - **Container** *(dict) --*

        Details about a container resource related to a finding.

        - **Name** *(string) --*

          The name of the container related to a finding.

        - **ImageId** *(string) --*

          The identifier of the image related to a finding.

        - **ImageName** *(string) --*

          The name of the image related to a finding.

        - **LaunchedAt** *(string) --*

          The date and time when the container started.

      - **Other** *(dict) --*

        Details about a resource that doesn't have a specific type defined.

        - *(string) --*

          - *(string) --*
    """


_ClientGetFindingsResponseFindingsSeverityTypeDef = TypedDict(
    "_ClientGetFindingsResponseFindingsSeverityTypeDef",
    {"Product": float, "Normalized": int},
    total=False,
)


class ClientGetFindingsResponseFindingsSeverityTypeDef(
    _ClientGetFindingsResponseFindingsSeverityTypeDef
):
    """
    Type definition for `ClientGetFindingsResponseFindings` `Severity`

    A finding's severity.

    - **Product** *(float) --*

      The native severity as defined by the AWS service or integrated partner product that generated
      the finding.

    - **Normalized** *(integer) --*

      The normalized severity of a finding.
    """


_ClientGetFindingsResponseFindingsThreatIntelIndicatorsTypeDef = TypedDict(
    "_ClientGetFindingsResponseFindingsThreatIntelIndicatorsTypeDef",
    {
        "Type": str,
        "Value": str,
        "Category": str,
        "LastObservedAt": str,
        "Source": str,
        "SourceUrl": str,
    },
    total=False,
)


class ClientGetFindingsResponseFindingsThreatIntelIndicatorsTypeDef(
    _ClientGetFindingsResponseFindingsThreatIntelIndicatorsTypeDef
):
    """
    Type definition for `ClientGetFindingsResponseFindings` `ThreatIntelIndicators`

    Details about the threat intel related to a finding.

    - **Type** *(string) --*

      The type of a threat intel indicator.

    - **Value** *(string) --*

      The value of a threat intel indicator.

    - **Category** *(string) --*

      The category of a threat intel indicator.

    - **LastObservedAt** *(string) --*

      The date and time when the most recent instance of a threat intel indicator was observed.

    - **Source** *(string) --*

      The source of the threat intel indicator.

    - **SourceUrl** *(string) --*

      The URL to the page or site where you can get more information about the threat intel
      indicator.
    """


_ClientGetFindingsResponseFindingsTypeDef = TypedDict(
    "_ClientGetFindingsResponseFindingsTypeDef",
    {
        "SchemaVersion": str,
        "Id": str,
        "ProductArn": str,
        "GeneratorId": str,
        "AwsAccountId": str,
        "Types": List[str],
        "FirstObservedAt": str,
        "LastObservedAt": str,
        "CreatedAt": str,
        "UpdatedAt": str,
        "Severity": ClientGetFindingsResponseFindingsSeverityTypeDef,
        "Confidence": int,
        "Criticality": int,
        "Title": str,
        "Description": str,
        "Remediation": ClientGetFindingsResponseFindingsRemediationTypeDef,
        "SourceUrl": str,
        "ProductFields": Dict[str, str],
        "UserDefinedFields": Dict[str, str],
        "Malware": List[ClientGetFindingsResponseFindingsMalwareTypeDef],
        "Network": ClientGetFindingsResponseFindingsNetworkTypeDef,
        "Process": ClientGetFindingsResponseFindingsProcessTypeDef,
        "ThreatIntelIndicators": List[
            ClientGetFindingsResponseFindingsThreatIntelIndicatorsTypeDef
        ],
        "Resources": List[ClientGetFindingsResponseFindingsResourcesTypeDef],
        "Compliance": ClientGetFindingsResponseFindingsComplianceTypeDef,
        "VerificationState": str,
        "WorkflowState": str,
        "RecordState": str,
        "RelatedFindings": List[ClientGetFindingsResponseFindingsRelatedFindingsTypeDef],
        "Note": ClientGetFindingsResponseFindingsNoteTypeDef,
    },
    total=False,
)


class ClientGetFindingsResponseFindingsTypeDef(_ClientGetFindingsResponseFindingsTypeDef):
    """
    Type definition for `ClientGetFindingsResponse` `Findings`

    Provides consistent format for the contents of the Security Hub-aggregated findings.
    ``AwsSecurityFinding`` format enables you to share findings between AWS security services and
    third-party solutions, and compliance checks.

    .. note::

      A finding is a potential security issue generated either by AWS services (Amazon GuardDuty,
      Amazon Inspector, and Amazon Macie) or by the integrated third-party solutions and compliance
      checks.

    - **SchemaVersion** *(string) --*

      The schema version that a finding is formatted for.

    - **Id** *(string) --*

      The security findings provider-specific identifier for a finding.

    - **ProductArn** *(string) --*

      The ARN generated by Security Hub that uniquely identifies a third-party company
      (security-findings provider) after this provider's product (solution that generates findings)
      is registered with Security Hub.

    - **GeneratorId** *(string) --*

      The identifier for the solution-specific component (a discrete unit of logic) that generated a
      finding. In various security-findings providers' solutions, this generator can be called a
      rule, a check, a detector, a plug-in, etc.

    - **AwsAccountId** *(string) --*

      The AWS account ID that a finding is generated in.

    - **Types** *(list) --*

      One or more finding types in the format of ``namespace/category/classifier`` that classify a
      finding.

      Valid namespace values are: Software and Configuration Checks | TTPs | Effects | Unusual
      Behaviors | Sensitive Data Identifications

      - *(string) --*

    - **FirstObservedAt** *(string) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider first
      observed the potential security issue that a finding captured.

    - **LastObservedAt** *(string) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider most
      recently observed the potential security issue that a finding captured.

    - **CreatedAt** *(string) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider created the
      potential security issue that a finding captured.

    - **UpdatedAt** *(string) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider last updated
      the finding record.

    - **Severity** *(dict) --*

      A finding's severity.

      - **Product** *(float) --*

        The native severity as defined by the AWS service or integrated partner product that
        generated the finding.

      - **Normalized** *(integer) --*

        The normalized severity of a finding.

    - **Confidence** *(integer) --*

      A finding's confidence. Confidence is defined as the likelihood that a finding accurately
      identifies the behavior or issue that it was intended to identify. Confidence is scored on a
      0-100 basis using a ratio scale, where 0 means zero percent confidence and 100 means 100
      percent confidence.

    - **Criticality** *(integer) --*

      The level of importance assigned to the resources associated with the finding. A score of 0
      means that the underlying resources have no criticality, and a score of 100 is reserved for
      the most critical resources.

    - **Title** *(string) --*

      A finding's title.

      .. note::

        In this release, ``Title`` is a required property.

    - **Description** *(string) --*

      A finding's description.

      .. note::

        In this release, ``Description`` is a required property.

    - **Remediation** *(dict) --*

      A data type that describes the remediation options for a finding.

      - **Recommendation** *(dict) --*

        A recommendation on the steps to take to remediate the issue identified by a finding.

        - **Text** *(string) --*

          Describes the recommended steps to take to remediate an issue identified in a finding.

        - **Url** *(string) --*

          A URL to a page or site that contains information about how to remediate a finding.

    - **SourceUrl** *(string) --*

      A URL that links to a page about the current finding in the security-findings provider's
      solution.

    - **ProductFields** *(dict) --*

      A data type where security-findings providers can include additional solution-specific details
      that aren't part of the defined ``AwsSecurityFinding`` format.

      - *(string) --*

        - *(string) --*

    - **UserDefinedFields** *(dict) --*

      A list of name/value string pairs associated with the finding. These are custom, user-defined
      fields added to a finding.

      - *(string) --*

        - *(string) --*

    - **Malware** *(list) --*

      A list of malware related to a finding.

      - *(dict) --*

        A list of malware related to a finding.

        - **Name** *(string) --*

          The name of the malware that was observed.

        - **Type** *(string) --*

          The type of the malware that was observed.

        - **Path** *(string) --*

          The file system path of the malware that was observed.

        - **State** *(string) --*

          The state of the malware that was observed.

    - **Network** *(dict) --*

      The details of network-related information about a finding.

      - **Direction** *(string) --*

        The direction of network traffic associated with a finding.

      - **Protocol** *(string) --*

        The protocol of network-related information about a finding.

      - **SourceIpV4** *(string) --*

        The source IPv4 address of network-related information about a finding.

      - **SourceIpV6** *(string) --*

        The source IPv6 address of network-related information about a finding.

      - **SourcePort** *(integer) --*

        The source port of network-related information about a finding.

      - **SourceDomain** *(string) --*

        The source domain of network-related information about a finding.

      - **SourceMac** *(string) --*

        The source media access control (MAC) address of network-related information about a
        finding.

      - **DestinationIpV4** *(string) --*

        The destination IPv4 address of network-related information about a finding.

      - **DestinationIpV6** *(string) --*

        The destination IPv6 address of network-related information about a finding.

      - **DestinationPort** *(integer) --*

        The destination port of network-related information about a finding.

      - **DestinationDomain** *(string) --*

        The destination domain of network-related information about a finding.

    - **Process** *(dict) --*

      The details of process-related information about a finding.

      - **Name** *(string) --*

        The name of the process.

      - **Path** *(string) --*

        The path to the process executable.

      - **Pid** *(integer) --*

        The process ID.

      - **ParentPid** *(integer) --*

        The parent process ID.

      - **LaunchedAt** *(string) --*

        The date/time that the process was launched.

      - **TerminatedAt** *(string) --*

        The date and time when the process was terminated.

    - **ThreatIntelIndicators** *(list) --*

      Threat intel details related to a finding.

      - *(dict) --*

        Details about the threat intel related to a finding.

        - **Type** *(string) --*

          The type of a threat intel indicator.

        - **Value** *(string) --*

          The value of a threat intel indicator.

        - **Category** *(string) --*

          The category of a threat intel indicator.

        - **LastObservedAt** *(string) --*

          The date and time when the most recent instance of a threat intel indicator was observed.

        - **Source** *(string) --*

          The source of the threat intel indicator.

        - **SourceUrl** *(string) --*

          The URL to the page or site where you can get more information about the threat intel
          indicator.

    - **Resources** *(list) --*

      A set of resource data types that describe the resources that the finding refers to.

      - *(dict) --*

        A resource related to a finding.

        - **Type** *(string) --*

          The type of the resource that details are provided for.

        - **Id** *(string) --*

          The canonical identifier for the given resource type.

        - **Partition** *(string) --*

          The canonical AWS partition name that the Region is assigned to.

        - **Region** *(string) --*

          The canonical AWS external Region name where this resource is located.

        - **Tags** *(dict) --*

          A list of AWS tags associated with a resource at the time the finding was processed.

          - *(string) --*

            - *(string) --*

        - **Details** *(dict) --*

          Additional details about the resource related to a finding.

          - **AwsEc2Instance** *(dict) --*

            Details about an Amazon EC2 instance related to a finding.

            - **Type** *(string) --*

              The instance type of the instance.

            - **ImageId** *(string) --*

              The Amazon Machine Image (AMI) ID of the instance.

            - **IpV4Addresses** *(list) --*

              The IPv4 addresses associated with the instance.

              - *(string) --*

            - **IpV6Addresses** *(list) --*

              The IPv6 addresses associated with the instance.

              - *(string) --*

            - **KeyName** *(string) --*

              The key name associated with the instance.

            - **IamInstanceProfileArn** *(string) --*

              The IAM profile ARN of the instance.

            - **VpcId** *(string) --*

              The identifier of the VPC that the instance was launched in.

            - **SubnetId** *(string) --*

              The identifier of the subnet that the instance was launched in.

            - **LaunchedAt** *(string) --*

              The date/time the instance was launched.

          - **AwsS3Bucket** *(dict) --*

            Details about an Amazon S3 Bucket related to a finding.

            - **OwnerId** *(string) --*

              The canonical user ID of the owner of the S3 bucket.

            - **OwnerName** *(string) --*

              The display name of the owner of the S3 bucket.

          - **AwsIamAccessKey** *(dict) --*

            Details about an IAM access key related to a finding.

            - **UserName** *(string) --*

              The user associated with the IAM access key related to a finding.

            - **Status** *(string) --*

              The status of the IAM access key related to a finding.

            - **CreatedAt** *(string) --*

              The creation date/time of the IAM access key related to a finding.

          - **Container** *(dict) --*

            Details about a container resource related to a finding.

            - **Name** *(string) --*

              The name of the container related to a finding.

            - **ImageId** *(string) --*

              The identifier of the image related to a finding.

            - **ImageName** *(string) --*

              The name of the image related to a finding.

            - **LaunchedAt** *(string) --*

              The date and time when the container started.

          - **Other** *(dict) --*

            Details about a resource that doesn't have a specific type defined.

            - *(string) --*

              - *(string) --*

    - **Compliance** *(dict) --*

      This data type is exclusive to findings that are generated as the result of a check run
      against a specific rule in a supported standard (for example, CIS AWS Foundations). Contains
      compliance-related finding details.

      - **Status** *(string) --*

        The result of a compliance check.

    - **VerificationState** *(string) --*

      Indicates the veracity of a finding.

    - **WorkflowState** *(string) --*

      The workflow state of a finding.

    - **RecordState** *(string) --*

      The record state of a finding.

    - **RelatedFindings** *(list) --*

      A list of related findings.

      - *(dict) --*

        Details about a related finding.

        - **ProductArn** *(string) --*

          The ARN of the product that generated a related finding.

        - **Id** *(string) --*

          The product-generated identifier for a related finding.

    - **Note** *(dict) --*

      A user-defined note added to a finding.

      - **Text** *(string) --*

        The text of a note.

      - **UpdatedBy** *(string) --*

        The principal that created a note.

      - **UpdatedAt** *(string) --*

        The timestamp of when the note was updated.
    """


_ClientGetFindingsResponseTypeDef = TypedDict(
    "_ClientGetFindingsResponseTypeDef",
    {"Findings": List[ClientGetFindingsResponseFindingsTypeDef], "NextToken": str},
    total=False,
)


class ClientGetFindingsResponseTypeDef(_ClientGetFindingsResponseTypeDef):
    """
    Type definition for `ClientGetFindings` `Response`

    - **Findings** *(list) --*

      The findings that matched the filters specified in the request.

      - *(dict) --*

        Provides consistent format for the contents of the Security Hub-aggregated findings.
        ``AwsSecurityFinding`` format enables you to share findings between AWS security services
        and third-party solutions, and compliance checks.

        .. note::

          A finding is a potential security issue generated either by AWS services (Amazon
          GuardDuty, Amazon Inspector, and Amazon Macie) or by the integrated third-party solutions
          and compliance checks.

        - **SchemaVersion** *(string) --*

          The schema version that a finding is formatted for.

        - **Id** *(string) --*

          The security findings provider-specific identifier for a finding.

        - **ProductArn** *(string) --*

          The ARN generated by Security Hub that uniquely identifies a third-party company
          (security-findings provider) after this provider's product (solution that generates
          findings) is registered with Security Hub.

        - **GeneratorId** *(string) --*

          The identifier for the solution-specific component (a discrete unit of logic) that
          generated a finding. In various security-findings providers' solutions, this generator can
          be called a rule, a check, a detector, a plug-in, etc.

        - **AwsAccountId** *(string) --*

          The AWS account ID that a finding is generated in.

        - **Types** *(list) --*

          One or more finding types in the format of ``namespace/category/classifier`` that classify
          a finding.

          Valid namespace values are: Software and Configuration Checks | TTPs | Effects
          | Unusual
          Behaviors | Sensitive Data Identifications

          - *(string) --*

        - **FirstObservedAt** *(string) --*

          An ISO8601-formatted timestamp that indicates when the security-findings provider first
          observed the potential security issue that a finding captured.

        - **LastObservedAt** *(string) --*

          An ISO8601-formatted timestamp that indicates when the security-findings provider most
          recently observed the potential security issue that a finding captured.

        - **CreatedAt** *(string) --*

          An ISO8601-formatted timestamp that indicates when the security-findings provider created
          the potential security issue that a finding captured.

        - **UpdatedAt** *(string) --*

          An ISO8601-formatted timestamp that indicates when the security-findings provider last
          updated the finding record.

        - **Severity** *(dict) --*

          A finding's severity.

          - **Product** *(float) --*

            The native severity as defined by the AWS service or integrated partner product that
            generated the finding.

          - **Normalized** *(integer) --*

            The normalized severity of a finding.

        - **Confidence** *(integer) --*

          A finding's confidence. Confidence is defined as the likelihood that a finding accurately
          identifies the behavior or issue that it was intended to identify. Confidence is scored on
          a 0-100 basis using a ratio scale, where 0 means zero percent confidence and 100 means 100
          percent confidence.

        - **Criticality** *(integer) --*

          The level of importance assigned to the resources associated with the finding. A score of
          0 means that the underlying resources have no criticality, and a score of 100 is reserved
          for the most critical resources.

        - **Title** *(string) --*

          A finding's title.

          .. note::

            In this release, ``Title`` is a required property.

        - **Description** *(string) --*

          A finding's description.

          .. note::

            In this release, ``Description`` is a required property.

        - **Remediation** *(dict) --*

          A data type that describes the remediation options for a finding.

          - **Recommendation** *(dict) --*

            A recommendation on the steps to take to remediate the issue identified by a finding.

            - **Text** *(string) --*

              Describes the recommended steps to take to remediate an issue identified in a finding.

            - **Url** *(string) --*

              A URL to a page or site that contains information about how to remediate a finding.

        - **SourceUrl** *(string) --*

          A URL that links to a page about the current finding in the security-findings provider's
          solution.

        - **ProductFields** *(dict) --*

          A data type where security-findings providers can include additional solution-specific
          details that aren't part of the defined ``AwsSecurityFinding`` format.

          - *(string) --*

            - *(string) --*

        - **UserDefinedFields** *(dict) --*

          A list of name/value string pairs associated with the finding. These are custom,
          user-defined fields added to a finding.

          - *(string) --*

            - *(string) --*

        - **Malware** *(list) --*

          A list of malware related to a finding.

          - *(dict) --*

            A list of malware related to a finding.

            - **Name** *(string) --*

              The name of the malware that was observed.

            - **Type** *(string) --*

              The type of the malware that was observed.

            - **Path** *(string) --*

              The file system path of the malware that was observed.

            - **State** *(string) --*

              The state of the malware that was observed.

        - **Network** *(dict) --*

          The details of network-related information about a finding.

          - **Direction** *(string) --*

            The direction of network traffic associated with a finding.

          - **Protocol** *(string) --*

            The protocol of network-related information about a finding.

          - **SourceIpV4** *(string) --*

            The source IPv4 address of network-related information about a finding.

          - **SourceIpV6** *(string) --*

            The source IPv6 address of network-related information about a finding.

          - **SourcePort** *(integer) --*

            The source port of network-related information about a finding.

          - **SourceDomain** *(string) --*

            The source domain of network-related information about a finding.

          - **SourceMac** *(string) --*

            The source media access control (MAC) address of network-related information about a
            finding.

          - **DestinationIpV4** *(string) --*

            The destination IPv4 address of network-related information about a finding.

          - **DestinationIpV6** *(string) --*

            The destination IPv6 address of network-related information about a finding.

          - **DestinationPort** *(integer) --*

            The destination port of network-related information about a finding.

          - **DestinationDomain** *(string) --*

            The destination domain of network-related information about a finding.

        - **Process** *(dict) --*

          The details of process-related information about a finding.

          - **Name** *(string) --*

            The name of the process.

          - **Path** *(string) --*

            The path to the process executable.

          - **Pid** *(integer) --*

            The process ID.

          - **ParentPid** *(integer) --*

            The parent process ID.

          - **LaunchedAt** *(string) --*

            The date/time that the process was launched.

          - **TerminatedAt** *(string) --*

            The date and time when the process was terminated.

        - **ThreatIntelIndicators** *(list) --*

          Threat intel details related to a finding.

          - *(dict) --*

            Details about the threat intel related to a finding.

            - **Type** *(string) --*

              The type of a threat intel indicator.

            - **Value** *(string) --*

              The value of a threat intel indicator.

            - **Category** *(string) --*

              The category of a threat intel indicator.

            - **LastObservedAt** *(string) --*

              The date and time when the most recent instance of a threat intel indicator was
              observed.

            - **Source** *(string) --*

              The source of the threat intel indicator.

            - **SourceUrl** *(string) --*

              The URL to the page or site where you can get more information about the threat intel
              indicator.

        - **Resources** *(list) --*

          A set of resource data types that describe the resources that the finding refers to.

          - *(dict) --*

            A resource related to a finding.

            - **Type** *(string) --*

              The type of the resource that details are provided for.

            - **Id** *(string) --*

              The canonical identifier for the given resource type.

            - **Partition** *(string) --*

              The canonical AWS partition name that the Region is assigned to.

            - **Region** *(string) --*

              The canonical AWS external Region name where this resource is located.

            - **Tags** *(dict) --*

              A list of AWS tags associated with a resource at the time the finding was processed.

              - *(string) --*

                - *(string) --*

            - **Details** *(dict) --*

              Additional details about the resource related to a finding.

              - **AwsEc2Instance** *(dict) --*

                Details about an Amazon EC2 instance related to a finding.

                - **Type** *(string) --*

                  The instance type of the instance.

                - **ImageId** *(string) --*

                  The Amazon Machine Image (AMI) ID of the instance.

                - **IpV4Addresses** *(list) --*

                  The IPv4 addresses associated with the instance.

                  - *(string) --*

                - **IpV6Addresses** *(list) --*

                  The IPv6 addresses associated with the instance.

                  - *(string) --*

                - **KeyName** *(string) --*

                  The key name associated with the instance.

                - **IamInstanceProfileArn** *(string) --*

                  The IAM profile ARN of the instance.

                - **VpcId** *(string) --*

                  The identifier of the VPC that the instance was launched in.

                - **SubnetId** *(string) --*

                  The identifier of the subnet that the instance was launched in.

                - **LaunchedAt** *(string) --*

                  The date/time the instance was launched.

              - **AwsS3Bucket** *(dict) --*

                Details about an Amazon S3 Bucket related to a finding.

                - **OwnerId** *(string) --*

                  The canonical user ID of the owner of the S3 bucket.

                - **OwnerName** *(string) --*

                  The display name of the owner of the S3 bucket.

              - **AwsIamAccessKey** *(dict) --*

                Details about an IAM access key related to a finding.

                - **UserName** *(string) --*

                  The user associated with the IAM access key related to a finding.

                - **Status** *(string) --*

                  The status of the IAM access key related to a finding.

                - **CreatedAt** *(string) --*

                  The creation date/time of the IAM access key related to a finding.

              - **Container** *(dict) --*

                Details about a container resource related to a finding.

                - **Name** *(string) --*

                  The name of the container related to a finding.

                - **ImageId** *(string) --*

                  The identifier of the image related to a finding.

                - **ImageName** *(string) --*

                  The name of the image related to a finding.

                - **LaunchedAt** *(string) --*

                  The date and time when the container started.

              - **Other** *(dict) --*

                Details about a resource that doesn't have a specific type defined.

                - *(string) --*

                  - *(string) --*

        - **Compliance** *(dict) --*

          This data type is exclusive to findings that are generated as the result of a check run
          against a specific rule in a supported standard (for example, CIS AWS Foundations).
          Contains compliance-related finding details.

          - **Status** *(string) --*

            The result of a compliance check.

        - **VerificationState** *(string) --*

          Indicates the veracity of a finding.

        - **WorkflowState** *(string) --*

          The workflow state of a finding.

        - **RecordState** *(string) --*

          The record state of a finding.

        - **RelatedFindings** *(list) --*

          A list of related findings.

          - *(dict) --*

            Details about a related finding.

            - **ProductArn** *(string) --*

              The ARN of the product that generated a related finding.

            - **Id** *(string) --*

              The product-generated identifier for a related finding.

        - **Note** *(dict) --*

          A user-defined note added to a finding.

          - **Text** *(string) --*

            The text of a note.

          - **UpdatedBy** *(string) --*

            The principal that created a note.

          - **UpdatedAt** *(string) --*

            The timestamp of when the note was updated.

    - **NextToken** *(string) --*

      The token that is required for pagination.
    """


_ClientGetFindingsSortCriteriaTypeDef = TypedDict(
    "_ClientGetFindingsSortCriteriaTypeDef", {"Field": str, "SortOrder": str}, total=False
)


class ClientGetFindingsSortCriteriaTypeDef(_ClientGetFindingsSortCriteriaTypeDef):
    """
    Type definition for `ClientGetFindings` `SortCriteria`

    A collection of finding attributes used to sort findings.

    - **Field** *(string) --*

      The finding attribute used to sort findings.

    - **SortOrder** *(string) --*

      The order used to sort findings.
    """


_ClientGetInsightResultsResponseInsightResultsResultValuesTypeDef = TypedDict(
    "_ClientGetInsightResultsResponseInsightResultsResultValuesTypeDef",
    {"GroupByAttributeValue": str, "Count": int},
    total=False,
)


class ClientGetInsightResultsResponseInsightResultsResultValuesTypeDef(
    _ClientGetInsightResultsResponseInsightResultsResultValuesTypeDef
):
    """
    Type definition for `ClientGetInsightResultsResponseInsightResults` `ResultValues`

    The insight result values returned by the ``GetInsightResults`` operation.

    - **GroupByAttributeValue** *(string) --*

      The value of the attribute that the findings are grouped by for the insight whose results are
      returned by the ``GetInsightResults`` operation.

    - **Count** *(integer) --*

      The number of findings returned for each ``GroupByAttributeValue`` .
    """


_ClientGetInsightResultsResponseInsightResultsTypeDef = TypedDict(
    "_ClientGetInsightResultsResponseInsightResultsTypeDef",
    {
        "InsightArn": str,
        "GroupByAttribute": str,
        "ResultValues": List[ClientGetInsightResultsResponseInsightResultsResultValuesTypeDef],
    },
    total=False,
)


class ClientGetInsightResultsResponseInsightResultsTypeDef(
    _ClientGetInsightResultsResponseInsightResultsTypeDef
):
    """
    Type definition for `ClientGetInsightResultsResponse` `InsightResults`

    The insight results returned by the operation.

    - **InsightArn** *(string) --*

      The ARN of the insight whose results are returned by the ``GetInsightResults`` operation.

    - **GroupByAttribute** *(string) --*

      The attribute that the findings are grouped by for the insight whose results are returned by
      the ``GetInsightResults`` operation.

    - **ResultValues** *(list) --*

      The list of insight result values returned by the ``GetInsightResults`` operation.

      - *(dict) --*

        The insight result values returned by the ``GetInsightResults`` operation.

        - **GroupByAttributeValue** *(string) --*

          The value of the attribute that the findings are grouped by for the insight whose results
          are returned by the ``GetInsightResults`` operation.

        - **Count** *(integer) --*

          The number of findings returned for each ``GroupByAttributeValue`` .
    """


_ClientGetInsightResultsResponseTypeDef = TypedDict(
    "_ClientGetInsightResultsResponseTypeDef",
    {"InsightResults": ClientGetInsightResultsResponseInsightResultsTypeDef},
    total=False,
)


class ClientGetInsightResultsResponseTypeDef(_ClientGetInsightResultsResponseTypeDef):
    """
    Type definition for `ClientGetInsightResults` `Response`

    - **InsightResults** *(dict) --*

      The insight results returned by the operation.

      - **InsightArn** *(string) --*

        The ARN of the insight whose results are returned by the ``GetInsightResults`` operation.

      - **GroupByAttribute** *(string) --*

        The attribute that the findings are grouped by for the insight whose results are returned by
        the ``GetInsightResults`` operation.

      - **ResultValues** *(list) --*

        The list of insight result values returned by the ``GetInsightResults`` operation.

        - *(dict) --*

          The insight result values returned by the ``GetInsightResults`` operation.

          - **GroupByAttributeValue** *(string) --*

            The value of the attribute that the findings are grouped by for the insight whose
            results are returned by the ``GetInsightResults`` operation.

          - **Count** *(integer) --*

            The number of findings returned for each ``GroupByAttributeValue`` .
    """


_ClientGetInsightsResponseInsightsFiltersAwsAccountIdTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersAwsAccountIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersAwsAccountIdTypeDef(
    _ClientGetInsightsResponseInsightsFiltersAwsAccountIdTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `AwsAccountId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersCompanyNameTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersCompanyNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersCompanyNameTypeDef(
    _ClientGetInsightsResponseInsightsFiltersCompanyNameTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `CompanyName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersComplianceStatusTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersComplianceStatusTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersComplianceStatusTypeDef(
    _ClientGetInsightsResponseInsightsFiltersComplianceStatusTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ComplianceStatus`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersConfidenceTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersConfidenceTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersConfidenceTypeDef(
    _ClientGetInsightsResponseInsightsFiltersConfidenceTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `Confidence`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersCreatedAtDateRangeTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersCreatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersCreatedAtDateRangeTypeDef(
    _ClientGetInsightsResponseInsightsFiltersCreatedAtDateRangeTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFiltersCreatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientGetInsightsResponseInsightsFiltersCreatedAtTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersCreatedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientGetInsightsResponseInsightsFiltersCreatedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersCreatedAtTypeDef(
    _ClientGetInsightsResponseInsightsFiltersCreatedAtTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `CreatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientGetInsightsResponseInsightsFiltersCriticalityTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersCriticalityTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersCriticalityTypeDef(
    _ClientGetInsightsResponseInsightsFiltersCriticalityTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `Criticality`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersDescriptionTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersDescriptionTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersDescriptionTypeDef(
    _ClientGetInsightsResponseInsightsFiltersDescriptionTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `Description`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersFirstObservedAtDateRangeTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersFirstObservedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersFirstObservedAtDateRangeTypeDef(
    _ClientGetInsightsResponseInsightsFiltersFirstObservedAtDateRangeTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFiltersFirstObservedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientGetInsightsResponseInsightsFiltersFirstObservedAtTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersFirstObservedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientGetInsightsResponseInsightsFiltersFirstObservedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersFirstObservedAtTypeDef(
    _ClientGetInsightsResponseInsightsFiltersFirstObservedAtTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `FirstObservedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientGetInsightsResponseInsightsFiltersGeneratorIdTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersGeneratorIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersGeneratorIdTypeDef(
    _ClientGetInsightsResponseInsightsFiltersGeneratorIdTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `GeneratorId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersIdTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersIdTypeDef(
    _ClientGetInsightsResponseInsightsFiltersIdTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `Id`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersKeywordTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersKeywordTypeDef", {"Value": str}, total=False
)


class ClientGetInsightsResponseInsightsFiltersKeywordTypeDef(
    _ClientGetInsightsResponseInsightsFiltersKeywordTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `Keyword`

    A keyword filter for querying findings.

    - **Value** *(string) --*

      A value for the keyword.
    """


_ClientGetInsightsResponseInsightsFiltersLastObservedAtDateRangeTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersLastObservedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersLastObservedAtDateRangeTypeDef(
    _ClientGetInsightsResponseInsightsFiltersLastObservedAtDateRangeTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFiltersLastObservedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientGetInsightsResponseInsightsFiltersLastObservedAtTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersLastObservedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientGetInsightsResponseInsightsFiltersLastObservedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersLastObservedAtTypeDef(
    _ClientGetInsightsResponseInsightsFiltersLastObservedAtTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `LastObservedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientGetInsightsResponseInsightsFiltersMalwareNameTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersMalwareNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersMalwareNameTypeDef(
    _ClientGetInsightsResponseInsightsFiltersMalwareNameTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `MalwareName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersMalwarePathTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersMalwarePathTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersMalwarePathTypeDef(
    _ClientGetInsightsResponseInsightsFiltersMalwarePathTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `MalwarePath`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersMalwareStateTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersMalwareStateTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersMalwareStateTypeDef(
    _ClientGetInsightsResponseInsightsFiltersMalwareStateTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `MalwareState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersMalwareTypeTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersMalwareTypeTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersMalwareTypeTypeDef(
    _ClientGetInsightsResponseInsightsFiltersMalwareTypeTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `MalwareType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersNetworkDestinationDomainTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersNetworkDestinationDomainTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersNetworkDestinationDomainTypeDef(
    _ClientGetInsightsResponseInsightsFiltersNetworkDestinationDomainTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `NetworkDestinationDomain`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersNetworkDestinationIpV4TypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersNetworkDestinationIpV4TypeDef",
    {"Cidr": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersNetworkDestinationIpV4TypeDef(
    _ClientGetInsightsResponseInsightsFiltersNetworkDestinationIpV4TypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `NetworkDestinationIpV4`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientGetInsightsResponseInsightsFiltersNetworkDestinationIpV6TypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersNetworkDestinationIpV6TypeDef",
    {"Cidr": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersNetworkDestinationIpV6TypeDef(
    _ClientGetInsightsResponseInsightsFiltersNetworkDestinationIpV6TypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `NetworkDestinationIpV6`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientGetInsightsResponseInsightsFiltersNetworkDestinationPortTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersNetworkDestinationPortTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersNetworkDestinationPortTypeDef(
    _ClientGetInsightsResponseInsightsFiltersNetworkDestinationPortTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `NetworkDestinationPort`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersNetworkDirectionTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersNetworkDirectionTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersNetworkDirectionTypeDef(
    _ClientGetInsightsResponseInsightsFiltersNetworkDirectionTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `NetworkDirection`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersNetworkProtocolTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersNetworkProtocolTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersNetworkProtocolTypeDef(
    _ClientGetInsightsResponseInsightsFiltersNetworkProtocolTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `NetworkProtocol`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersNetworkSourceDomainTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersNetworkSourceDomainTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersNetworkSourceDomainTypeDef(
    _ClientGetInsightsResponseInsightsFiltersNetworkSourceDomainTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `NetworkSourceDomain`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersNetworkSourceIpV4TypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersNetworkSourceIpV4TypeDef", {"Cidr": str}, total=False
)


class ClientGetInsightsResponseInsightsFiltersNetworkSourceIpV4TypeDef(
    _ClientGetInsightsResponseInsightsFiltersNetworkSourceIpV4TypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `NetworkSourceIpV4`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientGetInsightsResponseInsightsFiltersNetworkSourceIpV6TypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersNetworkSourceIpV6TypeDef", {"Cidr": str}, total=False
)


class ClientGetInsightsResponseInsightsFiltersNetworkSourceIpV6TypeDef(
    _ClientGetInsightsResponseInsightsFiltersNetworkSourceIpV6TypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `NetworkSourceIpV6`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientGetInsightsResponseInsightsFiltersNetworkSourceMacTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersNetworkSourceMacTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersNetworkSourceMacTypeDef(
    _ClientGetInsightsResponseInsightsFiltersNetworkSourceMacTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `NetworkSourceMac`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersNetworkSourcePortTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersNetworkSourcePortTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersNetworkSourcePortTypeDef(
    _ClientGetInsightsResponseInsightsFiltersNetworkSourcePortTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `NetworkSourcePort`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersNoteTextTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersNoteTextTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersNoteTextTypeDef(
    _ClientGetInsightsResponseInsightsFiltersNoteTextTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `NoteText`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersNoteUpdatedAtDateRangeTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersNoteUpdatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersNoteUpdatedAtDateRangeTypeDef(
    _ClientGetInsightsResponseInsightsFiltersNoteUpdatedAtDateRangeTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFiltersNoteUpdatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientGetInsightsResponseInsightsFiltersNoteUpdatedAtTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersNoteUpdatedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientGetInsightsResponseInsightsFiltersNoteUpdatedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersNoteUpdatedAtTypeDef(
    _ClientGetInsightsResponseInsightsFiltersNoteUpdatedAtTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `NoteUpdatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientGetInsightsResponseInsightsFiltersNoteUpdatedByTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersNoteUpdatedByTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersNoteUpdatedByTypeDef(
    _ClientGetInsightsResponseInsightsFiltersNoteUpdatedByTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `NoteUpdatedBy`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersProcessLaunchedAtDateRangeTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersProcessLaunchedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersProcessLaunchedAtDateRangeTypeDef(
    _ClientGetInsightsResponseInsightsFiltersProcessLaunchedAtDateRangeTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFiltersProcessLaunchedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientGetInsightsResponseInsightsFiltersProcessLaunchedAtTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersProcessLaunchedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientGetInsightsResponseInsightsFiltersProcessLaunchedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersProcessLaunchedAtTypeDef(
    _ClientGetInsightsResponseInsightsFiltersProcessLaunchedAtTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ProcessLaunchedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientGetInsightsResponseInsightsFiltersProcessNameTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersProcessNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersProcessNameTypeDef(
    _ClientGetInsightsResponseInsightsFiltersProcessNameTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ProcessName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersProcessParentPidTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersProcessParentPidTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersProcessParentPidTypeDef(
    _ClientGetInsightsResponseInsightsFiltersProcessParentPidTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ProcessParentPid`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersProcessPathTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersProcessPathTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersProcessPathTypeDef(
    _ClientGetInsightsResponseInsightsFiltersProcessPathTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ProcessPath`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersProcessPidTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersProcessPidTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersProcessPidTypeDef(
    _ClientGetInsightsResponseInsightsFiltersProcessPidTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ProcessPid`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersProcessTerminatedAtDateRangeTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersProcessTerminatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersProcessTerminatedAtDateRangeTypeDef(
    _ClientGetInsightsResponseInsightsFiltersProcessTerminatedAtDateRangeTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFiltersProcessTerminatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientGetInsightsResponseInsightsFiltersProcessTerminatedAtTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersProcessTerminatedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientGetInsightsResponseInsightsFiltersProcessTerminatedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersProcessTerminatedAtTypeDef(
    _ClientGetInsightsResponseInsightsFiltersProcessTerminatedAtTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ProcessTerminatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientGetInsightsResponseInsightsFiltersProductArnTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersProductArnTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersProductArnTypeDef(
    _ClientGetInsightsResponseInsightsFiltersProductArnTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ProductArn`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersProductFieldsTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersProductFieldsTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersProductFieldsTypeDef(
    _ClientGetInsightsResponseInsightsFiltersProductFieldsTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ProductFields`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_ClientGetInsightsResponseInsightsFiltersProductNameTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersProductNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersProductNameTypeDef(
    _ClientGetInsightsResponseInsightsFiltersProductNameTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ProductName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersRecommendationTextTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersRecommendationTextTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersRecommendationTextTypeDef(
    _ClientGetInsightsResponseInsightsFiltersRecommendationTextTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `RecommendationText`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersRecordStateTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersRecordStateTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersRecordStateTypeDef(
    _ClientGetInsightsResponseInsightsFiltersRecordStateTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `RecordState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersRelatedFindingsIdTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersRelatedFindingsIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersRelatedFindingsIdTypeDef(
    _ClientGetInsightsResponseInsightsFiltersRelatedFindingsIdTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `RelatedFindingsId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersRelatedFindingsProductArnTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersRelatedFindingsProductArnTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersRelatedFindingsProductArnTypeDef(
    _ClientGetInsightsResponseInsightsFiltersRelatedFindingsProductArnTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `RelatedFindingsProductArn`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters`
    `ResourceAwsEc2InstanceIamInstanceProfileArn`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceImageIdTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceImageIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceImageIdTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceImageIdTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ResourceAwsEc2InstanceImageId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef",
    {"Cidr": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters`
    `ResourceAwsEc2InstanceIpV4Addresses`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef",
    {"Cidr": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters`
    `ResourceAwsEc2InstanceIpV6Addresses`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceKeyNameTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceKeyNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceKeyNameTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceKeyNameTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ResourceAwsEc2InstanceKeyName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceLaunchedAt`
    `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceLaunchedAtTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceLaunchedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceLaunchedAtTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceLaunchedAtTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters`
    `ResourceAwsEc2InstanceLaunchedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceSubnetIdTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceSubnetIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceSubnetIdTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceSubnetIdTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ResourceAwsEc2InstanceSubnetId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceTypeTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceTypeTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceTypeTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceTypeTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ResourceAwsEc2InstanceType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceVpcIdTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceVpcIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceVpcIdTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceVpcIdTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ResourceAwsEc2InstanceVpcId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFiltersResourceAwsIamAccessKeyCreatedAt`
    `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientGetInsightsResponseInsightsFiltersResourceAwsIamAccessKeyCreatedAtTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourceAwsIamAccessKeyCreatedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientGetInsightsResponseInsightsFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourceAwsIamAccessKeyCreatedAtTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourceAwsIamAccessKeyCreatedAtTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters`
    `ResourceAwsIamAccessKeyCreatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientGetInsightsResponseInsightsFiltersResourceAwsIamAccessKeyStatusTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourceAwsIamAccessKeyStatusTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourceAwsIamAccessKeyStatusTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourceAwsIamAccessKeyStatusTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ResourceAwsIamAccessKeyStatus`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersResourceAwsIamAccessKeyUserNameTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourceAwsIamAccessKeyUserNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourceAwsIamAccessKeyUserNameTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourceAwsIamAccessKeyUserNameTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ResourceAwsIamAccessKeyUserName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersResourceAwsS3BucketOwnerIdTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourceAwsS3BucketOwnerIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourceAwsS3BucketOwnerIdTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourceAwsS3BucketOwnerIdTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ResourceAwsS3BucketOwnerId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersResourceAwsS3BucketOwnerNameTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourceAwsS3BucketOwnerNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourceAwsS3BucketOwnerNameTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourceAwsS3BucketOwnerNameTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ResourceAwsS3BucketOwnerName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersResourceContainerImageIdTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourceContainerImageIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourceContainerImageIdTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourceContainerImageIdTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ResourceContainerImageId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersResourceContainerImageNameTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourceContainerImageNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourceContainerImageNameTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourceContainerImageNameTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ResourceContainerImageName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersResourceContainerLaunchedAtDateRangeTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourceContainerLaunchedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourceContainerLaunchedAtDateRangeTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourceContainerLaunchedAtDateRangeTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFiltersResourceContainerLaunchedAt`
    `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientGetInsightsResponseInsightsFiltersResourceContainerLaunchedAtTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourceContainerLaunchedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientGetInsightsResponseInsightsFiltersResourceContainerLaunchedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourceContainerLaunchedAtTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourceContainerLaunchedAtTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ResourceContainerLaunchedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientGetInsightsResponseInsightsFiltersResourceContainerNameTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourceContainerNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourceContainerNameTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourceContainerNameTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ResourceContainerName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersResourceDetailsOtherTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourceDetailsOtherTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourceDetailsOtherTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourceDetailsOtherTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ResourceDetailsOther`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_ClientGetInsightsResponseInsightsFiltersResourceIdTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourceIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourceIdTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourceIdTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ResourceId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersResourcePartitionTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourcePartitionTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourcePartitionTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourcePartitionTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ResourcePartition`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersResourceRegionTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourceRegionTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourceRegionTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourceRegionTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ResourceRegion`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersResourceTagsTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourceTagsTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourceTagsTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourceTagsTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ResourceTags`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_ClientGetInsightsResponseInsightsFiltersResourceTypeTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersResourceTypeTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersResourceTypeTypeDef(
    _ClientGetInsightsResponseInsightsFiltersResourceTypeTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ResourceType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersSeverityLabelTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersSeverityLabelTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersSeverityLabelTypeDef(
    _ClientGetInsightsResponseInsightsFiltersSeverityLabelTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `SeverityLabel`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersSeverityNormalizedTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersSeverityNormalizedTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersSeverityNormalizedTypeDef(
    _ClientGetInsightsResponseInsightsFiltersSeverityNormalizedTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `SeverityNormalized`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersSeverityProductTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersSeverityProductTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersSeverityProductTypeDef(
    _ClientGetInsightsResponseInsightsFiltersSeverityProductTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `SeverityProduct`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersSourceUrlTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersSourceUrlTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersSourceUrlTypeDef(
    _ClientGetInsightsResponseInsightsFiltersSourceUrlTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `SourceUrl`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorCategoryTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorCategoryTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorCategoryTypeDef(
    _ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorCategoryTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ThreatIntelIndicatorCategory`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef(
    _ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorLastObservedAt`
    `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorLastObservedAtTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorLastObservedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorLastObservedAtTypeDef(
    _ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorLastObservedAtTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters`
    `ThreatIntelIndicatorLastObservedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorSourceTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorSourceTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorSourceTypeDef(
    _ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorSourceTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ThreatIntelIndicatorSource`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorSourceUrlTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorSourceUrlTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorSourceUrlTypeDef(
    _ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorSourceUrlTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ThreatIntelIndicatorSourceUrl`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorTypeTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorTypeTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorTypeTypeDef(
    _ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorTypeTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ThreatIntelIndicatorType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorValueTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorValueTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorValueTypeDef(
    _ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorValueTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `ThreatIntelIndicatorValue`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersTitleTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersTitleTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersTitleTypeDef(
    _ClientGetInsightsResponseInsightsFiltersTitleTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `Title`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersTypeTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersTypeTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersTypeTypeDef(
    _ClientGetInsightsResponseInsightsFiltersTypeTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `Type`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersUpdatedAtDateRangeTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersUpdatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersUpdatedAtDateRangeTypeDef(
    _ClientGetInsightsResponseInsightsFiltersUpdatedAtDateRangeTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFiltersUpdatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientGetInsightsResponseInsightsFiltersUpdatedAtTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersUpdatedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientGetInsightsResponseInsightsFiltersUpdatedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersUpdatedAtTypeDef(
    _ClientGetInsightsResponseInsightsFiltersUpdatedAtTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `UpdatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientGetInsightsResponseInsightsFiltersUserDefinedFieldsTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersUserDefinedFieldsTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersUserDefinedFieldsTypeDef(
    _ClientGetInsightsResponseInsightsFiltersUserDefinedFieldsTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `UserDefinedFields`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_ClientGetInsightsResponseInsightsFiltersVerificationStateTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersVerificationStateTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersVerificationStateTypeDef(
    _ClientGetInsightsResponseInsightsFiltersVerificationStateTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `VerificationState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersWorkflowStateTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersWorkflowStateTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersWorkflowStateTypeDef(
    _ClientGetInsightsResponseInsightsFiltersWorkflowStateTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsightsFilters` `WorkflowState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientGetInsightsResponseInsightsFiltersTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsFiltersTypeDef",
    {
        "ProductArn": List[ClientGetInsightsResponseInsightsFiltersProductArnTypeDef],
        "AwsAccountId": List[ClientGetInsightsResponseInsightsFiltersAwsAccountIdTypeDef],
        "Id": List[ClientGetInsightsResponseInsightsFiltersIdTypeDef],
        "GeneratorId": List[ClientGetInsightsResponseInsightsFiltersGeneratorIdTypeDef],
        "Type": List[ClientGetInsightsResponseInsightsFiltersTypeTypeDef],
        "FirstObservedAt": List[ClientGetInsightsResponseInsightsFiltersFirstObservedAtTypeDef],
        "LastObservedAt": List[ClientGetInsightsResponseInsightsFiltersLastObservedAtTypeDef],
        "CreatedAt": List[ClientGetInsightsResponseInsightsFiltersCreatedAtTypeDef],
        "UpdatedAt": List[ClientGetInsightsResponseInsightsFiltersUpdatedAtTypeDef],
        "SeverityProduct": List[ClientGetInsightsResponseInsightsFiltersSeverityProductTypeDef],
        "SeverityNormalized": List[
            ClientGetInsightsResponseInsightsFiltersSeverityNormalizedTypeDef
        ],
        "SeverityLabel": List[ClientGetInsightsResponseInsightsFiltersSeverityLabelTypeDef],
        "Confidence": List[ClientGetInsightsResponseInsightsFiltersConfidenceTypeDef],
        "Criticality": List[ClientGetInsightsResponseInsightsFiltersCriticalityTypeDef],
        "Title": List[ClientGetInsightsResponseInsightsFiltersTitleTypeDef],
        "Description": List[ClientGetInsightsResponseInsightsFiltersDescriptionTypeDef],
        "RecommendationText": List[
            ClientGetInsightsResponseInsightsFiltersRecommendationTextTypeDef
        ],
        "SourceUrl": List[ClientGetInsightsResponseInsightsFiltersSourceUrlTypeDef],
        "ProductFields": List[ClientGetInsightsResponseInsightsFiltersProductFieldsTypeDef],
        "ProductName": List[ClientGetInsightsResponseInsightsFiltersProductNameTypeDef],
        "CompanyName": List[ClientGetInsightsResponseInsightsFiltersCompanyNameTypeDef],
        "UserDefinedFields": List[ClientGetInsightsResponseInsightsFiltersUserDefinedFieldsTypeDef],
        "MalwareName": List[ClientGetInsightsResponseInsightsFiltersMalwareNameTypeDef],
        "MalwareType": List[ClientGetInsightsResponseInsightsFiltersMalwareTypeTypeDef],
        "MalwarePath": List[ClientGetInsightsResponseInsightsFiltersMalwarePathTypeDef],
        "MalwareState": List[ClientGetInsightsResponseInsightsFiltersMalwareStateTypeDef],
        "NetworkDirection": List[ClientGetInsightsResponseInsightsFiltersNetworkDirectionTypeDef],
        "NetworkProtocol": List[ClientGetInsightsResponseInsightsFiltersNetworkProtocolTypeDef],
        "NetworkSourceIpV4": List[ClientGetInsightsResponseInsightsFiltersNetworkSourceIpV4TypeDef],
        "NetworkSourceIpV6": List[ClientGetInsightsResponseInsightsFiltersNetworkSourceIpV6TypeDef],
        "NetworkSourcePort": List[ClientGetInsightsResponseInsightsFiltersNetworkSourcePortTypeDef],
        "NetworkSourceDomain": List[
            ClientGetInsightsResponseInsightsFiltersNetworkSourceDomainTypeDef
        ],
        "NetworkSourceMac": List[ClientGetInsightsResponseInsightsFiltersNetworkSourceMacTypeDef],
        "NetworkDestinationIpV4": List[
            ClientGetInsightsResponseInsightsFiltersNetworkDestinationIpV4TypeDef
        ],
        "NetworkDestinationIpV6": List[
            ClientGetInsightsResponseInsightsFiltersNetworkDestinationIpV6TypeDef
        ],
        "NetworkDestinationPort": List[
            ClientGetInsightsResponseInsightsFiltersNetworkDestinationPortTypeDef
        ],
        "NetworkDestinationDomain": List[
            ClientGetInsightsResponseInsightsFiltersNetworkDestinationDomainTypeDef
        ],
        "ProcessName": List[ClientGetInsightsResponseInsightsFiltersProcessNameTypeDef],
        "ProcessPath": List[ClientGetInsightsResponseInsightsFiltersProcessPathTypeDef],
        "ProcessPid": List[ClientGetInsightsResponseInsightsFiltersProcessPidTypeDef],
        "ProcessParentPid": List[ClientGetInsightsResponseInsightsFiltersProcessParentPidTypeDef],
        "ProcessLaunchedAt": List[ClientGetInsightsResponseInsightsFiltersProcessLaunchedAtTypeDef],
        "ProcessTerminatedAt": List[
            ClientGetInsightsResponseInsightsFiltersProcessTerminatedAtTypeDef
        ],
        "ThreatIntelIndicatorType": List[
            ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorTypeTypeDef
        ],
        "ThreatIntelIndicatorValue": List[
            ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorValueTypeDef
        ],
        "ThreatIntelIndicatorCategory": List[
            ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorCategoryTypeDef
        ],
        "ThreatIntelIndicatorLastObservedAt": List[
            ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorLastObservedAtTypeDef
        ],
        "ThreatIntelIndicatorSource": List[
            ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorSourceTypeDef
        ],
        "ThreatIntelIndicatorSourceUrl": List[
            ClientGetInsightsResponseInsightsFiltersThreatIntelIndicatorSourceUrlTypeDef
        ],
        "ResourceType": List[ClientGetInsightsResponseInsightsFiltersResourceTypeTypeDef],
        "ResourceId": List[ClientGetInsightsResponseInsightsFiltersResourceIdTypeDef],
        "ResourcePartition": List[ClientGetInsightsResponseInsightsFiltersResourcePartitionTypeDef],
        "ResourceRegion": List[ClientGetInsightsResponseInsightsFiltersResourceRegionTypeDef],
        "ResourceTags": List[ClientGetInsightsResponseInsightsFiltersResourceTagsTypeDef],
        "ResourceAwsEc2InstanceType": List[
            ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceTypeTypeDef
        ],
        "ResourceAwsEc2InstanceImageId": List[
            ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceImageIdTypeDef
        ],
        "ResourceAwsEc2InstanceIpV4Addresses": List[
            ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef
        ],
        "ResourceAwsEc2InstanceIpV6Addresses": List[
            ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef
        ],
        "ResourceAwsEc2InstanceKeyName": List[
            ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceKeyNameTypeDef
        ],
        "ResourceAwsEc2InstanceIamInstanceProfileArn": List[
            ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef
        ],
        "ResourceAwsEc2InstanceVpcId": List[
            ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceVpcIdTypeDef
        ],
        "ResourceAwsEc2InstanceSubnetId": List[
            ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceSubnetIdTypeDef
        ],
        "ResourceAwsEc2InstanceLaunchedAt": List[
            ClientGetInsightsResponseInsightsFiltersResourceAwsEc2InstanceLaunchedAtTypeDef
        ],
        "ResourceAwsS3BucketOwnerId": List[
            ClientGetInsightsResponseInsightsFiltersResourceAwsS3BucketOwnerIdTypeDef
        ],
        "ResourceAwsS3BucketOwnerName": List[
            ClientGetInsightsResponseInsightsFiltersResourceAwsS3BucketOwnerNameTypeDef
        ],
        "ResourceAwsIamAccessKeyUserName": List[
            ClientGetInsightsResponseInsightsFiltersResourceAwsIamAccessKeyUserNameTypeDef
        ],
        "ResourceAwsIamAccessKeyStatus": List[
            ClientGetInsightsResponseInsightsFiltersResourceAwsIamAccessKeyStatusTypeDef
        ],
        "ResourceAwsIamAccessKeyCreatedAt": List[
            ClientGetInsightsResponseInsightsFiltersResourceAwsIamAccessKeyCreatedAtTypeDef
        ],
        "ResourceContainerName": List[
            ClientGetInsightsResponseInsightsFiltersResourceContainerNameTypeDef
        ],
        "ResourceContainerImageId": List[
            ClientGetInsightsResponseInsightsFiltersResourceContainerImageIdTypeDef
        ],
        "ResourceContainerImageName": List[
            ClientGetInsightsResponseInsightsFiltersResourceContainerImageNameTypeDef
        ],
        "ResourceContainerLaunchedAt": List[
            ClientGetInsightsResponseInsightsFiltersResourceContainerLaunchedAtTypeDef
        ],
        "ResourceDetailsOther": List[
            ClientGetInsightsResponseInsightsFiltersResourceDetailsOtherTypeDef
        ],
        "ComplianceStatus": List[ClientGetInsightsResponseInsightsFiltersComplianceStatusTypeDef],
        "VerificationState": List[ClientGetInsightsResponseInsightsFiltersVerificationStateTypeDef],
        "WorkflowState": List[ClientGetInsightsResponseInsightsFiltersWorkflowStateTypeDef],
        "RecordState": List[ClientGetInsightsResponseInsightsFiltersRecordStateTypeDef],
        "RelatedFindingsProductArn": List[
            ClientGetInsightsResponseInsightsFiltersRelatedFindingsProductArnTypeDef
        ],
        "RelatedFindingsId": List[ClientGetInsightsResponseInsightsFiltersRelatedFindingsIdTypeDef],
        "NoteText": List[ClientGetInsightsResponseInsightsFiltersNoteTextTypeDef],
        "NoteUpdatedAt": List[ClientGetInsightsResponseInsightsFiltersNoteUpdatedAtTypeDef],
        "NoteUpdatedBy": List[ClientGetInsightsResponseInsightsFiltersNoteUpdatedByTypeDef],
        "Keyword": List[ClientGetInsightsResponseInsightsFiltersKeywordTypeDef],
    },
    total=False,
)


class ClientGetInsightsResponseInsightsFiltersTypeDef(
    _ClientGetInsightsResponseInsightsFiltersTypeDef
):
    """
    Type definition for `ClientGetInsightsResponseInsights` `Filters`

    One or more attributes used to filter the findings included in the insight. Only findings that
    match the criteria defined in the filters are included in the insight.

    - **ProductArn** *(list) --*

      The ARN generated by Security Hub that uniquely identifies a third-party company (security
      findings provider) after this provider's product (solution that generates findings) is
      registered with Security Hub.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **AwsAccountId** *(list) --*

      The AWS account ID that a finding is generated in.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Id** *(list) --*

      The security findings provider-specific identifier for a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **GeneratorId** *(list) --*

      The identifier for the solution-specific component (a discrete unit of logic) that generated a
      finding. In various security-findings providers' solutions, this generator can be called a
      rule, a check, a detector, a plug-in, etc.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Type** *(list) --*

      A finding type in the format of ``namespace/category/classifier`` that classifies a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **FirstObservedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider first
      observed the potential security issue that a finding captured.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **LastObservedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider most
      recently observed the potential security issue that a finding captured.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **CreatedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider captured the
      potential security issue that a finding captured.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **UpdatedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider last updated
      the finding record.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **SeverityProduct** *(list) --*

      The native severity as defined by the security-findings provider's solution that generated the
      finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **SeverityNormalized** *(list) --*

      The normalized severity of a finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **SeverityLabel** *(list) --*

      The label of a finding's severity.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Confidence** *(list) --*

      A finding's confidence. Confidence is defined as the likelihood that a finding accurately
      identifies the behavior or issue that it was intended to identify. Confidence is scored on a
      0-100 basis using a ratio scale, where 0 means zero percent confidence and 100 means 100
      percent confidence.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **Criticality** *(list) --*

      The level of importance assigned to the resources associated with the finding. A score of 0
      means that the underlying resources have no criticality, and a score of 100 is reserved for
      the most critical resources.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **Title** *(list) --*

      A finding's title.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Description** *(list) --*

      A finding's description.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RecommendationText** *(list) --*

      The recommendation of what to do about the issue described in a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **SourceUrl** *(list) --*

      A URL that links to a page about the current finding in the security-findings provider's
      solution.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProductFields** *(list) --*

      A data type where security-findings providers can include additional solution-specific details
      that aren't part of the defined ``AwsSecurityFinding`` format.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **ProductName** *(list) --*

      The name of the solution (product) that generates findings.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **CompanyName** *(list) --*

      The name of the findings provider (company) that owns the solution (product) that generates
      findings.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **UserDefinedFields** *(list) --*

      A list of name/value string pairs associated with the finding. These are custom, user-defined
      fields added to a finding.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **MalwareName** *(list) --*

      The name of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **MalwareType** *(list) --*

      The type of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **MalwarePath** *(list) --*

      The filesystem path of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **MalwareState** *(list) --*

      The state of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkDirection** *(list) --*

      Indicates the direction of network traffic associated with a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkProtocol** *(list) --*

      The protocol of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkSourceIpV4** *(list) --*

      The source IPv4 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkSourceIpV6** *(list) --*

      The source IPv6 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkSourcePort** *(list) --*

      The source port of network-related information about a finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **NetworkSourceDomain** *(list) --*

      The source domain of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkSourceMac** *(list) --*

      The source media access control (MAC) address of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkDestinationIpV4** *(list) --*

      The destination IPv4 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkDestinationIpV6** *(list) --*

      The destination IPv6 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkDestinationPort** *(list) --*

      The destination port of network-related information about a finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **NetworkDestinationDomain** *(list) --*

      The destination domain of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProcessName** *(list) --*

      The name of the process.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProcessPath** *(list) --*

      The path to the process executable.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProcessPid** *(list) --*

      The process ID.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **ProcessParentPid** *(list) --*

      The parent process ID.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **ProcessLaunchedAt** *(list) --*

      The date/time that the process was launched.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ProcessTerminatedAt** *(list) --*

      The date/time that the process was terminated.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ThreatIntelIndicatorType** *(list) --*

      The type of a threat intel indicator.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorValue** *(list) --*

      The value of a threat intel indicator.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorCategory** *(list) --*

      The category of a threat intel indicator.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorLastObservedAt** *(list) --*

      The date/time of the last observation of a threat intel indicator.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ThreatIntelIndicatorSource** *(list) --*

      The source of the threat intel.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorSourceUrl** *(list) --*

      The URL for more details from the source of the threat intel.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceType** *(list) --*

      Specifies the type of the resource that details are provided for.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceId** *(list) --*

      The canonical identifier for the given resource type.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourcePartition** *(list) --*

      The canonical AWS partition name that the Region is assigned to.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceRegion** *(list) --*

      The canonical AWS external Region name where this resource is located.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceTags** *(list) --*

      A list of AWS tags associated with a resource at the time the finding was processed.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **ResourceAwsEc2InstanceType** *(list) --*

      The instance type of the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceImageId** *(list) --*

      The Amazon Machine Image (AMI) ID of the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceIpV4Addresses** *(list) --*

      The IPv4 addresses associated with the instance.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **ResourceAwsEc2InstanceIpV6Addresses** *(list) --*

      The IPv6 addresses associated with the instance.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **ResourceAwsEc2InstanceKeyName** *(list) --*

      The key name associated with the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceIamInstanceProfileArn** *(list) --*

      The IAM profile ARN of the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceVpcId** *(list) --*

      The identifier of the VPC that the instance was launched in.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceSubnetId** *(list) --*

      The identifier of the subnet that the instance was launched in.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceLaunchedAt** *(list) --*

      The date/time the instance was launched.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ResourceAwsS3BucketOwnerId** *(list) --*

      The canonical user ID of the owner of the S3 bucket.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsS3BucketOwnerName** *(list) --*

      The display name of the owner of the S3 bucket.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsIamAccessKeyUserName** *(list) --*

      The user associated with the IAM access key related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsIamAccessKeyStatus** *(list) --*

      The status of the IAM access key related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsIamAccessKeyCreatedAt** *(list) --*

      The creation date/time of the IAM access key related to a finding.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ResourceContainerName** *(list) --*

      The name of the container related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceContainerImageId** *(list) --*

      The identifier of the image related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceContainerImageName** *(list) --*

      The name of the image related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceContainerLaunchedAt** *(list) --*

      The date/time that the container was started.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ResourceDetailsOther** *(list) --*

      The details of a resource that doesn't have a specific subfield for the resource type defined.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **ComplianceStatus** *(list) --*

      Exclusive to findings that are generated as the result of a check run against a specific rule
      in a supported standard (for example, CIS AWS Foundations). Contains compliance-related
      finding details.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **VerificationState** *(list) --*

      The veracity of a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **WorkflowState** *(list) --*

      The workflow state of a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RecordState** *(list) --*

      The updated record state for the finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RelatedFindingsProductArn** *(list) --*

      The ARN of the solution that generated a related finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RelatedFindingsId** *(list) --*

      The solution-generated identifier for a related finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NoteText** *(list) --*

      The text of a note.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NoteUpdatedAt** *(list) --*

      The timestamp of when the note was updated.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **NoteUpdatedBy** *(list) --*

      The principal that created a note.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Keyword** *(list) --*

      A keyword for a finding.

      - *(dict) --*

        A keyword filter for querying findings.

        - **Value** *(string) --*

          A value for the keyword.
    """


_ClientGetInsightsResponseInsightsTypeDef = TypedDict(
    "_ClientGetInsightsResponseInsightsTypeDef",
    {
        "InsightArn": str,
        "Name": str,
        "Filters": ClientGetInsightsResponseInsightsFiltersTypeDef,
        "GroupByAttribute": str,
    },
    total=False,
)


class ClientGetInsightsResponseInsightsTypeDef(_ClientGetInsightsResponseInsightsTypeDef):
    """
    Type definition for `ClientGetInsightsResponse` `Insights`

    Contains information about a Security Hub insight.

    - **InsightArn** *(string) --*

      The ARN of a Security Hub insight.

    - **Name** *(string) --*

      The name of a Security Hub insight.

    - **Filters** *(dict) --*

      One or more attributes used to filter the findings included in the insight. Only findings that
      match the criteria defined in the filters are included in the insight.

      - **ProductArn** *(list) --*

        The ARN generated by Security Hub that uniquely identifies a third-party company (security
        findings provider) after this provider's product (solution that generates findings) is
        registered with Security Hub.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **AwsAccountId** *(list) --*

        The AWS account ID that a finding is generated in.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **Id** *(list) --*

        The security findings provider-specific identifier for a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **GeneratorId** *(list) --*

        The identifier for the solution-specific component (a discrete unit of logic) that generated
        a finding. In various security-findings providers' solutions, this generator can be called a
        rule, a check, a detector, a plug-in, etc.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **Type** *(list) --*

        A finding type in the format of ``namespace/category/classifier`` that classifies a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **FirstObservedAt** *(list) --*

        An ISO8601-formatted timestamp that indicates when the security-findings provider first
        observed the potential security issue that a finding captured.

        - *(dict) --*

          A date filter for querying findings.

          - **Start** *(string) --*

            A start date for the date filter.

          - **End** *(string) --*

            An end date for the date filter.

          - **DateRange** *(dict) --*

            A date range for the date filter.

            - **Value** *(integer) --*

              A date range value for the date filter.

            - **Unit** *(string) --*

              A date range unit for the date filter.

      - **LastObservedAt** *(list) --*

        An ISO8601-formatted timestamp that indicates when the security-findings provider most
        recently observed the potential security issue that a finding captured.

        - *(dict) --*

          A date filter for querying findings.

          - **Start** *(string) --*

            A start date for the date filter.

          - **End** *(string) --*

            An end date for the date filter.

          - **DateRange** *(dict) --*

            A date range for the date filter.

            - **Value** *(integer) --*

              A date range value for the date filter.

            - **Unit** *(string) --*

              A date range unit for the date filter.

      - **CreatedAt** *(list) --*

        An ISO8601-formatted timestamp that indicates when the security-findings provider captured
        the potential security issue that a finding captured.

        - *(dict) --*

          A date filter for querying findings.

          - **Start** *(string) --*

            A start date for the date filter.

          - **End** *(string) --*

            An end date for the date filter.

          - **DateRange** *(dict) --*

            A date range for the date filter.

            - **Value** *(integer) --*

              A date range value for the date filter.

            - **Unit** *(string) --*

              A date range unit for the date filter.

      - **UpdatedAt** *(list) --*

        An ISO8601-formatted timestamp that indicates when the security-findings provider last
        updated the finding record.

        - *(dict) --*

          A date filter for querying findings.

          - **Start** *(string) --*

            A start date for the date filter.

          - **End** *(string) --*

            An end date for the date filter.

          - **DateRange** *(dict) --*

            A date range for the date filter.

            - **Value** *(integer) --*

              A date range value for the date filter.

            - **Unit** *(string) --*

              A date range unit for the date filter.

      - **SeverityProduct** *(list) --*

        The native severity as defined by the security-findings provider's solution that generated
        the finding.

        - *(dict) --*

          A number filter for querying findings.

          - **Gte** *(float) --*

            The greater-than-equal condition to be applied to a single field when querying for
            findings.

          - **Lte** *(float) --*

            The less-than-equal condition to be applied to a single field when querying for
            findings.

          - **Eq** *(float) --*

            The equal-to condition to be applied to a single field when querying for findings.

      - **SeverityNormalized** *(list) --*

        The normalized severity of a finding.

        - *(dict) --*

          A number filter for querying findings.

          - **Gte** *(float) --*

            The greater-than-equal condition to be applied to a single field when querying for
            findings.

          - **Lte** *(float) --*

            The less-than-equal condition to be applied to a single field when querying for
            findings.

          - **Eq** *(float) --*

            The equal-to condition to be applied to a single field when querying for findings.

      - **SeverityLabel** *(list) --*

        The label of a finding's severity.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **Confidence** *(list) --*

        A finding's confidence. Confidence is defined as the likelihood that a finding accurately
        identifies the behavior or issue that it was intended to identify. Confidence is scored on a
        0-100 basis using a ratio scale, where 0 means zero percent confidence and 100 means 100
        percent confidence.

        - *(dict) --*

          A number filter for querying findings.

          - **Gte** *(float) --*

            The greater-than-equal condition to be applied to a single field when querying for
            findings.

          - **Lte** *(float) --*

            The less-than-equal condition to be applied to a single field when querying for
            findings.

          - **Eq** *(float) --*

            The equal-to condition to be applied to a single field when querying for findings.

      - **Criticality** *(list) --*

        The level of importance assigned to the resources associated with the finding. A score of 0
        means that the underlying resources have no criticality, and a score of 100 is reserved for
        the most critical resources.

        - *(dict) --*

          A number filter for querying findings.

          - **Gte** *(float) --*

            The greater-than-equal condition to be applied to a single field when querying for
            findings.

          - **Lte** *(float) --*

            The less-than-equal condition to be applied to a single field when querying for
            findings.

          - **Eq** *(float) --*

            The equal-to condition to be applied to a single field when querying for findings.

      - **Title** *(list) --*

        A finding's title.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **Description** *(list) --*

        A finding's description.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **RecommendationText** *(list) --*

        The recommendation of what to do about the issue described in a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **SourceUrl** *(list) --*

        A URL that links to a page about the current finding in the security-findings provider's
        solution.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ProductFields** *(list) --*

        A data type where security-findings providers can include additional solution-specific
        details that aren't part of the defined ``AwsSecurityFinding`` format.

        - *(dict) --*

          The map filter for querying findings.

          - **Key** *(string) --*

            The key of the map filter.

          - **Value** *(string) --*

            The value for the key in the map filter.

          - **Comparison** *(string) --*

            The condition to apply to a key value when querying for findings with a map filter.

      - **ProductName** *(list) --*

        The name of the solution (product) that generates findings.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **CompanyName** *(list) --*

        The name of the findings provider (company) that owns the solution (product) that generates
        findings.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **UserDefinedFields** *(list) --*

        A list of name/value string pairs associated with the finding. These are custom,
        user-defined fields added to a finding.

        - *(dict) --*

          The map filter for querying findings.

          - **Key** *(string) --*

            The key of the map filter.

          - **Value** *(string) --*

            The value for the key in the map filter.

          - **Comparison** *(string) --*

            The condition to apply to a key value when querying for findings with a map filter.

      - **MalwareName** *(list) --*

        The name of the malware that was observed.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **MalwareType** *(list) --*

        The type of the malware that was observed.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **MalwarePath** *(list) --*

        The filesystem path of the malware that was observed.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **MalwareState** *(list) --*

        The state of the malware that was observed.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **NetworkDirection** *(list) --*

        Indicates the direction of network traffic associated with a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **NetworkProtocol** *(list) --*

        The protocol of network-related information about a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **NetworkSourceIpV4** *(list) --*

        The source IPv4 address of network-related information about a finding.

        - *(dict) --*

          The IP filter for querying findings.

          - **Cidr** *(string) --*

            A finding's CIDR value.

      - **NetworkSourceIpV6** *(list) --*

        The source IPv6 address of network-related information about a finding.

        - *(dict) --*

          The IP filter for querying findings.

          - **Cidr** *(string) --*

            A finding's CIDR value.

      - **NetworkSourcePort** *(list) --*

        The source port of network-related information about a finding.

        - *(dict) --*

          A number filter for querying findings.

          - **Gte** *(float) --*

            The greater-than-equal condition to be applied to a single field when querying for
            findings.

          - **Lte** *(float) --*

            The less-than-equal condition to be applied to a single field when querying for
            findings.

          - **Eq** *(float) --*

            The equal-to condition to be applied to a single field when querying for findings.

      - **NetworkSourceDomain** *(list) --*

        The source domain of network-related information about a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **NetworkSourceMac** *(list) --*

        The source media access control (MAC) address of network-related information about a
        finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **NetworkDestinationIpV4** *(list) --*

        The destination IPv4 address of network-related information about a finding.

        - *(dict) --*

          The IP filter for querying findings.

          - **Cidr** *(string) --*

            A finding's CIDR value.

      - **NetworkDestinationIpV6** *(list) --*

        The destination IPv6 address of network-related information about a finding.

        - *(dict) --*

          The IP filter for querying findings.

          - **Cidr** *(string) --*

            A finding's CIDR value.

      - **NetworkDestinationPort** *(list) --*

        The destination port of network-related information about a finding.

        - *(dict) --*

          A number filter for querying findings.

          - **Gte** *(float) --*

            The greater-than-equal condition to be applied to a single field when querying for
            findings.

          - **Lte** *(float) --*

            The less-than-equal condition to be applied to a single field when querying for
            findings.

          - **Eq** *(float) --*

            The equal-to condition to be applied to a single field when querying for findings.

      - **NetworkDestinationDomain** *(list) --*

        The destination domain of network-related information about a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ProcessName** *(list) --*

        The name of the process.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ProcessPath** *(list) --*

        The path to the process executable.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ProcessPid** *(list) --*

        The process ID.

        - *(dict) --*

          A number filter for querying findings.

          - **Gte** *(float) --*

            The greater-than-equal condition to be applied to a single field when querying for
            findings.

          - **Lte** *(float) --*

            The less-than-equal condition to be applied to a single field when querying for
            findings.

          - **Eq** *(float) --*

            The equal-to condition to be applied to a single field when querying for findings.

      - **ProcessParentPid** *(list) --*

        The parent process ID.

        - *(dict) --*

          A number filter for querying findings.

          - **Gte** *(float) --*

            The greater-than-equal condition to be applied to a single field when querying for
            findings.

          - **Lte** *(float) --*

            The less-than-equal condition to be applied to a single field when querying for
            findings.

          - **Eq** *(float) --*

            The equal-to condition to be applied to a single field when querying for findings.

      - **ProcessLaunchedAt** *(list) --*

        The date/time that the process was launched.

        - *(dict) --*

          A date filter for querying findings.

          - **Start** *(string) --*

            A start date for the date filter.

          - **End** *(string) --*

            An end date for the date filter.

          - **DateRange** *(dict) --*

            A date range for the date filter.

            - **Value** *(integer) --*

              A date range value for the date filter.

            - **Unit** *(string) --*

              A date range unit for the date filter.

      - **ProcessTerminatedAt** *(list) --*

        The date/time that the process was terminated.

        - *(dict) --*

          A date filter for querying findings.

          - **Start** *(string) --*

            A start date for the date filter.

          - **End** *(string) --*

            An end date for the date filter.

          - **DateRange** *(dict) --*

            A date range for the date filter.

            - **Value** *(integer) --*

              A date range value for the date filter.

            - **Unit** *(string) --*

              A date range unit for the date filter.

      - **ThreatIntelIndicatorType** *(list) --*

        The type of a threat intel indicator.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ThreatIntelIndicatorValue** *(list) --*

        The value of a threat intel indicator.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ThreatIntelIndicatorCategory** *(list) --*

        The category of a threat intel indicator.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ThreatIntelIndicatorLastObservedAt** *(list) --*

        The date/time of the last observation of a threat intel indicator.

        - *(dict) --*

          A date filter for querying findings.

          - **Start** *(string) --*

            A start date for the date filter.

          - **End** *(string) --*

            An end date for the date filter.

          - **DateRange** *(dict) --*

            A date range for the date filter.

            - **Value** *(integer) --*

              A date range value for the date filter.

            - **Unit** *(string) --*

              A date range unit for the date filter.

      - **ThreatIntelIndicatorSource** *(list) --*

        The source of the threat intel.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ThreatIntelIndicatorSourceUrl** *(list) --*

        The URL for more details from the source of the threat intel.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceType** *(list) --*

        Specifies the type of the resource that details are provided for.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceId** *(list) --*

        The canonical identifier for the given resource type.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourcePartition** *(list) --*

        The canonical AWS partition name that the Region is assigned to.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceRegion** *(list) --*

        The canonical AWS external Region name where this resource is located.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceTags** *(list) --*

        A list of AWS tags associated with a resource at the time the finding was processed.

        - *(dict) --*

          The map filter for querying findings.

          - **Key** *(string) --*

            The key of the map filter.

          - **Value** *(string) --*

            The value for the key in the map filter.

          - **Comparison** *(string) --*

            The condition to apply to a key value when querying for findings with a map filter.

      - **ResourceAwsEc2InstanceType** *(list) --*

        The instance type of the instance.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceAwsEc2InstanceImageId** *(list) --*

        The Amazon Machine Image (AMI) ID of the instance.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceAwsEc2InstanceIpV4Addresses** *(list) --*

        The IPv4 addresses associated with the instance.

        - *(dict) --*

          The IP filter for querying findings.

          - **Cidr** *(string) --*

            A finding's CIDR value.

      - **ResourceAwsEc2InstanceIpV6Addresses** *(list) --*

        The IPv6 addresses associated with the instance.

        - *(dict) --*

          The IP filter for querying findings.

          - **Cidr** *(string) --*

            A finding's CIDR value.

      - **ResourceAwsEc2InstanceKeyName** *(list) --*

        The key name associated with the instance.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceAwsEc2InstanceIamInstanceProfileArn** *(list) --*

        The IAM profile ARN of the instance.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceAwsEc2InstanceVpcId** *(list) --*

        The identifier of the VPC that the instance was launched in.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceAwsEc2InstanceSubnetId** *(list) --*

        The identifier of the subnet that the instance was launched in.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceAwsEc2InstanceLaunchedAt** *(list) --*

        The date/time the instance was launched.

        - *(dict) --*

          A date filter for querying findings.

          - **Start** *(string) --*

            A start date for the date filter.

          - **End** *(string) --*

            An end date for the date filter.

          - **DateRange** *(dict) --*

            A date range for the date filter.

            - **Value** *(integer) --*

              A date range value for the date filter.

            - **Unit** *(string) --*

              A date range unit for the date filter.

      - **ResourceAwsS3BucketOwnerId** *(list) --*

        The canonical user ID of the owner of the S3 bucket.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceAwsS3BucketOwnerName** *(list) --*

        The display name of the owner of the S3 bucket.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceAwsIamAccessKeyUserName** *(list) --*

        The user associated with the IAM access key related to a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceAwsIamAccessKeyStatus** *(list) --*

        The status of the IAM access key related to a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceAwsIamAccessKeyCreatedAt** *(list) --*

        The creation date/time of the IAM access key related to a finding.

        - *(dict) --*

          A date filter for querying findings.

          - **Start** *(string) --*

            A start date for the date filter.

          - **End** *(string) --*

            An end date for the date filter.

          - **DateRange** *(dict) --*

            A date range for the date filter.

            - **Value** *(integer) --*

              A date range value for the date filter.

            - **Unit** *(string) --*

              A date range unit for the date filter.

      - **ResourceContainerName** *(list) --*

        The name of the container related to a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceContainerImageId** *(list) --*

        The identifier of the image related to a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceContainerImageName** *(list) --*

        The name of the image related to a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceContainerLaunchedAt** *(list) --*

        The date/time that the container was started.

        - *(dict) --*

          A date filter for querying findings.

          - **Start** *(string) --*

            A start date for the date filter.

          - **End** *(string) --*

            An end date for the date filter.

          - **DateRange** *(dict) --*

            A date range for the date filter.

            - **Value** *(integer) --*

              A date range value for the date filter.

            - **Unit** *(string) --*

              A date range unit for the date filter.

      - **ResourceDetailsOther** *(list) --*

        The details of a resource that doesn't have a specific subfield for the resource type
        defined.

        - *(dict) --*

          The map filter for querying findings.

          - **Key** *(string) --*

            The key of the map filter.

          - **Value** *(string) --*

            The value for the key in the map filter.

          - **Comparison** *(string) --*

            The condition to apply to a key value when querying for findings with a map filter.

      - **ComplianceStatus** *(list) --*

        Exclusive to findings that are generated as the result of a check run against a specific
        rule in a supported standard (for example, CIS AWS Foundations). Contains compliance-related
        finding details.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **VerificationState** *(list) --*

        The veracity of a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **WorkflowState** *(list) --*

        The workflow state of a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **RecordState** *(list) --*

        The updated record state for the finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **RelatedFindingsProductArn** *(list) --*

        The ARN of the solution that generated a related finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **RelatedFindingsId** *(list) --*

        The solution-generated identifier for a related finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **NoteText** *(list) --*

        The text of a note.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **NoteUpdatedAt** *(list) --*

        The timestamp of when the note was updated.

        - *(dict) --*

          A date filter for querying findings.

          - **Start** *(string) --*

            A start date for the date filter.

          - **End** *(string) --*

            An end date for the date filter.

          - **DateRange** *(dict) --*

            A date range for the date filter.

            - **Value** *(integer) --*

              A date range value for the date filter.

            - **Unit** *(string) --*

              A date range unit for the date filter.

      - **NoteUpdatedBy** *(list) --*

        The principal that created a note.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **Keyword** *(list) --*

        A keyword for a finding.

        - *(dict) --*

          A keyword filter for querying findings.

          - **Value** *(string) --*

            A value for the keyword.

    - **GroupByAttribute** *(string) --*

      The attribute that the insight's findings are grouped by. This attribute is used as a findings
      aggregator for the purposes of viewing and managing multiple related findings under a single
      operand.
    """


_ClientGetInsightsResponseTypeDef = TypedDict(
    "_ClientGetInsightsResponseTypeDef",
    {"Insights": List[ClientGetInsightsResponseInsightsTypeDef], "NextToken": str},
    total=False,
)


class ClientGetInsightsResponseTypeDef(_ClientGetInsightsResponseTypeDef):
    """
    Type definition for `ClientGetInsights` `Response`

    - **Insights** *(list) --*

      The insights returned by the operation.

      - *(dict) --*

        Contains information about a Security Hub insight.

        - **InsightArn** *(string) --*

          The ARN of a Security Hub insight.

        - **Name** *(string) --*

          The name of a Security Hub insight.

        - **Filters** *(dict) --*

          One or more attributes used to filter the findings included in the insight. Only findings
          that match the criteria defined in the filters are included in the insight.

          - **ProductArn** *(list) --*

            The ARN generated by Security Hub that uniquely identifies a third-party company
            (security findings provider) after this provider's product (solution that generates
            findings) is registered with Security Hub.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **AwsAccountId** *(list) --*

            The AWS account ID that a finding is generated in.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **Id** *(list) --*

            The security findings provider-specific identifier for a finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **GeneratorId** *(list) --*

            The identifier for the solution-specific component (a discrete unit of logic) that
            generated a finding. In various security-findings providers' solutions, this generator
            can be called a rule, a check, a detector, a plug-in, etc.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **Type** *(list) --*

            A finding type in the format of ``namespace/category/classifier`` that classifies a
            finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **FirstObservedAt** *(list) --*

            An ISO8601-formatted timestamp that indicates when the security-findings provider first
            observed the potential security issue that a finding captured.

            - *(dict) --*

              A date filter for querying findings.

              - **Start** *(string) --*

                A start date for the date filter.

              - **End** *(string) --*

                An end date for the date filter.

              - **DateRange** *(dict) --*

                A date range for the date filter.

                - **Value** *(integer) --*

                  A date range value for the date filter.

                - **Unit** *(string) --*

                  A date range unit for the date filter.

          - **LastObservedAt** *(list) --*

            An ISO8601-formatted timestamp that indicates when the security-findings provider most
            recently observed the potential security issue that a finding captured.

            - *(dict) --*

              A date filter for querying findings.

              - **Start** *(string) --*

                A start date for the date filter.

              - **End** *(string) --*

                An end date for the date filter.

              - **DateRange** *(dict) --*

                A date range for the date filter.

                - **Value** *(integer) --*

                  A date range value for the date filter.

                - **Unit** *(string) --*

                  A date range unit for the date filter.

          - **CreatedAt** *(list) --*

            An ISO8601-formatted timestamp that indicates when the security-findings provider
            captured the potential security issue that a finding captured.

            - *(dict) --*

              A date filter for querying findings.

              - **Start** *(string) --*

                A start date for the date filter.

              - **End** *(string) --*

                An end date for the date filter.

              - **DateRange** *(dict) --*

                A date range for the date filter.

                - **Value** *(integer) --*

                  A date range value for the date filter.

                - **Unit** *(string) --*

                  A date range unit for the date filter.

          - **UpdatedAt** *(list) --*

            An ISO8601-formatted timestamp that indicates when the security-findings provider last
            updated the finding record.

            - *(dict) --*

              A date filter for querying findings.

              - **Start** *(string) --*

                A start date for the date filter.

              - **End** *(string) --*

                An end date for the date filter.

              - **DateRange** *(dict) --*

                A date range for the date filter.

                - **Value** *(integer) --*

                  A date range value for the date filter.

                - **Unit** *(string) --*

                  A date range unit for the date filter.

          - **SeverityProduct** *(list) --*

            The native severity as defined by the security-findings provider's solution that
            generated the finding.

            - *(dict) --*

              A number filter for querying findings.

              - **Gte** *(float) --*

                The greater-than-equal condition to be applied to a single field when querying for
                findings.

              - **Lte** *(float) --*

                The less-than-equal condition to be applied to a single field when querying for
                findings.

              - **Eq** *(float) --*

                The equal-to condition to be applied to a single field when querying for findings.

          - **SeverityNormalized** *(list) --*

            The normalized severity of a finding.

            - *(dict) --*

              A number filter for querying findings.

              - **Gte** *(float) --*

                The greater-than-equal condition to be applied to a single field when querying for
                findings.

              - **Lte** *(float) --*

                The less-than-equal condition to be applied to a single field when querying for
                findings.

              - **Eq** *(float) --*

                The equal-to condition to be applied to a single field when querying for findings.

          - **SeverityLabel** *(list) --*

            The label of a finding's severity.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **Confidence** *(list) --*

            A finding's confidence. Confidence is defined as the likelihood that a finding
            accurately identifies the behavior or issue that it was intended to identify. Confidence
            is scored on a 0-100 basis using a ratio scale, where 0 means zero percent confidence
            and 100 means 100 percent confidence.

            - *(dict) --*

              A number filter for querying findings.

              - **Gte** *(float) --*

                The greater-than-equal condition to be applied to a single field when querying for
                findings.

              - **Lte** *(float) --*

                The less-than-equal condition to be applied to a single field when querying for
                findings.

              - **Eq** *(float) --*

                The equal-to condition to be applied to a single field when querying for findings.

          - **Criticality** *(list) --*

            The level of importance assigned to the resources associated with the finding. A score
            of 0 means that the underlying resources have no criticality, and a score of 100 is
            reserved for the most critical resources.

            - *(dict) --*

              A number filter for querying findings.

              - **Gte** *(float) --*

                The greater-than-equal condition to be applied to a single field when querying for
                findings.

              - **Lte** *(float) --*

                The less-than-equal condition to be applied to a single field when querying for
                findings.

              - **Eq** *(float) --*

                The equal-to condition to be applied to a single field when querying for findings.

          - **Title** *(list) --*

            A finding's title.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **Description** *(list) --*

            A finding's description.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **RecommendationText** *(list) --*

            The recommendation of what to do about the issue described in a finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **SourceUrl** *(list) --*

            A URL that links to a page about the current finding in the security-findings provider's
            solution.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ProductFields** *(list) --*

            A data type where security-findings providers can include additional solution-specific
            details that aren't part of the defined ``AwsSecurityFinding`` format.

            - *(dict) --*

              The map filter for querying findings.

              - **Key** *(string) --*

                The key of the map filter.

              - **Value** *(string) --*

                The value for the key in the map filter.

              - **Comparison** *(string) --*

                The condition to apply to a key value when querying for findings with a map filter.

          - **ProductName** *(list) --*

            The name of the solution (product) that generates findings.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **CompanyName** *(list) --*

            The name of the findings provider (company) that owns the solution (product) that
            generates findings.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **UserDefinedFields** *(list) --*

            A list of name/value string pairs associated with the finding. These are custom,
            user-defined fields added to a finding.

            - *(dict) --*

              The map filter for querying findings.

              - **Key** *(string) --*

                The key of the map filter.

              - **Value** *(string) --*

                The value for the key in the map filter.

              - **Comparison** *(string) --*

                The condition to apply to a key value when querying for findings with a map filter.

          - **MalwareName** *(list) --*

            The name of the malware that was observed.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **MalwareType** *(list) --*

            The type of the malware that was observed.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **MalwarePath** *(list) --*

            The filesystem path of the malware that was observed.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **MalwareState** *(list) --*

            The state of the malware that was observed.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **NetworkDirection** *(list) --*

            Indicates the direction of network traffic associated with a finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **NetworkProtocol** *(list) --*

            The protocol of network-related information about a finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **NetworkSourceIpV4** *(list) --*

            The source IPv4 address of network-related information about a finding.

            - *(dict) --*

              The IP filter for querying findings.

              - **Cidr** *(string) --*

                A finding's CIDR value.

          - **NetworkSourceIpV6** *(list) --*

            The source IPv6 address of network-related information about a finding.

            - *(dict) --*

              The IP filter for querying findings.

              - **Cidr** *(string) --*

                A finding's CIDR value.

          - **NetworkSourcePort** *(list) --*

            The source port of network-related information about a finding.

            - *(dict) --*

              A number filter for querying findings.

              - **Gte** *(float) --*

                The greater-than-equal condition to be applied to a single field when querying for
                findings.

              - **Lte** *(float) --*

                The less-than-equal condition to be applied to a single field when querying for
                findings.

              - **Eq** *(float) --*

                The equal-to condition to be applied to a single field when querying for findings.

          - **NetworkSourceDomain** *(list) --*

            The source domain of network-related information about a finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **NetworkSourceMac** *(list) --*

            The source media access control (MAC) address of network-related information about a
            finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **NetworkDestinationIpV4** *(list) --*

            The destination IPv4 address of network-related information about a finding.

            - *(dict) --*

              The IP filter for querying findings.

              - **Cidr** *(string) --*

                A finding's CIDR value.

          - **NetworkDestinationIpV6** *(list) --*

            The destination IPv6 address of network-related information about a finding.

            - *(dict) --*

              The IP filter for querying findings.

              - **Cidr** *(string) --*

                A finding's CIDR value.

          - **NetworkDestinationPort** *(list) --*

            The destination port of network-related information about a finding.

            - *(dict) --*

              A number filter for querying findings.

              - **Gte** *(float) --*

                The greater-than-equal condition to be applied to a single field when querying for
                findings.

              - **Lte** *(float) --*

                The less-than-equal condition to be applied to a single field when querying for
                findings.

              - **Eq** *(float) --*

                The equal-to condition to be applied to a single field when querying for findings.

          - **NetworkDestinationDomain** *(list) --*

            The destination domain of network-related information about a finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ProcessName** *(list) --*

            The name of the process.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ProcessPath** *(list) --*

            The path to the process executable.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ProcessPid** *(list) --*

            The process ID.

            - *(dict) --*

              A number filter for querying findings.

              - **Gte** *(float) --*

                The greater-than-equal condition to be applied to a single field when querying for
                findings.

              - **Lte** *(float) --*

                The less-than-equal condition to be applied to a single field when querying for
                findings.

              - **Eq** *(float) --*

                The equal-to condition to be applied to a single field when querying for findings.

          - **ProcessParentPid** *(list) --*

            The parent process ID.

            - *(dict) --*

              A number filter for querying findings.

              - **Gte** *(float) --*

                The greater-than-equal condition to be applied to a single field when querying for
                findings.

              - **Lte** *(float) --*

                The less-than-equal condition to be applied to a single field when querying for
                findings.

              - **Eq** *(float) --*

                The equal-to condition to be applied to a single field when querying for findings.

          - **ProcessLaunchedAt** *(list) --*

            The date/time that the process was launched.

            - *(dict) --*

              A date filter for querying findings.

              - **Start** *(string) --*

                A start date for the date filter.

              - **End** *(string) --*

                An end date for the date filter.

              - **DateRange** *(dict) --*

                A date range for the date filter.

                - **Value** *(integer) --*

                  A date range value for the date filter.

                - **Unit** *(string) --*

                  A date range unit for the date filter.

          - **ProcessTerminatedAt** *(list) --*

            The date/time that the process was terminated.

            - *(dict) --*

              A date filter for querying findings.

              - **Start** *(string) --*

                A start date for the date filter.

              - **End** *(string) --*

                An end date for the date filter.

              - **DateRange** *(dict) --*

                A date range for the date filter.

                - **Value** *(integer) --*

                  A date range value for the date filter.

                - **Unit** *(string) --*

                  A date range unit for the date filter.

          - **ThreatIntelIndicatorType** *(list) --*

            The type of a threat intel indicator.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ThreatIntelIndicatorValue** *(list) --*

            The value of a threat intel indicator.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ThreatIntelIndicatorCategory** *(list) --*

            The category of a threat intel indicator.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ThreatIntelIndicatorLastObservedAt** *(list) --*

            The date/time of the last observation of a threat intel indicator.

            - *(dict) --*

              A date filter for querying findings.

              - **Start** *(string) --*

                A start date for the date filter.

              - **End** *(string) --*

                An end date for the date filter.

              - **DateRange** *(dict) --*

                A date range for the date filter.

                - **Value** *(integer) --*

                  A date range value for the date filter.

                - **Unit** *(string) --*

                  A date range unit for the date filter.

          - **ThreatIntelIndicatorSource** *(list) --*

            The source of the threat intel.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ThreatIntelIndicatorSourceUrl** *(list) --*

            The URL for more details from the source of the threat intel.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceType** *(list) --*

            Specifies the type of the resource that details are provided for.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceId** *(list) --*

            The canonical identifier for the given resource type.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourcePartition** *(list) --*

            The canonical AWS partition name that the Region is assigned to.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceRegion** *(list) --*

            The canonical AWS external Region name where this resource is located.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceTags** *(list) --*

            A list of AWS tags associated with a resource at the time the finding was processed.

            - *(dict) --*

              The map filter for querying findings.

              - **Key** *(string) --*

                The key of the map filter.

              - **Value** *(string) --*

                The value for the key in the map filter.

              - **Comparison** *(string) --*

                The condition to apply to a key value when querying for findings with a map filter.

          - **ResourceAwsEc2InstanceType** *(list) --*

            The instance type of the instance.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceAwsEc2InstanceImageId** *(list) --*

            The Amazon Machine Image (AMI) ID of the instance.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceAwsEc2InstanceIpV4Addresses** *(list) --*

            The IPv4 addresses associated with the instance.

            - *(dict) --*

              The IP filter for querying findings.

              - **Cidr** *(string) --*

                A finding's CIDR value.

          - **ResourceAwsEc2InstanceIpV6Addresses** *(list) --*

            The IPv6 addresses associated with the instance.

            - *(dict) --*

              The IP filter for querying findings.

              - **Cidr** *(string) --*

                A finding's CIDR value.

          - **ResourceAwsEc2InstanceKeyName** *(list) --*

            The key name associated with the instance.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceAwsEc2InstanceIamInstanceProfileArn** *(list) --*

            The IAM profile ARN of the instance.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceAwsEc2InstanceVpcId** *(list) --*

            The identifier of the VPC that the instance was launched in.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceAwsEc2InstanceSubnetId** *(list) --*

            The identifier of the subnet that the instance was launched in.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceAwsEc2InstanceLaunchedAt** *(list) --*

            The date/time the instance was launched.

            - *(dict) --*

              A date filter for querying findings.

              - **Start** *(string) --*

                A start date for the date filter.

              - **End** *(string) --*

                An end date for the date filter.

              - **DateRange** *(dict) --*

                A date range for the date filter.

                - **Value** *(integer) --*

                  A date range value for the date filter.

                - **Unit** *(string) --*

                  A date range unit for the date filter.

          - **ResourceAwsS3BucketOwnerId** *(list) --*

            The canonical user ID of the owner of the S3 bucket.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceAwsS3BucketOwnerName** *(list) --*

            The display name of the owner of the S3 bucket.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceAwsIamAccessKeyUserName** *(list) --*

            The user associated with the IAM access key related to a finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceAwsIamAccessKeyStatus** *(list) --*

            The status of the IAM access key related to a finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceAwsIamAccessKeyCreatedAt** *(list) --*

            The creation date/time of the IAM access key related to a finding.

            - *(dict) --*

              A date filter for querying findings.

              - **Start** *(string) --*

                A start date for the date filter.

              - **End** *(string) --*

                An end date for the date filter.

              - **DateRange** *(dict) --*

                A date range for the date filter.

                - **Value** *(integer) --*

                  A date range value for the date filter.

                - **Unit** *(string) --*

                  A date range unit for the date filter.

          - **ResourceContainerName** *(list) --*

            The name of the container related to a finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceContainerImageId** *(list) --*

            The identifier of the image related to a finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceContainerImageName** *(list) --*

            The name of the image related to a finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceContainerLaunchedAt** *(list) --*

            The date/time that the container was started.

            - *(dict) --*

              A date filter for querying findings.

              - **Start** *(string) --*

                A start date for the date filter.

              - **End** *(string) --*

                An end date for the date filter.

              - **DateRange** *(dict) --*

                A date range for the date filter.

                - **Value** *(integer) --*

                  A date range value for the date filter.

                - **Unit** *(string) --*

                  A date range unit for the date filter.

          - **ResourceDetailsOther** *(list) --*

            The details of a resource that doesn't have a specific subfield for the resource type
            defined.

            - *(dict) --*

              The map filter for querying findings.

              - **Key** *(string) --*

                The key of the map filter.

              - **Value** *(string) --*

                The value for the key in the map filter.

              - **Comparison** *(string) --*

                The condition to apply to a key value when querying for findings with a map filter.

          - **ComplianceStatus** *(list) --*

            Exclusive to findings that are generated as the result of a check run against a specific
            rule in a supported standard (for example, CIS AWS Foundations). Contains
            compliance-related finding details.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **VerificationState** *(list) --*

            The veracity of a finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **WorkflowState** *(list) --*

            The workflow state of a finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **RecordState** *(list) --*

            The updated record state for the finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **RelatedFindingsProductArn** *(list) --*

            The ARN of the solution that generated a related finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **RelatedFindingsId** *(list) --*

            The solution-generated identifier for a related finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **NoteText** *(list) --*

            The text of a note.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **NoteUpdatedAt** *(list) --*

            The timestamp of when the note was updated.

            - *(dict) --*

              A date filter for querying findings.

              - **Start** *(string) --*

                A start date for the date filter.

              - **End** *(string) --*

                An end date for the date filter.

              - **DateRange** *(dict) --*

                A date range for the date filter.

                - **Value** *(integer) --*

                  A date range value for the date filter.

                - **Unit** *(string) --*

                  A date range unit for the date filter.

          - **NoteUpdatedBy** *(list) --*

            The principal that created a note.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **Keyword** *(list) --*

            A keyword for a finding.

            - *(dict) --*

              A keyword filter for querying findings.

              - **Value** *(string) --*

                A value for the keyword.

        - **GroupByAttribute** *(string) --*

          The attribute that the insight's findings are grouped by. This attribute is used as a
          findings aggregator for the purposes of viewing and managing multiple related findings
          under a single operand.

    - **NextToken** *(string) --*

      The token that is required for pagination.
    """


_ClientGetInvitationsCountResponseTypeDef = TypedDict(
    "_ClientGetInvitationsCountResponseTypeDef", {"InvitationsCount": int}, total=False
)


class ClientGetInvitationsCountResponseTypeDef(_ClientGetInvitationsCountResponseTypeDef):
    """
    Type definition for `ClientGetInvitationsCount` `Response`

    - **InvitationsCount** *(integer) --*

      The number of all membership invitations sent to this Security Hub member account, not
      including the currently accepted invitation.
    """


_ClientGetMasterAccountResponseMasterTypeDef = TypedDict(
    "_ClientGetMasterAccountResponseMasterTypeDef",
    {"AccountId": str, "InvitationId": str, "InvitedAt": datetime, "MemberStatus": str},
    total=False,
)


class ClientGetMasterAccountResponseMasterTypeDef(_ClientGetMasterAccountResponseMasterTypeDef):
    """
    Type definition for `ClientGetMasterAccountResponse` `Master`

    A list of details about the Security Hub master account for the current member account.

    - **AccountId** *(string) --*

      The account ID of the Security Hub master account that the invitation was sent from.

    - **InvitationId** *(string) --*

      The ID of the invitation sent to the member account.

    - **InvitedAt** *(datetime) --*

      The timestamp of when the invitation was sent.

    - **MemberStatus** *(string) --*

      The current status of the association between member and master accounts.
    """


_ClientGetMasterAccountResponseTypeDef = TypedDict(
    "_ClientGetMasterAccountResponseTypeDef",
    {"Master": ClientGetMasterAccountResponseMasterTypeDef},
    total=False,
)


class ClientGetMasterAccountResponseTypeDef(_ClientGetMasterAccountResponseTypeDef):
    """
    Type definition for `ClientGetMasterAccount` `Response`

    - **Master** *(dict) --*

      A list of details about the Security Hub master account for the current member account.

      - **AccountId** *(string) --*

        The account ID of the Security Hub master account that the invitation was sent from.

      - **InvitationId** *(string) --*

        The ID of the invitation sent to the member account.

      - **InvitedAt** *(datetime) --*

        The timestamp of when the invitation was sent.

      - **MemberStatus** *(string) --*

        The current status of the association between member and master accounts.
    """


_ClientGetMembersResponseMembersTypeDef = TypedDict(
    "_ClientGetMembersResponseMembersTypeDef",
    {
        "AccountId": str,
        "Email": str,
        "MasterId": str,
        "MemberStatus": str,
        "InvitedAt": datetime,
        "UpdatedAt": datetime,
    },
    total=False,
)


class ClientGetMembersResponseMembersTypeDef(_ClientGetMembersResponseMembersTypeDef):
    """
    Type definition for `ClientGetMembersResponse` `Members`

    The details about a member account.

    - **AccountId** *(string) --*

      The AWS account ID of the member account.

    - **Email** *(string) --*

      The email address of the member account.

    - **MasterId** *(string) --*

      The AWS account ID of the Security Hub master account associated with this member account.

    - **MemberStatus** *(string) --*

      The status of the relationship between the member account and its master account.

    - **InvitedAt** *(datetime) --*

      A timestamp for the date and time when the invitation was sent to the member account.

    - **UpdatedAt** *(datetime) --*

      The timestamp for the date and time when the member account was updated.
    """


_ClientGetMembersResponseUnprocessedAccountsTypeDef = TypedDict(
    "_ClientGetMembersResponseUnprocessedAccountsTypeDef",
    {"AccountId": str, "ProcessingResult": str},
    total=False,
)


class ClientGetMembersResponseUnprocessedAccountsTypeDef(
    _ClientGetMembersResponseUnprocessedAccountsTypeDef
):
    """
    Type definition for `ClientGetMembersResponse` `UnprocessedAccounts`

    Details about the account that wasn't processed.

    - **AccountId** *(string) --*

      An AWS account ID of the account that wasn't be processed.

    - **ProcessingResult** *(string) --*

      The reason that the account wasn't be processed.
    """


_ClientGetMembersResponseTypeDef = TypedDict(
    "_ClientGetMembersResponseTypeDef",
    {
        "Members": List[ClientGetMembersResponseMembersTypeDef],
        "UnprocessedAccounts": List[ClientGetMembersResponseUnprocessedAccountsTypeDef],
    },
    total=False,
)


class ClientGetMembersResponseTypeDef(_ClientGetMembersResponseTypeDef):
    """
    Type definition for `ClientGetMembers` `Response`

    - **Members** *(list) --*

      A list of details about the Security Hub member accounts.

      - *(dict) --*

        The details about a member account.

        - **AccountId** *(string) --*

          The AWS account ID of the member account.

        - **Email** *(string) --*

          The email address of the member account.

        - **MasterId** *(string) --*

          The AWS account ID of the Security Hub master account associated with this member account.

        - **MemberStatus** *(string) --*

          The status of the relationship between the member account and its master account.

        - **InvitedAt** *(datetime) --*

          A timestamp for the date and time when the invitation was sent to the member account.

        - **UpdatedAt** *(datetime) --*

          The timestamp for the date and time when the member account was updated.

    - **UnprocessedAccounts** *(list) --*

      A list of account ID and email address pairs of the AWS accounts that couldn't be processed.

      - *(dict) --*

        Details about the account that wasn't processed.

        - **AccountId** *(string) --*

          An AWS account ID of the account that wasn't be processed.

        - **ProcessingResult** *(string) --*

          The reason that the account wasn't be processed.
    """


_ClientInviteMembersResponseUnprocessedAccountsTypeDef = TypedDict(
    "_ClientInviteMembersResponseUnprocessedAccountsTypeDef",
    {"AccountId": str, "ProcessingResult": str},
    total=False,
)


class ClientInviteMembersResponseUnprocessedAccountsTypeDef(
    _ClientInviteMembersResponseUnprocessedAccountsTypeDef
):
    """
    Type definition for `ClientInviteMembersResponse` `UnprocessedAccounts`

    Details about the account that wasn't processed.

    - **AccountId** *(string) --*

      An AWS account ID of the account that wasn't be processed.

    - **ProcessingResult** *(string) --*

      The reason that the account wasn't be processed.
    """


_ClientInviteMembersResponseTypeDef = TypedDict(
    "_ClientInviteMembersResponseTypeDef",
    {"UnprocessedAccounts": List[ClientInviteMembersResponseUnprocessedAccountsTypeDef]},
    total=False,
)


class ClientInviteMembersResponseTypeDef(_ClientInviteMembersResponseTypeDef):
    """
    Type definition for `ClientInviteMembers` `Response`

    - **UnprocessedAccounts** *(list) --*

      A list of account ID and email address pairs of the AWS accounts that couldn't be processed.

      - *(dict) --*

        Details about the account that wasn't processed.

        - **AccountId** *(string) --*

          An AWS account ID of the account that wasn't be processed.

        - **ProcessingResult** *(string) --*

          The reason that the account wasn't be processed.
    """


_ClientListEnabledProductsForImportResponseTypeDef = TypedDict(
    "_ClientListEnabledProductsForImportResponseTypeDef",
    {"ProductSubscriptions": List[str], "NextToken": str},
    total=False,
)


class ClientListEnabledProductsForImportResponseTypeDef(
    _ClientListEnabledProductsForImportResponseTypeDef
):
    """
    Type definition for `ClientListEnabledProductsForImport` `Response`

    - **ProductSubscriptions** *(list) --*

      A list of ARNs for the resources that represent your subscriptions to products.

      - *(string) --*

    - **NextToken** *(string) --*

      The token that is required for pagination.
    """


_ClientListInvitationsResponseInvitationsTypeDef = TypedDict(
    "_ClientListInvitationsResponseInvitationsTypeDef",
    {"AccountId": str, "InvitationId": str, "InvitedAt": datetime, "MemberStatus": str},
    total=False,
)


class ClientListInvitationsResponseInvitationsTypeDef(
    _ClientListInvitationsResponseInvitationsTypeDef
):
    """
    Type definition for `ClientListInvitationsResponse` `Invitations`

    Details about an invitation.

    - **AccountId** *(string) --*

      The account ID of the Security Hub master account that the invitation was sent from.

    - **InvitationId** *(string) --*

      The ID of the invitation sent to the member account.

    - **InvitedAt** *(datetime) --*

      The timestamp of when the invitation was sent.

    - **MemberStatus** *(string) --*

      The current status of the association between member and master accounts.
    """


_ClientListInvitationsResponseTypeDef = TypedDict(
    "_ClientListInvitationsResponseTypeDef",
    {"Invitations": List[ClientListInvitationsResponseInvitationsTypeDef], "NextToken": str},
    total=False,
)


class ClientListInvitationsResponseTypeDef(_ClientListInvitationsResponseTypeDef):
    """
    Type definition for `ClientListInvitations` `Response`

    - **Invitations** *(list) --*

      The details of the invitations returned by the operation.

      - *(dict) --*

        Details about an invitation.

        - **AccountId** *(string) --*

          The account ID of the Security Hub master account that the invitation was sent from.

        - **InvitationId** *(string) --*

          The ID of the invitation sent to the member account.

        - **InvitedAt** *(datetime) --*

          The timestamp of when the invitation was sent.

        - **MemberStatus** *(string) --*

          The current status of the association between member and master accounts.

    - **NextToken** *(string) --*

      The token that is required for pagination.
    """


_ClientListMembersResponseMembersTypeDef = TypedDict(
    "_ClientListMembersResponseMembersTypeDef",
    {
        "AccountId": str,
        "Email": str,
        "MasterId": str,
        "MemberStatus": str,
        "InvitedAt": datetime,
        "UpdatedAt": datetime,
    },
    total=False,
)


class ClientListMembersResponseMembersTypeDef(_ClientListMembersResponseMembersTypeDef):
    """
    Type definition for `ClientListMembersResponse` `Members`

    The details about a member account.

    - **AccountId** *(string) --*

      The AWS account ID of the member account.

    - **Email** *(string) --*

      The email address of the member account.

    - **MasterId** *(string) --*

      The AWS account ID of the Security Hub master account associated with this member account.

    - **MemberStatus** *(string) --*

      The status of the relationship between the member account and its master account.

    - **InvitedAt** *(datetime) --*

      A timestamp for the date and time when the invitation was sent to the member account.

    - **UpdatedAt** *(datetime) --*

      The timestamp for the date and time when the member account was updated.
    """


_ClientListMembersResponseTypeDef = TypedDict(
    "_ClientListMembersResponseTypeDef",
    {"Members": List[ClientListMembersResponseMembersTypeDef], "NextToken": str},
    total=False,
)


class ClientListMembersResponseTypeDef(_ClientListMembersResponseTypeDef):
    """
    Type definition for `ClientListMembers` `Response`

    - **Members** *(list) --*

      Member details returned by the operation.

      - *(dict) --*

        The details about a member account.

        - **AccountId** *(string) --*

          The AWS account ID of the member account.

        - **Email** *(string) --*

          The email address of the member account.

        - **MasterId** *(string) --*

          The AWS account ID of the Security Hub master account associated with this member account.

        - **MemberStatus** *(string) --*

          The status of the relationship between the member account and its master account.

        - **InvitedAt** *(datetime) --*

          A timestamp for the date and time when the invitation was sent to the member account.

        - **UpdatedAt** *(datetime) --*

          The timestamp for the date and time when the member account was updated.

    - **NextToken** *(string) --*

      The token that is required for pagination.
    """


_ClientListTagsForResourceResponseTypeDef = TypedDict(
    "_ClientListTagsForResourceResponseTypeDef", {"Tags": Dict[str, str]}, total=False
)


class ClientListTagsForResourceResponseTypeDef(_ClientListTagsForResourceResponseTypeDef):
    """
    Type definition for `ClientListTagsForResource` `Response`

    - **Tags** *(dict) --*

      The tags associated with a resource.

      - *(string) --*

        - *(string) --*
    """


_ClientUpdateFindingsFiltersAwsAccountIdTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersAwsAccountIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersAwsAccountIdTypeDef(
    _ClientUpdateFindingsFiltersAwsAccountIdTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `AwsAccountId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersCompanyNameTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersCompanyNameTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateFindingsFiltersCompanyNameTypeDef(_ClientUpdateFindingsFiltersCompanyNameTypeDef):
    """
    Type definition for `ClientUpdateFindingsFilters` `CompanyName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersComplianceStatusTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersComplianceStatusTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersComplianceStatusTypeDef(
    _ClientUpdateFindingsFiltersComplianceStatusTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ComplianceStatus`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersConfidenceTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersConfidenceTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientUpdateFindingsFiltersConfidenceTypeDef(_ClientUpdateFindingsFiltersConfidenceTypeDef):
    """
    Type definition for `ClientUpdateFindingsFilters` `Confidence`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientUpdateFindingsFiltersCreatedAtDateRangeTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersCreatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientUpdateFindingsFiltersCreatedAtDateRangeTypeDef(
    _ClientUpdateFindingsFiltersCreatedAtDateRangeTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFiltersCreatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientUpdateFindingsFiltersCreatedAtTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersCreatedAtTypeDef",
    {"Start": str, "End": str, "DateRange": ClientUpdateFindingsFiltersCreatedAtDateRangeTypeDef},
    total=False,
)


class ClientUpdateFindingsFiltersCreatedAtTypeDef(_ClientUpdateFindingsFiltersCreatedAtTypeDef):
    """
    Type definition for `ClientUpdateFindingsFilters` `CreatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientUpdateFindingsFiltersCriticalityTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersCriticalityTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientUpdateFindingsFiltersCriticalityTypeDef(_ClientUpdateFindingsFiltersCriticalityTypeDef):
    """
    Type definition for `ClientUpdateFindingsFilters` `Criticality`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientUpdateFindingsFiltersDescriptionTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersDescriptionTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateFindingsFiltersDescriptionTypeDef(_ClientUpdateFindingsFiltersDescriptionTypeDef):
    """
    Type definition for `ClientUpdateFindingsFilters` `Description`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersFirstObservedAtDateRangeTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersFirstObservedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientUpdateFindingsFiltersFirstObservedAtDateRangeTypeDef(
    _ClientUpdateFindingsFiltersFirstObservedAtDateRangeTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFiltersFirstObservedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientUpdateFindingsFiltersFirstObservedAtTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersFirstObservedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientUpdateFindingsFiltersFirstObservedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientUpdateFindingsFiltersFirstObservedAtTypeDef(
    _ClientUpdateFindingsFiltersFirstObservedAtTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `FirstObservedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientUpdateFindingsFiltersGeneratorIdTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersGeneratorIdTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateFindingsFiltersGeneratorIdTypeDef(_ClientUpdateFindingsFiltersGeneratorIdTypeDef):
    """
    Type definition for `ClientUpdateFindingsFilters` `GeneratorId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersIdTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersIdTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateFindingsFiltersIdTypeDef(_ClientUpdateFindingsFiltersIdTypeDef):
    """
    Type definition for `ClientUpdateFindingsFilters` `Id`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersKeywordTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersKeywordTypeDef", {"Value": str}, total=False
)


class ClientUpdateFindingsFiltersKeywordTypeDef(_ClientUpdateFindingsFiltersKeywordTypeDef):
    """
    Type definition for `ClientUpdateFindingsFilters` `Keyword`

    A keyword filter for querying findings.

    - **Value** *(string) --*

      A value for the keyword.
    """


_ClientUpdateFindingsFiltersLastObservedAtDateRangeTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersLastObservedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientUpdateFindingsFiltersLastObservedAtDateRangeTypeDef(
    _ClientUpdateFindingsFiltersLastObservedAtDateRangeTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFiltersLastObservedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientUpdateFindingsFiltersLastObservedAtTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersLastObservedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientUpdateFindingsFiltersLastObservedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientUpdateFindingsFiltersLastObservedAtTypeDef(
    _ClientUpdateFindingsFiltersLastObservedAtTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `LastObservedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientUpdateFindingsFiltersMalwareNameTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersMalwareNameTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateFindingsFiltersMalwareNameTypeDef(_ClientUpdateFindingsFiltersMalwareNameTypeDef):
    """
    Type definition for `ClientUpdateFindingsFilters` `MalwareName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersMalwarePathTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersMalwarePathTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateFindingsFiltersMalwarePathTypeDef(_ClientUpdateFindingsFiltersMalwarePathTypeDef):
    """
    Type definition for `ClientUpdateFindingsFilters` `MalwarePath`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersMalwareStateTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersMalwareStateTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersMalwareStateTypeDef(
    _ClientUpdateFindingsFiltersMalwareStateTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `MalwareState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersMalwareTypeTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersMalwareTypeTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateFindingsFiltersMalwareTypeTypeDef(_ClientUpdateFindingsFiltersMalwareTypeTypeDef):
    """
    Type definition for `ClientUpdateFindingsFilters` `MalwareType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersNetworkDestinationDomainTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersNetworkDestinationDomainTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersNetworkDestinationDomainTypeDef(
    _ClientUpdateFindingsFiltersNetworkDestinationDomainTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `NetworkDestinationDomain`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersNetworkDestinationIpV4TypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersNetworkDestinationIpV4TypeDef", {"Cidr": str}, total=False
)


class ClientUpdateFindingsFiltersNetworkDestinationIpV4TypeDef(
    _ClientUpdateFindingsFiltersNetworkDestinationIpV4TypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `NetworkDestinationIpV4`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientUpdateFindingsFiltersNetworkDestinationIpV6TypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersNetworkDestinationIpV6TypeDef", {"Cidr": str}, total=False
)


class ClientUpdateFindingsFiltersNetworkDestinationIpV6TypeDef(
    _ClientUpdateFindingsFiltersNetworkDestinationIpV6TypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `NetworkDestinationIpV6`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientUpdateFindingsFiltersNetworkDestinationPortTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersNetworkDestinationPortTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientUpdateFindingsFiltersNetworkDestinationPortTypeDef(
    _ClientUpdateFindingsFiltersNetworkDestinationPortTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `NetworkDestinationPort`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientUpdateFindingsFiltersNetworkDirectionTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersNetworkDirectionTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersNetworkDirectionTypeDef(
    _ClientUpdateFindingsFiltersNetworkDirectionTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `NetworkDirection`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersNetworkProtocolTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersNetworkProtocolTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersNetworkProtocolTypeDef(
    _ClientUpdateFindingsFiltersNetworkProtocolTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `NetworkProtocol`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersNetworkSourceDomainTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersNetworkSourceDomainTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersNetworkSourceDomainTypeDef(
    _ClientUpdateFindingsFiltersNetworkSourceDomainTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `NetworkSourceDomain`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersNetworkSourceIpV4TypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersNetworkSourceIpV4TypeDef", {"Cidr": str}, total=False
)


class ClientUpdateFindingsFiltersNetworkSourceIpV4TypeDef(
    _ClientUpdateFindingsFiltersNetworkSourceIpV4TypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `NetworkSourceIpV4`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientUpdateFindingsFiltersNetworkSourceIpV6TypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersNetworkSourceIpV6TypeDef", {"Cidr": str}, total=False
)


class ClientUpdateFindingsFiltersNetworkSourceIpV6TypeDef(
    _ClientUpdateFindingsFiltersNetworkSourceIpV6TypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `NetworkSourceIpV6`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientUpdateFindingsFiltersNetworkSourceMacTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersNetworkSourceMacTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersNetworkSourceMacTypeDef(
    _ClientUpdateFindingsFiltersNetworkSourceMacTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `NetworkSourceMac`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersNetworkSourcePortTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersNetworkSourcePortTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientUpdateFindingsFiltersNetworkSourcePortTypeDef(
    _ClientUpdateFindingsFiltersNetworkSourcePortTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `NetworkSourcePort`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientUpdateFindingsFiltersNoteTextTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersNoteTextTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateFindingsFiltersNoteTextTypeDef(_ClientUpdateFindingsFiltersNoteTextTypeDef):
    """
    Type definition for `ClientUpdateFindingsFilters` `NoteText`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersNoteUpdatedAtDateRangeTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersNoteUpdatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientUpdateFindingsFiltersNoteUpdatedAtDateRangeTypeDef(
    _ClientUpdateFindingsFiltersNoteUpdatedAtDateRangeTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFiltersNoteUpdatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientUpdateFindingsFiltersNoteUpdatedAtTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersNoteUpdatedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientUpdateFindingsFiltersNoteUpdatedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientUpdateFindingsFiltersNoteUpdatedAtTypeDef(
    _ClientUpdateFindingsFiltersNoteUpdatedAtTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `NoteUpdatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientUpdateFindingsFiltersNoteUpdatedByTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersNoteUpdatedByTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersNoteUpdatedByTypeDef(
    _ClientUpdateFindingsFiltersNoteUpdatedByTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `NoteUpdatedBy`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersProcessLaunchedAtDateRangeTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersProcessLaunchedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientUpdateFindingsFiltersProcessLaunchedAtDateRangeTypeDef(
    _ClientUpdateFindingsFiltersProcessLaunchedAtDateRangeTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFiltersProcessLaunchedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientUpdateFindingsFiltersProcessLaunchedAtTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersProcessLaunchedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientUpdateFindingsFiltersProcessLaunchedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientUpdateFindingsFiltersProcessLaunchedAtTypeDef(
    _ClientUpdateFindingsFiltersProcessLaunchedAtTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ProcessLaunchedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientUpdateFindingsFiltersProcessNameTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersProcessNameTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateFindingsFiltersProcessNameTypeDef(_ClientUpdateFindingsFiltersProcessNameTypeDef):
    """
    Type definition for `ClientUpdateFindingsFilters` `ProcessName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersProcessParentPidTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersProcessParentPidTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientUpdateFindingsFiltersProcessParentPidTypeDef(
    _ClientUpdateFindingsFiltersProcessParentPidTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ProcessParentPid`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientUpdateFindingsFiltersProcessPathTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersProcessPathTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateFindingsFiltersProcessPathTypeDef(_ClientUpdateFindingsFiltersProcessPathTypeDef):
    """
    Type definition for `ClientUpdateFindingsFilters` `ProcessPath`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersProcessPidTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersProcessPidTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientUpdateFindingsFiltersProcessPidTypeDef(_ClientUpdateFindingsFiltersProcessPidTypeDef):
    """
    Type definition for `ClientUpdateFindingsFilters` `ProcessPid`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientUpdateFindingsFiltersProcessTerminatedAtDateRangeTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersProcessTerminatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientUpdateFindingsFiltersProcessTerminatedAtDateRangeTypeDef(
    _ClientUpdateFindingsFiltersProcessTerminatedAtDateRangeTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFiltersProcessTerminatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientUpdateFindingsFiltersProcessTerminatedAtTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersProcessTerminatedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientUpdateFindingsFiltersProcessTerminatedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientUpdateFindingsFiltersProcessTerminatedAtTypeDef(
    _ClientUpdateFindingsFiltersProcessTerminatedAtTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ProcessTerminatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientUpdateFindingsFiltersProductArnTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersProductArnTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateFindingsFiltersProductArnTypeDef(_ClientUpdateFindingsFiltersProductArnTypeDef):
    """
    Type definition for `ClientUpdateFindingsFilters` `ProductArn`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersProductFieldsTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersProductFieldsTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersProductFieldsTypeDef(
    _ClientUpdateFindingsFiltersProductFieldsTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ProductFields`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_ClientUpdateFindingsFiltersProductNameTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersProductNameTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateFindingsFiltersProductNameTypeDef(_ClientUpdateFindingsFiltersProductNameTypeDef):
    """
    Type definition for `ClientUpdateFindingsFilters` `ProductName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersRecommendationTextTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersRecommendationTextTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersRecommendationTextTypeDef(
    _ClientUpdateFindingsFiltersRecommendationTextTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `RecommendationText`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersRecordStateTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersRecordStateTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateFindingsFiltersRecordStateTypeDef(_ClientUpdateFindingsFiltersRecordStateTypeDef):
    """
    Type definition for `ClientUpdateFindingsFilters` `RecordState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersRelatedFindingsIdTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersRelatedFindingsIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersRelatedFindingsIdTypeDef(
    _ClientUpdateFindingsFiltersRelatedFindingsIdTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `RelatedFindingsId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersRelatedFindingsProductArnTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersRelatedFindingsProductArnTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersRelatedFindingsProductArnTypeDef(
    _ClientUpdateFindingsFiltersRelatedFindingsProductArnTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `RelatedFindingsProductArn`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef(
    _ClientUpdateFindingsFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ResourceAwsEc2InstanceIamInstanceProfileArn`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersResourceAwsEc2InstanceImageIdTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourceAwsEc2InstanceImageIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersResourceAwsEc2InstanceImageIdTypeDef(
    _ClientUpdateFindingsFiltersResourceAwsEc2InstanceImageIdTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ResourceAwsEc2InstanceImageId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef",
    {"Cidr": str},
    total=False,
)


class ClientUpdateFindingsFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef(
    _ClientUpdateFindingsFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ResourceAwsEc2InstanceIpV4Addresses`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientUpdateFindingsFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef",
    {"Cidr": str},
    total=False,
)


class ClientUpdateFindingsFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef(
    _ClientUpdateFindingsFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ResourceAwsEc2InstanceIpV6Addresses`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientUpdateFindingsFiltersResourceAwsEc2InstanceKeyNameTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourceAwsEc2InstanceKeyNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersResourceAwsEc2InstanceKeyNameTypeDef(
    _ClientUpdateFindingsFiltersResourceAwsEc2InstanceKeyNameTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ResourceAwsEc2InstanceKeyName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientUpdateFindingsFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef(
    _ClientUpdateFindingsFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFiltersResourceAwsEc2InstanceLaunchedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientUpdateFindingsFiltersResourceAwsEc2InstanceLaunchedAtTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourceAwsEc2InstanceLaunchedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientUpdateFindingsFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientUpdateFindingsFiltersResourceAwsEc2InstanceLaunchedAtTypeDef(
    _ClientUpdateFindingsFiltersResourceAwsEc2InstanceLaunchedAtTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ResourceAwsEc2InstanceLaunchedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientUpdateFindingsFiltersResourceAwsEc2InstanceSubnetIdTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourceAwsEc2InstanceSubnetIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersResourceAwsEc2InstanceSubnetIdTypeDef(
    _ClientUpdateFindingsFiltersResourceAwsEc2InstanceSubnetIdTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ResourceAwsEc2InstanceSubnetId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersResourceAwsEc2InstanceTypeTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourceAwsEc2InstanceTypeTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersResourceAwsEc2InstanceTypeTypeDef(
    _ClientUpdateFindingsFiltersResourceAwsEc2InstanceTypeTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ResourceAwsEc2InstanceType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersResourceAwsEc2InstanceVpcIdTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourceAwsEc2InstanceVpcIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersResourceAwsEc2InstanceVpcIdTypeDef(
    _ClientUpdateFindingsFiltersResourceAwsEc2InstanceVpcIdTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ResourceAwsEc2InstanceVpcId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientUpdateFindingsFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef(
    _ClientUpdateFindingsFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFiltersResourceAwsIamAccessKeyCreatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientUpdateFindingsFiltersResourceAwsIamAccessKeyCreatedAtTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourceAwsIamAccessKeyCreatedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientUpdateFindingsFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientUpdateFindingsFiltersResourceAwsIamAccessKeyCreatedAtTypeDef(
    _ClientUpdateFindingsFiltersResourceAwsIamAccessKeyCreatedAtTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ResourceAwsIamAccessKeyCreatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientUpdateFindingsFiltersResourceAwsIamAccessKeyStatusTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourceAwsIamAccessKeyStatusTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersResourceAwsIamAccessKeyStatusTypeDef(
    _ClientUpdateFindingsFiltersResourceAwsIamAccessKeyStatusTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ResourceAwsIamAccessKeyStatus`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersResourceAwsIamAccessKeyUserNameTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourceAwsIamAccessKeyUserNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersResourceAwsIamAccessKeyUserNameTypeDef(
    _ClientUpdateFindingsFiltersResourceAwsIamAccessKeyUserNameTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ResourceAwsIamAccessKeyUserName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersResourceAwsS3BucketOwnerIdTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourceAwsS3BucketOwnerIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersResourceAwsS3BucketOwnerIdTypeDef(
    _ClientUpdateFindingsFiltersResourceAwsS3BucketOwnerIdTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ResourceAwsS3BucketOwnerId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersResourceAwsS3BucketOwnerNameTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourceAwsS3BucketOwnerNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersResourceAwsS3BucketOwnerNameTypeDef(
    _ClientUpdateFindingsFiltersResourceAwsS3BucketOwnerNameTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ResourceAwsS3BucketOwnerName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersResourceContainerImageIdTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourceContainerImageIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersResourceContainerImageIdTypeDef(
    _ClientUpdateFindingsFiltersResourceContainerImageIdTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ResourceContainerImageId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersResourceContainerImageNameTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourceContainerImageNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersResourceContainerImageNameTypeDef(
    _ClientUpdateFindingsFiltersResourceContainerImageNameTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ResourceContainerImageName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersResourceContainerLaunchedAtDateRangeTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourceContainerLaunchedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientUpdateFindingsFiltersResourceContainerLaunchedAtDateRangeTypeDef(
    _ClientUpdateFindingsFiltersResourceContainerLaunchedAtDateRangeTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFiltersResourceContainerLaunchedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientUpdateFindingsFiltersResourceContainerLaunchedAtTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourceContainerLaunchedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientUpdateFindingsFiltersResourceContainerLaunchedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientUpdateFindingsFiltersResourceContainerLaunchedAtTypeDef(
    _ClientUpdateFindingsFiltersResourceContainerLaunchedAtTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ResourceContainerLaunchedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientUpdateFindingsFiltersResourceContainerNameTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourceContainerNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersResourceContainerNameTypeDef(
    _ClientUpdateFindingsFiltersResourceContainerNameTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ResourceContainerName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersResourceDetailsOtherTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourceDetailsOtherTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersResourceDetailsOtherTypeDef(
    _ClientUpdateFindingsFiltersResourceDetailsOtherTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ResourceDetailsOther`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_ClientUpdateFindingsFiltersResourceIdTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourceIdTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateFindingsFiltersResourceIdTypeDef(_ClientUpdateFindingsFiltersResourceIdTypeDef):
    """
    Type definition for `ClientUpdateFindingsFilters` `ResourceId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersResourcePartitionTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourcePartitionTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersResourcePartitionTypeDef(
    _ClientUpdateFindingsFiltersResourcePartitionTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ResourcePartition`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersResourceRegionTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourceRegionTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersResourceRegionTypeDef(
    _ClientUpdateFindingsFiltersResourceRegionTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ResourceRegion`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersResourceTagsTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourceTagsTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersResourceTagsTypeDef(
    _ClientUpdateFindingsFiltersResourceTagsTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ResourceTags`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_ClientUpdateFindingsFiltersResourceTypeTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersResourceTypeTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersResourceTypeTypeDef(
    _ClientUpdateFindingsFiltersResourceTypeTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ResourceType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersSeverityLabelTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersSeverityLabelTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersSeverityLabelTypeDef(
    _ClientUpdateFindingsFiltersSeverityLabelTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `SeverityLabel`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersSeverityNormalizedTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersSeverityNormalizedTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientUpdateFindingsFiltersSeverityNormalizedTypeDef(
    _ClientUpdateFindingsFiltersSeverityNormalizedTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `SeverityNormalized`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientUpdateFindingsFiltersSeverityProductTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersSeverityProductTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientUpdateFindingsFiltersSeverityProductTypeDef(
    _ClientUpdateFindingsFiltersSeverityProductTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `SeverityProduct`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientUpdateFindingsFiltersSourceUrlTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersSourceUrlTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateFindingsFiltersSourceUrlTypeDef(_ClientUpdateFindingsFiltersSourceUrlTypeDef):
    """
    Type definition for `ClientUpdateFindingsFilters` `SourceUrl`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersThreatIntelIndicatorCategoryTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersThreatIntelIndicatorCategoryTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersThreatIntelIndicatorCategoryTypeDef(
    _ClientUpdateFindingsFiltersThreatIntelIndicatorCategoryTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ThreatIntelIndicatorCategory`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientUpdateFindingsFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef(
    _ClientUpdateFindingsFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFiltersThreatIntelIndicatorLastObservedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientUpdateFindingsFiltersThreatIntelIndicatorLastObservedAtTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersThreatIntelIndicatorLastObservedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientUpdateFindingsFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientUpdateFindingsFiltersThreatIntelIndicatorLastObservedAtTypeDef(
    _ClientUpdateFindingsFiltersThreatIntelIndicatorLastObservedAtTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ThreatIntelIndicatorLastObservedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientUpdateFindingsFiltersThreatIntelIndicatorSourceTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersThreatIntelIndicatorSourceTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersThreatIntelIndicatorSourceTypeDef(
    _ClientUpdateFindingsFiltersThreatIntelIndicatorSourceTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ThreatIntelIndicatorSource`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersThreatIntelIndicatorSourceUrlTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersThreatIntelIndicatorSourceUrlTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersThreatIntelIndicatorSourceUrlTypeDef(
    _ClientUpdateFindingsFiltersThreatIntelIndicatorSourceUrlTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ThreatIntelIndicatorSourceUrl`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersThreatIntelIndicatorTypeTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersThreatIntelIndicatorTypeTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersThreatIntelIndicatorTypeTypeDef(
    _ClientUpdateFindingsFiltersThreatIntelIndicatorTypeTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ThreatIntelIndicatorType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersThreatIntelIndicatorValueTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersThreatIntelIndicatorValueTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersThreatIntelIndicatorValueTypeDef(
    _ClientUpdateFindingsFiltersThreatIntelIndicatorValueTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `ThreatIntelIndicatorValue`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersTitleTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersTitleTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateFindingsFiltersTitleTypeDef(_ClientUpdateFindingsFiltersTitleTypeDef):
    """
    Type definition for `ClientUpdateFindingsFilters` `Title`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersTypeTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersTypeTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateFindingsFiltersTypeTypeDef(_ClientUpdateFindingsFiltersTypeTypeDef):
    """
    Type definition for `ClientUpdateFindingsFilters` `Type`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersUpdatedAtDateRangeTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersUpdatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientUpdateFindingsFiltersUpdatedAtDateRangeTypeDef(
    _ClientUpdateFindingsFiltersUpdatedAtDateRangeTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFiltersUpdatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientUpdateFindingsFiltersUpdatedAtTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersUpdatedAtTypeDef",
    {"Start": str, "End": str, "DateRange": ClientUpdateFindingsFiltersUpdatedAtDateRangeTypeDef},
    total=False,
)


class ClientUpdateFindingsFiltersUpdatedAtTypeDef(_ClientUpdateFindingsFiltersUpdatedAtTypeDef):
    """
    Type definition for `ClientUpdateFindingsFilters` `UpdatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientUpdateFindingsFiltersUserDefinedFieldsTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersUserDefinedFieldsTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersUserDefinedFieldsTypeDef(
    _ClientUpdateFindingsFiltersUserDefinedFieldsTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `UserDefinedFields`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_ClientUpdateFindingsFiltersVerificationStateTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersVerificationStateTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersVerificationStateTypeDef(
    _ClientUpdateFindingsFiltersVerificationStateTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `VerificationState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersWorkflowStateTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersWorkflowStateTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateFindingsFiltersWorkflowStateTypeDef(
    _ClientUpdateFindingsFiltersWorkflowStateTypeDef
):
    """
    Type definition for `ClientUpdateFindingsFilters` `WorkflowState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateFindingsFiltersTypeDef = TypedDict(
    "_ClientUpdateFindingsFiltersTypeDef",
    {
        "ProductArn": List[ClientUpdateFindingsFiltersProductArnTypeDef],
        "AwsAccountId": List[ClientUpdateFindingsFiltersAwsAccountIdTypeDef],
        "Id": List[ClientUpdateFindingsFiltersIdTypeDef],
        "GeneratorId": List[ClientUpdateFindingsFiltersGeneratorIdTypeDef],
        "Type": List[ClientUpdateFindingsFiltersTypeTypeDef],
        "FirstObservedAt": List[ClientUpdateFindingsFiltersFirstObservedAtTypeDef],
        "LastObservedAt": List[ClientUpdateFindingsFiltersLastObservedAtTypeDef],
        "CreatedAt": List[ClientUpdateFindingsFiltersCreatedAtTypeDef],
        "UpdatedAt": List[ClientUpdateFindingsFiltersUpdatedAtTypeDef],
        "SeverityProduct": List[ClientUpdateFindingsFiltersSeverityProductTypeDef],
        "SeverityNormalized": List[ClientUpdateFindingsFiltersSeverityNormalizedTypeDef],
        "SeverityLabel": List[ClientUpdateFindingsFiltersSeverityLabelTypeDef],
        "Confidence": List[ClientUpdateFindingsFiltersConfidenceTypeDef],
        "Criticality": List[ClientUpdateFindingsFiltersCriticalityTypeDef],
        "Title": List[ClientUpdateFindingsFiltersTitleTypeDef],
        "Description": List[ClientUpdateFindingsFiltersDescriptionTypeDef],
        "RecommendationText": List[ClientUpdateFindingsFiltersRecommendationTextTypeDef],
        "SourceUrl": List[ClientUpdateFindingsFiltersSourceUrlTypeDef],
        "ProductFields": List[ClientUpdateFindingsFiltersProductFieldsTypeDef],
        "ProductName": List[ClientUpdateFindingsFiltersProductNameTypeDef],
        "CompanyName": List[ClientUpdateFindingsFiltersCompanyNameTypeDef],
        "UserDefinedFields": List[ClientUpdateFindingsFiltersUserDefinedFieldsTypeDef],
        "MalwareName": List[ClientUpdateFindingsFiltersMalwareNameTypeDef],
        "MalwareType": List[ClientUpdateFindingsFiltersMalwareTypeTypeDef],
        "MalwarePath": List[ClientUpdateFindingsFiltersMalwarePathTypeDef],
        "MalwareState": List[ClientUpdateFindingsFiltersMalwareStateTypeDef],
        "NetworkDirection": List[ClientUpdateFindingsFiltersNetworkDirectionTypeDef],
        "NetworkProtocol": List[ClientUpdateFindingsFiltersNetworkProtocolTypeDef],
        "NetworkSourceIpV4": List[ClientUpdateFindingsFiltersNetworkSourceIpV4TypeDef],
        "NetworkSourceIpV6": List[ClientUpdateFindingsFiltersNetworkSourceIpV6TypeDef],
        "NetworkSourcePort": List[ClientUpdateFindingsFiltersNetworkSourcePortTypeDef],
        "NetworkSourceDomain": List[ClientUpdateFindingsFiltersNetworkSourceDomainTypeDef],
        "NetworkSourceMac": List[ClientUpdateFindingsFiltersNetworkSourceMacTypeDef],
        "NetworkDestinationIpV4": List[ClientUpdateFindingsFiltersNetworkDestinationIpV4TypeDef],
        "NetworkDestinationIpV6": List[ClientUpdateFindingsFiltersNetworkDestinationIpV6TypeDef],
        "NetworkDestinationPort": List[ClientUpdateFindingsFiltersNetworkDestinationPortTypeDef],
        "NetworkDestinationDomain": List[
            ClientUpdateFindingsFiltersNetworkDestinationDomainTypeDef
        ],
        "ProcessName": List[ClientUpdateFindingsFiltersProcessNameTypeDef],
        "ProcessPath": List[ClientUpdateFindingsFiltersProcessPathTypeDef],
        "ProcessPid": List[ClientUpdateFindingsFiltersProcessPidTypeDef],
        "ProcessParentPid": List[ClientUpdateFindingsFiltersProcessParentPidTypeDef],
        "ProcessLaunchedAt": List[ClientUpdateFindingsFiltersProcessLaunchedAtTypeDef],
        "ProcessTerminatedAt": List[ClientUpdateFindingsFiltersProcessTerminatedAtTypeDef],
        "ThreatIntelIndicatorType": List[
            ClientUpdateFindingsFiltersThreatIntelIndicatorTypeTypeDef
        ],
        "ThreatIntelIndicatorValue": List[
            ClientUpdateFindingsFiltersThreatIntelIndicatorValueTypeDef
        ],
        "ThreatIntelIndicatorCategory": List[
            ClientUpdateFindingsFiltersThreatIntelIndicatorCategoryTypeDef
        ],
        "ThreatIntelIndicatorLastObservedAt": List[
            ClientUpdateFindingsFiltersThreatIntelIndicatorLastObservedAtTypeDef
        ],
        "ThreatIntelIndicatorSource": List[
            ClientUpdateFindingsFiltersThreatIntelIndicatorSourceTypeDef
        ],
        "ThreatIntelIndicatorSourceUrl": List[
            ClientUpdateFindingsFiltersThreatIntelIndicatorSourceUrlTypeDef
        ],
        "ResourceType": List[ClientUpdateFindingsFiltersResourceTypeTypeDef],
        "ResourceId": List[ClientUpdateFindingsFiltersResourceIdTypeDef],
        "ResourcePartition": List[ClientUpdateFindingsFiltersResourcePartitionTypeDef],
        "ResourceRegion": List[ClientUpdateFindingsFiltersResourceRegionTypeDef],
        "ResourceTags": List[ClientUpdateFindingsFiltersResourceTagsTypeDef],
        "ResourceAwsEc2InstanceType": List[
            ClientUpdateFindingsFiltersResourceAwsEc2InstanceTypeTypeDef
        ],
        "ResourceAwsEc2InstanceImageId": List[
            ClientUpdateFindingsFiltersResourceAwsEc2InstanceImageIdTypeDef
        ],
        "ResourceAwsEc2InstanceIpV4Addresses": List[
            ClientUpdateFindingsFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef
        ],
        "ResourceAwsEc2InstanceIpV6Addresses": List[
            ClientUpdateFindingsFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef
        ],
        "ResourceAwsEc2InstanceKeyName": List[
            ClientUpdateFindingsFiltersResourceAwsEc2InstanceKeyNameTypeDef
        ],
        "ResourceAwsEc2InstanceIamInstanceProfileArn": List[
            ClientUpdateFindingsFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef
        ],
        "ResourceAwsEc2InstanceVpcId": List[
            ClientUpdateFindingsFiltersResourceAwsEc2InstanceVpcIdTypeDef
        ],
        "ResourceAwsEc2InstanceSubnetId": List[
            ClientUpdateFindingsFiltersResourceAwsEc2InstanceSubnetIdTypeDef
        ],
        "ResourceAwsEc2InstanceLaunchedAt": List[
            ClientUpdateFindingsFiltersResourceAwsEc2InstanceLaunchedAtTypeDef
        ],
        "ResourceAwsS3BucketOwnerId": List[
            ClientUpdateFindingsFiltersResourceAwsS3BucketOwnerIdTypeDef
        ],
        "ResourceAwsS3BucketOwnerName": List[
            ClientUpdateFindingsFiltersResourceAwsS3BucketOwnerNameTypeDef
        ],
        "ResourceAwsIamAccessKeyUserName": List[
            ClientUpdateFindingsFiltersResourceAwsIamAccessKeyUserNameTypeDef
        ],
        "ResourceAwsIamAccessKeyStatus": List[
            ClientUpdateFindingsFiltersResourceAwsIamAccessKeyStatusTypeDef
        ],
        "ResourceAwsIamAccessKeyCreatedAt": List[
            ClientUpdateFindingsFiltersResourceAwsIamAccessKeyCreatedAtTypeDef
        ],
        "ResourceContainerName": List[ClientUpdateFindingsFiltersResourceContainerNameTypeDef],
        "ResourceContainerImageId": List[
            ClientUpdateFindingsFiltersResourceContainerImageIdTypeDef
        ],
        "ResourceContainerImageName": List[
            ClientUpdateFindingsFiltersResourceContainerImageNameTypeDef
        ],
        "ResourceContainerLaunchedAt": List[
            ClientUpdateFindingsFiltersResourceContainerLaunchedAtTypeDef
        ],
        "ResourceDetailsOther": List[ClientUpdateFindingsFiltersResourceDetailsOtherTypeDef],
        "ComplianceStatus": List[ClientUpdateFindingsFiltersComplianceStatusTypeDef],
        "VerificationState": List[ClientUpdateFindingsFiltersVerificationStateTypeDef],
        "WorkflowState": List[ClientUpdateFindingsFiltersWorkflowStateTypeDef],
        "RecordState": List[ClientUpdateFindingsFiltersRecordStateTypeDef],
        "RelatedFindingsProductArn": List[
            ClientUpdateFindingsFiltersRelatedFindingsProductArnTypeDef
        ],
        "RelatedFindingsId": List[ClientUpdateFindingsFiltersRelatedFindingsIdTypeDef],
        "NoteText": List[ClientUpdateFindingsFiltersNoteTextTypeDef],
        "NoteUpdatedAt": List[ClientUpdateFindingsFiltersNoteUpdatedAtTypeDef],
        "NoteUpdatedBy": List[ClientUpdateFindingsFiltersNoteUpdatedByTypeDef],
        "Keyword": List[ClientUpdateFindingsFiltersKeywordTypeDef],
    },
    total=False,
)


class ClientUpdateFindingsFiltersTypeDef(_ClientUpdateFindingsFiltersTypeDef):
    """
    Type definition for `ClientUpdateFindings` `Filters`

    A collection of attributes that specify which findings you want to update.

    - **ProductArn** *(list) --*

      The ARN generated by Security Hub that uniquely identifies a third-party company (security
      findings provider) after this provider's product (solution that generates findings) is
      registered with Security Hub.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **AwsAccountId** *(list) --*

      The AWS account ID that a finding is generated in.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Id** *(list) --*

      The security findings provider-specific identifier for a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **GeneratorId** *(list) --*

      The identifier for the solution-specific component (a discrete unit of logic) that generated a
      finding. In various security-findings providers' solutions, this generator can be called a
      rule, a check, a detector, a plug-in, etc.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Type** *(list) --*

      A finding type in the format of ``namespace/category/classifier`` that classifies a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **FirstObservedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider first
      observed the potential security issue that a finding captured.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **LastObservedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider most
      recently observed the potential security issue that a finding captured.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **CreatedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider captured the
      potential security issue that a finding captured.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **UpdatedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider last updated
      the finding record.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **SeverityProduct** *(list) --*

      The native severity as defined by the security-findings provider's solution that generated the
      finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **SeverityNormalized** *(list) --*

      The normalized severity of a finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **SeverityLabel** *(list) --*

      The label of a finding's severity.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Confidence** *(list) --*

      A finding's confidence. Confidence is defined as the likelihood that a finding accurately
      identifies the behavior or issue that it was intended to identify. Confidence is scored on a
      0-100 basis using a ratio scale, where 0 means zero percent confidence and 100 means 100
      percent confidence.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **Criticality** *(list) --*

      The level of importance assigned to the resources associated with the finding. A score of 0
      means that the underlying resources have no criticality, and a score of 100 is reserved for
      the most critical resources.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **Title** *(list) --*

      A finding's title.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Description** *(list) --*

      A finding's description.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RecommendationText** *(list) --*

      The recommendation of what to do about the issue described in a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **SourceUrl** *(list) --*

      A URL that links to a page about the current finding in the security-findings provider's
      solution.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProductFields** *(list) --*

      A data type where security-findings providers can include additional solution-specific details
      that aren't part of the defined ``AwsSecurityFinding`` format.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **ProductName** *(list) --*

      The name of the solution (product) that generates findings.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **CompanyName** *(list) --*

      The name of the findings provider (company) that owns the solution (product) that generates
      findings.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **UserDefinedFields** *(list) --*

      A list of name/value string pairs associated with the finding. These are custom, user-defined
      fields added to a finding.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **MalwareName** *(list) --*

      The name of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **MalwareType** *(list) --*

      The type of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **MalwarePath** *(list) --*

      The filesystem path of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **MalwareState** *(list) --*

      The state of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkDirection** *(list) --*

      Indicates the direction of network traffic associated with a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkProtocol** *(list) --*

      The protocol of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkSourceIpV4** *(list) --*

      The source IPv4 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkSourceIpV6** *(list) --*

      The source IPv6 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkSourcePort** *(list) --*

      The source port of network-related information about a finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **NetworkSourceDomain** *(list) --*

      The source domain of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkSourceMac** *(list) --*

      The source media access control (MAC) address of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkDestinationIpV4** *(list) --*

      The destination IPv4 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkDestinationIpV6** *(list) --*

      The destination IPv6 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkDestinationPort** *(list) --*

      The destination port of network-related information about a finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **NetworkDestinationDomain** *(list) --*

      The destination domain of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProcessName** *(list) --*

      The name of the process.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProcessPath** *(list) --*

      The path to the process executable.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProcessPid** *(list) --*

      The process ID.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **ProcessParentPid** *(list) --*

      The parent process ID.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **ProcessLaunchedAt** *(list) --*

      The date/time that the process was launched.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ProcessTerminatedAt** *(list) --*

      The date/time that the process was terminated.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ThreatIntelIndicatorType** *(list) --*

      The type of a threat intel indicator.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorValue** *(list) --*

      The value of a threat intel indicator.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorCategory** *(list) --*

      The category of a threat intel indicator.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorLastObservedAt** *(list) --*

      The date/time of the last observation of a threat intel indicator.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ThreatIntelIndicatorSource** *(list) --*

      The source of the threat intel.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorSourceUrl** *(list) --*

      The URL for more details from the source of the threat intel.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceType** *(list) --*

      Specifies the type of the resource that details are provided for.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceId** *(list) --*

      The canonical identifier for the given resource type.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourcePartition** *(list) --*

      The canonical AWS partition name that the Region is assigned to.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceRegion** *(list) --*

      The canonical AWS external Region name where this resource is located.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceTags** *(list) --*

      A list of AWS tags associated with a resource at the time the finding was processed.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **ResourceAwsEc2InstanceType** *(list) --*

      The instance type of the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceImageId** *(list) --*

      The Amazon Machine Image (AMI) ID of the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceIpV4Addresses** *(list) --*

      The IPv4 addresses associated with the instance.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **ResourceAwsEc2InstanceIpV6Addresses** *(list) --*

      The IPv6 addresses associated with the instance.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **ResourceAwsEc2InstanceKeyName** *(list) --*

      The key name associated with the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceIamInstanceProfileArn** *(list) --*

      The IAM profile ARN of the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceVpcId** *(list) --*

      The identifier of the VPC that the instance was launched in.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceSubnetId** *(list) --*

      The identifier of the subnet that the instance was launched in.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceLaunchedAt** *(list) --*

      The date/time the instance was launched.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ResourceAwsS3BucketOwnerId** *(list) --*

      The canonical user ID of the owner of the S3 bucket.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsS3BucketOwnerName** *(list) --*

      The display name of the owner of the S3 bucket.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsIamAccessKeyUserName** *(list) --*

      The user associated with the IAM access key related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsIamAccessKeyStatus** *(list) --*

      The status of the IAM access key related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsIamAccessKeyCreatedAt** *(list) --*

      The creation date/time of the IAM access key related to a finding.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ResourceContainerName** *(list) --*

      The name of the container related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceContainerImageId** *(list) --*

      The identifier of the image related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceContainerImageName** *(list) --*

      The name of the image related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceContainerLaunchedAt** *(list) --*

      The date/time that the container was started.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ResourceDetailsOther** *(list) --*

      The details of a resource that doesn't have a specific subfield for the resource type defined.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **ComplianceStatus** *(list) --*

      Exclusive to findings that are generated as the result of a check run against a specific rule
      in a supported standard (for example, CIS AWS Foundations). Contains compliance-related
      finding details.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **VerificationState** *(list) --*

      The veracity of a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **WorkflowState** *(list) --*

      The workflow state of a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RecordState** *(list) --*

      The updated record state for the finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RelatedFindingsProductArn** *(list) --*

      The ARN of the solution that generated a related finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RelatedFindingsId** *(list) --*

      The solution-generated identifier for a related finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NoteText** *(list) --*

      The text of a note.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NoteUpdatedAt** *(list) --*

      The timestamp of when the note was updated.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **NoteUpdatedBy** *(list) --*

      The principal that created a note.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Keyword** *(list) --*

      A keyword for a finding.

      - *(dict) --*

        A keyword filter for querying findings.

        - **Value** *(string) --*

          A value for the keyword.
    """


_ClientUpdateFindingsNoteTypeDef = TypedDict(
    "_ClientUpdateFindingsNoteTypeDef", {"Text": str, "UpdatedBy": str}
)


class ClientUpdateFindingsNoteTypeDef(_ClientUpdateFindingsNoteTypeDef):
    """
    Type definition for `ClientUpdateFindings` `Note`

    The updated note for the finding.

    - **Text** *(string) --* **[REQUIRED]**

      The updated note text.

    - **UpdatedBy** *(string) --* **[REQUIRED]**

      The principal that updated the note.
    """


_ClientUpdateInsightFiltersAwsAccountIdTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersAwsAccountIdTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateInsightFiltersAwsAccountIdTypeDef(_ClientUpdateInsightFiltersAwsAccountIdTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `AwsAccountId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersCompanyNameTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersCompanyNameTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateInsightFiltersCompanyNameTypeDef(_ClientUpdateInsightFiltersCompanyNameTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `CompanyName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersComplianceStatusTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersComplianceStatusTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersComplianceStatusTypeDef(
    _ClientUpdateInsightFiltersComplianceStatusTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ComplianceStatus`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersConfidenceTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersConfidenceTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientUpdateInsightFiltersConfidenceTypeDef(_ClientUpdateInsightFiltersConfidenceTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `Confidence`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientUpdateInsightFiltersCreatedAtDateRangeTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersCreatedAtDateRangeTypeDef", {"Value": int, "Unit": str}, total=False
)


class ClientUpdateInsightFiltersCreatedAtDateRangeTypeDef(
    _ClientUpdateInsightFiltersCreatedAtDateRangeTypeDef
):
    """
    Type definition for `ClientUpdateInsightFiltersCreatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientUpdateInsightFiltersCreatedAtTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersCreatedAtTypeDef",
    {"Start": str, "End": str, "DateRange": ClientUpdateInsightFiltersCreatedAtDateRangeTypeDef},
    total=False,
)


class ClientUpdateInsightFiltersCreatedAtTypeDef(_ClientUpdateInsightFiltersCreatedAtTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `CreatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientUpdateInsightFiltersCriticalityTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersCriticalityTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientUpdateInsightFiltersCriticalityTypeDef(_ClientUpdateInsightFiltersCriticalityTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `Criticality`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientUpdateInsightFiltersDescriptionTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersDescriptionTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateInsightFiltersDescriptionTypeDef(_ClientUpdateInsightFiltersDescriptionTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `Description`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersFirstObservedAtDateRangeTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersFirstObservedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientUpdateInsightFiltersFirstObservedAtDateRangeTypeDef(
    _ClientUpdateInsightFiltersFirstObservedAtDateRangeTypeDef
):
    """
    Type definition for `ClientUpdateInsightFiltersFirstObservedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientUpdateInsightFiltersFirstObservedAtTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersFirstObservedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientUpdateInsightFiltersFirstObservedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientUpdateInsightFiltersFirstObservedAtTypeDef(
    _ClientUpdateInsightFiltersFirstObservedAtTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `FirstObservedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientUpdateInsightFiltersGeneratorIdTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersGeneratorIdTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateInsightFiltersGeneratorIdTypeDef(_ClientUpdateInsightFiltersGeneratorIdTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `GeneratorId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersIdTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersIdTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateInsightFiltersIdTypeDef(_ClientUpdateInsightFiltersIdTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `Id`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersKeywordTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersKeywordTypeDef", {"Value": str}, total=False
)


class ClientUpdateInsightFiltersKeywordTypeDef(_ClientUpdateInsightFiltersKeywordTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `Keyword`

    A keyword filter for querying findings.

    - **Value** *(string) --*

      A value for the keyword.
    """


_ClientUpdateInsightFiltersLastObservedAtDateRangeTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersLastObservedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientUpdateInsightFiltersLastObservedAtDateRangeTypeDef(
    _ClientUpdateInsightFiltersLastObservedAtDateRangeTypeDef
):
    """
    Type definition for `ClientUpdateInsightFiltersLastObservedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientUpdateInsightFiltersLastObservedAtTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersLastObservedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientUpdateInsightFiltersLastObservedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientUpdateInsightFiltersLastObservedAtTypeDef(
    _ClientUpdateInsightFiltersLastObservedAtTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `LastObservedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientUpdateInsightFiltersMalwareNameTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersMalwareNameTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateInsightFiltersMalwareNameTypeDef(_ClientUpdateInsightFiltersMalwareNameTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `MalwareName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersMalwarePathTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersMalwarePathTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateInsightFiltersMalwarePathTypeDef(_ClientUpdateInsightFiltersMalwarePathTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `MalwarePath`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersMalwareStateTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersMalwareStateTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateInsightFiltersMalwareStateTypeDef(_ClientUpdateInsightFiltersMalwareStateTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `MalwareState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersMalwareTypeTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersMalwareTypeTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateInsightFiltersMalwareTypeTypeDef(_ClientUpdateInsightFiltersMalwareTypeTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `MalwareType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersNetworkDestinationDomainTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersNetworkDestinationDomainTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersNetworkDestinationDomainTypeDef(
    _ClientUpdateInsightFiltersNetworkDestinationDomainTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `NetworkDestinationDomain`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersNetworkDestinationIpV4TypeDef = TypedDict(
    "_ClientUpdateInsightFiltersNetworkDestinationIpV4TypeDef", {"Cidr": str}, total=False
)


class ClientUpdateInsightFiltersNetworkDestinationIpV4TypeDef(
    _ClientUpdateInsightFiltersNetworkDestinationIpV4TypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `NetworkDestinationIpV4`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientUpdateInsightFiltersNetworkDestinationIpV6TypeDef = TypedDict(
    "_ClientUpdateInsightFiltersNetworkDestinationIpV6TypeDef", {"Cidr": str}, total=False
)


class ClientUpdateInsightFiltersNetworkDestinationIpV6TypeDef(
    _ClientUpdateInsightFiltersNetworkDestinationIpV6TypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `NetworkDestinationIpV6`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientUpdateInsightFiltersNetworkDestinationPortTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersNetworkDestinationPortTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientUpdateInsightFiltersNetworkDestinationPortTypeDef(
    _ClientUpdateInsightFiltersNetworkDestinationPortTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `NetworkDestinationPort`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientUpdateInsightFiltersNetworkDirectionTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersNetworkDirectionTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersNetworkDirectionTypeDef(
    _ClientUpdateInsightFiltersNetworkDirectionTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `NetworkDirection`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersNetworkProtocolTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersNetworkProtocolTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersNetworkProtocolTypeDef(
    _ClientUpdateInsightFiltersNetworkProtocolTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `NetworkProtocol`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersNetworkSourceDomainTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersNetworkSourceDomainTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersNetworkSourceDomainTypeDef(
    _ClientUpdateInsightFiltersNetworkSourceDomainTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `NetworkSourceDomain`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersNetworkSourceIpV4TypeDef = TypedDict(
    "_ClientUpdateInsightFiltersNetworkSourceIpV4TypeDef", {"Cidr": str}, total=False
)


class ClientUpdateInsightFiltersNetworkSourceIpV4TypeDef(
    _ClientUpdateInsightFiltersNetworkSourceIpV4TypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `NetworkSourceIpV4`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientUpdateInsightFiltersNetworkSourceIpV6TypeDef = TypedDict(
    "_ClientUpdateInsightFiltersNetworkSourceIpV6TypeDef", {"Cidr": str}, total=False
)


class ClientUpdateInsightFiltersNetworkSourceIpV6TypeDef(
    _ClientUpdateInsightFiltersNetworkSourceIpV6TypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `NetworkSourceIpV6`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientUpdateInsightFiltersNetworkSourceMacTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersNetworkSourceMacTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersNetworkSourceMacTypeDef(
    _ClientUpdateInsightFiltersNetworkSourceMacTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `NetworkSourceMac`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersNetworkSourcePortTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersNetworkSourcePortTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientUpdateInsightFiltersNetworkSourcePortTypeDef(
    _ClientUpdateInsightFiltersNetworkSourcePortTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `NetworkSourcePort`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientUpdateInsightFiltersNoteTextTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersNoteTextTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateInsightFiltersNoteTextTypeDef(_ClientUpdateInsightFiltersNoteTextTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `NoteText`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersNoteUpdatedAtDateRangeTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersNoteUpdatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientUpdateInsightFiltersNoteUpdatedAtDateRangeTypeDef(
    _ClientUpdateInsightFiltersNoteUpdatedAtDateRangeTypeDef
):
    """
    Type definition for `ClientUpdateInsightFiltersNoteUpdatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientUpdateInsightFiltersNoteUpdatedAtTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersNoteUpdatedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientUpdateInsightFiltersNoteUpdatedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientUpdateInsightFiltersNoteUpdatedAtTypeDef(
    _ClientUpdateInsightFiltersNoteUpdatedAtTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `NoteUpdatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientUpdateInsightFiltersNoteUpdatedByTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersNoteUpdatedByTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersNoteUpdatedByTypeDef(
    _ClientUpdateInsightFiltersNoteUpdatedByTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `NoteUpdatedBy`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersProcessLaunchedAtDateRangeTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersProcessLaunchedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientUpdateInsightFiltersProcessLaunchedAtDateRangeTypeDef(
    _ClientUpdateInsightFiltersProcessLaunchedAtDateRangeTypeDef
):
    """
    Type definition for `ClientUpdateInsightFiltersProcessLaunchedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientUpdateInsightFiltersProcessLaunchedAtTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersProcessLaunchedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientUpdateInsightFiltersProcessLaunchedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientUpdateInsightFiltersProcessLaunchedAtTypeDef(
    _ClientUpdateInsightFiltersProcessLaunchedAtTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ProcessLaunchedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientUpdateInsightFiltersProcessNameTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersProcessNameTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateInsightFiltersProcessNameTypeDef(_ClientUpdateInsightFiltersProcessNameTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `ProcessName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersProcessParentPidTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersProcessParentPidTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientUpdateInsightFiltersProcessParentPidTypeDef(
    _ClientUpdateInsightFiltersProcessParentPidTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ProcessParentPid`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientUpdateInsightFiltersProcessPathTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersProcessPathTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateInsightFiltersProcessPathTypeDef(_ClientUpdateInsightFiltersProcessPathTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `ProcessPath`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersProcessPidTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersProcessPidTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientUpdateInsightFiltersProcessPidTypeDef(_ClientUpdateInsightFiltersProcessPidTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `ProcessPid`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientUpdateInsightFiltersProcessTerminatedAtDateRangeTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersProcessTerminatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientUpdateInsightFiltersProcessTerminatedAtDateRangeTypeDef(
    _ClientUpdateInsightFiltersProcessTerminatedAtDateRangeTypeDef
):
    """
    Type definition for `ClientUpdateInsightFiltersProcessTerminatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientUpdateInsightFiltersProcessTerminatedAtTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersProcessTerminatedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientUpdateInsightFiltersProcessTerminatedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientUpdateInsightFiltersProcessTerminatedAtTypeDef(
    _ClientUpdateInsightFiltersProcessTerminatedAtTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ProcessTerminatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientUpdateInsightFiltersProductArnTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersProductArnTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateInsightFiltersProductArnTypeDef(_ClientUpdateInsightFiltersProductArnTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `ProductArn`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersProductFieldsTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersProductFieldsTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersProductFieldsTypeDef(
    _ClientUpdateInsightFiltersProductFieldsTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ProductFields`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_ClientUpdateInsightFiltersProductNameTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersProductNameTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateInsightFiltersProductNameTypeDef(_ClientUpdateInsightFiltersProductNameTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `ProductName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersRecommendationTextTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersRecommendationTextTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersRecommendationTextTypeDef(
    _ClientUpdateInsightFiltersRecommendationTextTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `RecommendationText`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersRecordStateTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersRecordStateTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateInsightFiltersRecordStateTypeDef(_ClientUpdateInsightFiltersRecordStateTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `RecordState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersRelatedFindingsIdTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersRelatedFindingsIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersRelatedFindingsIdTypeDef(
    _ClientUpdateInsightFiltersRelatedFindingsIdTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `RelatedFindingsId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersRelatedFindingsProductArnTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersRelatedFindingsProductArnTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersRelatedFindingsProductArnTypeDef(
    _ClientUpdateInsightFiltersRelatedFindingsProductArnTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `RelatedFindingsProductArn`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef(
    _ClientUpdateInsightFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ResourceAwsEc2InstanceIamInstanceProfileArn`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersResourceAwsEc2InstanceImageIdTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourceAwsEc2InstanceImageIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersResourceAwsEc2InstanceImageIdTypeDef(
    _ClientUpdateInsightFiltersResourceAwsEc2InstanceImageIdTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ResourceAwsEc2InstanceImageId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef",
    {"Cidr": str},
    total=False,
)


class ClientUpdateInsightFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef(
    _ClientUpdateInsightFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ResourceAwsEc2InstanceIpV4Addresses`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientUpdateInsightFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef",
    {"Cidr": str},
    total=False,
)


class ClientUpdateInsightFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef(
    _ClientUpdateInsightFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ResourceAwsEc2InstanceIpV6Addresses`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_ClientUpdateInsightFiltersResourceAwsEc2InstanceKeyNameTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourceAwsEc2InstanceKeyNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersResourceAwsEc2InstanceKeyNameTypeDef(
    _ClientUpdateInsightFiltersResourceAwsEc2InstanceKeyNameTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ResourceAwsEc2InstanceKeyName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientUpdateInsightFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef(
    _ClientUpdateInsightFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef
):
    """
    Type definition for `ClientUpdateInsightFiltersResourceAwsEc2InstanceLaunchedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientUpdateInsightFiltersResourceAwsEc2InstanceLaunchedAtTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourceAwsEc2InstanceLaunchedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientUpdateInsightFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientUpdateInsightFiltersResourceAwsEc2InstanceLaunchedAtTypeDef(
    _ClientUpdateInsightFiltersResourceAwsEc2InstanceLaunchedAtTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ResourceAwsEc2InstanceLaunchedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientUpdateInsightFiltersResourceAwsEc2InstanceSubnetIdTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourceAwsEc2InstanceSubnetIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersResourceAwsEc2InstanceSubnetIdTypeDef(
    _ClientUpdateInsightFiltersResourceAwsEc2InstanceSubnetIdTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ResourceAwsEc2InstanceSubnetId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersResourceAwsEc2InstanceTypeTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourceAwsEc2InstanceTypeTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersResourceAwsEc2InstanceTypeTypeDef(
    _ClientUpdateInsightFiltersResourceAwsEc2InstanceTypeTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ResourceAwsEc2InstanceType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersResourceAwsEc2InstanceVpcIdTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourceAwsEc2InstanceVpcIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersResourceAwsEc2InstanceVpcIdTypeDef(
    _ClientUpdateInsightFiltersResourceAwsEc2InstanceVpcIdTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ResourceAwsEc2InstanceVpcId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientUpdateInsightFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef(
    _ClientUpdateInsightFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef
):
    """
    Type definition for `ClientUpdateInsightFiltersResourceAwsIamAccessKeyCreatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientUpdateInsightFiltersResourceAwsIamAccessKeyCreatedAtTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourceAwsIamAccessKeyCreatedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientUpdateInsightFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientUpdateInsightFiltersResourceAwsIamAccessKeyCreatedAtTypeDef(
    _ClientUpdateInsightFiltersResourceAwsIamAccessKeyCreatedAtTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ResourceAwsIamAccessKeyCreatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientUpdateInsightFiltersResourceAwsIamAccessKeyStatusTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourceAwsIamAccessKeyStatusTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersResourceAwsIamAccessKeyStatusTypeDef(
    _ClientUpdateInsightFiltersResourceAwsIamAccessKeyStatusTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ResourceAwsIamAccessKeyStatus`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersResourceAwsIamAccessKeyUserNameTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourceAwsIamAccessKeyUserNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersResourceAwsIamAccessKeyUserNameTypeDef(
    _ClientUpdateInsightFiltersResourceAwsIamAccessKeyUserNameTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ResourceAwsIamAccessKeyUserName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersResourceAwsS3BucketOwnerIdTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourceAwsS3BucketOwnerIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersResourceAwsS3BucketOwnerIdTypeDef(
    _ClientUpdateInsightFiltersResourceAwsS3BucketOwnerIdTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ResourceAwsS3BucketOwnerId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersResourceAwsS3BucketOwnerNameTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourceAwsS3BucketOwnerNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersResourceAwsS3BucketOwnerNameTypeDef(
    _ClientUpdateInsightFiltersResourceAwsS3BucketOwnerNameTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ResourceAwsS3BucketOwnerName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersResourceContainerImageIdTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourceContainerImageIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersResourceContainerImageIdTypeDef(
    _ClientUpdateInsightFiltersResourceContainerImageIdTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ResourceContainerImageId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersResourceContainerImageNameTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourceContainerImageNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersResourceContainerImageNameTypeDef(
    _ClientUpdateInsightFiltersResourceContainerImageNameTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ResourceContainerImageName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersResourceContainerLaunchedAtDateRangeTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourceContainerLaunchedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientUpdateInsightFiltersResourceContainerLaunchedAtDateRangeTypeDef(
    _ClientUpdateInsightFiltersResourceContainerLaunchedAtDateRangeTypeDef
):
    """
    Type definition for `ClientUpdateInsightFiltersResourceContainerLaunchedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientUpdateInsightFiltersResourceContainerLaunchedAtTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourceContainerLaunchedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientUpdateInsightFiltersResourceContainerLaunchedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientUpdateInsightFiltersResourceContainerLaunchedAtTypeDef(
    _ClientUpdateInsightFiltersResourceContainerLaunchedAtTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ResourceContainerLaunchedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientUpdateInsightFiltersResourceContainerNameTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourceContainerNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersResourceContainerNameTypeDef(
    _ClientUpdateInsightFiltersResourceContainerNameTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ResourceContainerName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersResourceDetailsOtherTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourceDetailsOtherTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersResourceDetailsOtherTypeDef(
    _ClientUpdateInsightFiltersResourceDetailsOtherTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ResourceDetailsOther`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_ClientUpdateInsightFiltersResourceIdTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourceIdTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateInsightFiltersResourceIdTypeDef(_ClientUpdateInsightFiltersResourceIdTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `ResourceId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersResourcePartitionTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourcePartitionTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersResourcePartitionTypeDef(
    _ClientUpdateInsightFiltersResourcePartitionTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ResourcePartition`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersResourceRegionTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourceRegionTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersResourceRegionTypeDef(
    _ClientUpdateInsightFiltersResourceRegionTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ResourceRegion`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersResourceTagsTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourceTagsTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersResourceTagsTypeDef(_ClientUpdateInsightFiltersResourceTagsTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `ResourceTags`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_ClientUpdateInsightFiltersResourceTypeTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersResourceTypeTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateInsightFiltersResourceTypeTypeDef(_ClientUpdateInsightFiltersResourceTypeTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `ResourceType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersSeverityLabelTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersSeverityLabelTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersSeverityLabelTypeDef(
    _ClientUpdateInsightFiltersSeverityLabelTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `SeverityLabel`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersSeverityNormalizedTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersSeverityNormalizedTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientUpdateInsightFiltersSeverityNormalizedTypeDef(
    _ClientUpdateInsightFiltersSeverityNormalizedTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `SeverityNormalized`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientUpdateInsightFiltersSeverityProductTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersSeverityProductTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class ClientUpdateInsightFiltersSeverityProductTypeDef(
    _ClientUpdateInsightFiltersSeverityProductTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `SeverityProduct`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_ClientUpdateInsightFiltersSourceUrlTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersSourceUrlTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateInsightFiltersSourceUrlTypeDef(_ClientUpdateInsightFiltersSourceUrlTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `SourceUrl`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersThreatIntelIndicatorCategoryTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersThreatIntelIndicatorCategoryTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersThreatIntelIndicatorCategoryTypeDef(
    _ClientUpdateInsightFiltersThreatIntelIndicatorCategoryTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ThreatIntelIndicatorCategory`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class ClientUpdateInsightFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef(
    _ClientUpdateInsightFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef
):
    """
    Type definition for `ClientUpdateInsightFiltersThreatIntelIndicatorLastObservedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientUpdateInsightFiltersThreatIntelIndicatorLastObservedAtTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersThreatIntelIndicatorLastObservedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": ClientUpdateInsightFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef,
    },
    total=False,
)


class ClientUpdateInsightFiltersThreatIntelIndicatorLastObservedAtTypeDef(
    _ClientUpdateInsightFiltersThreatIntelIndicatorLastObservedAtTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ThreatIntelIndicatorLastObservedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientUpdateInsightFiltersThreatIntelIndicatorSourceTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersThreatIntelIndicatorSourceTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersThreatIntelIndicatorSourceTypeDef(
    _ClientUpdateInsightFiltersThreatIntelIndicatorSourceTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ThreatIntelIndicatorSource`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersThreatIntelIndicatorSourceUrlTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersThreatIntelIndicatorSourceUrlTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersThreatIntelIndicatorSourceUrlTypeDef(
    _ClientUpdateInsightFiltersThreatIntelIndicatorSourceUrlTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ThreatIntelIndicatorSourceUrl`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersThreatIntelIndicatorTypeTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersThreatIntelIndicatorTypeTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersThreatIntelIndicatorTypeTypeDef(
    _ClientUpdateInsightFiltersThreatIntelIndicatorTypeTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ThreatIntelIndicatorType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersThreatIntelIndicatorValueTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersThreatIntelIndicatorValueTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersThreatIntelIndicatorValueTypeDef(
    _ClientUpdateInsightFiltersThreatIntelIndicatorValueTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `ThreatIntelIndicatorValue`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersTitleTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersTitleTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateInsightFiltersTitleTypeDef(_ClientUpdateInsightFiltersTitleTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `Title`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersTypeTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersTypeTypeDef", {"Value": str, "Comparison": str}, total=False
)


class ClientUpdateInsightFiltersTypeTypeDef(_ClientUpdateInsightFiltersTypeTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `Type`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersUpdatedAtDateRangeTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersUpdatedAtDateRangeTypeDef", {"Value": int, "Unit": str}, total=False
)


class ClientUpdateInsightFiltersUpdatedAtDateRangeTypeDef(
    _ClientUpdateInsightFiltersUpdatedAtDateRangeTypeDef
):
    """
    Type definition for `ClientUpdateInsightFiltersUpdatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_ClientUpdateInsightFiltersUpdatedAtTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersUpdatedAtTypeDef",
    {"Start": str, "End": str, "DateRange": ClientUpdateInsightFiltersUpdatedAtDateRangeTypeDef},
    total=False,
)


class ClientUpdateInsightFiltersUpdatedAtTypeDef(_ClientUpdateInsightFiltersUpdatedAtTypeDef):
    """
    Type definition for `ClientUpdateInsightFilters` `UpdatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_ClientUpdateInsightFiltersUserDefinedFieldsTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersUserDefinedFieldsTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersUserDefinedFieldsTypeDef(
    _ClientUpdateInsightFiltersUserDefinedFieldsTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `UserDefinedFields`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_ClientUpdateInsightFiltersVerificationStateTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersVerificationStateTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersVerificationStateTypeDef(
    _ClientUpdateInsightFiltersVerificationStateTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `VerificationState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersWorkflowStateTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersWorkflowStateTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class ClientUpdateInsightFiltersWorkflowStateTypeDef(
    _ClientUpdateInsightFiltersWorkflowStateTypeDef
):
    """
    Type definition for `ClientUpdateInsightFilters` `WorkflowState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_ClientUpdateInsightFiltersTypeDef = TypedDict(
    "_ClientUpdateInsightFiltersTypeDef",
    {
        "ProductArn": List[ClientUpdateInsightFiltersProductArnTypeDef],
        "AwsAccountId": List[ClientUpdateInsightFiltersAwsAccountIdTypeDef],
        "Id": List[ClientUpdateInsightFiltersIdTypeDef],
        "GeneratorId": List[ClientUpdateInsightFiltersGeneratorIdTypeDef],
        "Type": List[ClientUpdateInsightFiltersTypeTypeDef],
        "FirstObservedAt": List[ClientUpdateInsightFiltersFirstObservedAtTypeDef],
        "LastObservedAt": List[ClientUpdateInsightFiltersLastObservedAtTypeDef],
        "CreatedAt": List[ClientUpdateInsightFiltersCreatedAtTypeDef],
        "UpdatedAt": List[ClientUpdateInsightFiltersUpdatedAtTypeDef],
        "SeverityProduct": List[ClientUpdateInsightFiltersSeverityProductTypeDef],
        "SeverityNormalized": List[ClientUpdateInsightFiltersSeverityNormalizedTypeDef],
        "SeverityLabel": List[ClientUpdateInsightFiltersSeverityLabelTypeDef],
        "Confidence": List[ClientUpdateInsightFiltersConfidenceTypeDef],
        "Criticality": List[ClientUpdateInsightFiltersCriticalityTypeDef],
        "Title": List[ClientUpdateInsightFiltersTitleTypeDef],
        "Description": List[ClientUpdateInsightFiltersDescriptionTypeDef],
        "RecommendationText": List[ClientUpdateInsightFiltersRecommendationTextTypeDef],
        "SourceUrl": List[ClientUpdateInsightFiltersSourceUrlTypeDef],
        "ProductFields": List[ClientUpdateInsightFiltersProductFieldsTypeDef],
        "ProductName": List[ClientUpdateInsightFiltersProductNameTypeDef],
        "CompanyName": List[ClientUpdateInsightFiltersCompanyNameTypeDef],
        "UserDefinedFields": List[ClientUpdateInsightFiltersUserDefinedFieldsTypeDef],
        "MalwareName": List[ClientUpdateInsightFiltersMalwareNameTypeDef],
        "MalwareType": List[ClientUpdateInsightFiltersMalwareTypeTypeDef],
        "MalwarePath": List[ClientUpdateInsightFiltersMalwarePathTypeDef],
        "MalwareState": List[ClientUpdateInsightFiltersMalwareStateTypeDef],
        "NetworkDirection": List[ClientUpdateInsightFiltersNetworkDirectionTypeDef],
        "NetworkProtocol": List[ClientUpdateInsightFiltersNetworkProtocolTypeDef],
        "NetworkSourceIpV4": List[ClientUpdateInsightFiltersNetworkSourceIpV4TypeDef],
        "NetworkSourceIpV6": List[ClientUpdateInsightFiltersNetworkSourceIpV6TypeDef],
        "NetworkSourcePort": List[ClientUpdateInsightFiltersNetworkSourcePortTypeDef],
        "NetworkSourceDomain": List[ClientUpdateInsightFiltersNetworkSourceDomainTypeDef],
        "NetworkSourceMac": List[ClientUpdateInsightFiltersNetworkSourceMacTypeDef],
        "NetworkDestinationIpV4": List[ClientUpdateInsightFiltersNetworkDestinationIpV4TypeDef],
        "NetworkDestinationIpV6": List[ClientUpdateInsightFiltersNetworkDestinationIpV6TypeDef],
        "NetworkDestinationPort": List[ClientUpdateInsightFiltersNetworkDestinationPortTypeDef],
        "NetworkDestinationDomain": List[ClientUpdateInsightFiltersNetworkDestinationDomainTypeDef],
        "ProcessName": List[ClientUpdateInsightFiltersProcessNameTypeDef],
        "ProcessPath": List[ClientUpdateInsightFiltersProcessPathTypeDef],
        "ProcessPid": List[ClientUpdateInsightFiltersProcessPidTypeDef],
        "ProcessParentPid": List[ClientUpdateInsightFiltersProcessParentPidTypeDef],
        "ProcessLaunchedAt": List[ClientUpdateInsightFiltersProcessLaunchedAtTypeDef],
        "ProcessTerminatedAt": List[ClientUpdateInsightFiltersProcessTerminatedAtTypeDef],
        "ThreatIntelIndicatorType": List[ClientUpdateInsightFiltersThreatIntelIndicatorTypeTypeDef],
        "ThreatIntelIndicatorValue": List[
            ClientUpdateInsightFiltersThreatIntelIndicatorValueTypeDef
        ],
        "ThreatIntelIndicatorCategory": List[
            ClientUpdateInsightFiltersThreatIntelIndicatorCategoryTypeDef
        ],
        "ThreatIntelIndicatorLastObservedAt": List[
            ClientUpdateInsightFiltersThreatIntelIndicatorLastObservedAtTypeDef
        ],
        "ThreatIntelIndicatorSource": List[
            ClientUpdateInsightFiltersThreatIntelIndicatorSourceTypeDef
        ],
        "ThreatIntelIndicatorSourceUrl": List[
            ClientUpdateInsightFiltersThreatIntelIndicatorSourceUrlTypeDef
        ],
        "ResourceType": List[ClientUpdateInsightFiltersResourceTypeTypeDef],
        "ResourceId": List[ClientUpdateInsightFiltersResourceIdTypeDef],
        "ResourcePartition": List[ClientUpdateInsightFiltersResourcePartitionTypeDef],
        "ResourceRegion": List[ClientUpdateInsightFiltersResourceRegionTypeDef],
        "ResourceTags": List[ClientUpdateInsightFiltersResourceTagsTypeDef],
        "ResourceAwsEc2InstanceType": List[
            ClientUpdateInsightFiltersResourceAwsEc2InstanceTypeTypeDef
        ],
        "ResourceAwsEc2InstanceImageId": List[
            ClientUpdateInsightFiltersResourceAwsEc2InstanceImageIdTypeDef
        ],
        "ResourceAwsEc2InstanceIpV4Addresses": List[
            ClientUpdateInsightFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef
        ],
        "ResourceAwsEc2InstanceIpV6Addresses": List[
            ClientUpdateInsightFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef
        ],
        "ResourceAwsEc2InstanceKeyName": List[
            ClientUpdateInsightFiltersResourceAwsEc2InstanceKeyNameTypeDef
        ],
        "ResourceAwsEc2InstanceIamInstanceProfileArn": List[
            ClientUpdateInsightFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef
        ],
        "ResourceAwsEc2InstanceVpcId": List[
            ClientUpdateInsightFiltersResourceAwsEc2InstanceVpcIdTypeDef
        ],
        "ResourceAwsEc2InstanceSubnetId": List[
            ClientUpdateInsightFiltersResourceAwsEc2InstanceSubnetIdTypeDef
        ],
        "ResourceAwsEc2InstanceLaunchedAt": List[
            ClientUpdateInsightFiltersResourceAwsEc2InstanceLaunchedAtTypeDef
        ],
        "ResourceAwsS3BucketOwnerId": List[
            ClientUpdateInsightFiltersResourceAwsS3BucketOwnerIdTypeDef
        ],
        "ResourceAwsS3BucketOwnerName": List[
            ClientUpdateInsightFiltersResourceAwsS3BucketOwnerNameTypeDef
        ],
        "ResourceAwsIamAccessKeyUserName": List[
            ClientUpdateInsightFiltersResourceAwsIamAccessKeyUserNameTypeDef
        ],
        "ResourceAwsIamAccessKeyStatus": List[
            ClientUpdateInsightFiltersResourceAwsIamAccessKeyStatusTypeDef
        ],
        "ResourceAwsIamAccessKeyCreatedAt": List[
            ClientUpdateInsightFiltersResourceAwsIamAccessKeyCreatedAtTypeDef
        ],
        "ResourceContainerName": List[ClientUpdateInsightFiltersResourceContainerNameTypeDef],
        "ResourceContainerImageId": List[ClientUpdateInsightFiltersResourceContainerImageIdTypeDef],
        "ResourceContainerImageName": List[
            ClientUpdateInsightFiltersResourceContainerImageNameTypeDef
        ],
        "ResourceContainerLaunchedAt": List[
            ClientUpdateInsightFiltersResourceContainerLaunchedAtTypeDef
        ],
        "ResourceDetailsOther": List[ClientUpdateInsightFiltersResourceDetailsOtherTypeDef],
        "ComplianceStatus": List[ClientUpdateInsightFiltersComplianceStatusTypeDef],
        "VerificationState": List[ClientUpdateInsightFiltersVerificationStateTypeDef],
        "WorkflowState": List[ClientUpdateInsightFiltersWorkflowStateTypeDef],
        "RecordState": List[ClientUpdateInsightFiltersRecordStateTypeDef],
        "RelatedFindingsProductArn": List[
            ClientUpdateInsightFiltersRelatedFindingsProductArnTypeDef
        ],
        "RelatedFindingsId": List[ClientUpdateInsightFiltersRelatedFindingsIdTypeDef],
        "NoteText": List[ClientUpdateInsightFiltersNoteTextTypeDef],
        "NoteUpdatedAt": List[ClientUpdateInsightFiltersNoteUpdatedAtTypeDef],
        "NoteUpdatedBy": List[ClientUpdateInsightFiltersNoteUpdatedByTypeDef],
        "Keyword": List[ClientUpdateInsightFiltersKeywordTypeDef],
    },
    total=False,
)


class ClientUpdateInsightFiltersTypeDef(_ClientUpdateInsightFiltersTypeDef):
    """
    Type definition for `ClientUpdateInsight` `Filters`

    The updated filters that define this insight.

    - **ProductArn** *(list) --*

      The ARN generated by Security Hub that uniquely identifies a third-party company (security
      findings provider) after this provider's product (solution that generates findings) is
      registered with Security Hub.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **AwsAccountId** *(list) --*

      The AWS account ID that a finding is generated in.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Id** *(list) --*

      The security findings provider-specific identifier for a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **GeneratorId** *(list) --*

      The identifier for the solution-specific component (a discrete unit of logic) that generated a
      finding. In various security-findings providers' solutions, this generator can be called a
      rule, a check, a detector, a plug-in, etc.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Type** *(list) --*

      A finding type in the format of ``namespace/category/classifier`` that classifies a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **FirstObservedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider first
      observed the potential security issue that a finding captured.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **LastObservedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider most
      recently observed the potential security issue that a finding captured.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **CreatedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider captured the
      potential security issue that a finding captured.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **UpdatedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider last updated
      the finding record.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **SeverityProduct** *(list) --*

      The native severity as defined by the security-findings provider's solution that generated the
      finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **SeverityNormalized** *(list) --*

      The normalized severity of a finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **SeverityLabel** *(list) --*

      The label of a finding's severity.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Confidence** *(list) --*

      A finding's confidence. Confidence is defined as the likelihood that a finding accurately
      identifies the behavior or issue that it was intended to identify. Confidence is scored on a
      0-100 basis using a ratio scale, where 0 means zero percent confidence and 100 means 100
      percent confidence.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **Criticality** *(list) --*

      The level of importance assigned to the resources associated with the finding. A score of 0
      means that the underlying resources have no criticality, and a score of 100 is reserved for
      the most critical resources.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **Title** *(list) --*

      A finding's title.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Description** *(list) --*

      A finding's description.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RecommendationText** *(list) --*

      The recommendation of what to do about the issue described in a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **SourceUrl** *(list) --*

      A URL that links to a page about the current finding in the security-findings provider's
      solution.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProductFields** *(list) --*

      A data type where security-findings providers can include additional solution-specific details
      that aren't part of the defined ``AwsSecurityFinding`` format.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **ProductName** *(list) --*

      The name of the solution (product) that generates findings.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **CompanyName** *(list) --*

      The name of the findings provider (company) that owns the solution (product) that generates
      findings.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **UserDefinedFields** *(list) --*

      A list of name/value string pairs associated with the finding. These are custom, user-defined
      fields added to a finding.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **MalwareName** *(list) --*

      The name of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **MalwareType** *(list) --*

      The type of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **MalwarePath** *(list) --*

      The filesystem path of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **MalwareState** *(list) --*

      The state of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkDirection** *(list) --*

      Indicates the direction of network traffic associated with a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkProtocol** *(list) --*

      The protocol of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkSourceIpV4** *(list) --*

      The source IPv4 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkSourceIpV6** *(list) --*

      The source IPv6 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkSourcePort** *(list) --*

      The source port of network-related information about a finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **NetworkSourceDomain** *(list) --*

      The source domain of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkSourceMac** *(list) --*

      The source media access control (MAC) address of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkDestinationIpV4** *(list) --*

      The destination IPv4 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkDestinationIpV6** *(list) --*

      The destination IPv6 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkDestinationPort** *(list) --*

      The destination port of network-related information about a finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **NetworkDestinationDomain** *(list) --*

      The destination domain of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProcessName** *(list) --*

      The name of the process.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProcessPath** *(list) --*

      The path to the process executable.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProcessPid** *(list) --*

      The process ID.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **ProcessParentPid** *(list) --*

      The parent process ID.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **ProcessLaunchedAt** *(list) --*

      The date/time that the process was launched.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ProcessTerminatedAt** *(list) --*

      The date/time that the process was terminated.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ThreatIntelIndicatorType** *(list) --*

      The type of a threat intel indicator.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorValue** *(list) --*

      The value of a threat intel indicator.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorCategory** *(list) --*

      The category of a threat intel indicator.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorLastObservedAt** *(list) --*

      The date/time of the last observation of a threat intel indicator.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ThreatIntelIndicatorSource** *(list) --*

      The source of the threat intel.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorSourceUrl** *(list) --*

      The URL for more details from the source of the threat intel.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceType** *(list) --*

      Specifies the type of the resource that details are provided for.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceId** *(list) --*

      The canonical identifier for the given resource type.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourcePartition** *(list) --*

      The canonical AWS partition name that the Region is assigned to.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceRegion** *(list) --*

      The canonical AWS external Region name where this resource is located.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceTags** *(list) --*

      A list of AWS tags associated with a resource at the time the finding was processed.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **ResourceAwsEc2InstanceType** *(list) --*

      The instance type of the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceImageId** *(list) --*

      The Amazon Machine Image (AMI) ID of the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceIpV4Addresses** *(list) --*

      The IPv4 addresses associated with the instance.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **ResourceAwsEc2InstanceIpV6Addresses** *(list) --*

      The IPv6 addresses associated with the instance.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **ResourceAwsEc2InstanceKeyName** *(list) --*

      The key name associated with the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceIamInstanceProfileArn** *(list) --*

      The IAM profile ARN of the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceVpcId** *(list) --*

      The identifier of the VPC that the instance was launched in.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceSubnetId** *(list) --*

      The identifier of the subnet that the instance was launched in.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceLaunchedAt** *(list) --*

      The date/time the instance was launched.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ResourceAwsS3BucketOwnerId** *(list) --*

      The canonical user ID of the owner of the S3 bucket.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsS3BucketOwnerName** *(list) --*

      The display name of the owner of the S3 bucket.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsIamAccessKeyUserName** *(list) --*

      The user associated with the IAM access key related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsIamAccessKeyStatus** *(list) --*

      The status of the IAM access key related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsIamAccessKeyCreatedAt** *(list) --*

      The creation date/time of the IAM access key related to a finding.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ResourceContainerName** *(list) --*

      The name of the container related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceContainerImageId** *(list) --*

      The identifier of the image related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceContainerImageName** *(list) --*

      The name of the image related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceContainerLaunchedAt** *(list) --*

      The date/time that the container was started.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ResourceDetailsOther** *(list) --*

      The details of a resource that doesn't have a specific subfield for the resource type defined.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **ComplianceStatus** *(list) --*

      Exclusive to findings that are generated as the result of a check run against a specific rule
      in a supported standard (for example, CIS AWS Foundations). Contains compliance-related
      finding details.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **VerificationState** *(list) --*

      The veracity of a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **WorkflowState** *(list) --*

      The workflow state of a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RecordState** *(list) --*

      The updated record state for the finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RelatedFindingsProductArn** *(list) --*

      The ARN of the solution that generated a related finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RelatedFindingsId** *(list) --*

      The solution-generated identifier for a related finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NoteText** *(list) --*

      The text of a note.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NoteUpdatedAt** *(list) --*

      The timestamp of when the note was updated.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **NoteUpdatedBy** *(list) --*

      The principal that created a note.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Keyword** *(list) --*

      A keyword for a finding.

      - *(dict) --*

        A keyword filter for querying findings.

        - **Value** *(string) --*

          A value for the keyword.
    """


_GetEnabledStandardsPaginatePaginationConfigTypeDef = TypedDict(
    "_GetEnabledStandardsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class GetEnabledStandardsPaginatePaginationConfigTypeDef(
    _GetEnabledStandardsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `GetEnabledStandardsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_GetEnabledStandardsPaginateResponseStandardsSubscriptionsTypeDef = TypedDict(
    "_GetEnabledStandardsPaginateResponseStandardsSubscriptionsTypeDef",
    {
        "StandardsSubscriptionArn": str,
        "StandardsArn": str,
        "StandardsInput": Dict[str, str],
        "StandardsStatus": str,
    },
    total=False,
)


class GetEnabledStandardsPaginateResponseStandardsSubscriptionsTypeDef(
    _GetEnabledStandardsPaginateResponseStandardsSubscriptionsTypeDef
):
    """
    Type definition for `GetEnabledStandardsPaginateResponse` `StandardsSubscriptions`

    A resource that represents your subscription to a supported standard.

    - **StandardsSubscriptionArn** *(string) --*

      The ARN of a resource that represents your subscription to a supported standard.

    - **StandardsArn** *(string) --*

      The ARN of a standard.

      In this release, Security Hub supports only the CIS AWS Foundations standard, which uses the
      following ARN: ``arn:aws:securityhub:::ruleset/cis-aws-foundations-benchmark/v/1.2.0.``

    - **StandardsInput** *(dict) --*

      A key-value pair of input for the standard.

      - *(string) --*

        - *(string) --*

    - **StandardsStatus** *(string) --*

      The status of the standards subscription.
    """


_GetEnabledStandardsPaginateResponseTypeDef = TypedDict(
    "_GetEnabledStandardsPaginateResponseTypeDef",
    {
        "StandardsSubscriptions": List[
            GetEnabledStandardsPaginateResponseStandardsSubscriptionsTypeDef
        ]
    },
    total=False,
)


class GetEnabledStandardsPaginateResponseTypeDef(_GetEnabledStandardsPaginateResponseTypeDef):
    """
    Type definition for `GetEnabledStandardsPaginate` `Response`

    - **StandardsSubscriptions** *(list) --*

      A list of ``StandardsSubscriptions`` objects that include information about the enabled
      standards.

      - *(dict) --*

        A resource that represents your subscription to a supported standard.

        - **StandardsSubscriptionArn** *(string) --*

          The ARN of a resource that represents your subscription to a supported standard.

        - **StandardsArn** *(string) --*

          The ARN of a standard.

          In this release, Security Hub supports only the CIS AWS Foundations standard, which uses
          the following ARN:
          ``arn:aws:securityhub:::ruleset/cis-aws-foundations-benchmark/v/1.2.0.``

        - **StandardsInput** *(dict) --*

          A key-value pair of input for the standard.

          - *(string) --*

            - *(string) --*

        - **StandardsStatus** *(string) --*

          The status of the standards subscription.
    """


_GetFindingsPaginateFiltersAwsAccountIdTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersAwsAccountIdTypeDef", {"Value": str, "Comparison": str}, total=False
)


class GetFindingsPaginateFiltersAwsAccountIdTypeDef(_GetFindingsPaginateFiltersAwsAccountIdTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `AwsAccountId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersCompanyNameTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersCompanyNameTypeDef", {"Value": str, "Comparison": str}, total=False
)


class GetFindingsPaginateFiltersCompanyNameTypeDef(_GetFindingsPaginateFiltersCompanyNameTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `CompanyName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersComplianceStatusTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersComplianceStatusTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersComplianceStatusTypeDef(
    _GetFindingsPaginateFiltersComplianceStatusTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ComplianceStatus`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersConfidenceTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersConfidenceTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class GetFindingsPaginateFiltersConfidenceTypeDef(_GetFindingsPaginateFiltersConfidenceTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `Confidence`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_GetFindingsPaginateFiltersCreatedAtDateRangeTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersCreatedAtDateRangeTypeDef", {"Value": int, "Unit": str}, total=False
)


class GetFindingsPaginateFiltersCreatedAtDateRangeTypeDef(
    _GetFindingsPaginateFiltersCreatedAtDateRangeTypeDef
):
    """
    Type definition for `GetFindingsPaginateFiltersCreatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_GetFindingsPaginateFiltersCreatedAtTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersCreatedAtTypeDef",
    {"Start": str, "End": str, "DateRange": GetFindingsPaginateFiltersCreatedAtDateRangeTypeDef},
    total=False,
)


class GetFindingsPaginateFiltersCreatedAtTypeDef(_GetFindingsPaginateFiltersCreatedAtTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `CreatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_GetFindingsPaginateFiltersCriticalityTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersCriticalityTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class GetFindingsPaginateFiltersCriticalityTypeDef(_GetFindingsPaginateFiltersCriticalityTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `Criticality`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_GetFindingsPaginateFiltersDescriptionTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersDescriptionTypeDef", {"Value": str, "Comparison": str}, total=False
)


class GetFindingsPaginateFiltersDescriptionTypeDef(_GetFindingsPaginateFiltersDescriptionTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `Description`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersFirstObservedAtDateRangeTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersFirstObservedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class GetFindingsPaginateFiltersFirstObservedAtDateRangeTypeDef(
    _GetFindingsPaginateFiltersFirstObservedAtDateRangeTypeDef
):
    """
    Type definition for `GetFindingsPaginateFiltersFirstObservedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_GetFindingsPaginateFiltersFirstObservedAtTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersFirstObservedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": GetFindingsPaginateFiltersFirstObservedAtDateRangeTypeDef,
    },
    total=False,
)


class GetFindingsPaginateFiltersFirstObservedAtTypeDef(
    _GetFindingsPaginateFiltersFirstObservedAtTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `FirstObservedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_GetFindingsPaginateFiltersGeneratorIdTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersGeneratorIdTypeDef", {"Value": str, "Comparison": str}, total=False
)


class GetFindingsPaginateFiltersGeneratorIdTypeDef(_GetFindingsPaginateFiltersGeneratorIdTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `GeneratorId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersIdTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersIdTypeDef", {"Value": str, "Comparison": str}, total=False
)


class GetFindingsPaginateFiltersIdTypeDef(_GetFindingsPaginateFiltersIdTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `Id`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersKeywordTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersKeywordTypeDef", {"Value": str}, total=False
)


class GetFindingsPaginateFiltersKeywordTypeDef(_GetFindingsPaginateFiltersKeywordTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `Keyword`

    A keyword filter for querying findings.

    - **Value** *(string) --*

      A value for the keyword.
    """


_GetFindingsPaginateFiltersLastObservedAtDateRangeTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersLastObservedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class GetFindingsPaginateFiltersLastObservedAtDateRangeTypeDef(
    _GetFindingsPaginateFiltersLastObservedAtDateRangeTypeDef
):
    """
    Type definition for `GetFindingsPaginateFiltersLastObservedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_GetFindingsPaginateFiltersLastObservedAtTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersLastObservedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": GetFindingsPaginateFiltersLastObservedAtDateRangeTypeDef,
    },
    total=False,
)


class GetFindingsPaginateFiltersLastObservedAtTypeDef(
    _GetFindingsPaginateFiltersLastObservedAtTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `LastObservedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_GetFindingsPaginateFiltersMalwareNameTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersMalwareNameTypeDef", {"Value": str, "Comparison": str}, total=False
)


class GetFindingsPaginateFiltersMalwareNameTypeDef(_GetFindingsPaginateFiltersMalwareNameTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `MalwareName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersMalwarePathTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersMalwarePathTypeDef", {"Value": str, "Comparison": str}, total=False
)


class GetFindingsPaginateFiltersMalwarePathTypeDef(_GetFindingsPaginateFiltersMalwarePathTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `MalwarePath`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersMalwareStateTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersMalwareStateTypeDef", {"Value": str, "Comparison": str}, total=False
)


class GetFindingsPaginateFiltersMalwareStateTypeDef(_GetFindingsPaginateFiltersMalwareStateTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `MalwareState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersMalwareTypeTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersMalwareTypeTypeDef", {"Value": str, "Comparison": str}, total=False
)


class GetFindingsPaginateFiltersMalwareTypeTypeDef(_GetFindingsPaginateFiltersMalwareTypeTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `MalwareType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersNetworkDestinationDomainTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersNetworkDestinationDomainTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersNetworkDestinationDomainTypeDef(
    _GetFindingsPaginateFiltersNetworkDestinationDomainTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `NetworkDestinationDomain`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersNetworkDestinationIpV4TypeDef = TypedDict(
    "_GetFindingsPaginateFiltersNetworkDestinationIpV4TypeDef", {"Cidr": str}, total=False
)


class GetFindingsPaginateFiltersNetworkDestinationIpV4TypeDef(
    _GetFindingsPaginateFiltersNetworkDestinationIpV4TypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `NetworkDestinationIpV4`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_GetFindingsPaginateFiltersNetworkDestinationIpV6TypeDef = TypedDict(
    "_GetFindingsPaginateFiltersNetworkDestinationIpV6TypeDef", {"Cidr": str}, total=False
)


class GetFindingsPaginateFiltersNetworkDestinationIpV6TypeDef(
    _GetFindingsPaginateFiltersNetworkDestinationIpV6TypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `NetworkDestinationIpV6`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_GetFindingsPaginateFiltersNetworkDestinationPortTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersNetworkDestinationPortTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class GetFindingsPaginateFiltersNetworkDestinationPortTypeDef(
    _GetFindingsPaginateFiltersNetworkDestinationPortTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `NetworkDestinationPort`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_GetFindingsPaginateFiltersNetworkDirectionTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersNetworkDirectionTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersNetworkDirectionTypeDef(
    _GetFindingsPaginateFiltersNetworkDirectionTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `NetworkDirection`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersNetworkProtocolTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersNetworkProtocolTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersNetworkProtocolTypeDef(
    _GetFindingsPaginateFiltersNetworkProtocolTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `NetworkProtocol`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersNetworkSourceDomainTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersNetworkSourceDomainTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersNetworkSourceDomainTypeDef(
    _GetFindingsPaginateFiltersNetworkSourceDomainTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `NetworkSourceDomain`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersNetworkSourceIpV4TypeDef = TypedDict(
    "_GetFindingsPaginateFiltersNetworkSourceIpV4TypeDef", {"Cidr": str}, total=False
)


class GetFindingsPaginateFiltersNetworkSourceIpV4TypeDef(
    _GetFindingsPaginateFiltersNetworkSourceIpV4TypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `NetworkSourceIpV4`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_GetFindingsPaginateFiltersNetworkSourceIpV6TypeDef = TypedDict(
    "_GetFindingsPaginateFiltersNetworkSourceIpV6TypeDef", {"Cidr": str}, total=False
)


class GetFindingsPaginateFiltersNetworkSourceIpV6TypeDef(
    _GetFindingsPaginateFiltersNetworkSourceIpV6TypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `NetworkSourceIpV6`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_GetFindingsPaginateFiltersNetworkSourceMacTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersNetworkSourceMacTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersNetworkSourceMacTypeDef(
    _GetFindingsPaginateFiltersNetworkSourceMacTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `NetworkSourceMac`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersNetworkSourcePortTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersNetworkSourcePortTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class GetFindingsPaginateFiltersNetworkSourcePortTypeDef(
    _GetFindingsPaginateFiltersNetworkSourcePortTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `NetworkSourcePort`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_GetFindingsPaginateFiltersNoteTextTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersNoteTextTypeDef", {"Value": str, "Comparison": str}, total=False
)


class GetFindingsPaginateFiltersNoteTextTypeDef(_GetFindingsPaginateFiltersNoteTextTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `NoteText`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersNoteUpdatedAtDateRangeTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersNoteUpdatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class GetFindingsPaginateFiltersNoteUpdatedAtDateRangeTypeDef(
    _GetFindingsPaginateFiltersNoteUpdatedAtDateRangeTypeDef
):
    """
    Type definition for `GetFindingsPaginateFiltersNoteUpdatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_GetFindingsPaginateFiltersNoteUpdatedAtTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersNoteUpdatedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": GetFindingsPaginateFiltersNoteUpdatedAtDateRangeTypeDef,
    },
    total=False,
)


class GetFindingsPaginateFiltersNoteUpdatedAtTypeDef(
    _GetFindingsPaginateFiltersNoteUpdatedAtTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `NoteUpdatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_GetFindingsPaginateFiltersNoteUpdatedByTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersNoteUpdatedByTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersNoteUpdatedByTypeDef(
    _GetFindingsPaginateFiltersNoteUpdatedByTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `NoteUpdatedBy`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersProcessLaunchedAtDateRangeTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersProcessLaunchedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class GetFindingsPaginateFiltersProcessLaunchedAtDateRangeTypeDef(
    _GetFindingsPaginateFiltersProcessLaunchedAtDateRangeTypeDef
):
    """
    Type definition for `GetFindingsPaginateFiltersProcessLaunchedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_GetFindingsPaginateFiltersProcessLaunchedAtTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersProcessLaunchedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": GetFindingsPaginateFiltersProcessLaunchedAtDateRangeTypeDef,
    },
    total=False,
)


class GetFindingsPaginateFiltersProcessLaunchedAtTypeDef(
    _GetFindingsPaginateFiltersProcessLaunchedAtTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ProcessLaunchedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_GetFindingsPaginateFiltersProcessNameTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersProcessNameTypeDef", {"Value": str, "Comparison": str}, total=False
)


class GetFindingsPaginateFiltersProcessNameTypeDef(_GetFindingsPaginateFiltersProcessNameTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `ProcessName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersProcessParentPidTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersProcessParentPidTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class GetFindingsPaginateFiltersProcessParentPidTypeDef(
    _GetFindingsPaginateFiltersProcessParentPidTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ProcessParentPid`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_GetFindingsPaginateFiltersProcessPathTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersProcessPathTypeDef", {"Value": str, "Comparison": str}, total=False
)


class GetFindingsPaginateFiltersProcessPathTypeDef(_GetFindingsPaginateFiltersProcessPathTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `ProcessPath`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersProcessPidTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersProcessPidTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class GetFindingsPaginateFiltersProcessPidTypeDef(_GetFindingsPaginateFiltersProcessPidTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `ProcessPid`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_GetFindingsPaginateFiltersProcessTerminatedAtDateRangeTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersProcessTerminatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class GetFindingsPaginateFiltersProcessTerminatedAtDateRangeTypeDef(
    _GetFindingsPaginateFiltersProcessTerminatedAtDateRangeTypeDef
):
    """
    Type definition for `GetFindingsPaginateFiltersProcessTerminatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_GetFindingsPaginateFiltersProcessTerminatedAtTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersProcessTerminatedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": GetFindingsPaginateFiltersProcessTerminatedAtDateRangeTypeDef,
    },
    total=False,
)


class GetFindingsPaginateFiltersProcessTerminatedAtTypeDef(
    _GetFindingsPaginateFiltersProcessTerminatedAtTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ProcessTerminatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_GetFindingsPaginateFiltersProductArnTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersProductArnTypeDef", {"Value": str, "Comparison": str}, total=False
)


class GetFindingsPaginateFiltersProductArnTypeDef(_GetFindingsPaginateFiltersProductArnTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `ProductArn`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersProductFieldsTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersProductFieldsTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersProductFieldsTypeDef(
    _GetFindingsPaginateFiltersProductFieldsTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ProductFields`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_GetFindingsPaginateFiltersProductNameTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersProductNameTypeDef", {"Value": str, "Comparison": str}, total=False
)


class GetFindingsPaginateFiltersProductNameTypeDef(_GetFindingsPaginateFiltersProductNameTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `ProductName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersRecommendationTextTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersRecommendationTextTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersRecommendationTextTypeDef(
    _GetFindingsPaginateFiltersRecommendationTextTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `RecommendationText`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersRecordStateTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersRecordStateTypeDef", {"Value": str, "Comparison": str}, total=False
)


class GetFindingsPaginateFiltersRecordStateTypeDef(_GetFindingsPaginateFiltersRecordStateTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `RecordState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersRelatedFindingsIdTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersRelatedFindingsIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersRelatedFindingsIdTypeDef(
    _GetFindingsPaginateFiltersRelatedFindingsIdTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `RelatedFindingsId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersRelatedFindingsProductArnTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersRelatedFindingsProductArnTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersRelatedFindingsProductArnTypeDef(
    _GetFindingsPaginateFiltersRelatedFindingsProductArnTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `RelatedFindingsProductArn`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef(
    _GetFindingsPaginateFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ResourceAwsEc2InstanceIamInstanceProfileArn`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersResourceAwsEc2InstanceImageIdTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourceAwsEc2InstanceImageIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersResourceAwsEc2InstanceImageIdTypeDef(
    _GetFindingsPaginateFiltersResourceAwsEc2InstanceImageIdTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ResourceAwsEc2InstanceImageId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef",
    {"Cidr": str},
    total=False,
)


class GetFindingsPaginateFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef(
    _GetFindingsPaginateFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ResourceAwsEc2InstanceIpV4Addresses`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_GetFindingsPaginateFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef",
    {"Cidr": str},
    total=False,
)


class GetFindingsPaginateFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef(
    _GetFindingsPaginateFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ResourceAwsEc2InstanceIpV6Addresses`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_GetFindingsPaginateFiltersResourceAwsEc2InstanceKeyNameTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourceAwsEc2InstanceKeyNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersResourceAwsEc2InstanceKeyNameTypeDef(
    _GetFindingsPaginateFiltersResourceAwsEc2InstanceKeyNameTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ResourceAwsEc2InstanceKeyName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class GetFindingsPaginateFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef(
    _GetFindingsPaginateFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef
):
    """
    Type definition for `GetFindingsPaginateFiltersResourceAwsEc2InstanceLaunchedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_GetFindingsPaginateFiltersResourceAwsEc2InstanceLaunchedAtTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourceAwsEc2InstanceLaunchedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": GetFindingsPaginateFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef,
    },
    total=False,
)


class GetFindingsPaginateFiltersResourceAwsEc2InstanceLaunchedAtTypeDef(
    _GetFindingsPaginateFiltersResourceAwsEc2InstanceLaunchedAtTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ResourceAwsEc2InstanceLaunchedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_GetFindingsPaginateFiltersResourceAwsEc2InstanceSubnetIdTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourceAwsEc2InstanceSubnetIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersResourceAwsEc2InstanceSubnetIdTypeDef(
    _GetFindingsPaginateFiltersResourceAwsEc2InstanceSubnetIdTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ResourceAwsEc2InstanceSubnetId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersResourceAwsEc2InstanceTypeTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourceAwsEc2InstanceTypeTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersResourceAwsEc2InstanceTypeTypeDef(
    _GetFindingsPaginateFiltersResourceAwsEc2InstanceTypeTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ResourceAwsEc2InstanceType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersResourceAwsEc2InstanceVpcIdTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourceAwsEc2InstanceVpcIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersResourceAwsEc2InstanceVpcIdTypeDef(
    _GetFindingsPaginateFiltersResourceAwsEc2InstanceVpcIdTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ResourceAwsEc2InstanceVpcId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class GetFindingsPaginateFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef(
    _GetFindingsPaginateFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef
):
    """
    Type definition for `GetFindingsPaginateFiltersResourceAwsIamAccessKeyCreatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_GetFindingsPaginateFiltersResourceAwsIamAccessKeyCreatedAtTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourceAwsIamAccessKeyCreatedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": GetFindingsPaginateFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef,
    },
    total=False,
)


class GetFindingsPaginateFiltersResourceAwsIamAccessKeyCreatedAtTypeDef(
    _GetFindingsPaginateFiltersResourceAwsIamAccessKeyCreatedAtTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ResourceAwsIamAccessKeyCreatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_GetFindingsPaginateFiltersResourceAwsIamAccessKeyStatusTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourceAwsIamAccessKeyStatusTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersResourceAwsIamAccessKeyStatusTypeDef(
    _GetFindingsPaginateFiltersResourceAwsIamAccessKeyStatusTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ResourceAwsIamAccessKeyStatus`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersResourceAwsIamAccessKeyUserNameTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourceAwsIamAccessKeyUserNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersResourceAwsIamAccessKeyUserNameTypeDef(
    _GetFindingsPaginateFiltersResourceAwsIamAccessKeyUserNameTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ResourceAwsIamAccessKeyUserName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersResourceAwsS3BucketOwnerIdTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourceAwsS3BucketOwnerIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersResourceAwsS3BucketOwnerIdTypeDef(
    _GetFindingsPaginateFiltersResourceAwsS3BucketOwnerIdTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ResourceAwsS3BucketOwnerId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersResourceAwsS3BucketOwnerNameTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourceAwsS3BucketOwnerNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersResourceAwsS3BucketOwnerNameTypeDef(
    _GetFindingsPaginateFiltersResourceAwsS3BucketOwnerNameTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ResourceAwsS3BucketOwnerName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersResourceContainerImageIdTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourceContainerImageIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersResourceContainerImageIdTypeDef(
    _GetFindingsPaginateFiltersResourceContainerImageIdTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ResourceContainerImageId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersResourceContainerImageNameTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourceContainerImageNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersResourceContainerImageNameTypeDef(
    _GetFindingsPaginateFiltersResourceContainerImageNameTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ResourceContainerImageName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersResourceContainerLaunchedAtDateRangeTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourceContainerLaunchedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class GetFindingsPaginateFiltersResourceContainerLaunchedAtDateRangeTypeDef(
    _GetFindingsPaginateFiltersResourceContainerLaunchedAtDateRangeTypeDef
):
    """
    Type definition for `GetFindingsPaginateFiltersResourceContainerLaunchedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_GetFindingsPaginateFiltersResourceContainerLaunchedAtTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourceContainerLaunchedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": GetFindingsPaginateFiltersResourceContainerLaunchedAtDateRangeTypeDef,
    },
    total=False,
)


class GetFindingsPaginateFiltersResourceContainerLaunchedAtTypeDef(
    _GetFindingsPaginateFiltersResourceContainerLaunchedAtTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ResourceContainerLaunchedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_GetFindingsPaginateFiltersResourceContainerNameTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourceContainerNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersResourceContainerNameTypeDef(
    _GetFindingsPaginateFiltersResourceContainerNameTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ResourceContainerName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersResourceDetailsOtherTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourceDetailsOtherTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersResourceDetailsOtherTypeDef(
    _GetFindingsPaginateFiltersResourceDetailsOtherTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ResourceDetailsOther`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_GetFindingsPaginateFiltersResourceIdTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourceIdTypeDef", {"Value": str, "Comparison": str}, total=False
)


class GetFindingsPaginateFiltersResourceIdTypeDef(_GetFindingsPaginateFiltersResourceIdTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `ResourceId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersResourcePartitionTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourcePartitionTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersResourcePartitionTypeDef(
    _GetFindingsPaginateFiltersResourcePartitionTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ResourcePartition`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersResourceRegionTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourceRegionTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersResourceRegionTypeDef(
    _GetFindingsPaginateFiltersResourceRegionTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ResourceRegion`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersResourceTagsTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourceTagsTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersResourceTagsTypeDef(_GetFindingsPaginateFiltersResourceTagsTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `ResourceTags`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_GetFindingsPaginateFiltersResourceTypeTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersResourceTypeTypeDef", {"Value": str, "Comparison": str}, total=False
)


class GetFindingsPaginateFiltersResourceTypeTypeDef(_GetFindingsPaginateFiltersResourceTypeTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `ResourceType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersSeverityLabelTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersSeverityLabelTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersSeverityLabelTypeDef(
    _GetFindingsPaginateFiltersSeverityLabelTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `SeverityLabel`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersSeverityNormalizedTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersSeverityNormalizedTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class GetFindingsPaginateFiltersSeverityNormalizedTypeDef(
    _GetFindingsPaginateFiltersSeverityNormalizedTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `SeverityNormalized`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_GetFindingsPaginateFiltersSeverityProductTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersSeverityProductTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class GetFindingsPaginateFiltersSeverityProductTypeDef(
    _GetFindingsPaginateFiltersSeverityProductTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `SeverityProduct`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_GetFindingsPaginateFiltersSourceUrlTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersSourceUrlTypeDef", {"Value": str, "Comparison": str}, total=False
)


class GetFindingsPaginateFiltersSourceUrlTypeDef(_GetFindingsPaginateFiltersSourceUrlTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `SourceUrl`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersThreatIntelIndicatorCategoryTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersThreatIntelIndicatorCategoryTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersThreatIntelIndicatorCategoryTypeDef(
    _GetFindingsPaginateFiltersThreatIntelIndicatorCategoryTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ThreatIntelIndicatorCategory`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class GetFindingsPaginateFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef(
    _GetFindingsPaginateFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef
):
    """
    Type definition for `GetFindingsPaginateFiltersThreatIntelIndicatorLastObservedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_GetFindingsPaginateFiltersThreatIntelIndicatorLastObservedAtTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersThreatIntelIndicatorLastObservedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": GetFindingsPaginateFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef,
    },
    total=False,
)


class GetFindingsPaginateFiltersThreatIntelIndicatorLastObservedAtTypeDef(
    _GetFindingsPaginateFiltersThreatIntelIndicatorLastObservedAtTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ThreatIntelIndicatorLastObservedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_GetFindingsPaginateFiltersThreatIntelIndicatorSourceTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersThreatIntelIndicatorSourceTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersThreatIntelIndicatorSourceTypeDef(
    _GetFindingsPaginateFiltersThreatIntelIndicatorSourceTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ThreatIntelIndicatorSource`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersThreatIntelIndicatorSourceUrlTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersThreatIntelIndicatorSourceUrlTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersThreatIntelIndicatorSourceUrlTypeDef(
    _GetFindingsPaginateFiltersThreatIntelIndicatorSourceUrlTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ThreatIntelIndicatorSourceUrl`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersThreatIntelIndicatorTypeTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersThreatIntelIndicatorTypeTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersThreatIntelIndicatorTypeTypeDef(
    _GetFindingsPaginateFiltersThreatIntelIndicatorTypeTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ThreatIntelIndicatorType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersThreatIntelIndicatorValueTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersThreatIntelIndicatorValueTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersThreatIntelIndicatorValueTypeDef(
    _GetFindingsPaginateFiltersThreatIntelIndicatorValueTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `ThreatIntelIndicatorValue`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersTitleTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersTitleTypeDef", {"Value": str, "Comparison": str}, total=False
)


class GetFindingsPaginateFiltersTitleTypeDef(_GetFindingsPaginateFiltersTitleTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `Title`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersTypeTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersTypeTypeDef", {"Value": str, "Comparison": str}, total=False
)


class GetFindingsPaginateFiltersTypeTypeDef(_GetFindingsPaginateFiltersTypeTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `Type`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersUpdatedAtDateRangeTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersUpdatedAtDateRangeTypeDef", {"Value": int, "Unit": str}, total=False
)


class GetFindingsPaginateFiltersUpdatedAtDateRangeTypeDef(
    _GetFindingsPaginateFiltersUpdatedAtDateRangeTypeDef
):
    """
    Type definition for `GetFindingsPaginateFiltersUpdatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_GetFindingsPaginateFiltersUpdatedAtTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersUpdatedAtTypeDef",
    {"Start": str, "End": str, "DateRange": GetFindingsPaginateFiltersUpdatedAtDateRangeTypeDef},
    total=False,
)


class GetFindingsPaginateFiltersUpdatedAtTypeDef(_GetFindingsPaginateFiltersUpdatedAtTypeDef):
    """
    Type definition for `GetFindingsPaginateFilters` `UpdatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_GetFindingsPaginateFiltersUserDefinedFieldsTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersUserDefinedFieldsTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersUserDefinedFieldsTypeDef(
    _GetFindingsPaginateFiltersUserDefinedFieldsTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `UserDefinedFields`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_GetFindingsPaginateFiltersVerificationStateTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersVerificationStateTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersVerificationStateTypeDef(
    _GetFindingsPaginateFiltersVerificationStateTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `VerificationState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersWorkflowStateTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersWorkflowStateTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetFindingsPaginateFiltersWorkflowStateTypeDef(
    _GetFindingsPaginateFiltersWorkflowStateTypeDef
):
    """
    Type definition for `GetFindingsPaginateFilters` `WorkflowState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetFindingsPaginateFiltersTypeDef = TypedDict(
    "_GetFindingsPaginateFiltersTypeDef",
    {
        "ProductArn": List[GetFindingsPaginateFiltersProductArnTypeDef],
        "AwsAccountId": List[GetFindingsPaginateFiltersAwsAccountIdTypeDef],
        "Id": List[GetFindingsPaginateFiltersIdTypeDef],
        "GeneratorId": List[GetFindingsPaginateFiltersGeneratorIdTypeDef],
        "Type": List[GetFindingsPaginateFiltersTypeTypeDef],
        "FirstObservedAt": List[GetFindingsPaginateFiltersFirstObservedAtTypeDef],
        "LastObservedAt": List[GetFindingsPaginateFiltersLastObservedAtTypeDef],
        "CreatedAt": List[GetFindingsPaginateFiltersCreatedAtTypeDef],
        "UpdatedAt": List[GetFindingsPaginateFiltersUpdatedAtTypeDef],
        "SeverityProduct": List[GetFindingsPaginateFiltersSeverityProductTypeDef],
        "SeverityNormalized": List[GetFindingsPaginateFiltersSeverityNormalizedTypeDef],
        "SeverityLabel": List[GetFindingsPaginateFiltersSeverityLabelTypeDef],
        "Confidence": List[GetFindingsPaginateFiltersConfidenceTypeDef],
        "Criticality": List[GetFindingsPaginateFiltersCriticalityTypeDef],
        "Title": List[GetFindingsPaginateFiltersTitleTypeDef],
        "Description": List[GetFindingsPaginateFiltersDescriptionTypeDef],
        "RecommendationText": List[GetFindingsPaginateFiltersRecommendationTextTypeDef],
        "SourceUrl": List[GetFindingsPaginateFiltersSourceUrlTypeDef],
        "ProductFields": List[GetFindingsPaginateFiltersProductFieldsTypeDef],
        "ProductName": List[GetFindingsPaginateFiltersProductNameTypeDef],
        "CompanyName": List[GetFindingsPaginateFiltersCompanyNameTypeDef],
        "UserDefinedFields": List[GetFindingsPaginateFiltersUserDefinedFieldsTypeDef],
        "MalwareName": List[GetFindingsPaginateFiltersMalwareNameTypeDef],
        "MalwareType": List[GetFindingsPaginateFiltersMalwareTypeTypeDef],
        "MalwarePath": List[GetFindingsPaginateFiltersMalwarePathTypeDef],
        "MalwareState": List[GetFindingsPaginateFiltersMalwareStateTypeDef],
        "NetworkDirection": List[GetFindingsPaginateFiltersNetworkDirectionTypeDef],
        "NetworkProtocol": List[GetFindingsPaginateFiltersNetworkProtocolTypeDef],
        "NetworkSourceIpV4": List[GetFindingsPaginateFiltersNetworkSourceIpV4TypeDef],
        "NetworkSourceIpV6": List[GetFindingsPaginateFiltersNetworkSourceIpV6TypeDef],
        "NetworkSourcePort": List[GetFindingsPaginateFiltersNetworkSourcePortTypeDef],
        "NetworkSourceDomain": List[GetFindingsPaginateFiltersNetworkSourceDomainTypeDef],
        "NetworkSourceMac": List[GetFindingsPaginateFiltersNetworkSourceMacTypeDef],
        "NetworkDestinationIpV4": List[GetFindingsPaginateFiltersNetworkDestinationIpV4TypeDef],
        "NetworkDestinationIpV6": List[GetFindingsPaginateFiltersNetworkDestinationIpV6TypeDef],
        "NetworkDestinationPort": List[GetFindingsPaginateFiltersNetworkDestinationPortTypeDef],
        "NetworkDestinationDomain": List[GetFindingsPaginateFiltersNetworkDestinationDomainTypeDef],
        "ProcessName": List[GetFindingsPaginateFiltersProcessNameTypeDef],
        "ProcessPath": List[GetFindingsPaginateFiltersProcessPathTypeDef],
        "ProcessPid": List[GetFindingsPaginateFiltersProcessPidTypeDef],
        "ProcessParentPid": List[GetFindingsPaginateFiltersProcessParentPidTypeDef],
        "ProcessLaunchedAt": List[GetFindingsPaginateFiltersProcessLaunchedAtTypeDef],
        "ProcessTerminatedAt": List[GetFindingsPaginateFiltersProcessTerminatedAtTypeDef],
        "ThreatIntelIndicatorType": List[GetFindingsPaginateFiltersThreatIntelIndicatorTypeTypeDef],
        "ThreatIntelIndicatorValue": List[
            GetFindingsPaginateFiltersThreatIntelIndicatorValueTypeDef
        ],
        "ThreatIntelIndicatorCategory": List[
            GetFindingsPaginateFiltersThreatIntelIndicatorCategoryTypeDef
        ],
        "ThreatIntelIndicatorLastObservedAt": List[
            GetFindingsPaginateFiltersThreatIntelIndicatorLastObservedAtTypeDef
        ],
        "ThreatIntelIndicatorSource": List[
            GetFindingsPaginateFiltersThreatIntelIndicatorSourceTypeDef
        ],
        "ThreatIntelIndicatorSourceUrl": List[
            GetFindingsPaginateFiltersThreatIntelIndicatorSourceUrlTypeDef
        ],
        "ResourceType": List[GetFindingsPaginateFiltersResourceTypeTypeDef],
        "ResourceId": List[GetFindingsPaginateFiltersResourceIdTypeDef],
        "ResourcePartition": List[GetFindingsPaginateFiltersResourcePartitionTypeDef],
        "ResourceRegion": List[GetFindingsPaginateFiltersResourceRegionTypeDef],
        "ResourceTags": List[GetFindingsPaginateFiltersResourceTagsTypeDef],
        "ResourceAwsEc2InstanceType": List[
            GetFindingsPaginateFiltersResourceAwsEc2InstanceTypeTypeDef
        ],
        "ResourceAwsEc2InstanceImageId": List[
            GetFindingsPaginateFiltersResourceAwsEc2InstanceImageIdTypeDef
        ],
        "ResourceAwsEc2InstanceIpV4Addresses": List[
            GetFindingsPaginateFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef
        ],
        "ResourceAwsEc2InstanceIpV6Addresses": List[
            GetFindingsPaginateFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef
        ],
        "ResourceAwsEc2InstanceKeyName": List[
            GetFindingsPaginateFiltersResourceAwsEc2InstanceKeyNameTypeDef
        ],
        "ResourceAwsEc2InstanceIamInstanceProfileArn": List[
            GetFindingsPaginateFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef
        ],
        "ResourceAwsEc2InstanceVpcId": List[
            GetFindingsPaginateFiltersResourceAwsEc2InstanceVpcIdTypeDef
        ],
        "ResourceAwsEc2InstanceSubnetId": List[
            GetFindingsPaginateFiltersResourceAwsEc2InstanceSubnetIdTypeDef
        ],
        "ResourceAwsEc2InstanceLaunchedAt": List[
            GetFindingsPaginateFiltersResourceAwsEc2InstanceLaunchedAtTypeDef
        ],
        "ResourceAwsS3BucketOwnerId": List[
            GetFindingsPaginateFiltersResourceAwsS3BucketOwnerIdTypeDef
        ],
        "ResourceAwsS3BucketOwnerName": List[
            GetFindingsPaginateFiltersResourceAwsS3BucketOwnerNameTypeDef
        ],
        "ResourceAwsIamAccessKeyUserName": List[
            GetFindingsPaginateFiltersResourceAwsIamAccessKeyUserNameTypeDef
        ],
        "ResourceAwsIamAccessKeyStatus": List[
            GetFindingsPaginateFiltersResourceAwsIamAccessKeyStatusTypeDef
        ],
        "ResourceAwsIamAccessKeyCreatedAt": List[
            GetFindingsPaginateFiltersResourceAwsIamAccessKeyCreatedAtTypeDef
        ],
        "ResourceContainerName": List[GetFindingsPaginateFiltersResourceContainerNameTypeDef],
        "ResourceContainerImageId": List[GetFindingsPaginateFiltersResourceContainerImageIdTypeDef],
        "ResourceContainerImageName": List[
            GetFindingsPaginateFiltersResourceContainerImageNameTypeDef
        ],
        "ResourceContainerLaunchedAt": List[
            GetFindingsPaginateFiltersResourceContainerLaunchedAtTypeDef
        ],
        "ResourceDetailsOther": List[GetFindingsPaginateFiltersResourceDetailsOtherTypeDef],
        "ComplianceStatus": List[GetFindingsPaginateFiltersComplianceStatusTypeDef],
        "VerificationState": List[GetFindingsPaginateFiltersVerificationStateTypeDef],
        "WorkflowState": List[GetFindingsPaginateFiltersWorkflowStateTypeDef],
        "RecordState": List[GetFindingsPaginateFiltersRecordStateTypeDef],
        "RelatedFindingsProductArn": List[
            GetFindingsPaginateFiltersRelatedFindingsProductArnTypeDef
        ],
        "RelatedFindingsId": List[GetFindingsPaginateFiltersRelatedFindingsIdTypeDef],
        "NoteText": List[GetFindingsPaginateFiltersNoteTextTypeDef],
        "NoteUpdatedAt": List[GetFindingsPaginateFiltersNoteUpdatedAtTypeDef],
        "NoteUpdatedBy": List[GetFindingsPaginateFiltersNoteUpdatedByTypeDef],
        "Keyword": List[GetFindingsPaginateFiltersKeywordTypeDef],
    },
    total=False,
)


class GetFindingsPaginateFiltersTypeDef(_GetFindingsPaginateFiltersTypeDef):
    """
    Type definition for `GetFindingsPaginate` `Filters`

    The findings attributes used to define a condition to filter the findings returned.

    - **ProductArn** *(list) --*

      The ARN generated by Security Hub that uniquely identifies a third-party company (security
      findings provider) after this provider's product (solution that generates findings) is
      registered with Security Hub.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **AwsAccountId** *(list) --*

      The AWS account ID that a finding is generated in.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Id** *(list) --*

      The security findings provider-specific identifier for a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **GeneratorId** *(list) --*

      The identifier for the solution-specific component (a discrete unit of logic) that generated a
      finding. In various security-findings providers' solutions, this generator can be called a
      rule, a check, a detector, a plug-in, etc.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Type** *(list) --*

      A finding type in the format of ``namespace/category/classifier`` that classifies a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **FirstObservedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider first
      observed the potential security issue that a finding captured.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **LastObservedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider most
      recently observed the potential security issue that a finding captured.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **CreatedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider captured the
      potential security issue that a finding captured.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **UpdatedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider last updated
      the finding record.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **SeverityProduct** *(list) --*

      The native severity as defined by the security-findings provider's solution that generated the
      finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **SeverityNormalized** *(list) --*

      The normalized severity of a finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **SeverityLabel** *(list) --*

      The label of a finding's severity.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Confidence** *(list) --*

      A finding's confidence. Confidence is defined as the likelihood that a finding accurately
      identifies the behavior or issue that it was intended to identify. Confidence is scored on a
      0-100 basis using a ratio scale, where 0 means zero percent confidence and 100 means 100
      percent confidence.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **Criticality** *(list) --*

      The level of importance assigned to the resources associated with the finding. A score of 0
      means that the underlying resources have no criticality, and a score of 100 is reserved for
      the most critical resources.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **Title** *(list) --*

      A finding's title.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Description** *(list) --*

      A finding's description.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RecommendationText** *(list) --*

      The recommendation of what to do about the issue described in a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **SourceUrl** *(list) --*

      A URL that links to a page about the current finding in the security-findings provider's
      solution.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProductFields** *(list) --*

      A data type where security-findings providers can include additional solution-specific details
      that aren't part of the defined ``AwsSecurityFinding`` format.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **ProductName** *(list) --*

      The name of the solution (product) that generates findings.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **CompanyName** *(list) --*

      The name of the findings provider (company) that owns the solution (product) that generates
      findings.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **UserDefinedFields** *(list) --*

      A list of name/value string pairs associated with the finding. These are custom, user-defined
      fields added to a finding.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **MalwareName** *(list) --*

      The name of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **MalwareType** *(list) --*

      The type of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **MalwarePath** *(list) --*

      The filesystem path of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **MalwareState** *(list) --*

      The state of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkDirection** *(list) --*

      Indicates the direction of network traffic associated with a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkProtocol** *(list) --*

      The protocol of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkSourceIpV4** *(list) --*

      The source IPv4 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkSourceIpV6** *(list) --*

      The source IPv6 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkSourcePort** *(list) --*

      The source port of network-related information about a finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **NetworkSourceDomain** *(list) --*

      The source domain of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkSourceMac** *(list) --*

      The source media access control (MAC) address of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkDestinationIpV4** *(list) --*

      The destination IPv4 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkDestinationIpV6** *(list) --*

      The destination IPv6 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkDestinationPort** *(list) --*

      The destination port of network-related information about a finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **NetworkDestinationDomain** *(list) --*

      The destination domain of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProcessName** *(list) --*

      The name of the process.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProcessPath** *(list) --*

      The path to the process executable.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProcessPid** *(list) --*

      The process ID.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **ProcessParentPid** *(list) --*

      The parent process ID.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **ProcessLaunchedAt** *(list) --*

      The date/time that the process was launched.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ProcessTerminatedAt** *(list) --*

      The date/time that the process was terminated.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ThreatIntelIndicatorType** *(list) --*

      The type of a threat intel indicator.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorValue** *(list) --*

      The value of a threat intel indicator.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorCategory** *(list) --*

      The category of a threat intel indicator.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorLastObservedAt** *(list) --*

      The date/time of the last observation of a threat intel indicator.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ThreatIntelIndicatorSource** *(list) --*

      The source of the threat intel.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorSourceUrl** *(list) --*

      The URL for more details from the source of the threat intel.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceType** *(list) --*

      Specifies the type of the resource that details are provided for.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceId** *(list) --*

      The canonical identifier for the given resource type.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourcePartition** *(list) --*

      The canonical AWS partition name that the Region is assigned to.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceRegion** *(list) --*

      The canonical AWS external Region name where this resource is located.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceTags** *(list) --*

      A list of AWS tags associated with a resource at the time the finding was processed.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **ResourceAwsEc2InstanceType** *(list) --*

      The instance type of the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceImageId** *(list) --*

      The Amazon Machine Image (AMI) ID of the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceIpV4Addresses** *(list) --*

      The IPv4 addresses associated with the instance.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **ResourceAwsEc2InstanceIpV6Addresses** *(list) --*

      The IPv6 addresses associated with the instance.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **ResourceAwsEc2InstanceKeyName** *(list) --*

      The key name associated with the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceIamInstanceProfileArn** *(list) --*

      The IAM profile ARN of the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceVpcId** *(list) --*

      The identifier of the VPC that the instance was launched in.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceSubnetId** *(list) --*

      The identifier of the subnet that the instance was launched in.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceLaunchedAt** *(list) --*

      The date/time the instance was launched.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ResourceAwsS3BucketOwnerId** *(list) --*

      The canonical user ID of the owner of the S3 bucket.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsS3BucketOwnerName** *(list) --*

      The display name of the owner of the S3 bucket.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsIamAccessKeyUserName** *(list) --*

      The user associated with the IAM access key related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsIamAccessKeyStatus** *(list) --*

      The status of the IAM access key related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsIamAccessKeyCreatedAt** *(list) --*

      The creation date/time of the IAM access key related to a finding.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ResourceContainerName** *(list) --*

      The name of the container related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceContainerImageId** *(list) --*

      The identifier of the image related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceContainerImageName** *(list) --*

      The name of the image related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceContainerLaunchedAt** *(list) --*

      The date/time that the container was started.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ResourceDetailsOther** *(list) --*

      The details of a resource that doesn't have a specific subfield for the resource type defined.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **ComplianceStatus** *(list) --*

      Exclusive to findings that are generated as the result of a check run against a specific rule
      in a supported standard (for example, CIS AWS Foundations). Contains compliance-related
      finding details.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **VerificationState** *(list) --*

      The veracity of a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **WorkflowState** *(list) --*

      The workflow state of a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RecordState** *(list) --*

      The updated record state for the finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RelatedFindingsProductArn** *(list) --*

      The ARN of the solution that generated a related finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RelatedFindingsId** *(list) --*

      The solution-generated identifier for a related finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NoteText** *(list) --*

      The text of a note.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NoteUpdatedAt** *(list) --*

      The timestamp of when the note was updated.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **NoteUpdatedBy** *(list) --*

      The principal that created a note.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Keyword** *(list) --*

      A keyword for a finding.

      - *(dict) --*

        A keyword filter for querying findings.

        - **Value** *(string) --*

          A value for the keyword.
    """


_GetFindingsPaginatePaginationConfigTypeDef = TypedDict(
    "_GetFindingsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class GetFindingsPaginatePaginationConfigTypeDef(_GetFindingsPaginatePaginationConfigTypeDef):
    """
    Type definition for `GetFindingsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_GetFindingsPaginateResponseFindingsComplianceTypeDef = TypedDict(
    "_GetFindingsPaginateResponseFindingsComplianceTypeDef", {"Status": str}, total=False
)


class GetFindingsPaginateResponseFindingsComplianceTypeDef(
    _GetFindingsPaginateResponseFindingsComplianceTypeDef
):
    """
    Type definition for `GetFindingsPaginateResponseFindings` `Compliance`

    This data type is exclusive to findings that are generated as the result of a check run against
    a specific rule in a supported standard (for example, CIS AWS Foundations). Contains
    compliance-related finding details.

    - **Status** *(string) --*

      The result of a compliance check.
    """


_GetFindingsPaginateResponseFindingsMalwareTypeDef = TypedDict(
    "_GetFindingsPaginateResponseFindingsMalwareTypeDef",
    {"Name": str, "Type": str, "Path": str, "State": str},
    total=False,
)


class GetFindingsPaginateResponseFindingsMalwareTypeDef(
    _GetFindingsPaginateResponseFindingsMalwareTypeDef
):
    """
    Type definition for `GetFindingsPaginateResponseFindings` `Malware`

    A list of malware related to a finding.

    - **Name** *(string) --*

      The name of the malware that was observed.

    - **Type** *(string) --*

      The type of the malware that was observed.

    - **Path** *(string) --*

      The file system path of the malware that was observed.

    - **State** *(string) --*

      The state of the malware that was observed.
    """


_GetFindingsPaginateResponseFindingsNetworkTypeDef = TypedDict(
    "_GetFindingsPaginateResponseFindingsNetworkTypeDef",
    {
        "Direction": str,
        "Protocol": str,
        "SourceIpV4": str,
        "SourceIpV6": str,
        "SourcePort": int,
        "SourceDomain": str,
        "SourceMac": str,
        "DestinationIpV4": str,
        "DestinationIpV6": str,
        "DestinationPort": int,
        "DestinationDomain": str,
    },
    total=False,
)


class GetFindingsPaginateResponseFindingsNetworkTypeDef(
    _GetFindingsPaginateResponseFindingsNetworkTypeDef
):
    """
    Type definition for `GetFindingsPaginateResponseFindings` `Network`

    The details of network-related information about a finding.

    - **Direction** *(string) --*

      The direction of network traffic associated with a finding.

    - **Protocol** *(string) --*

      The protocol of network-related information about a finding.

    - **SourceIpV4** *(string) --*

      The source IPv4 address of network-related information about a finding.

    - **SourceIpV6** *(string) --*

      The source IPv6 address of network-related information about a finding.

    - **SourcePort** *(integer) --*

      The source port of network-related information about a finding.

    - **SourceDomain** *(string) --*

      The source domain of network-related information about a finding.

    - **SourceMac** *(string) --*

      The source media access control (MAC) address of network-related information about a finding.

    - **DestinationIpV4** *(string) --*

      The destination IPv4 address of network-related information about a finding.

    - **DestinationIpV6** *(string) --*

      The destination IPv6 address of network-related information about a finding.

    - **DestinationPort** *(integer) --*

      The destination port of network-related information about a finding.

    - **DestinationDomain** *(string) --*

      The destination domain of network-related information about a finding.
    """


_GetFindingsPaginateResponseFindingsNoteTypeDef = TypedDict(
    "_GetFindingsPaginateResponseFindingsNoteTypeDef",
    {"Text": str, "UpdatedBy": str, "UpdatedAt": str},
    total=False,
)


class GetFindingsPaginateResponseFindingsNoteTypeDef(
    _GetFindingsPaginateResponseFindingsNoteTypeDef
):
    """
    Type definition for `GetFindingsPaginateResponseFindings` `Note`

    A user-defined note added to a finding.

    - **Text** *(string) --*

      The text of a note.

    - **UpdatedBy** *(string) --*

      The principal that created a note.

    - **UpdatedAt** *(string) --*

      The timestamp of when the note was updated.
    """


_GetFindingsPaginateResponseFindingsProcessTypeDef = TypedDict(
    "_GetFindingsPaginateResponseFindingsProcessTypeDef",
    {
        "Name": str,
        "Path": str,
        "Pid": int,
        "ParentPid": int,
        "LaunchedAt": str,
        "TerminatedAt": str,
    },
    total=False,
)


class GetFindingsPaginateResponseFindingsProcessTypeDef(
    _GetFindingsPaginateResponseFindingsProcessTypeDef
):
    """
    Type definition for `GetFindingsPaginateResponseFindings` `Process`

    The details of process-related information about a finding.

    - **Name** *(string) --*

      The name of the process.

    - **Path** *(string) --*

      The path to the process executable.

    - **Pid** *(integer) --*

      The process ID.

    - **ParentPid** *(integer) --*

      The parent process ID.

    - **LaunchedAt** *(string) --*

      The date/time that the process was launched.

    - **TerminatedAt** *(string) --*

      The date and time when the process was terminated.
    """


_GetFindingsPaginateResponseFindingsRelatedFindingsTypeDef = TypedDict(
    "_GetFindingsPaginateResponseFindingsRelatedFindingsTypeDef",
    {"ProductArn": str, "Id": str},
    total=False,
)


class GetFindingsPaginateResponseFindingsRelatedFindingsTypeDef(
    _GetFindingsPaginateResponseFindingsRelatedFindingsTypeDef
):
    """
    Type definition for `GetFindingsPaginateResponseFindings` `RelatedFindings`

    Details about a related finding.

    - **ProductArn** *(string) --*

      The ARN of the product that generated a related finding.

    - **Id** *(string) --*

      The product-generated identifier for a related finding.
    """


_GetFindingsPaginateResponseFindingsRemediationRecommendationTypeDef = TypedDict(
    "_GetFindingsPaginateResponseFindingsRemediationRecommendationTypeDef",
    {"Text": str, "Url": str},
    total=False,
)


class GetFindingsPaginateResponseFindingsRemediationRecommendationTypeDef(
    _GetFindingsPaginateResponseFindingsRemediationRecommendationTypeDef
):
    """
    Type definition for `GetFindingsPaginateResponseFindingsRemediation` `Recommendation`

    A recommendation on the steps to take to remediate the issue identified by a finding.

    - **Text** *(string) --*

      Describes the recommended steps to take to remediate an issue identified in a finding.

    - **Url** *(string) --*

      A URL to a page or site that contains information about how to remediate a finding.
    """


_GetFindingsPaginateResponseFindingsRemediationTypeDef = TypedDict(
    "_GetFindingsPaginateResponseFindingsRemediationTypeDef",
    {"Recommendation": GetFindingsPaginateResponseFindingsRemediationRecommendationTypeDef},
    total=False,
)


class GetFindingsPaginateResponseFindingsRemediationTypeDef(
    _GetFindingsPaginateResponseFindingsRemediationTypeDef
):
    """
    Type definition for `GetFindingsPaginateResponseFindings` `Remediation`

    A data type that describes the remediation options for a finding.

    - **Recommendation** *(dict) --*

      A recommendation on the steps to take to remediate the issue identified by a finding.

      - **Text** *(string) --*

        Describes the recommended steps to take to remediate an issue identified in a finding.

      - **Url** *(string) --*

        A URL to a page or site that contains information about how to remediate a finding.
    """


_GetFindingsPaginateResponseFindingsResourcesDetailsAwsEc2InstanceTypeDef = TypedDict(
    "_GetFindingsPaginateResponseFindingsResourcesDetailsAwsEc2InstanceTypeDef",
    {
        "Type": str,
        "ImageId": str,
        "IpV4Addresses": List[str],
        "IpV6Addresses": List[str],
        "KeyName": str,
        "IamInstanceProfileArn": str,
        "VpcId": str,
        "SubnetId": str,
        "LaunchedAt": str,
    },
    total=False,
)


class GetFindingsPaginateResponseFindingsResourcesDetailsAwsEc2InstanceTypeDef(
    _GetFindingsPaginateResponseFindingsResourcesDetailsAwsEc2InstanceTypeDef
):
    """
    Type definition for `GetFindingsPaginateResponseFindingsResourcesDetails` `AwsEc2Instance`

    Details about an Amazon EC2 instance related to a finding.

    - **Type** *(string) --*

      The instance type of the instance.

    - **ImageId** *(string) --*

      The Amazon Machine Image (AMI) ID of the instance.

    - **IpV4Addresses** *(list) --*

      The IPv4 addresses associated with the instance.

      - *(string) --*

    - **IpV6Addresses** *(list) --*

      The IPv6 addresses associated with the instance.

      - *(string) --*

    - **KeyName** *(string) --*

      The key name associated with the instance.

    - **IamInstanceProfileArn** *(string) --*

      The IAM profile ARN of the instance.

    - **VpcId** *(string) --*

      The identifier of the VPC that the instance was launched in.

    - **SubnetId** *(string) --*

      The identifier of the subnet that the instance was launched in.

    - **LaunchedAt** *(string) --*

      The date/time the instance was launched.
    """


_GetFindingsPaginateResponseFindingsResourcesDetailsAwsIamAccessKeyTypeDef = TypedDict(
    "_GetFindingsPaginateResponseFindingsResourcesDetailsAwsIamAccessKeyTypeDef",
    {"UserName": str, "Status": str, "CreatedAt": str},
    total=False,
)


class GetFindingsPaginateResponseFindingsResourcesDetailsAwsIamAccessKeyTypeDef(
    _GetFindingsPaginateResponseFindingsResourcesDetailsAwsIamAccessKeyTypeDef
):
    """
    Type definition for `GetFindingsPaginateResponseFindingsResourcesDetails` `AwsIamAccessKey`

    Details about an IAM access key related to a finding.

    - **UserName** *(string) --*

      The user associated with the IAM access key related to a finding.

    - **Status** *(string) --*

      The status of the IAM access key related to a finding.

    - **CreatedAt** *(string) --*

      The creation date/time of the IAM access key related to a finding.
    """


_GetFindingsPaginateResponseFindingsResourcesDetailsAwsS3BucketTypeDef = TypedDict(
    "_GetFindingsPaginateResponseFindingsResourcesDetailsAwsS3BucketTypeDef",
    {"OwnerId": str, "OwnerName": str},
    total=False,
)


class GetFindingsPaginateResponseFindingsResourcesDetailsAwsS3BucketTypeDef(
    _GetFindingsPaginateResponseFindingsResourcesDetailsAwsS3BucketTypeDef
):
    """
    Type definition for `GetFindingsPaginateResponseFindingsResourcesDetails` `AwsS3Bucket`

    Details about an Amazon S3 Bucket related to a finding.

    - **OwnerId** *(string) --*

      The canonical user ID of the owner of the S3 bucket.

    - **OwnerName** *(string) --*

      The display name of the owner of the S3 bucket.
    """


_GetFindingsPaginateResponseFindingsResourcesDetailsContainerTypeDef = TypedDict(
    "_GetFindingsPaginateResponseFindingsResourcesDetailsContainerTypeDef",
    {"Name": str, "ImageId": str, "ImageName": str, "LaunchedAt": str},
    total=False,
)


class GetFindingsPaginateResponseFindingsResourcesDetailsContainerTypeDef(
    _GetFindingsPaginateResponseFindingsResourcesDetailsContainerTypeDef
):
    """
    Type definition for `GetFindingsPaginateResponseFindingsResourcesDetails` `Container`

    Details about a container resource related to a finding.

    - **Name** *(string) --*

      The name of the container related to a finding.

    - **ImageId** *(string) --*

      The identifier of the image related to a finding.

    - **ImageName** *(string) --*

      The name of the image related to a finding.

    - **LaunchedAt** *(string) --*

      The date and time when the container started.
    """


_GetFindingsPaginateResponseFindingsResourcesDetailsTypeDef = TypedDict(
    "_GetFindingsPaginateResponseFindingsResourcesDetailsTypeDef",
    {
        "AwsEc2Instance": GetFindingsPaginateResponseFindingsResourcesDetailsAwsEc2InstanceTypeDef,
        "AwsS3Bucket": GetFindingsPaginateResponseFindingsResourcesDetailsAwsS3BucketTypeDef,
        "AwsIamAccessKey": GetFindingsPaginateResponseFindingsResourcesDetailsAwsIamAccessKeyTypeDef,
        "Container": GetFindingsPaginateResponseFindingsResourcesDetailsContainerTypeDef,
        "Other": Dict[str, str],
    },
    total=False,
)


class GetFindingsPaginateResponseFindingsResourcesDetailsTypeDef(
    _GetFindingsPaginateResponseFindingsResourcesDetailsTypeDef
):
    """
    Type definition for `GetFindingsPaginateResponseFindingsResources` `Details`

    Additional details about the resource related to a finding.

    - **AwsEc2Instance** *(dict) --*

      Details about an Amazon EC2 instance related to a finding.

      - **Type** *(string) --*

        The instance type of the instance.

      - **ImageId** *(string) --*

        The Amazon Machine Image (AMI) ID of the instance.

      - **IpV4Addresses** *(list) --*

        The IPv4 addresses associated with the instance.

        - *(string) --*

      - **IpV6Addresses** *(list) --*

        The IPv6 addresses associated with the instance.

        - *(string) --*

      - **KeyName** *(string) --*

        The key name associated with the instance.

      - **IamInstanceProfileArn** *(string) --*

        The IAM profile ARN of the instance.

      - **VpcId** *(string) --*

        The identifier of the VPC that the instance was launched in.

      - **SubnetId** *(string) --*

        The identifier of the subnet that the instance was launched in.

      - **LaunchedAt** *(string) --*

        The date/time the instance was launched.

    - **AwsS3Bucket** *(dict) --*

      Details about an Amazon S3 Bucket related to a finding.

      - **OwnerId** *(string) --*

        The canonical user ID of the owner of the S3 bucket.

      - **OwnerName** *(string) --*

        The display name of the owner of the S3 bucket.

    - **AwsIamAccessKey** *(dict) --*

      Details about an IAM access key related to a finding.

      - **UserName** *(string) --*

        The user associated with the IAM access key related to a finding.

      - **Status** *(string) --*

        The status of the IAM access key related to a finding.

      - **CreatedAt** *(string) --*

        The creation date/time of the IAM access key related to a finding.

    - **Container** *(dict) --*

      Details about a container resource related to a finding.

      - **Name** *(string) --*

        The name of the container related to a finding.

      - **ImageId** *(string) --*

        The identifier of the image related to a finding.

      - **ImageName** *(string) --*

        The name of the image related to a finding.

      - **LaunchedAt** *(string) --*

        The date and time when the container started.

    - **Other** *(dict) --*

      Details about a resource that doesn't have a specific type defined.

      - *(string) --*

        - *(string) --*
    """


_GetFindingsPaginateResponseFindingsResourcesTypeDef = TypedDict(
    "_GetFindingsPaginateResponseFindingsResourcesTypeDef",
    {
        "Type": str,
        "Id": str,
        "Partition": str,
        "Region": str,
        "Tags": Dict[str, str],
        "Details": GetFindingsPaginateResponseFindingsResourcesDetailsTypeDef,
    },
    total=False,
)


class GetFindingsPaginateResponseFindingsResourcesTypeDef(
    _GetFindingsPaginateResponseFindingsResourcesTypeDef
):
    """
    Type definition for `GetFindingsPaginateResponseFindings` `Resources`

    A resource related to a finding.

    - **Type** *(string) --*

      The type of the resource that details are provided for.

    - **Id** *(string) --*

      The canonical identifier for the given resource type.

    - **Partition** *(string) --*

      The canonical AWS partition name that the Region is assigned to.

    - **Region** *(string) --*

      The canonical AWS external Region name where this resource is located.

    - **Tags** *(dict) --*

      A list of AWS tags associated with a resource at the time the finding was processed.

      - *(string) --*

        - *(string) --*

    - **Details** *(dict) --*

      Additional details about the resource related to a finding.

      - **AwsEc2Instance** *(dict) --*

        Details about an Amazon EC2 instance related to a finding.

        - **Type** *(string) --*

          The instance type of the instance.

        - **ImageId** *(string) --*

          The Amazon Machine Image (AMI) ID of the instance.

        - **IpV4Addresses** *(list) --*

          The IPv4 addresses associated with the instance.

          - *(string) --*

        - **IpV6Addresses** *(list) --*

          The IPv6 addresses associated with the instance.

          - *(string) --*

        - **KeyName** *(string) --*

          The key name associated with the instance.

        - **IamInstanceProfileArn** *(string) --*

          The IAM profile ARN of the instance.

        - **VpcId** *(string) --*

          The identifier of the VPC that the instance was launched in.

        - **SubnetId** *(string) --*

          The identifier of the subnet that the instance was launched in.

        - **LaunchedAt** *(string) --*

          The date/time the instance was launched.

      - **AwsS3Bucket** *(dict) --*

        Details about an Amazon S3 Bucket related to a finding.

        - **OwnerId** *(string) --*

          The canonical user ID of the owner of the S3 bucket.

        - **OwnerName** *(string) --*

          The display name of the owner of the S3 bucket.

      - **AwsIamAccessKey** *(dict) --*

        Details about an IAM access key related to a finding.

        - **UserName** *(string) --*

          The user associated with the IAM access key related to a finding.

        - **Status** *(string) --*

          The status of the IAM access key related to a finding.

        - **CreatedAt** *(string) --*

          The creation date/time of the IAM access key related to a finding.

      - **Container** *(dict) --*

        Details about a container resource related to a finding.

        - **Name** *(string) --*

          The name of the container related to a finding.

        - **ImageId** *(string) --*

          The identifier of the image related to a finding.

        - **ImageName** *(string) --*

          The name of the image related to a finding.

        - **LaunchedAt** *(string) --*

          The date and time when the container started.

      - **Other** *(dict) --*

        Details about a resource that doesn't have a specific type defined.

        - *(string) --*

          - *(string) --*
    """


_GetFindingsPaginateResponseFindingsSeverityTypeDef = TypedDict(
    "_GetFindingsPaginateResponseFindingsSeverityTypeDef",
    {"Product": float, "Normalized": int},
    total=False,
)


class GetFindingsPaginateResponseFindingsSeverityTypeDef(
    _GetFindingsPaginateResponseFindingsSeverityTypeDef
):
    """
    Type definition for `GetFindingsPaginateResponseFindings` `Severity`

    A finding's severity.

    - **Product** *(float) --*

      The native severity as defined by the AWS service or integrated partner product that generated
      the finding.

    - **Normalized** *(integer) --*

      The normalized severity of a finding.
    """


_GetFindingsPaginateResponseFindingsThreatIntelIndicatorsTypeDef = TypedDict(
    "_GetFindingsPaginateResponseFindingsThreatIntelIndicatorsTypeDef",
    {
        "Type": str,
        "Value": str,
        "Category": str,
        "LastObservedAt": str,
        "Source": str,
        "SourceUrl": str,
    },
    total=False,
)


class GetFindingsPaginateResponseFindingsThreatIntelIndicatorsTypeDef(
    _GetFindingsPaginateResponseFindingsThreatIntelIndicatorsTypeDef
):
    """
    Type definition for `GetFindingsPaginateResponseFindings` `ThreatIntelIndicators`

    Details about the threat intel related to a finding.

    - **Type** *(string) --*

      The type of a threat intel indicator.

    - **Value** *(string) --*

      The value of a threat intel indicator.

    - **Category** *(string) --*

      The category of a threat intel indicator.

    - **LastObservedAt** *(string) --*

      The date and time when the most recent instance of a threat intel indicator was observed.

    - **Source** *(string) --*

      The source of the threat intel indicator.

    - **SourceUrl** *(string) --*

      The URL to the page or site where you can get more information about the threat intel
      indicator.
    """


_GetFindingsPaginateResponseFindingsTypeDef = TypedDict(
    "_GetFindingsPaginateResponseFindingsTypeDef",
    {
        "SchemaVersion": str,
        "Id": str,
        "ProductArn": str,
        "GeneratorId": str,
        "AwsAccountId": str,
        "Types": List[str],
        "FirstObservedAt": str,
        "LastObservedAt": str,
        "CreatedAt": str,
        "UpdatedAt": str,
        "Severity": GetFindingsPaginateResponseFindingsSeverityTypeDef,
        "Confidence": int,
        "Criticality": int,
        "Title": str,
        "Description": str,
        "Remediation": GetFindingsPaginateResponseFindingsRemediationTypeDef,
        "SourceUrl": str,
        "ProductFields": Dict[str, str],
        "UserDefinedFields": Dict[str, str],
        "Malware": List[GetFindingsPaginateResponseFindingsMalwareTypeDef],
        "Network": GetFindingsPaginateResponseFindingsNetworkTypeDef,
        "Process": GetFindingsPaginateResponseFindingsProcessTypeDef,
        "ThreatIntelIndicators": List[
            GetFindingsPaginateResponseFindingsThreatIntelIndicatorsTypeDef
        ],
        "Resources": List[GetFindingsPaginateResponseFindingsResourcesTypeDef],
        "Compliance": GetFindingsPaginateResponseFindingsComplianceTypeDef,
        "VerificationState": str,
        "WorkflowState": str,
        "RecordState": str,
        "RelatedFindings": List[GetFindingsPaginateResponseFindingsRelatedFindingsTypeDef],
        "Note": GetFindingsPaginateResponseFindingsNoteTypeDef,
    },
    total=False,
)


class GetFindingsPaginateResponseFindingsTypeDef(_GetFindingsPaginateResponseFindingsTypeDef):
    """
    Type definition for `GetFindingsPaginateResponse` `Findings`

    Provides consistent format for the contents of the Security Hub-aggregated findings.
    ``AwsSecurityFinding`` format enables you to share findings between AWS security services and
    third-party solutions, and compliance checks.

    .. note::

      A finding is a potential security issue generated either by AWS services (Amazon GuardDuty,
      Amazon Inspector, and Amazon Macie) or by the integrated third-party solutions and compliance
      checks.

    - **SchemaVersion** *(string) --*

      The schema version that a finding is formatted for.

    - **Id** *(string) --*

      The security findings provider-specific identifier for a finding.

    - **ProductArn** *(string) --*

      The ARN generated by Security Hub that uniquely identifies a third-party company
      (security-findings provider) after this provider's product (solution that generates findings)
      is registered with Security Hub.

    - **GeneratorId** *(string) --*

      The identifier for the solution-specific component (a discrete unit of logic) that generated a
      finding. In various security-findings providers' solutions, this generator can be called a
      rule, a check, a detector, a plug-in, etc.

    - **AwsAccountId** *(string) --*

      The AWS account ID that a finding is generated in.

    - **Types** *(list) --*

      One or more finding types in the format of ``namespace/category/classifier`` that classify a
      finding.

      Valid namespace values are: Software and Configuration Checks | TTPs | Effects | Unusual
      Behaviors | Sensitive Data Identifications

      - *(string) --*

    - **FirstObservedAt** *(string) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider first
      observed the potential security issue that a finding captured.

    - **LastObservedAt** *(string) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider most
      recently observed the potential security issue that a finding captured.

    - **CreatedAt** *(string) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider created the
      potential security issue that a finding captured.

    - **UpdatedAt** *(string) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider last updated
      the finding record.

    - **Severity** *(dict) --*

      A finding's severity.

      - **Product** *(float) --*

        The native severity as defined by the AWS service or integrated partner product that
        generated the finding.

      - **Normalized** *(integer) --*

        The normalized severity of a finding.

    - **Confidence** *(integer) --*

      A finding's confidence. Confidence is defined as the likelihood that a finding accurately
      identifies the behavior or issue that it was intended to identify. Confidence is scored on a
      0-100 basis using a ratio scale, where 0 means zero percent confidence and 100 means 100
      percent confidence.

    - **Criticality** *(integer) --*

      The level of importance assigned to the resources associated with the finding. A score of 0
      means that the underlying resources have no criticality, and a score of 100 is reserved for
      the most critical resources.

    - **Title** *(string) --*

      A finding's title.

      .. note::

        In this release, ``Title`` is a required property.

    - **Description** *(string) --*

      A finding's description.

      .. note::

        In this release, ``Description`` is a required property.

    - **Remediation** *(dict) --*

      A data type that describes the remediation options for a finding.

      - **Recommendation** *(dict) --*

        A recommendation on the steps to take to remediate the issue identified by a finding.

        - **Text** *(string) --*

          Describes the recommended steps to take to remediate an issue identified in a finding.

        - **Url** *(string) --*

          A URL to a page or site that contains information about how to remediate a finding.

    - **SourceUrl** *(string) --*

      A URL that links to a page about the current finding in the security-findings provider's
      solution.

    - **ProductFields** *(dict) --*

      A data type where security-findings providers can include additional solution-specific details
      that aren't part of the defined ``AwsSecurityFinding`` format.

      - *(string) --*

        - *(string) --*

    - **UserDefinedFields** *(dict) --*

      A list of name/value string pairs associated with the finding. These are custom, user-defined
      fields added to a finding.

      - *(string) --*

        - *(string) --*

    - **Malware** *(list) --*

      A list of malware related to a finding.

      - *(dict) --*

        A list of malware related to a finding.

        - **Name** *(string) --*

          The name of the malware that was observed.

        - **Type** *(string) --*

          The type of the malware that was observed.

        - **Path** *(string) --*

          The file system path of the malware that was observed.

        - **State** *(string) --*

          The state of the malware that was observed.

    - **Network** *(dict) --*

      The details of network-related information about a finding.

      - **Direction** *(string) --*

        The direction of network traffic associated with a finding.

      - **Protocol** *(string) --*

        The protocol of network-related information about a finding.

      - **SourceIpV4** *(string) --*

        The source IPv4 address of network-related information about a finding.

      - **SourceIpV6** *(string) --*

        The source IPv6 address of network-related information about a finding.

      - **SourcePort** *(integer) --*

        The source port of network-related information about a finding.

      - **SourceDomain** *(string) --*

        The source domain of network-related information about a finding.

      - **SourceMac** *(string) --*

        The source media access control (MAC) address of network-related information about a
        finding.

      - **DestinationIpV4** *(string) --*

        The destination IPv4 address of network-related information about a finding.

      - **DestinationIpV6** *(string) --*

        The destination IPv6 address of network-related information about a finding.

      - **DestinationPort** *(integer) --*

        The destination port of network-related information about a finding.

      - **DestinationDomain** *(string) --*

        The destination domain of network-related information about a finding.

    - **Process** *(dict) --*

      The details of process-related information about a finding.

      - **Name** *(string) --*

        The name of the process.

      - **Path** *(string) --*

        The path to the process executable.

      - **Pid** *(integer) --*

        The process ID.

      - **ParentPid** *(integer) --*

        The parent process ID.

      - **LaunchedAt** *(string) --*

        The date/time that the process was launched.

      - **TerminatedAt** *(string) --*

        The date and time when the process was terminated.

    - **ThreatIntelIndicators** *(list) --*

      Threat intel details related to a finding.

      - *(dict) --*

        Details about the threat intel related to a finding.

        - **Type** *(string) --*

          The type of a threat intel indicator.

        - **Value** *(string) --*

          The value of a threat intel indicator.

        - **Category** *(string) --*

          The category of a threat intel indicator.

        - **LastObservedAt** *(string) --*

          The date and time when the most recent instance of a threat intel indicator was observed.

        - **Source** *(string) --*

          The source of the threat intel indicator.

        - **SourceUrl** *(string) --*

          The URL to the page or site where you can get more information about the threat intel
          indicator.

    - **Resources** *(list) --*

      A set of resource data types that describe the resources that the finding refers to.

      - *(dict) --*

        A resource related to a finding.

        - **Type** *(string) --*

          The type of the resource that details are provided for.

        - **Id** *(string) --*

          The canonical identifier for the given resource type.

        - **Partition** *(string) --*

          The canonical AWS partition name that the Region is assigned to.

        - **Region** *(string) --*

          The canonical AWS external Region name where this resource is located.

        - **Tags** *(dict) --*

          A list of AWS tags associated with a resource at the time the finding was processed.

          - *(string) --*

            - *(string) --*

        - **Details** *(dict) --*

          Additional details about the resource related to a finding.

          - **AwsEc2Instance** *(dict) --*

            Details about an Amazon EC2 instance related to a finding.

            - **Type** *(string) --*

              The instance type of the instance.

            - **ImageId** *(string) --*

              The Amazon Machine Image (AMI) ID of the instance.

            - **IpV4Addresses** *(list) --*

              The IPv4 addresses associated with the instance.

              - *(string) --*

            - **IpV6Addresses** *(list) --*

              The IPv6 addresses associated with the instance.

              - *(string) --*

            - **KeyName** *(string) --*

              The key name associated with the instance.

            - **IamInstanceProfileArn** *(string) --*

              The IAM profile ARN of the instance.

            - **VpcId** *(string) --*

              The identifier of the VPC that the instance was launched in.

            - **SubnetId** *(string) --*

              The identifier of the subnet that the instance was launched in.

            - **LaunchedAt** *(string) --*

              The date/time the instance was launched.

          - **AwsS3Bucket** *(dict) --*

            Details about an Amazon S3 Bucket related to a finding.

            - **OwnerId** *(string) --*

              The canonical user ID of the owner of the S3 bucket.

            - **OwnerName** *(string) --*

              The display name of the owner of the S3 bucket.

          - **AwsIamAccessKey** *(dict) --*

            Details about an IAM access key related to a finding.

            - **UserName** *(string) --*

              The user associated with the IAM access key related to a finding.

            - **Status** *(string) --*

              The status of the IAM access key related to a finding.

            - **CreatedAt** *(string) --*

              The creation date/time of the IAM access key related to a finding.

          - **Container** *(dict) --*

            Details about a container resource related to a finding.

            - **Name** *(string) --*

              The name of the container related to a finding.

            - **ImageId** *(string) --*

              The identifier of the image related to a finding.

            - **ImageName** *(string) --*

              The name of the image related to a finding.

            - **LaunchedAt** *(string) --*

              The date and time when the container started.

          - **Other** *(dict) --*

            Details about a resource that doesn't have a specific type defined.

            - *(string) --*

              - *(string) --*

    - **Compliance** *(dict) --*

      This data type is exclusive to findings that are generated as the result of a check run
      against a specific rule in a supported standard (for example, CIS AWS Foundations). Contains
      compliance-related finding details.

      - **Status** *(string) --*

        The result of a compliance check.

    - **VerificationState** *(string) --*

      Indicates the veracity of a finding.

    - **WorkflowState** *(string) --*

      The workflow state of a finding.

    - **RecordState** *(string) --*

      The record state of a finding.

    - **RelatedFindings** *(list) --*

      A list of related findings.

      - *(dict) --*

        Details about a related finding.

        - **ProductArn** *(string) --*

          The ARN of the product that generated a related finding.

        - **Id** *(string) --*

          The product-generated identifier for a related finding.

    - **Note** *(dict) --*

      A user-defined note added to a finding.

      - **Text** *(string) --*

        The text of a note.

      - **UpdatedBy** *(string) --*

        The principal that created a note.

      - **UpdatedAt** *(string) --*

        The timestamp of when the note was updated.
    """


_GetFindingsPaginateResponseTypeDef = TypedDict(
    "_GetFindingsPaginateResponseTypeDef",
    {"Findings": List[GetFindingsPaginateResponseFindingsTypeDef]},
    total=False,
)


class GetFindingsPaginateResponseTypeDef(_GetFindingsPaginateResponseTypeDef):
    """
    Type definition for `GetFindingsPaginate` `Response`

    - **Findings** *(list) --*

      The findings that matched the filters specified in the request.

      - *(dict) --*

        Provides consistent format for the contents of the Security Hub-aggregated findings.
        ``AwsSecurityFinding`` format enables you to share findings between AWS security services
        and third-party solutions, and compliance checks.

        .. note::

          A finding is a potential security issue generated either by AWS services (Amazon
          GuardDuty, Amazon Inspector, and Amazon Macie) or by the integrated third-party solutions
          and compliance checks.

        - **SchemaVersion** *(string) --*

          The schema version that a finding is formatted for.

        - **Id** *(string) --*

          The security findings provider-specific identifier for a finding.

        - **ProductArn** *(string) --*

          The ARN generated by Security Hub that uniquely identifies a third-party company
          (security-findings provider) after this provider's product (solution that generates
          findings) is registered with Security Hub.

        - **GeneratorId** *(string) --*

          The identifier for the solution-specific component (a discrete unit of logic) that
          generated a finding. In various security-findings providers' solutions, this generator can
          be called a rule, a check, a detector, a plug-in, etc.

        - **AwsAccountId** *(string) --*

          The AWS account ID that a finding is generated in.

        - **Types** *(list) --*

          One or more finding types in the format of ``namespace/category/classifier`` that classify
          a finding.

          Valid namespace values are: Software and Configuration Checks | TTPs | Effects
          | Unusual
          Behaviors | Sensitive Data Identifications

          - *(string) --*

        - **FirstObservedAt** *(string) --*

          An ISO8601-formatted timestamp that indicates when the security-findings provider first
          observed the potential security issue that a finding captured.

        - **LastObservedAt** *(string) --*

          An ISO8601-formatted timestamp that indicates when the security-findings provider most
          recently observed the potential security issue that a finding captured.

        - **CreatedAt** *(string) --*

          An ISO8601-formatted timestamp that indicates when the security-findings provider created
          the potential security issue that a finding captured.

        - **UpdatedAt** *(string) --*

          An ISO8601-formatted timestamp that indicates when the security-findings provider last
          updated the finding record.

        - **Severity** *(dict) --*

          A finding's severity.

          - **Product** *(float) --*

            The native severity as defined by the AWS service or integrated partner product that
            generated the finding.

          - **Normalized** *(integer) --*

            The normalized severity of a finding.

        - **Confidence** *(integer) --*

          A finding's confidence. Confidence is defined as the likelihood that a finding accurately
          identifies the behavior or issue that it was intended to identify. Confidence is scored on
          a 0-100 basis using a ratio scale, where 0 means zero percent confidence and 100 means 100
          percent confidence.

        - **Criticality** *(integer) --*

          The level of importance assigned to the resources associated with the finding. A score of
          0 means that the underlying resources have no criticality, and a score of 100 is reserved
          for the most critical resources.

        - **Title** *(string) --*

          A finding's title.

          .. note::

            In this release, ``Title`` is a required property.

        - **Description** *(string) --*

          A finding's description.

          .. note::

            In this release, ``Description`` is a required property.

        - **Remediation** *(dict) --*

          A data type that describes the remediation options for a finding.

          - **Recommendation** *(dict) --*

            A recommendation on the steps to take to remediate the issue identified by a finding.

            - **Text** *(string) --*

              Describes the recommended steps to take to remediate an issue identified in a finding.

            - **Url** *(string) --*

              A URL to a page or site that contains information about how to remediate a finding.

        - **SourceUrl** *(string) --*

          A URL that links to a page about the current finding in the security-findings provider's
          solution.

        - **ProductFields** *(dict) --*

          A data type where security-findings providers can include additional solution-specific
          details that aren't part of the defined ``AwsSecurityFinding`` format.

          - *(string) --*

            - *(string) --*

        - **UserDefinedFields** *(dict) --*

          A list of name/value string pairs associated with the finding. These are custom,
          user-defined fields added to a finding.

          - *(string) --*

            - *(string) --*

        - **Malware** *(list) --*

          A list of malware related to a finding.

          - *(dict) --*

            A list of malware related to a finding.

            - **Name** *(string) --*

              The name of the malware that was observed.

            - **Type** *(string) --*

              The type of the malware that was observed.

            - **Path** *(string) --*

              The file system path of the malware that was observed.

            - **State** *(string) --*

              The state of the malware that was observed.

        - **Network** *(dict) --*

          The details of network-related information about a finding.

          - **Direction** *(string) --*

            The direction of network traffic associated with a finding.

          - **Protocol** *(string) --*

            The protocol of network-related information about a finding.

          - **SourceIpV4** *(string) --*

            The source IPv4 address of network-related information about a finding.

          - **SourceIpV6** *(string) --*

            The source IPv6 address of network-related information about a finding.

          - **SourcePort** *(integer) --*

            The source port of network-related information about a finding.

          - **SourceDomain** *(string) --*

            The source domain of network-related information about a finding.

          - **SourceMac** *(string) --*

            The source media access control (MAC) address of network-related information about a
            finding.

          - **DestinationIpV4** *(string) --*

            The destination IPv4 address of network-related information about a finding.

          - **DestinationIpV6** *(string) --*

            The destination IPv6 address of network-related information about a finding.

          - **DestinationPort** *(integer) --*

            The destination port of network-related information about a finding.

          - **DestinationDomain** *(string) --*

            The destination domain of network-related information about a finding.

        - **Process** *(dict) --*

          The details of process-related information about a finding.

          - **Name** *(string) --*

            The name of the process.

          - **Path** *(string) --*

            The path to the process executable.

          - **Pid** *(integer) --*

            The process ID.

          - **ParentPid** *(integer) --*

            The parent process ID.

          - **LaunchedAt** *(string) --*

            The date/time that the process was launched.

          - **TerminatedAt** *(string) --*

            The date and time when the process was terminated.

        - **ThreatIntelIndicators** *(list) --*

          Threat intel details related to a finding.

          - *(dict) --*

            Details about the threat intel related to a finding.

            - **Type** *(string) --*

              The type of a threat intel indicator.

            - **Value** *(string) --*

              The value of a threat intel indicator.

            - **Category** *(string) --*

              The category of a threat intel indicator.

            - **LastObservedAt** *(string) --*

              The date and time when the most recent instance of a threat intel indicator was
              observed.

            - **Source** *(string) --*

              The source of the threat intel indicator.

            - **SourceUrl** *(string) --*

              The URL to the page or site where you can get more information about the threat intel
              indicator.

        - **Resources** *(list) --*

          A set of resource data types that describe the resources that the finding refers to.

          - *(dict) --*

            A resource related to a finding.

            - **Type** *(string) --*

              The type of the resource that details are provided for.

            - **Id** *(string) --*

              The canonical identifier for the given resource type.

            - **Partition** *(string) --*

              The canonical AWS partition name that the Region is assigned to.

            - **Region** *(string) --*

              The canonical AWS external Region name where this resource is located.

            - **Tags** *(dict) --*

              A list of AWS tags associated with a resource at the time the finding was processed.

              - *(string) --*

                - *(string) --*

            - **Details** *(dict) --*

              Additional details about the resource related to a finding.

              - **AwsEc2Instance** *(dict) --*

                Details about an Amazon EC2 instance related to a finding.

                - **Type** *(string) --*

                  The instance type of the instance.

                - **ImageId** *(string) --*

                  The Amazon Machine Image (AMI) ID of the instance.

                - **IpV4Addresses** *(list) --*

                  The IPv4 addresses associated with the instance.

                  - *(string) --*

                - **IpV6Addresses** *(list) --*

                  The IPv6 addresses associated with the instance.

                  - *(string) --*

                - **KeyName** *(string) --*

                  The key name associated with the instance.

                - **IamInstanceProfileArn** *(string) --*

                  The IAM profile ARN of the instance.

                - **VpcId** *(string) --*

                  The identifier of the VPC that the instance was launched in.

                - **SubnetId** *(string) --*

                  The identifier of the subnet that the instance was launched in.

                - **LaunchedAt** *(string) --*

                  The date/time the instance was launched.

              - **AwsS3Bucket** *(dict) --*

                Details about an Amazon S3 Bucket related to a finding.

                - **OwnerId** *(string) --*

                  The canonical user ID of the owner of the S3 bucket.

                - **OwnerName** *(string) --*

                  The display name of the owner of the S3 bucket.

              - **AwsIamAccessKey** *(dict) --*

                Details about an IAM access key related to a finding.

                - **UserName** *(string) --*

                  The user associated with the IAM access key related to a finding.

                - **Status** *(string) --*

                  The status of the IAM access key related to a finding.

                - **CreatedAt** *(string) --*

                  The creation date/time of the IAM access key related to a finding.

              - **Container** *(dict) --*

                Details about a container resource related to a finding.

                - **Name** *(string) --*

                  The name of the container related to a finding.

                - **ImageId** *(string) --*

                  The identifier of the image related to a finding.

                - **ImageName** *(string) --*

                  The name of the image related to a finding.

                - **LaunchedAt** *(string) --*

                  The date and time when the container started.

              - **Other** *(dict) --*

                Details about a resource that doesn't have a specific type defined.

                - *(string) --*

                  - *(string) --*

        - **Compliance** *(dict) --*

          This data type is exclusive to findings that are generated as the result of a check run
          against a specific rule in a supported standard (for example, CIS AWS Foundations).
          Contains compliance-related finding details.

          - **Status** *(string) --*

            The result of a compliance check.

        - **VerificationState** *(string) --*

          Indicates the veracity of a finding.

        - **WorkflowState** *(string) --*

          The workflow state of a finding.

        - **RecordState** *(string) --*

          The record state of a finding.

        - **RelatedFindings** *(list) --*

          A list of related findings.

          - *(dict) --*

            Details about a related finding.

            - **ProductArn** *(string) --*

              The ARN of the product that generated a related finding.

            - **Id** *(string) --*

              The product-generated identifier for a related finding.

        - **Note** *(dict) --*

          A user-defined note added to a finding.

          - **Text** *(string) --*

            The text of a note.

          - **UpdatedBy** *(string) --*

            The principal that created a note.

          - **UpdatedAt** *(string) --*

            The timestamp of when the note was updated.
    """


_GetFindingsPaginateSortCriteriaTypeDef = TypedDict(
    "_GetFindingsPaginateSortCriteriaTypeDef", {"Field": str, "SortOrder": str}, total=False
)


class GetFindingsPaginateSortCriteriaTypeDef(_GetFindingsPaginateSortCriteriaTypeDef):
    """
    Type definition for `GetFindingsPaginate` `SortCriteria`

    A collection of finding attributes used to sort findings.

    - **Field** *(string) --*

      The finding attribute used to sort findings.

    - **SortOrder** *(string) --*

      The order used to sort findings.
    """


_GetInsightsPaginatePaginationConfigTypeDef = TypedDict(
    "_GetInsightsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class GetInsightsPaginatePaginationConfigTypeDef(_GetInsightsPaginatePaginationConfigTypeDef):
    """
    Type definition for `GetInsightsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_GetInsightsPaginateResponseInsightsFiltersAwsAccountIdTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersAwsAccountIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersAwsAccountIdTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersAwsAccountIdTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `AwsAccountId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersCompanyNameTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersCompanyNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersCompanyNameTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersCompanyNameTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `CompanyName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersComplianceStatusTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersComplianceStatusTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersComplianceStatusTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersComplianceStatusTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ComplianceStatus`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersConfidenceTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersConfidenceTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersConfidenceTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersConfidenceTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `Confidence`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersCreatedAtDateRangeTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersCreatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersCreatedAtDateRangeTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersCreatedAtDateRangeTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFiltersCreatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_GetInsightsPaginateResponseInsightsFiltersCreatedAtTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersCreatedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": GetInsightsPaginateResponseInsightsFiltersCreatedAtDateRangeTypeDef,
    },
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersCreatedAtTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersCreatedAtTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `CreatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_GetInsightsPaginateResponseInsightsFiltersCriticalityTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersCriticalityTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersCriticalityTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersCriticalityTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `Criticality`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersDescriptionTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersDescriptionTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersDescriptionTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersDescriptionTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `Description`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersFirstObservedAtDateRangeTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersFirstObservedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersFirstObservedAtDateRangeTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersFirstObservedAtDateRangeTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFiltersFirstObservedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_GetInsightsPaginateResponseInsightsFiltersFirstObservedAtTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersFirstObservedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": GetInsightsPaginateResponseInsightsFiltersFirstObservedAtDateRangeTypeDef,
    },
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersFirstObservedAtTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersFirstObservedAtTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `FirstObservedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_GetInsightsPaginateResponseInsightsFiltersGeneratorIdTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersGeneratorIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersGeneratorIdTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersGeneratorIdTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `GeneratorId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersIdTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersIdTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersIdTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `Id`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersKeywordTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersKeywordTypeDef", {"Value": str}, total=False
)


class GetInsightsPaginateResponseInsightsFiltersKeywordTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersKeywordTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `Keyword`

    A keyword filter for querying findings.

    - **Value** *(string) --*

      A value for the keyword.
    """


_GetInsightsPaginateResponseInsightsFiltersLastObservedAtDateRangeTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersLastObservedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersLastObservedAtDateRangeTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersLastObservedAtDateRangeTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFiltersLastObservedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_GetInsightsPaginateResponseInsightsFiltersLastObservedAtTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersLastObservedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": GetInsightsPaginateResponseInsightsFiltersLastObservedAtDateRangeTypeDef,
    },
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersLastObservedAtTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersLastObservedAtTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `LastObservedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_GetInsightsPaginateResponseInsightsFiltersMalwareNameTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersMalwareNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersMalwareNameTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersMalwareNameTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `MalwareName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersMalwarePathTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersMalwarePathTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersMalwarePathTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersMalwarePathTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `MalwarePath`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersMalwareStateTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersMalwareStateTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersMalwareStateTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersMalwareStateTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `MalwareState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersMalwareTypeTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersMalwareTypeTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersMalwareTypeTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersMalwareTypeTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `MalwareType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersNetworkDestinationDomainTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersNetworkDestinationDomainTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersNetworkDestinationDomainTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersNetworkDestinationDomainTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `NetworkDestinationDomain`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersNetworkDestinationIpV4TypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersNetworkDestinationIpV4TypeDef",
    {"Cidr": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersNetworkDestinationIpV4TypeDef(
    _GetInsightsPaginateResponseInsightsFiltersNetworkDestinationIpV4TypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `NetworkDestinationIpV4`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_GetInsightsPaginateResponseInsightsFiltersNetworkDestinationIpV6TypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersNetworkDestinationIpV6TypeDef",
    {"Cidr": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersNetworkDestinationIpV6TypeDef(
    _GetInsightsPaginateResponseInsightsFiltersNetworkDestinationIpV6TypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `NetworkDestinationIpV6`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_GetInsightsPaginateResponseInsightsFiltersNetworkDestinationPortTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersNetworkDestinationPortTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersNetworkDestinationPortTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersNetworkDestinationPortTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `NetworkDestinationPort`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersNetworkDirectionTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersNetworkDirectionTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersNetworkDirectionTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersNetworkDirectionTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `NetworkDirection`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersNetworkProtocolTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersNetworkProtocolTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersNetworkProtocolTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersNetworkProtocolTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `NetworkProtocol`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersNetworkSourceDomainTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersNetworkSourceDomainTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersNetworkSourceDomainTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersNetworkSourceDomainTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `NetworkSourceDomain`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersNetworkSourceIpV4TypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersNetworkSourceIpV4TypeDef",
    {"Cidr": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersNetworkSourceIpV4TypeDef(
    _GetInsightsPaginateResponseInsightsFiltersNetworkSourceIpV4TypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `NetworkSourceIpV4`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_GetInsightsPaginateResponseInsightsFiltersNetworkSourceIpV6TypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersNetworkSourceIpV6TypeDef",
    {"Cidr": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersNetworkSourceIpV6TypeDef(
    _GetInsightsPaginateResponseInsightsFiltersNetworkSourceIpV6TypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `NetworkSourceIpV6`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_GetInsightsPaginateResponseInsightsFiltersNetworkSourceMacTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersNetworkSourceMacTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersNetworkSourceMacTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersNetworkSourceMacTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `NetworkSourceMac`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersNetworkSourcePortTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersNetworkSourcePortTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersNetworkSourcePortTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersNetworkSourcePortTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `NetworkSourcePort`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersNoteTextTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersNoteTextTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersNoteTextTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersNoteTextTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `NoteText`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersNoteUpdatedAtDateRangeTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersNoteUpdatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersNoteUpdatedAtDateRangeTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersNoteUpdatedAtDateRangeTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFiltersNoteUpdatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_GetInsightsPaginateResponseInsightsFiltersNoteUpdatedAtTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersNoteUpdatedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": GetInsightsPaginateResponseInsightsFiltersNoteUpdatedAtDateRangeTypeDef,
    },
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersNoteUpdatedAtTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersNoteUpdatedAtTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `NoteUpdatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_GetInsightsPaginateResponseInsightsFiltersNoteUpdatedByTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersNoteUpdatedByTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersNoteUpdatedByTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersNoteUpdatedByTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `NoteUpdatedBy`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersProcessLaunchedAtDateRangeTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersProcessLaunchedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersProcessLaunchedAtDateRangeTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersProcessLaunchedAtDateRangeTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFiltersProcessLaunchedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_GetInsightsPaginateResponseInsightsFiltersProcessLaunchedAtTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersProcessLaunchedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": GetInsightsPaginateResponseInsightsFiltersProcessLaunchedAtDateRangeTypeDef,
    },
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersProcessLaunchedAtTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersProcessLaunchedAtTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ProcessLaunchedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_GetInsightsPaginateResponseInsightsFiltersProcessNameTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersProcessNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersProcessNameTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersProcessNameTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ProcessName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersProcessParentPidTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersProcessParentPidTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersProcessParentPidTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersProcessParentPidTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ProcessParentPid`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersProcessPathTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersProcessPathTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersProcessPathTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersProcessPathTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ProcessPath`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersProcessPidTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersProcessPidTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersProcessPidTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersProcessPidTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ProcessPid`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersProcessTerminatedAtDateRangeTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersProcessTerminatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersProcessTerminatedAtDateRangeTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersProcessTerminatedAtDateRangeTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFiltersProcessTerminatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_GetInsightsPaginateResponseInsightsFiltersProcessTerminatedAtTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersProcessTerminatedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": GetInsightsPaginateResponseInsightsFiltersProcessTerminatedAtDateRangeTypeDef,
    },
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersProcessTerminatedAtTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersProcessTerminatedAtTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ProcessTerminatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_GetInsightsPaginateResponseInsightsFiltersProductArnTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersProductArnTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersProductArnTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersProductArnTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ProductArn`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersProductFieldsTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersProductFieldsTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersProductFieldsTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersProductFieldsTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ProductFields`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_GetInsightsPaginateResponseInsightsFiltersProductNameTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersProductNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersProductNameTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersProductNameTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ProductName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersRecommendationTextTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersRecommendationTextTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersRecommendationTextTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersRecommendationTextTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `RecommendationText`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersRecordStateTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersRecordStateTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersRecordStateTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersRecordStateTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `RecordState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersRelatedFindingsIdTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersRelatedFindingsIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersRelatedFindingsIdTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersRelatedFindingsIdTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `RelatedFindingsId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersRelatedFindingsProductArnTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersRelatedFindingsProductArnTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersRelatedFindingsProductArnTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersRelatedFindingsProductArnTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `RelatedFindingsProductArn`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters`
    `ResourceAwsEc2InstanceIamInstanceProfileArn`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceImageIdTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceImageIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceImageIdTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceImageIdTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ResourceAwsEc2InstanceImageId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef",
    {"Cidr": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters`
    `ResourceAwsEc2InstanceIpV4Addresses`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef",
    {"Cidr": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters`
    `ResourceAwsEc2InstanceIpV6Addresses`

    The IP filter for querying findings.

    - **Cidr** *(string) --*

      A finding's CIDR value.
    """


_GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceKeyNameTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceKeyNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceKeyNameTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceKeyNameTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ResourceAwsEc2InstanceKeyName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceLaunchedAt`
    `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceLaunchedAtTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceLaunchedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceLaunchedAtDateRangeTypeDef,
    },
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceLaunchedAtTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceLaunchedAtTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters`
    `ResourceAwsEc2InstanceLaunchedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceSubnetIdTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceSubnetIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceSubnetIdTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceSubnetIdTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters`
    `ResourceAwsEc2InstanceSubnetId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceTypeTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceTypeTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceTypeTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceTypeTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ResourceAwsEc2InstanceType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceVpcIdTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceVpcIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceVpcIdTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceVpcIdTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ResourceAwsEc2InstanceVpcId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFiltersResourceAwsIamAccessKeyCreatedAt`
    `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_GetInsightsPaginateResponseInsightsFiltersResourceAwsIamAccessKeyCreatedAtTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourceAwsIamAccessKeyCreatedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": GetInsightsPaginateResponseInsightsFiltersResourceAwsIamAccessKeyCreatedAtDateRangeTypeDef,
    },
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourceAwsIamAccessKeyCreatedAtTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourceAwsIamAccessKeyCreatedAtTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters`
    `ResourceAwsIamAccessKeyCreatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_GetInsightsPaginateResponseInsightsFiltersResourceAwsIamAccessKeyStatusTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourceAwsIamAccessKeyStatusTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourceAwsIamAccessKeyStatusTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourceAwsIamAccessKeyStatusTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ResourceAwsIamAccessKeyStatus`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersResourceAwsIamAccessKeyUserNameTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourceAwsIamAccessKeyUserNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourceAwsIamAccessKeyUserNameTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourceAwsIamAccessKeyUserNameTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters`
    `ResourceAwsIamAccessKeyUserName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersResourceAwsS3BucketOwnerIdTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourceAwsS3BucketOwnerIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourceAwsS3BucketOwnerIdTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourceAwsS3BucketOwnerIdTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ResourceAwsS3BucketOwnerId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersResourceAwsS3BucketOwnerNameTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourceAwsS3BucketOwnerNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourceAwsS3BucketOwnerNameTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourceAwsS3BucketOwnerNameTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ResourceAwsS3BucketOwnerName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersResourceContainerImageIdTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourceContainerImageIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourceContainerImageIdTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourceContainerImageIdTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ResourceContainerImageId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersResourceContainerImageNameTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourceContainerImageNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourceContainerImageNameTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourceContainerImageNameTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ResourceContainerImageName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersResourceContainerLaunchedAtDateRangeTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourceContainerLaunchedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourceContainerLaunchedAtDateRangeTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourceContainerLaunchedAtDateRangeTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFiltersResourceContainerLaunchedAt`
    `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_GetInsightsPaginateResponseInsightsFiltersResourceContainerLaunchedAtTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourceContainerLaunchedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": GetInsightsPaginateResponseInsightsFiltersResourceContainerLaunchedAtDateRangeTypeDef,
    },
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourceContainerLaunchedAtTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourceContainerLaunchedAtTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ResourceContainerLaunchedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_GetInsightsPaginateResponseInsightsFiltersResourceContainerNameTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourceContainerNameTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourceContainerNameTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourceContainerNameTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ResourceContainerName`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersResourceDetailsOtherTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourceDetailsOtherTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourceDetailsOtherTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourceDetailsOtherTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ResourceDetailsOther`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_GetInsightsPaginateResponseInsightsFiltersResourceIdTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourceIdTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourceIdTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourceIdTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ResourceId`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersResourcePartitionTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourcePartitionTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourcePartitionTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourcePartitionTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ResourcePartition`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersResourceRegionTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourceRegionTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourceRegionTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourceRegionTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ResourceRegion`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersResourceTagsTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourceTagsTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourceTagsTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourceTagsTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ResourceTags`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_GetInsightsPaginateResponseInsightsFiltersResourceTypeTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersResourceTypeTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersResourceTypeTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersResourceTypeTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ResourceType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersSeverityLabelTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersSeverityLabelTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersSeverityLabelTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersSeverityLabelTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `SeverityLabel`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersSeverityNormalizedTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersSeverityNormalizedTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersSeverityNormalizedTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersSeverityNormalizedTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `SeverityNormalized`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersSeverityProductTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersSeverityProductTypeDef",
    {"Gte": float, "Lte": float, "Eq": float},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersSeverityProductTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersSeverityProductTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `SeverityProduct`

    A number filter for querying findings.

    - **Gte** *(float) --*

      The greater-than-equal condition to be applied to a single field when querying for findings.

    - **Lte** *(float) --*

      The less-than-equal condition to be applied to a single field when querying for findings.

    - **Eq** *(float) --*

      The equal-to condition to be applied to a single field when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersSourceUrlTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersSourceUrlTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersSourceUrlTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersSourceUrlTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `SourceUrl`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorCategoryTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorCategoryTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorCategoryTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorCategoryTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ThreatIntelIndicatorCategory`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef
):
    """
    Type definition for
    `GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorLastObservedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorLastObservedAtTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorLastObservedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorLastObservedAtDateRangeTypeDef,
    },
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorLastObservedAtTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorLastObservedAtTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters`
    `ThreatIntelIndicatorLastObservedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorSourceTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorSourceTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorSourceTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorSourceTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ThreatIntelIndicatorSource`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorSourceUrlTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorSourceUrlTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorSourceUrlTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorSourceUrlTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ThreatIntelIndicatorSourceUrl`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorTypeTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorTypeTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorTypeTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorTypeTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ThreatIntelIndicatorType`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorValueTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorValueTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorValueTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorValueTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `ThreatIntelIndicatorValue`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersTitleTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersTitleTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersTitleTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersTitleTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `Title`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersTypeTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersTypeTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersTypeTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersTypeTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `Type`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersUpdatedAtDateRangeTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersUpdatedAtDateRangeTypeDef",
    {"Value": int, "Unit": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersUpdatedAtDateRangeTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersUpdatedAtDateRangeTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFiltersUpdatedAt` `DateRange`

    A date range for the date filter.

    - **Value** *(integer) --*

      A date range value for the date filter.

    - **Unit** *(string) --*

      A date range unit for the date filter.
    """


_GetInsightsPaginateResponseInsightsFiltersUpdatedAtTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersUpdatedAtTypeDef",
    {
        "Start": str,
        "End": str,
        "DateRange": GetInsightsPaginateResponseInsightsFiltersUpdatedAtDateRangeTypeDef,
    },
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersUpdatedAtTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersUpdatedAtTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `UpdatedAt`

    A date filter for querying findings.

    - **Start** *(string) --*

      A start date for the date filter.

    - **End** *(string) --*

      An end date for the date filter.

    - **DateRange** *(dict) --*

      A date range for the date filter.

      - **Value** *(integer) --*

        A date range value for the date filter.

      - **Unit** *(string) --*

        A date range unit for the date filter.
    """


_GetInsightsPaginateResponseInsightsFiltersUserDefinedFieldsTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersUserDefinedFieldsTypeDef",
    {"Key": str, "Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersUserDefinedFieldsTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersUserDefinedFieldsTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `UserDefinedFields`

    The map filter for querying findings.

    - **Key** *(string) --*

      The key of the map filter.

    - **Value** *(string) --*

      The value for the key in the map filter.

    - **Comparison** *(string) --*

      The condition to apply to a key value when querying for findings with a map filter.
    """


_GetInsightsPaginateResponseInsightsFiltersVerificationStateTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersVerificationStateTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersVerificationStateTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersVerificationStateTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `VerificationState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersWorkflowStateTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersWorkflowStateTypeDef",
    {"Value": str, "Comparison": str},
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersWorkflowStateTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersWorkflowStateTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsightsFilters` `WorkflowState`

    A string filter for querying findings.

    - **Value** *(string) --*

      The string filter value.

    - **Comparison** *(string) --*

      The condition to be applied to a string value when querying for findings.
    """


_GetInsightsPaginateResponseInsightsFiltersTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsFiltersTypeDef",
    {
        "ProductArn": List[GetInsightsPaginateResponseInsightsFiltersProductArnTypeDef],
        "AwsAccountId": List[GetInsightsPaginateResponseInsightsFiltersAwsAccountIdTypeDef],
        "Id": List[GetInsightsPaginateResponseInsightsFiltersIdTypeDef],
        "GeneratorId": List[GetInsightsPaginateResponseInsightsFiltersGeneratorIdTypeDef],
        "Type": List[GetInsightsPaginateResponseInsightsFiltersTypeTypeDef],
        "FirstObservedAt": List[GetInsightsPaginateResponseInsightsFiltersFirstObservedAtTypeDef],
        "LastObservedAt": List[GetInsightsPaginateResponseInsightsFiltersLastObservedAtTypeDef],
        "CreatedAt": List[GetInsightsPaginateResponseInsightsFiltersCreatedAtTypeDef],
        "UpdatedAt": List[GetInsightsPaginateResponseInsightsFiltersUpdatedAtTypeDef],
        "SeverityProduct": List[GetInsightsPaginateResponseInsightsFiltersSeverityProductTypeDef],
        "SeverityNormalized": List[
            GetInsightsPaginateResponseInsightsFiltersSeverityNormalizedTypeDef
        ],
        "SeverityLabel": List[GetInsightsPaginateResponseInsightsFiltersSeverityLabelTypeDef],
        "Confidence": List[GetInsightsPaginateResponseInsightsFiltersConfidenceTypeDef],
        "Criticality": List[GetInsightsPaginateResponseInsightsFiltersCriticalityTypeDef],
        "Title": List[GetInsightsPaginateResponseInsightsFiltersTitleTypeDef],
        "Description": List[GetInsightsPaginateResponseInsightsFiltersDescriptionTypeDef],
        "RecommendationText": List[
            GetInsightsPaginateResponseInsightsFiltersRecommendationTextTypeDef
        ],
        "SourceUrl": List[GetInsightsPaginateResponseInsightsFiltersSourceUrlTypeDef],
        "ProductFields": List[GetInsightsPaginateResponseInsightsFiltersProductFieldsTypeDef],
        "ProductName": List[GetInsightsPaginateResponseInsightsFiltersProductNameTypeDef],
        "CompanyName": List[GetInsightsPaginateResponseInsightsFiltersCompanyNameTypeDef],
        "UserDefinedFields": List[
            GetInsightsPaginateResponseInsightsFiltersUserDefinedFieldsTypeDef
        ],
        "MalwareName": List[GetInsightsPaginateResponseInsightsFiltersMalwareNameTypeDef],
        "MalwareType": List[GetInsightsPaginateResponseInsightsFiltersMalwareTypeTypeDef],
        "MalwarePath": List[GetInsightsPaginateResponseInsightsFiltersMalwarePathTypeDef],
        "MalwareState": List[GetInsightsPaginateResponseInsightsFiltersMalwareStateTypeDef],
        "NetworkDirection": List[GetInsightsPaginateResponseInsightsFiltersNetworkDirectionTypeDef],
        "NetworkProtocol": List[GetInsightsPaginateResponseInsightsFiltersNetworkProtocolTypeDef],
        "NetworkSourceIpV4": List[
            GetInsightsPaginateResponseInsightsFiltersNetworkSourceIpV4TypeDef
        ],
        "NetworkSourceIpV6": List[
            GetInsightsPaginateResponseInsightsFiltersNetworkSourceIpV6TypeDef
        ],
        "NetworkSourcePort": List[
            GetInsightsPaginateResponseInsightsFiltersNetworkSourcePortTypeDef
        ],
        "NetworkSourceDomain": List[
            GetInsightsPaginateResponseInsightsFiltersNetworkSourceDomainTypeDef
        ],
        "NetworkSourceMac": List[GetInsightsPaginateResponseInsightsFiltersNetworkSourceMacTypeDef],
        "NetworkDestinationIpV4": List[
            GetInsightsPaginateResponseInsightsFiltersNetworkDestinationIpV4TypeDef
        ],
        "NetworkDestinationIpV6": List[
            GetInsightsPaginateResponseInsightsFiltersNetworkDestinationIpV6TypeDef
        ],
        "NetworkDestinationPort": List[
            GetInsightsPaginateResponseInsightsFiltersNetworkDestinationPortTypeDef
        ],
        "NetworkDestinationDomain": List[
            GetInsightsPaginateResponseInsightsFiltersNetworkDestinationDomainTypeDef
        ],
        "ProcessName": List[GetInsightsPaginateResponseInsightsFiltersProcessNameTypeDef],
        "ProcessPath": List[GetInsightsPaginateResponseInsightsFiltersProcessPathTypeDef],
        "ProcessPid": List[GetInsightsPaginateResponseInsightsFiltersProcessPidTypeDef],
        "ProcessParentPid": List[GetInsightsPaginateResponseInsightsFiltersProcessParentPidTypeDef],
        "ProcessLaunchedAt": List[
            GetInsightsPaginateResponseInsightsFiltersProcessLaunchedAtTypeDef
        ],
        "ProcessTerminatedAt": List[
            GetInsightsPaginateResponseInsightsFiltersProcessTerminatedAtTypeDef
        ],
        "ThreatIntelIndicatorType": List[
            GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorTypeTypeDef
        ],
        "ThreatIntelIndicatorValue": List[
            GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorValueTypeDef
        ],
        "ThreatIntelIndicatorCategory": List[
            GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorCategoryTypeDef
        ],
        "ThreatIntelIndicatorLastObservedAt": List[
            GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorLastObservedAtTypeDef
        ],
        "ThreatIntelIndicatorSource": List[
            GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorSourceTypeDef
        ],
        "ThreatIntelIndicatorSourceUrl": List[
            GetInsightsPaginateResponseInsightsFiltersThreatIntelIndicatorSourceUrlTypeDef
        ],
        "ResourceType": List[GetInsightsPaginateResponseInsightsFiltersResourceTypeTypeDef],
        "ResourceId": List[GetInsightsPaginateResponseInsightsFiltersResourceIdTypeDef],
        "ResourcePartition": List[
            GetInsightsPaginateResponseInsightsFiltersResourcePartitionTypeDef
        ],
        "ResourceRegion": List[GetInsightsPaginateResponseInsightsFiltersResourceRegionTypeDef],
        "ResourceTags": List[GetInsightsPaginateResponseInsightsFiltersResourceTagsTypeDef],
        "ResourceAwsEc2InstanceType": List[
            GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceTypeTypeDef
        ],
        "ResourceAwsEc2InstanceImageId": List[
            GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceImageIdTypeDef
        ],
        "ResourceAwsEc2InstanceIpV4Addresses": List[
            GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceIpV4AddressesTypeDef
        ],
        "ResourceAwsEc2InstanceIpV6Addresses": List[
            GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceIpV6AddressesTypeDef
        ],
        "ResourceAwsEc2InstanceKeyName": List[
            GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceKeyNameTypeDef
        ],
        "ResourceAwsEc2InstanceIamInstanceProfileArn": List[
            GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceIamInstanceProfileArnTypeDef
        ],
        "ResourceAwsEc2InstanceVpcId": List[
            GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceVpcIdTypeDef
        ],
        "ResourceAwsEc2InstanceSubnetId": List[
            GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceSubnetIdTypeDef
        ],
        "ResourceAwsEc2InstanceLaunchedAt": List[
            GetInsightsPaginateResponseInsightsFiltersResourceAwsEc2InstanceLaunchedAtTypeDef
        ],
        "ResourceAwsS3BucketOwnerId": List[
            GetInsightsPaginateResponseInsightsFiltersResourceAwsS3BucketOwnerIdTypeDef
        ],
        "ResourceAwsS3BucketOwnerName": List[
            GetInsightsPaginateResponseInsightsFiltersResourceAwsS3BucketOwnerNameTypeDef
        ],
        "ResourceAwsIamAccessKeyUserName": List[
            GetInsightsPaginateResponseInsightsFiltersResourceAwsIamAccessKeyUserNameTypeDef
        ],
        "ResourceAwsIamAccessKeyStatus": List[
            GetInsightsPaginateResponseInsightsFiltersResourceAwsIamAccessKeyStatusTypeDef
        ],
        "ResourceAwsIamAccessKeyCreatedAt": List[
            GetInsightsPaginateResponseInsightsFiltersResourceAwsIamAccessKeyCreatedAtTypeDef
        ],
        "ResourceContainerName": List[
            GetInsightsPaginateResponseInsightsFiltersResourceContainerNameTypeDef
        ],
        "ResourceContainerImageId": List[
            GetInsightsPaginateResponseInsightsFiltersResourceContainerImageIdTypeDef
        ],
        "ResourceContainerImageName": List[
            GetInsightsPaginateResponseInsightsFiltersResourceContainerImageNameTypeDef
        ],
        "ResourceContainerLaunchedAt": List[
            GetInsightsPaginateResponseInsightsFiltersResourceContainerLaunchedAtTypeDef
        ],
        "ResourceDetailsOther": List[
            GetInsightsPaginateResponseInsightsFiltersResourceDetailsOtherTypeDef
        ],
        "ComplianceStatus": List[GetInsightsPaginateResponseInsightsFiltersComplianceStatusTypeDef],
        "VerificationState": List[
            GetInsightsPaginateResponseInsightsFiltersVerificationStateTypeDef
        ],
        "WorkflowState": List[GetInsightsPaginateResponseInsightsFiltersWorkflowStateTypeDef],
        "RecordState": List[GetInsightsPaginateResponseInsightsFiltersRecordStateTypeDef],
        "RelatedFindingsProductArn": List[
            GetInsightsPaginateResponseInsightsFiltersRelatedFindingsProductArnTypeDef
        ],
        "RelatedFindingsId": List[
            GetInsightsPaginateResponseInsightsFiltersRelatedFindingsIdTypeDef
        ],
        "NoteText": List[GetInsightsPaginateResponseInsightsFiltersNoteTextTypeDef],
        "NoteUpdatedAt": List[GetInsightsPaginateResponseInsightsFiltersNoteUpdatedAtTypeDef],
        "NoteUpdatedBy": List[GetInsightsPaginateResponseInsightsFiltersNoteUpdatedByTypeDef],
        "Keyword": List[GetInsightsPaginateResponseInsightsFiltersKeywordTypeDef],
    },
    total=False,
)


class GetInsightsPaginateResponseInsightsFiltersTypeDef(
    _GetInsightsPaginateResponseInsightsFiltersTypeDef
):
    """
    Type definition for `GetInsightsPaginateResponseInsights` `Filters`

    One or more attributes used to filter the findings included in the insight. Only findings that
    match the criteria defined in the filters are included in the insight.

    - **ProductArn** *(list) --*

      The ARN generated by Security Hub that uniquely identifies a third-party company (security
      findings provider) after this provider's product (solution that generates findings) is
      registered with Security Hub.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **AwsAccountId** *(list) --*

      The AWS account ID that a finding is generated in.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Id** *(list) --*

      The security findings provider-specific identifier for a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **GeneratorId** *(list) --*

      The identifier for the solution-specific component (a discrete unit of logic) that generated a
      finding. In various security-findings providers' solutions, this generator can be called a
      rule, a check, a detector, a plug-in, etc.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Type** *(list) --*

      A finding type in the format of ``namespace/category/classifier`` that classifies a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **FirstObservedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider first
      observed the potential security issue that a finding captured.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **LastObservedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider most
      recently observed the potential security issue that a finding captured.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **CreatedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider captured the
      potential security issue that a finding captured.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **UpdatedAt** *(list) --*

      An ISO8601-formatted timestamp that indicates when the security-findings provider last updated
      the finding record.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **SeverityProduct** *(list) --*

      The native severity as defined by the security-findings provider's solution that generated the
      finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **SeverityNormalized** *(list) --*

      The normalized severity of a finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **SeverityLabel** *(list) --*

      The label of a finding's severity.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Confidence** *(list) --*

      A finding's confidence. Confidence is defined as the likelihood that a finding accurately
      identifies the behavior or issue that it was intended to identify. Confidence is scored on a
      0-100 basis using a ratio scale, where 0 means zero percent confidence and 100 means 100
      percent confidence.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **Criticality** *(list) --*

      The level of importance assigned to the resources associated with the finding. A score of 0
      means that the underlying resources have no criticality, and a score of 100 is reserved for
      the most critical resources.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **Title** *(list) --*

      A finding's title.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Description** *(list) --*

      A finding's description.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RecommendationText** *(list) --*

      The recommendation of what to do about the issue described in a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **SourceUrl** *(list) --*

      A URL that links to a page about the current finding in the security-findings provider's
      solution.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProductFields** *(list) --*

      A data type where security-findings providers can include additional solution-specific details
      that aren't part of the defined ``AwsSecurityFinding`` format.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **ProductName** *(list) --*

      The name of the solution (product) that generates findings.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **CompanyName** *(list) --*

      The name of the findings provider (company) that owns the solution (product) that generates
      findings.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **UserDefinedFields** *(list) --*

      A list of name/value string pairs associated with the finding. These are custom, user-defined
      fields added to a finding.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **MalwareName** *(list) --*

      The name of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **MalwareType** *(list) --*

      The type of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **MalwarePath** *(list) --*

      The filesystem path of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **MalwareState** *(list) --*

      The state of the malware that was observed.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkDirection** *(list) --*

      Indicates the direction of network traffic associated with a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkProtocol** *(list) --*

      The protocol of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkSourceIpV4** *(list) --*

      The source IPv4 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkSourceIpV6** *(list) --*

      The source IPv6 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkSourcePort** *(list) --*

      The source port of network-related information about a finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **NetworkSourceDomain** *(list) --*

      The source domain of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkSourceMac** *(list) --*

      The source media access control (MAC) address of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NetworkDestinationIpV4** *(list) --*

      The destination IPv4 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkDestinationIpV6** *(list) --*

      The destination IPv6 address of network-related information about a finding.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **NetworkDestinationPort** *(list) --*

      The destination port of network-related information about a finding.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **NetworkDestinationDomain** *(list) --*

      The destination domain of network-related information about a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProcessName** *(list) --*

      The name of the process.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProcessPath** *(list) --*

      The path to the process executable.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ProcessPid** *(list) --*

      The process ID.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **ProcessParentPid** *(list) --*

      The parent process ID.

      - *(dict) --*

        A number filter for querying findings.

        - **Gte** *(float) --*

          The greater-than-equal condition to be applied to a single field when querying for
          findings.

        - **Lte** *(float) --*

          The less-than-equal condition to be applied to a single field when querying for findings.

        - **Eq** *(float) --*

          The equal-to condition to be applied to a single field when querying for findings.

    - **ProcessLaunchedAt** *(list) --*

      The date/time that the process was launched.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ProcessTerminatedAt** *(list) --*

      The date/time that the process was terminated.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ThreatIntelIndicatorType** *(list) --*

      The type of a threat intel indicator.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorValue** *(list) --*

      The value of a threat intel indicator.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorCategory** *(list) --*

      The category of a threat intel indicator.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorLastObservedAt** *(list) --*

      The date/time of the last observation of a threat intel indicator.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ThreatIntelIndicatorSource** *(list) --*

      The source of the threat intel.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ThreatIntelIndicatorSourceUrl** *(list) --*

      The URL for more details from the source of the threat intel.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceType** *(list) --*

      Specifies the type of the resource that details are provided for.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceId** *(list) --*

      The canonical identifier for the given resource type.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourcePartition** *(list) --*

      The canonical AWS partition name that the Region is assigned to.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceRegion** *(list) --*

      The canonical AWS external Region name where this resource is located.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceTags** *(list) --*

      A list of AWS tags associated with a resource at the time the finding was processed.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **ResourceAwsEc2InstanceType** *(list) --*

      The instance type of the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceImageId** *(list) --*

      The Amazon Machine Image (AMI) ID of the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceIpV4Addresses** *(list) --*

      The IPv4 addresses associated with the instance.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **ResourceAwsEc2InstanceIpV6Addresses** *(list) --*

      The IPv6 addresses associated with the instance.

      - *(dict) --*

        The IP filter for querying findings.

        - **Cidr** *(string) --*

          A finding's CIDR value.

    - **ResourceAwsEc2InstanceKeyName** *(list) --*

      The key name associated with the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceIamInstanceProfileArn** *(list) --*

      The IAM profile ARN of the instance.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceVpcId** *(list) --*

      The identifier of the VPC that the instance was launched in.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceSubnetId** *(list) --*

      The identifier of the subnet that the instance was launched in.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsEc2InstanceLaunchedAt** *(list) --*

      The date/time the instance was launched.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ResourceAwsS3BucketOwnerId** *(list) --*

      The canonical user ID of the owner of the S3 bucket.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsS3BucketOwnerName** *(list) --*

      The display name of the owner of the S3 bucket.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsIamAccessKeyUserName** *(list) --*

      The user associated with the IAM access key related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsIamAccessKeyStatus** *(list) --*

      The status of the IAM access key related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceAwsIamAccessKeyCreatedAt** *(list) --*

      The creation date/time of the IAM access key related to a finding.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ResourceContainerName** *(list) --*

      The name of the container related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceContainerImageId** *(list) --*

      The identifier of the image related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceContainerImageName** *(list) --*

      The name of the image related to a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **ResourceContainerLaunchedAt** *(list) --*

      The date/time that the container was started.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **ResourceDetailsOther** *(list) --*

      The details of a resource that doesn't have a specific subfield for the resource type defined.

      - *(dict) --*

        The map filter for querying findings.

        - **Key** *(string) --*

          The key of the map filter.

        - **Value** *(string) --*

          The value for the key in the map filter.

        - **Comparison** *(string) --*

          The condition to apply to a key value when querying for findings with a map filter.

    - **ComplianceStatus** *(list) --*

      Exclusive to findings that are generated as the result of a check run against a specific rule
      in a supported standard (for example, CIS AWS Foundations). Contains compliance-related
      finding details.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **VerificationState** *(list) --*

      The veracity of a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **WorkflowState** *(list) --*

      The workflow state of a finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RecordState** *(list) --*

      The updated record state for the finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RelatedFindingsProductArn** *(list) --*

      The ARN of the solution that generated a related finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **RelatedFindingsId** *(list) --*

      The solution-generated identifier for a related finding.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NoteText** *(list) --*

      The text of a note.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **NoteUpdatedAt** *(list) --*

      The timestamp of when the note was updated.

      - *(dict) --*

        A date filter for querying findings.

        - **Start** *(string) --*

          A start date for the date filter.

        - **End** *(string) --*

          An end date for the date filter.

        - **DateRange** *(dict) --*

          A date range for the date filter.

          - **Value** *(integer) --*

            A date range value for the date filter.

          - **Unit** *(string) --*

            A date range unit for the date filter.

    - **NoteUpdatedBy** *(list) --*

      The principal that created a note.

      - *(dict) --*

        A string filter for querying findings.

        - **Value** *(string) --*

          The string filter value.

        - **Comparison** *(string) --*

          The condition to be applied to a string value when querying for findings.

    - **Keyword** *(list) --*

      A keyword for a finding.

      - *(dict) --*

        A keyword filter for querying findings.

        - **Value** *(string) --*

          A value for the keyword.
    """


_GetInsightsPaginateResponseInsightsTypeDef = TypedDict(
    "_GetInsightsPaginateResponseInsightsTypeDef",
    {
        "InsightArn": str,
        "Name": str,
        "Filters": GetInsightsPaginateResponseInsightsFiltersTypeDef,
        "GroupByAttribute": str,
    },
    total=False,
)


class GetInsightsPaginateResponseInsightsTypeDef(_GetInsightsPaginateResponseInsightsTypeDef):
    """
    Type definition for `GetInsightsPaginateResponse` `Insights`

    Contains information about a Security Hub insight.

    - **InsightArn** *(string) --*

      The ARN of a Security Hub insight.

    - **Name** *(string) --*

      The name of a Security Hub insight.

    - **Filters** *(dict) --*

      One or more attributes used to filter the findings included in the insight. Only findings that
      match the criteria defined in the filters are included in the insight.

      - **ProductArn** *(list) --*

        The ARN generated by Security Hub that uniquely identifies a third-party company (security
        findings provider) after this provider's product (solution that generates findings) is
        registered with Security Hub.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **AwsAccountId** *(list) --*

        The AWS account ID that a finding is generated in.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **Id** *(list) --*

        The security findings provider-specific identifier for a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **GeneratorId** *(list) --*

        The identifier for the solution-specific component (a discrete unit of logic) that generated
        a finding. In various security-findings providers' solutions, this generator can be called a
        rule, a check, a detector, a plug-in, etc.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **Type** *(list) --*

        A finding type in the format of ``namespace/category/classifier`` that classifies a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **FirstObservedAt** *(list) --*

        An ISO8601-formatted timestamp that indicates when the security-findings provider first
        observed the potential security issue that a finding captured.

        - *(dict) --*

          A date filter for querying findings.

          - **Start** *(string) --*

            A start date for the date filter.

          - **End** *(string) --*

            An end date for the date filter.

          - **DateRange** *(dict) --*

            A date range for the date filter.

            - **Value** *(integer) --*

              A date range value for the date filter.

            - **Unit** *(string) --*

              A date range unit for the date filter.

      - **LastObservedAt** *(list) --*

        An ISO8601-formatted timestamp that indicates when the security-findings provider most
        recently observed the potential security issue that a finding captured.

        - *(dict) --*

          A date filter for querying findings.

          - **Start** *(string) --*

            A start date for the date filter.

          - **End** *(string) --*

            An end date for the date filter.

          - **DateRange** *(dict) --*

            A date range for the date filter.

            - **Value** *(integer) --*

              A date range value for the date filter.

            - **Unit** *(string) --*

              A date range unit for the date filter.

      - **CreatedAt** *(list) --*

        An ISO8601-formatted timestamp that indicates when the security-findings provider captured
        the potential security issue that a finding captured.

        - *(dict) --*

          A date filter for querying findings.

          - **Start** *(string) --*

            A start date for the date filter.

          - **End** *(string) --*

            An end date for the date filter.

          - **DateRange** *(dict) --*

            A date range for the date filter.

            - **Value** *(integer) --*

              A date range value for the date filter.

            - **Unit** *(string) --*

              A date range unit for the date filter.

      - **UpdatedAt** *(list) --*

        An ISO8601-formatted timestamp that indicates when the security-findings provider last
        updated the finding record.

        - *(dict) --*

          A date filter for querying findings.

          - **Start** *(string) --*

            A start date for the date filter.

          - **End** *(string) --*

            An end date for the date filter.

          - **DateRange** *(dict) --*

            A date range for the date filter.

            - **Value** *(integer) --*

              A date range value for the date filter.

            - **Unit** *(string) --*

              A date range unit for the date filter.

      - **SeverityProduct** *(list) --*

        The native severity as defined by the security-findings provider's solution that generated
        the finding.

        - *(dict) --*

          A number filter for querying findings.

          - **Gte** *(float) --*

            The greater-than-equal condition to be applied to a single field when querying for
            findings.

          - **Lte** *(float) --*

            The less-than-equal condition to be applied to a single field when querying for
            findings.

          - **Eq** *(float) --*

            The equal-to condition to be applied to a single field when querying for findings.

      - **SeverityNormalized** *(list) --*

        The normalized severity of a finding.

        - *(dict) --*

          A number filter for querying findings.

          - **Gte** *(float) --*

            The greater-than-equal condition to be applied to a single field when querying for
            findings.

          - **Lte** *(float) --*

            The less-than-equal condition to be applied to a single field when querying for
            findings.

          - **Eq** *(float) --*

            The equal-to condition to be applied to a single field when querying for findings.

      - **SeverityLabel** *(list) --*

        The label of a finding's severity.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **Confidence** *(list) --*

        A finding's confidence. Confidence is defined as the likelihood that a finding accurately
        identifies the behavior or issue that it was intended to identify. Confidence is scored on a
        0-100 basis using a ratio scale, where 0 means zero percent confidence and 100 means 100
        percent confidence.

        - *(dict) --*

          A number filter for querying findings.

          - **Gte** *(float) --*

            The greater-than-equal condition to be applied to a single field when querying for
            findings.

          - **Lte** *(float) --*

            The less-than-equal condition to be applied to a single field when querying for
            findings.

          - **Eq** *(float) --*

            The equal-to condition to be applied to a single field when querying for findings.

      - **Criticality** *(list) --*

        The level of importance assigned to the resources associated with the finding. A score of 0
        means that the underlying resources have no criticality, and a score of 100 is reserved for
        the most critical resources.

        - *(dict) --*

          A number filter for querying findings.

          - **Gte** *(float) --*

            The greater-than-equal condition to be applied to a single field when querying for
            findings.

          - **Lte** *(float) --*

            The less-than-equal condition to be applied to a single field when querying for
            findings.

          - **Eq** *(float) --*

            The equal-to condition to be applied to a single field when querying for findings.

      - **Title** *(list) --*

        A finding's title.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **Description** *(list) --*

        A finding's description.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **RecommendationText** *(list) --*

        The recommendation of what to do about the issue described in a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **SourceUrl** *(list) --*

        A URL that links to a page about the current finding in the security-findings provider's
        solution.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ProductFields** *(list) --*

        A data type where security-findings providers can include additional solution-specific
        details that aren't part of the defined ``AwsSecurityFinding`` format.

        - *(dict) --*

          The map filter for querying findings.

          - **Key** *(string) --*

            The key of the map filter.

          - **Value** *(string) --*

            The value for the key in the map filter.

          - **Comparison** *(string) --*

            The condition to apply to a key value when querying for findings with a map filter.

      - **ProductName** *(list) --*

        The name of the solution (product) that generates findings.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **CompanyName** *(list) --*

        The name of the findings provider (company) that owns the solution (product) that generates
        findings.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **UserDefinedFields** *(list) --*

        A list of name/value string pairs associated with the finding. These are custom,
        user-defined fields added to a finding.

        - *(dict) --*

          The map filter for querying findings.

          - **Key** *(string) --*

            The key of the map filter.

          - **Value** *(string) --*

            The value for the key in the map filter.

          - **Comparison** *(string) --*

            The condition to apply to a key value when querying for findings with a map filter.

      - **MalwareName** *(list) --*

        The name of the malware that was observed.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **MalwareType** *(list) --*

        The type of the malware that was observed.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **MalwarePath** *(list) --*

        The filesystem path of the malware that was observed.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **MalwareState** *(list) --*

        The state of the malware that was observed.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **NetworkDirection** *(list) --*

        Indicates the direction of network traffic associated with a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **NetworkProtocol** *(list) --*

        The protocol of network-related information about a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **NetworkSourceIpV4** *(list) --*

        The source IPv4 address of network-related information about a finding.

        - *(dict) --*

          The IP filter for querying findings.

          - **Cidr** *(string) --*

            A finding's CIDR value.

      - **NetworkSourceIpV6** *(list) --*

        The source IPv6 address of network-related information about a finding.

        - *(dict) --*

          The IP filter for querying findings.

          - **Cidr** *(string) --*

            A finding's CIDR value.

      - **NetworkSourcePort** *(list) --*

        The source port of network-related information about a finding.

        - *(dict) --*

          A number filter for querying findings.

          - **Gte** *(float) --*

            The greater-than-equal condition to be applied to a single field when querying for
            findings.

          - **Lte** *(float) --*

            The less-than-equal condition to be applied to a single field when querying for
            findings.

          - **Eq** *(float) --*

            The equal-to condition to be applied to a single field when querying for findings.

      - **NetworkSourceDomain** *(list) --*

        The source domain of network-related information about a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **NetworkSourceMac** *(list) --*

        The source media access control (MAC) address of network-related information about a
        finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **NetworkDestinationIpV4** *(list) --*

        The destination IPv4 address of network-related information about a finding.

        - *(dict) --*

          The IP filter for querying findings.

          - **Cidr** *(string) --*

            A finding's CIDR value.

      - **NetworkDestinationIpV6** *(list) --*

        The destination IPv6 address of network-related information about a finding.

        - *(dict) --*

          The IP filter for querying findings.

          - **Cidr** *(string) --*

            A finding's CIDR value.

      - **NetworkDestinationPort** *(list) --*

        The destination port of network-related information about a finding.

        - *(dict) --*

          A number filter for querying findings.

          - **Gte** *(float) --*

            The greater-than-equal condition to be applied to a single field when querying for
            findings.

          - **Lte** *(float) --*

            The less-than-equal condition to be applied to a single field when querying for
            findings.

          - **Eq** *(float) --*

            The equal-to condition to be applied to a single field when querying for findings.

      - **NetworkDestinationDomain** *(list) --*

        The destination domain of network-related information about a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ProcessName** *(list) --*

        The name of the process.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ProcessPath** *(list) --*

        The path to the process executable.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ProcessPid** *(list) --*

        The process ID.

        - *(dict) --*

          A number filter for querying findings.

          - **Gte** *(float) --*

            The greater-than-equal condition to be applied to a single field when querying for
            findings.

          - **Lte** *(float) --*

            The less-than-equal condition to be applied to a single field when querying for
            findings.

          - **Eq** *(float) --*

            The equal-to condition to be applied to a single field when querying for findings.

      - **ProcessParentPid** *(list) --*

        The parent process ID.

        - *(dict) --*

          A number filter for querying findings.

          - **Gte** *(float) --*

            The greater-than-equal condition to be applied to a single field when querying for
            findings.

          - **Lte** *(float) --*

            The less-than-equal condition to be applied to a single field when querying for
            findings.

          - **Eq** *(float) --*

            The equal-to condition to be applied to a single field when querying for findings.

      - **ProcessLaunchedAt** *(list) --*

        The date/time that the process was launched.

        - *(dict) --*

          A date filter for querying findings.

          - **Start** *(string) --*

            A start date for the date filter.

          - **End** *(string) --*

            An end date for the date filter.

          - **DateRange** *(dict) --*

            A date range for the date filter.

            - **Value** *(integer) --*

              A date range value for the date filter.

            - **Unit** *(string) --*

              A date range unit for the date filter.

      - **ProcessTerminatedAt** *(list) --*

        The date/time that the process was terminated.

        - *(dict) --*

          A date filter for querying findings.

          - **Start** *(string) --*

            A start date for the date filter.

          - **End** *(string) --*

            An end date for the date filter.

          - **DateRange** *(dict) --*

            A date range for the date filter.

            - **Value** *(integer) --*

              A date range value for the date filter.

            - **Unit** *(string) --*

              A date range unit for the date filter.

      - **ThreatIntelIndicatorType** *(list) --*

        The type of a threat intel indicator.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ThreatIntelIndicatorValue** *(list) --*

        The value of a threat intel indicator.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ThreatIntelIndicatorCategory** *(list) --*

        The category of a threat intel indicator.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ThreatIntelIndicatorLastObservedAt** *(list) --*

        The date/time of the last observation of a threat intel indicator.

        - *(dict) --*

          A date filter for querying findings.

          - **Start** *(string) --*

            A start date for the date filter.

          - **End** *(string) --*

            An end date for the date filter.

          - **DateRange** *(dict) --*

            A date range for the date filter.

            - **Value** *(integer) --*

              A date range value for the date filter.

            - **Unit** *(string) --*

              A date range unit for the date filter.

      - **ThreatIntelIndicatorSource** *(list) --*

        The source of the threat intel.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ThreatIntelIndicatorSourceUrl** *(list) --*

        The URL for more details from the source of the threat intel.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceType** *(list) --*

        Specifies the type of the resource that details are provided for.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceId** *(list) --*

        The canonical identifier for the given resource type.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourcePartition** *(list) --*

        The canonical AWS partition name that the Region is assigned to.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceRegion** *(list) --*

        The canonical AWS external Region name where this resource is located.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceTags** *(list) --*

        A list of AWS tags associated with a resource at the time the finding was processed.

        - *(dict) --*

          The map filter for querying findings.

          - **Key** *(string) --*

            The key of the map filter.

          - **Value** *(string) --*

            The value for the key in the map filter.

          - **Comparison** *(string) --*

            The condition to apply to a key value when querying for findings with a map filter.

      - **ResourceAwsEc2InstanceType** *(list) --*

        The instance type of the instance.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceAwsEc2InstanceImageId** *(list) --*

        The Amazon Machine Image (AMI) ID of the instance.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceAwsEc2InstanceIpV4Addresses** *(list) --*

        The IPv4 addresses associated with the instance.

        - *(dict) --*

          The IP filter for querying findings.

          - **Cidr** *(string) --*

            A finding's CIDR value.

      - **ResourceAwsEc2InstanceIpV6Addresses** *(list) --*

        The IPv6 addresses associated with the instance.

        - *(dict) --*

          The IP filter for querying findings.

          - **Cidr** *(string) --*

            A finding's CIDR value.

      - **ResourceAwsEc2InstanceKeyName** *(list) --*

        The key name associated with the instance.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceAwsEc2InstanceIamInstanceProfileArn** *(list) --*

        The IAM profile ARN of the instance.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceAwsEc2InstanceVpcId** *(list) --*

        The identifier of the VPC that the instance was launched in.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceAwsEc2InstanceSubnetId** *(list) --*

        The identifier of the subnet that the instance was launched in.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceAwsEc2InstanceLaunchedAt** *(list) --*

        The date/time the instance was launched.

        - *(dict) --*

          A date filter for querying findings.

          - **Start** *(string) --*

            A start date for the date filter.

          - **End** *(string) --*

            An end date for the date filter.

          - **DateRange** *(dict) --*

            A date range for the date filter.

            - **Value** *(integer) --*

              A date range value for the date filter.

            - **Unit** *(string) --*

              A date range unit for the date filter.

      - **ResourceAwsS3BucketOwnerId** *(list) --*

        The canonical user ID of the owner of the S3 bucket.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceAwsS3BucketOwnerName** *(list) --*

        The display name of the owner of the S3 bucket.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceAwsIamAccessKeyUserName** *(list) --*

        The user associated with the IAM access key related to a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceAwsIamAccessKeyStatus** *(list) --*

        The status of the IAM access key related to a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceAwsIamAccessKeyCreatedAt** *(list) --*

        The creation date/time of the IAM access key related to a finding.

        - *(dict) --*

          A date filter for querying findings.

          - **Start** *(string) --*

            A start date for the date filter.

          - **End** *(string) --*

            An end date for the date filter.

          - **DateRange** *(dict) --*

            A date range for the date filter.

            - **Value** *(integer) --*

              A date range value for the date filter.

            - **Unit** *(string) --*

              A date range unit for the date filter.

      - **ResourceContainerName** *(list) --*

        The name of the container related to a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceContainerImageId** *(list) --*

        The identifier of the image related to a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceContainerImageName** *(list) --*

        The name of the image related to a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **ResourceContainerLaunchedAt** *(list) --*

        The date/time that the container was started.

        - *(dict) --*

          A date filter for querying findings.

          - **Start** *(string) --*

            A start date for the date filter.

          - **End** *(string) --*

            An end date for the date filter.

          - **DateRange** *(dict) --*

            A date range for the date filter.

            - **Value** *(integer) --*

              A date range value for the date filter.

            - **Unit** *(string) --*

              A date range unit for the date filter.

      - **ResourceDetailsOther** *(list) --*

        The details of a resource that doesn't have a specific subfield for the resource type
        defined.

        - *(dict) --*

          The map filter for querying findings.

          - **Key** *(string) --*

            The key of the map filter.

          - **Value** *(string) --*

            The value for the key in the map filter.

          - **Comparison** *(string) --*

            The condition to apply to a key value when querying for findings with a map filter.

      - **ComplianceStatus** *(list) --*

        Exclusive to findings that are generated as the result of a check run against a specific
        rule in a supported standard (for example, CIS AWS Foundations). Contains compliance-related
        finding details.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **VerificationState** *(list) --*

        The veracity of a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **WorkflowState** *(list) --*

        The workflow state of a finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **RecordState** *(list) --*

        The updated record state for the finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **RelatedFindingsProductArn** *(list) --*

        The ARN of the solution that generated a related finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **RelatedFindingsId** *(list) --*

        The solution-generated identifier for a related finding.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **NoteText** *(list) --*

        The text of a note.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **NoteUpdatedAt** *(list) --*

        The timestamp of when the note was updated.

        - *(dict) --*

          A date filter for querying findings.

          - **Start** *(string) --*

            A start date for the date filter.

          - **End** *(string) --*

            An end date for the date filter.

          - **DateRange** *(dict) --*

            A date range for the date filter.

            - **Value** *(integer) --*

              A date range value for the date filter.

            - **Unit** *(string) --*

              A date range unit for the date filter.

      - **NoteUpdatedBy** *(list) --*

        The principal that created a note.

        - *(dict) --*

          A string filter for querying findings.

          - **Value** *(string) --*

            The string filter value.

          - **Comparison** *(string) --*

            The condition to be applied to a string value when querying for findings.

      - **Keyword** *(list) --*

        A keyword for a finding.

        - *(dict) --*

          A keyword filter for querying findings.

          - **Value** *(string) --*

            A value for the keyword.

    - **GroupByAttribute** *(string) --*

      The attribute that the insight's findings are grouped by. This attribute is used as a findings
      aggregator for the purposes of viewing and managing multiple related findings under a single
      operand.
    """


_GetInsightsPaginateResponseTypeDef = TypedDict(
    "_GetInsightsPaginateResponseTypeDef",
    {"Insights": List[GetInsightsPaginateResponseInsightsTypeDef]},
    total=False,
)


class GetInsightsPaginateResponseTypeDef(_GetInsightsPaginateResponseTypeDef):
    """
    Type definition for `GetInsightsPaginate` `Response`

    - **Insights** *(list) --*

      The insights returned by the operation.

      - *(dict) --*

        Contains information about a Security Hub insight.

        - **InsightArn** *(string) --*

          The ARN of a Security Hub insight.

        - **Name** *(string) --*

          The name of a Security Hub insight.

        - **Filters** *(dict) --*

          One or more attributes used to filter the findings included in the insight. Only findings
          that match the criteria defined in the filters are included in the insight.

          - **ProductArn** *(list) --*

            The ARN generated by Security Hub that uniquely identifies a third-party company
            (security findings provider) after this provider's product (solution that generates
            findings) is registered with Security Hub.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **AwsAccountId** *(list) --*

            The AWS account ID that a finding is generated in.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **Id** *(list) --*

            The security findings provider-specific identifier for a finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **GeneratorId** *(list) --*

            The identifier for the solution-specific component (a discrete unit of logic) that
            generated a finding. In various security-findings providers' solutions, this generator
            can be called a rule, a check, a detector, a plug-in, etc.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **Type** *(list) --*

            A finding type in the format of ``namespace/category/classifier`` that classifies a
            finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **FirstObservedAt** *(list) --*

            An ISO8601-formatted timestamp that indicates when the security-findings provider first
            observed the potential security issue that a finding captured.

            - *(dict) --*

              A date filter for querying findings.

              - **Start** *(string) --*

                A start date for the date filter.

              - **End** *(string) --*

                An end date for the date filter.

              - **DateRange** *(dict) --*

                A date range for the date filter.

                - **Value** *(integer) --*

                  A date range value for the date filter.

                - **Unit** *(string) --*

                  A date range unit for the date filter.

          - **LastObservedAt** *(list) --*

            An ISO8601-formatted timestamp that indicates when the security-findings provider most
            recently observed the potential security issue that a finding captured.

            - *(dict) --*

              A date filter for querying findings.

              - **Start** *(string) --*

                A start date for the date filter.

              - **End** *(string) --*

                An end date for the date filter.

              - **DateRange** *(dict) --*

                A date range for the date filter.

                - **Value** *(integer) --*

                  A date range value for the date filter.

                - **Unit** *(string) --*

                  A date range unit for the date filter.

          - **CreatedAt** *(list) --*

            An ISO8601-formatted timestamp that indicates when the security-findings provider
            captured the potential security issue that a finding captured.

            - *(dict) --*

              A date filter for querying findings.

              - **Start** *(string) --*

                A start date for the date filter.

              - **End** *(string) --*

                An end date for the date filter.

              - **DateRange** *(dict) --*

                A date range for the date filter.

                - **Value** *(integer) --*

                  A date range value for the date filter.

                - **Unit** *(string) --*

                  A date range unit for the date filter.

          - **UpdatedAt** *(list) --*

            An ISO8601-formatted timestamp that indicates when the security-findings provider last
            updated the finding record.

            - *(dict) --*

              A date filter for querying findings.

              - **Start** *(string) --*

                A start date for the date filter.

              - **End** *(string) --*

                An end date for the date filter.

              - **DateRange** *(dict) --*

                A date range for the date filter.

                - **Value** *(integer) --*

                  A date range value for the date filter.

                - **Unit** *(string) --*

                  A date range unit for the date filter.

          - **SeverityProduct** *(list) --*

            The native severity as defined by the security-findings provider's solution that
            generated the finding.

            - *(dict) --*

              A number filter for querying findings.

              - **Gte** *(float) --*

                The greater-than-equal condition to be applied to a single field when querying for
                findings.

              - **Lte** *(float) --*

                The less-than-equal condition to be applied to a single field when querying for
                findings.

              - **Eq** *(float) --*

                The equal-to condition to be applied to a single field when querying for findings.

          - **SeverityNormalized** *(list) --*

            The normalized severity of a finding.

            - *(dict) --*

              A number filter for querying findings.

              - **Gte** *(float) --*

                The greater-than-equal condition to be applied to a single field when querying for
                findings.

              - **Lte** *(float) --*

                The less-than-equal condition to be applied to a single field when querying for
                findings.

              - **Eq** *(float) --*

                The equal-to condition to be applied to a single field when querying for findings.

          - **SeverityLabel** *(list) --*

            The label of a finding's severity.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **Confidence** *(list) --*

            A finding's confidence. Confidence is defined as the likelihood that a finding
            accurately identifies the behavior or issue that it was intended to identify. Confidence
            is scored on a 0-100 basis using a ratio scale, where 0 means zero percent confidence
            and 100 means 100 percent confidence.

            - *(dict) --*

              A number filter for querying findings.

              - **Gte** *(float) --*

                The greater-than-equal condition to be applied to a single field when querying for
                findings.

              - **Lte** *(float) --*

                The less-than-equal condition to be applied to a single field when querying for
                findings.

              - **Eq** *(float) --*

                The equal-to condition to be applied to a single field when querying for findings.

          - **Criticality** *(list) --*

            The level of importance assigned to the resources associated with the finding. A score
            of 0 means that the underlying resources have no criticality, and a score of 100 is
            reserved for the most critical resources.

            - *(dict) --*

              A number filter for querying findings.

              - **Gte** *(float) --*

                The greater-than-equal condition to be applied to a single field when querying for
                findings.

              - **Lte** *(float) --*

                The less-than-equal condition to be applied to a single field when querying for
                findings.

              - **Eq** *(float) --*

                The equal-to condition to be applied to a single field when querying for findings.

          - **Title** *(list) --*

            A finding's title.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **Description** *(list) --*

            A finding's description.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **RecommendationText** *(list) --*

            The recommendation of what to do about the issue described in a finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **SourceUrl** *(list) --*

            A URL that links to a page about the current finding in the security-findings provider's
            solution.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ProductFields** *(list) --*

            A data type where security-findings providers can include additional solution-specific
            details that aren't part of the defined ``AwsSecurityFinding`` format.

            - *(dict) --*

              The map filter for querying findings.

              - **Key** *(string) --*

                The key of the map filter.

              - **Value** *(string) --*

                The value for the key in the map filter.

              - **Comparison** *(string) --*

                The condition to apply to a key value when querying for findings with a map filter.

          - **ProductName** *(list) --*

            The name of the solution (product) that generates findings.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **CompanyName** *(list) --*

            The name of the findings provider (company) that owns the solution (product) that
            generates findings.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **UserDefinedFields** *(list) --*

            A list of name/value string pairs associated with the finding. These are custom,
            user-defined fields added to a finding.

            - *(dict) --*

              The map filter for querying findings.

              - **Key** *(string) --*

                The key of the map filter.

              - **Value** *(string) --*

                The value for the key in the map filter.

              - **Comparison** *(string) --*

                The condition to apply to a key value when querying for findings with a map filter.

          - **MalwareName** *(list) --*

            The name of the malware that was observed.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **MalwareType** *(list) --*

            The type of the malware that was observed.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **MalwarePath** *(list) --*

            The filesystem path of the malware that was observed.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **MalwareState** *(list) --*

            The state of the malware that was observed.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **NetworkDirection** *(list) --*

            Indicates the direction of network traffic associated with a finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **NetworkProtocol** *(list) --*

            The protocol of network-related information about a finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **NetworkSourceIpV4** *(list) --*

            The source IPv4 address of network-related information about a finding.

            - *(dict) --*

              The IP filter for querying findings.

              - **Cidr** *(string) --*

                A finding's CIDR value.

          - **NetworkSourceIpV6** *(list) --*

            The source IPv6 address of network-related information about a finding.

            - *(dict) --*

              The IP filter for querying findings.

              - **Cidr** *(string) --*

                A finding's CIDR value.

          - **NetworkSourcePort** *(list) --*

            The source port of network-related information about a finding.

            - *(dict) --*

              A number filter for querying findings.

              - **Gte** *(float) --*

                The greater-than-equal condition to be applied to a single field when querying for
                findings.

              - **Lte** *(float) --*

                The less-than-equal condition to be applied to a single field when querying for
                findings.

              - **Eq** *(float) --*

                The equal-to condition to be applied to a single field when querying for findings.

          - **NetworkSourceDomain** *(list) --*

            The source domain of network-related information about a finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **NetworkSourceMac** *(list) --*

            The source media access control (MAC) address of network-related information about a
            finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **NetworkDestinationIpV4** *(list) --*

            The destination IPv4 address of network-related information about a finding.

            - *(dict) --*

              The IP filter for querying findings.

              - **Cidr** *(string) --*

                A finding's CIDR value.

          - **NetworkDestinationIpV6** *(list) --*

            The destination IPv6 address of network-related information about a finding.

            - *(dict) --*

              The IP filter for querying findings.

              - **Cidr** *(string) --*

                A finding's CIDR value.

          - **NetworkDestinationPort** *(list) --*

            The destination port of network-related information about a finding.

            - *(dict) --*

              A number filter for querying findings.

              - **Gte** *(float) --*

                The greater-than-equal condition to be applied to a single field when querying for
                findings.

              - **Lte** *(float) --*

                The less-than-equal condition to be applied to a single field when querying for
                findings.

              - **Eq** *(float) --*

                The equal-to condition to be applied to a single field when querying for findings.

          - **NetworkDestinationDomain** *(list) --*

            The destination domain of network-related information about a finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ProcessName** *(list) --*

            The name of the process.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ProcessPath** *(list) --*

            The path to the process executable.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ProcessPid** *(list) --*

            The process ID.

            - *(dict) --*

              A number filter for querying findings.

              - **Gte** *(float) --*

                The greater-than-equal condition to be applied to a single field when querying for
                findings.

              - **Lte** *(float) --*

                The less-than-equal condition to be applied to a single field when querying for
                findings.

              - **Eq** *(float) --*

                The equal-to condition to be applied to a single field when querying for findings.

          - **ProcessParentPid** *(list) --*

            The parent process ID.

            - *(dict) --*

              A number filter for querying findings.

              - **Gte** *(float) --*

                The greater-than-equal condition to be applied to a single field when querying for
                findings.

              - **Lte** *(float) --*

                The less-than-equal condition to be applied to a single field when querying for
                findings.

              - **Eq** *(float) --*

                The equal-to condition to be applied to a single field when querying for findings.

          - **ProcessLaunchedAt** *(list) --*

            The date/time that the process was launched.

            - *(dict) --*

              A date filter for querying findings.

              - **Start** *(string) --*

                A start date for the date filter.

              - **End** *(string) --*

                An end date for the date filter.

              - **DateRange** *(dict) --*

                A date range for the date filter.

                - **Value** *(integer) --*

                  A date range value for the date filter.

                - **Unit** *(string) --*

                  A date range unit for the date filter.

          - **ProcessTerminatedAt** *(list) --*

            The date/time that the process was terminated.

            - *(dict) --*

              A date filter for querying findings.

              - **Start** *(string) --*

                A start date for the date filter.

              - **End** *(string) --*

                An end date for the date filter.

              - **DateRange** *(dict) --*

                A date range for the date filter.

                - **Value** *(integer) --*

                  A date range value for the date filter.

                - **Unit** *(string) --*

                  A date range unit for the date filter.

          - **ThreatIntelIndicatorType** *(list) --*

            The type of a threat intel indicator.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ThreatIntelIndicatorValue** *(list) --*

            The value of a threat intel indicator.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ThreatIntelIndicatorCategory** *(list) --*

            The category of a threat intel indicator.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ThreatIntelIndicatorLastObservedAt** *(list) --*

            The date/time of the last observation of a threat intel indicator.

            - *(dict) --*

              A date filter for querying findings.

              - **Start** *(string) --*

                A start date for the date filter.

              - **End** *(string) --*

                An end date for the date filter.

              - **DateRange** *(dict) --*

                A date range for the date filter.

                - **Value** *(integer) --*

                  A date range value for the date filter.

                - **Unit** *(string) --*

                  A date range unit for the date filter.

          - **ThreatIntelIndicatorSource** *(list) --*

            The source of the threat intel.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ThreatIntelIndicatorSourceUrl** *(list) --*

            The URL for more details from the source of the threat intel.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceType** *(list) --*

            Specifies the type of the resource that details are provided for.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceId** *(list) --*

            The canonical identifier for the given resource type.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourcePartition** *(list) --*

            The canonical AWS partition name that the Region is assigned to.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceRegion** *(list) --*

            The canonical AWS external Region name where this resource is located.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceTags** *(list) --*

            A list of AWS tags associated with a resource at the time the finding was processed.

            - *(dict) --*

              The map filter for querying findings.

              - **Key** *(string) --*

                The key of the map filter.

              - **Value** *(string) --*

                The value for the key in the map filter.

              - **Comparison** *(string) --*

                The condition to apply to a key value when querying for findings with a map filter.

          - **ResourceAwsEc2InstanceType** *(list) --*

            The instance type of the instance.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceAwsEc2InstanceImageId** *(list) --*

            The Amazon Machine Image (AMI) ID of the instance.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceAwsEc2InstanceIpV4Addresses** *(list) --*

            The IPv4 addresses associated with the instance.

            - *(dict) --*

              The IP filter for querying findings.

              - **Cidr** *(string) --*

                A finding's CIDR value.

          - **ResourceAwsEc2InstanceIpV6Addresses** *(list) --*

            The IPv6 addresses associated with the instance.

            - *(dict) --*

              The IP filter for querying findings.

              - **Cidr** *(string) --*

                A finding's CIDR value.

          - **ResourceAwsEc2InstanceKeyName** *(list) --*

            The key name associated with the instance.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceAwsEc2InstanceIamInstanceProfileArn** *(list) --*

            The IAM profile ARN of the instance.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceAwsEc2InstanceVpcId** *(list) --*

            The identifier of the VPC that the instance was launched in.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceAwsEc2InstanceSubnetId** *(list) --*

            The identifier of the subnet that the instance was launched in.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceAwsEc2InstanceLaunchedAt** *(list) --*

            The date/time the instance was launched.

            - *(dict) --*

              A date filter for querying findings.

              - **Start** *(string) --*

                A start date for the date filter.

              - **End** *(string) --*

                An end date for the date filter.

              - **DateRange** *(dict) --*

                A date range for the date filter.

                - **Value** *(integer) --*

                  A date range value for the date filter.

                - **Unit** *(string) --*

                  A date range unit for the date filter.

          - **ResourceAwsS3BucketOwnerId** *(list) --*

            The canonical user ID of the owner of the S3 bucket.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceAwsS3BucketOwnerName** *(list) --*

            The display name of the owner of the S3 bucket.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceAwsIamAccessKeyUserName** *(list) --*

            The user associated with the IAM access key related to a finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceAwsIamAccessKeyStatus** *(list) --*

            The status of the IAM access key related to a finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceAwsIamAccessKeyCreatedAt** *(list) --*

            The creation date/time of the IAM access key related to a finding.

            - *(dict) --*

              A date filter for querying findings.

              - **Start** *(string) --*

                A start date for the date filter.

              - **End** *(string) --*

                An end date for the date filter.

              - **DateRange** *(dict) --*

                A date range for the date filter.

                - **Value** *(integer) --*

                  A date range value for the date filter.

                - **Unit** *(string) --*

                  A date range unit for the date filter.

          - **ResourceContainerName** *(list) --*

            The name of the container related to a finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceContainerImageId** *(list) --*

            The identifier of the image related to a finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceContainerImageName** *(list) --*

            The name of the image related to a finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **ResourceContainerLaunchedAt** *(list) --*

            The date/time that the container was started.

            - *(dict) --*

              A date filter for querying findings.

              - **Start** *(string) --*

                A start date for the date filter.

              - **End** *(string) --*

                An end date for the date filter.

              - **DateRange** *(dict) --*

                A date range for the date filter.

                - **Value** *(integer) --*

                  A date range value for the date filter.

                - **Unit** *(string) --*

                  A date range unit for the date filter.

          - **ResourceDetailsOther** *(list) --*

            The details of a resource that doesn't have a specific subfield for the resource type
            defined.

            - *(dict) --*

              The map filter for querying findings.

              - **Key** *(string) --*

                The key of the map filter.

              - **Value** *(string) --*

                The value for the key in the map filter.

              - **Comparison** *(string) --*

                The condition to apply to a key value when querying for findings with a map filter.

          - **ComplianceStatus** *(list) --*

            Exclusive to findings that are generated as the result of a check run against a specific
            rule in a supported standard (for example, CIS AWS Foundations). Contains
            compliance-related finding details.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **VerificationState** *(list) --*

            The veracity of a finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **WorkflowState** *(list) --*

            The workflow state of a finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **RecordState** *(list) --*

            The updated record state for the finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **RelatedFindingsProductArn** *(list) --*

            The ARN of the solution that generated a related finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **RelatedFindingsId** *(list) --*

            The solution-generated identifier for a related finding.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **NoteText** *(list) --*

            The text of a note.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **NoteUpdatedAt** *(list) --*

            The timestamp of when the note was updated.

            - *(dict) --*

              A date filter for querying findings.

              - **Start** *(string) --*

                A start date for the date filter.

              - **End** *(string) --*

                An end date for the date filter.

              - **DateRange** *(dict) --*

                A date range for the date filter.

                - **Value** *(integer) --*

                  A date range value for the date filter.

                - **Unit** *(string) --*

                  A date range unit for the date filter.

          - **NoteUpdatedBy** *(list) --*

            The principal that created a note.

            - *(dict) --*

              A string filter for querying findings.

              - **Value** *(string) --*

                The string filter value.

              - **Comparison** *(string) --*

                The condition to be applied to a string value when querying for findings.

          - **Keyword** *(list) --*

            A keyword for a finding.

            - *(dict) --*

              A keyword filter for querying findings.

              - **Value** *(string) --*

                A value for the keyword.

        - **GroupByAttribute** *(string) --*

          The attribute that the insight's findings are grouped by. This attribute is used as a
          findings aggregator for the purposes of viewing and managing multiple related findings
          under a single operand.
    """


_ListEnabledProductsForImportPaginatePaginationConfigTypeDef = TypedDict(
    "_ListEnabledProductsForImportPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class ListEnabledProductsForImportPaginatePaginationConfigTypeDef(
    _ListEnabledProductsForImportPaginatePaginationConfigTypeDef
):
    """
    Type definition for `ListEnabledProductsForImportPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_ListEnabledProductsForImportPaginateResponseTypeDef = TypedDict(
    "_ListEnabledProductsForImportPaginateResponseTypeDef",
    {"ProductSubscriptions": List[str]},
    total=False,
)


class ListEnabledProductsForImportPaginateResponseTypeDef(
    _ListEnabledProductsForImportPaginateResponseTypeDef
):
    """
    Type definition for `ListEnabledProductsForImportPaginate` `Response`

    - **ProductSubscriptions** *(list) --*

      A list of ARNs for the resources that represent your subscriptions to products.

      - *(string) --*
    """


_ListInvitationsPaginatePaginationConfigTypeDef = TypedDict(
    "_ListInvitationsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class ListInvitationsPaginatePaginationConfigTypeDef(
    _ListInvitationsPaginatePaginationConfigTypeDef
):
    """
    Type definition for `ListInvitationsPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_ListInvitationsPaginateResponseInvitationsTypeDef = TypedDict(
    "_ListInvitationsPaginateResponseInvitationsTypeDef",
    {"AccountId": str, "InvitationId": str, "InvitedAt": datetime, "MemberStatus": str},
    total=False,
)


class ListInvitationsPaginateResponseInvitationsTypeDef(
    _ListInvitationsPaginateResponseInvitationsTypeDef
):
    """
    Type definition for `ListInvitationsPaginateResponse` `Invitations`

    Details about an invitation.

    - **AccountId** *(string) --*

      The account ID of the Security Hub master account that the invitation was sent from.

    - **InvitationId** *(string) --*

      The ID of the invitation sent to the member account.

    - **InvitedAt** *(datetime) --*

      The timestamp of when the invitation was sent.

    - **MemberStatus** *(string) --*

      The current status of the association between member and master accounts.
    """


_ListInvitationsPaginateResponseTypeDef = TypedDict(
    "_ListInvitationsPaginateResponseTypeDef",
    {"Invitations": List[ListInvitationsPaginateResponseInvitationsTypeDef]},
    total=False,
)


class ListInvitationsPaginateResponseTypeDef(_ListInvitationsPaginateResponseTypeDef):
    """
    Type definition for `ListInvitationsPaginate` `Response`

    - **Invitations** *(list) --*

      The details of the invitations returned by the operation.

      - *(dict) --*

        Details about an invitation.

        - **AccountId** *(string) --*

          The account ID of the Security Hub master account that the invitation was sent from.

        - **InvitationId** *(string) --*

          The ID of the invitation sent to the member account.

        - **InvitedAt** *(datetime) --*

          The timestamp of when the invitation was sent.

        - **MemberStatus** *(string) --*

          The current status of the association between member and master accounts.
    """


_ListMembersPaginatePaginationConfigTypeDef = TypedDict(
    "_ListMembersPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class ListMembersPaginatePaginationConfigTypeDef(_ListMembersPaginatePaginationConfigTypeDef):
    """
    Type definition for `ListMembersPaginate` `PaginationConfig`

    A dictionary that provides parameters to control pagination.

    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.

    - **PageSize** *(integer) --*

      The size of each page.

    - **StartingToken** *(string) --*

      A token to specify where to start paginating. This is the ``NextToken`` from a previous
      response.
    """


_ListMembersPaginateResponseMembersTypeDef = TypedDict(
    "_ListMembersPaginateResponseMembersTypeDef",
    {
        "AccountId": str,
        "Email": str,
        "MasterId": str,
        "MemberStatus": str,
        "InvitedAt": datetime,
        "UpdatedAt": datetime,
    },
    total=False,
)


class ListMembersPaginateResponseMembersTypeDef(_ListMembersPaginateResponseMembersTypeDef):
    """
    Type definition for `ListMembersPaginateResponse` `Members`

    The details about a member account.

    - **AccountId** *(string) --*

      The AWS account ID of the member account.

    - **Email** *(string) --*

      The email address of the member account.

    - **MasterId** *(string) --*

      The AWS account ID of the Security Hub master account associated with this member account.

    - **MemberStatus** *(string) --*

      The status of the relationship between the member account and its master account.

    - **InvitedAt** *(datetime) --*

      A timestamp for the date and time when the invitation was sent to the member account.

    - **UpdatedAt** *(datetime) --*

      The timestamp for the date and time when the member account was updated.
    """


_ListMembersPaginateResponseTypeDef = TypedDict(
    "_ListMembersPaginateResponseTypeDef",
    {"Members": List[ListMembersPaginateResponseMembersTypeDef]},
    total=False,
)


class ListMembersPaginateResponseTypeDef(_ListMembersPaginateResponseTypeDef):
    """
    Type definition for `ListMembersPaginate` `Response`

    - **Members** *(list) --*

      Member details returned by the operation.

      - *(dict) --*

        The details about a member account.

        - **AccountId** *(string) --*

          The AWS account ID of the member account.

        - **Email** *(string) --*

          The email address of the member account.

        - **MasterId** *(string) --*

          The AWS account ID of the Security Hub master account associated with this member account.

        - **MemberStatus** *(string) --*

          The status of the relationship between the member account and its master account.

        - **InvitedAt** *(datetime) --*

          A timestamp for the date and time when the invitation was sent to the member account.

        - **UpdatedAt** *(datetime) --*

          The timestamp for the date and time when the member account was updated.
    """
